# OpenCL.jl

[![][buildkite-img]][buildkite-url]
[![Test](https://github.com/JuliaGPU/OpenCL.jl/actions/workflows/Test.yml/badge.svg)](https://github.com/JuliaGPU/OpenCL.jl/actions/workflows/Test.yml)
[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliagpu.github.io/OpenCL.jl/stable)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliagpu.github.io/OpenCL.jl/dev)

[buildkite-img]: https://badge.buildkite.com/6b2a46bff67692115dea3ad5a275d2f80777a5a99ffe42adb0.svg?branch=main
[buildkite-url]: https://buildkite.com/julialang/opencl-dot-jl

*Julia interface for the OpenCL parallel computation API*

This package aims to be a complete solution for OpenCL programming in Julia, similar in
scope to [PyOpenCL](http://mathema.tician.de/software/pyopencl/) for Python. It provides a high level API for OpenCL to make programing
hardware accelerators, such as GPUs, FPGAs, and DSPs, as well as multicore CPUs much less
onerous.

**OpenCL.jl needs your help! If you can help maintaining this package, please reach out on
the [JuliaLang Slack](https://julialang.org/slack/) #gpu channel**

**Also note: OpenCL.jl is currently undergoing major changes. If you have old code,
developed for OpenCL.jl v0.9, please check [`NEWS.md`](NEWS.md) for an overview of the
changes.**


## Installation

1. Install an OpenCL driver. You can install one system-wide, i.e., using your package
   manager, or use `pocl_jll.jl` for a CPU back-end.
2. Add OpenCL to your Julia environment:

```julia
using Pkg
Pkg.add("OpenCL")
```

3. Test your installation:

```julia-repl
julia> OpenCL.versioninfo()
OpenCL.jl version 0.10.0

Toolchain:
 - Julia v1.10.5
 - OpenCL_jll v2024.5.8+1

Available platforms: 3
 - Portable Computing Language
   version: OpenCL 3.0 PoCL 6.0  Linux, Release, RELOC, SPIR-V, LLVM 15.0.7jl, SLEEF, DISTRO, POCL_DEBUG
   · cpu-haswell-AMD Ryzen 9 5950X 16-Core Processor (fp64, il)
 - NVIDIA CUDA
   version: OpenCL 3.0 CUDA 12.6.65
   · NVIDIA RTX 6000 Ada Generation (fp64)
 - Intel(R) OpenCL Graphics
   version: OpenCL 3.0
   · Intel(R) Arc(TM) A770 Graphics (fp16, il)
```

> [!WARNING]
> OpenCL is only computing the list of platforms [once](https://github.com/KhronosGroup/OpenCL-ICD-Loader/blob/d547426c32f9af274ec1369acd1adcfd8fe0ee40/loader/linux/icd_linux.c#L234-L238).
> Therefore if `using pocl_jll` is executed after `OpenCL.versioninfo()` or other calls to the OpenCL API
> then it won't affect the list of platforms available and you will need to restart the Julia session
> and run `using pocl_jll` before `OpenCL` is used.

## Basic example: vector add

The traditional way of using OpenCL is by writing kernel source code in OpenCL C. For
example, a simple vector addition:

```julia
using OpenCL, pocl_jll

const source = """
   __kernel void vadd(__global const float *a,
                      __global const float *b,
                      __global float *c) {
      int gid = get_global_id(0);
      c[gid] = a[gid] + b[gid];
    }"""

a = rand(Float32, 50_000)
b = rand(Float32, 50_000)

d_a = CLArray(a)
d_b = CLArray(b)
d_c = similar(d_a)

p = cl.Program(; source) |> cl.build!
k = cl.Kernel(p, "vadd")

clcall(k, Tuple{CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}},
       d_a, d_b, d_c; global_size=size(a))

c = Array(d_c)

@assert a + b ≈ c
```


## Native example: vector add

If your platform supports SPIR-V, it's possible to use Julia functions as kernels:

```julia
using OpenCL, pocl_jll

function vadd(a, b, c)
    gid = get_global_id(1)
    @inbounds c[gid] = a[gid] + b[gid]
    return
end

a = rand(Float32, 50_000)
b = rand(Float32, 50_000)

d_a = CLArray(a)
d_b = CLArray(b)
d_c = similar(d_a)

@opencl global_size=size(a) vadd(d_a, d_b, d_c)

c = Array(d_c)

@assert a + b ≈ c
```


## More examples

You may want to check out the `examples` folder. Either `git clone` the repository to your
local machine or navigate to the OpenCL.jl install directory via:

```julia
using OpenCL
cd(joinpath(dirname(pathof(OpenCL)), ".."))
```

Otherwise, feel free to take a look at the Jupyter notebooks below:

  * [Julia set fractals](https://github.com/JuliaGPU/OpenCL.jl/blob/main/examples/notebooks/julia_set_fractal.ipynb)
  * [Mandlebrot fractal](https://github.com/JuliaGPU/OpenCL.jl/blob/main/examples/notebooks/mandelbrot_fractal.ipynb)
  * [Transpose bandwidth](https://github.com/JuliaGPU/OpenCL.jl/blob/main/examples/notebooks/Transpose.ipynb)


## Credit

This package is heavily influenced by the work of others:

  * [PyOpenCL](http://mathema.tician.de/software/pyopencl/) by Andreas Klockner
  * [oclpb](https://github.com/srossross/oclpb) by Sean Ross
  * [Boost.Compute](https://github.com/kylelutz/compute) by Kyle Lutz
  * [rust-opencl](https://github.com/luqmana/rust-opencl)

# SPIRVIntrinsics.jl

*Reusable intrinsic functions for SPIRV-based programming packages in Julia.*

This package provides Julia functions that compile down to compiler intrinsics
usable in SPIR-V code. It is used by packages such as OpenCL.jl and oneAPI.jl.


## Usage

End users can use this package by calling the intrinsics from Julia kernel code.
For documentation, refer to the user-facing package (OpenCL.jl, oneAPI.jl).

For developers wanting to integrate this package, there are a couple of
considerations:

- to prevent accidental use of the intrinsics in non-SPIR-V code, method overlay
  tables are used, implying that `SPIRVIntrinsics.method_table` should be used
  for compilation;

- exported functionality is meant to be re-exported, while non-exported
  functionality is typically meant to be accessed via the module of the
  user-facing package. This can be accomplished using some metaprogramming:

  ```julia
  # re-export functionality from SPIRVIntrinsics
  for name in names(SPIRVIntrinsics)
      name == :SPIRVIntrinsics && continue
      @eval export $name
  end

  # import all the others so that the user can refer to them through the OpenCL module
  for name in names(SPIRVIntrinsics; all=true)
      # bring all the names of this module in scope
      name in (:SPIRVIntrinsics, :eval, :include) && continue
      startswith(string(name), "#") && continue
      @eval begin
          using .SPIRVIntrinsics: $name
      end
  end
  ```


## SPIR-V representation

Intrinsics that map to core SPIR-V operations should be encoded using LLVM's
SPIR-V wrapper builtins, such as `__spirv_AtomicIAdd` or
`__spirv_GroupNonUniformShuffle`. This keeps the emitted LLVM IR independent of
OpenCL C builtin spellings.

Some math and integer functions intentionally keep OpenCL.std names. In SPIR-V,
those operations are represented through the OpenCL extended instruction set,
so the OpenCL spelling is the SPIR-V-level contract rather than an OpenCL.jl API
dependency.

Hands On OpenCL Lecture Course Solutions

See the [github repo] for Presentation Materials and
implementations in C ,C++, and Python.

[github repo]:http://handsonopencl.github.io/


#### LICENSE
This work is licensed under the Creative Commons Attribution 3.0 Unported License.

To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/
or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.

# task-bound state

function clear_task_local_storage!()
    # the primary key for all task-local state is the context
    delete!(task_local_storage(), :CLContext)

    # all other state is derived
    delete!(task_local_storage(), :CLDevice)
    delete!(task_local_storage(), :CLPlatform)
    delete!(task_local_storage(), :CLQueue)
    delete!(task_local_storage(), :CLMemoryBackend)
    delete!(task_local_storage(), :CLUnifiedMemoryBackend)
end


## context creation

# we maintain a single global context per device
const device_contexts = Dict{Device, Context}()
const device_context_lock = ReentrantLock()
function device_context(dev::Device)
    return @lock device_context_lock begin
        get!(device_contexts, dev) do
            device_contexts[dev] = Context(dev)
        end
    end
end

function context()
    return get!(task_local_storage(), :CLContext) do
        dev = if haskey(task_local_storage(), :CLDevice)
            device()
        elseif haskey(task_local_storage(), :CLPlatform)
            default_device(platform())
        else
            default_device(default_platform())
        end
        isnothing(dev) && throw(ArgumentError("No OpenCL devices found"))
        device_context(dev)
    end::Context
end

function context!(ctx::Context)
    ctx == context() && return ctx

    clear_task_local_storage!()
    task_local_storage(:CLContext, ctx)
    return ctx
end

# temporarily switch the current context to a different context
function context!(f::Base.Callable, args...)
    old = context()
    context!(args...)
    try
        f()
    finally
        context!(old)
    end
end


## platform selection

function default_platform()
    ps = platforms()
    if isempty(ps)
        throw(ArgumentError("No OpenCL platforms found"))
    end

    # prefer platforms that implement the full profile
    idx = findfirst(ps) do p
        p.profile == "FULL_PROFILE"
    end
    isnothing(idx) || return ps[idx]

    # otherwise, just return the first platform
    return first(ps)
end

function platform()
    get!(task_local_storage(), :CLPlatform) do
        device().platform
    end::Platform
end

# allow overriding with a specific platform
function platform!(p::Platform)
    p == platform() && return p

    clear_task_local_storage!()
    task_local_storage(:CLPlatform, p)
    return p
end

# allow selecting a platform by name or vendor
function platform!(name::String)
    ps = platforms()

    # check the name
    idx = findfirst(ps) do p
        contains(lowercase(p.name), lowercase(name))
    end
    isnothing(idx) || return platform!(ps[idx])

    # check the vendor
    idx = findfirst(ps) do p
        contains(lowercase(p.vendor), lowercase(name))
    end
    isnothing(idx) || return platform!(ps[idx])

    throw(ArgumentError("No OpenCL platform found with name or vendor $name"))
end


## device selection

function default_device(p::Platform)
    devs = devices(p, CL_DEVICE_TYPE_DEFAULT)
    isempty(devs) && return nothing
    # XXX: clGetDeviceIDs documents CL_DEVICE_TYPE_DEFAULT should only return one device,
    #      but it's been observed to return multiple devices on some platforms...
    return first(devs)
end

function device()
    get!(task_local_storage(), :CLDevice) do
        only(context().devices)
    end::Device
end

# allow overriding with a specific device
function device!(dev::Device)
    dev == device() && return dev

    clear_task_local_storage!()
    task_local_storage(:CLDevice, dev)
    return dev
end

# allow selecting a device by type
function device!(dtype::Symbol)
    dev = devices(platform(), dtype)
    isempty(dev) && throw(ArgumentError("No OpenCL devices found of type $dtype"))
    device!(first(dev))
end

# temporarily switch the current device to a different device
function device!(f::Base.Callable, args...)
    old = device()
    device!(args...)
    try
        f()
    finally
        device!(old)
    end
end


## memory back-end

abstract type AbstractMemoryBackend end
struct SVMBackend <: AbstractMemoryBackend end
struct USMBackend <: AbstractMemoryBackend end
struct BufferBackend <: AbstractMemoryBackend end

function supported_memory_backends(dev::Device; unified=false)
    backends = AbstractMemoryBackend[]

    # unified shared memory is the first choice, as it gives us separate host and device
    # memory spaces that can be directly referenced by raw pointers.
    if usm_supported(dev)
        usm_caps = usm_capabilities(dev)
        if usm_caps.host.access && usm_caps.device.access
            push!(backends, USMBackend())
        end
    end

    # plain old buffers are always supported, but we only want to use them if we have the
    # buffer device address extension, which allows us to reference them by raw pointers.
    if !unified && bda_supported(dev)
        push!(backends, BufferBackend())
    end

    # shared virtual memory is last, because it comes at a performance cost.
    svm_caps = svm_capabilities(dev)
    if svm_caps.coarse_grain_buffer
        push!(backends, SVMBackend())
    end

    if !unified && isempty(backends)
        # as a last resort, use plain buffers without the ability to reference by pointer.
        # this severely limits compatibility, but it's better than nothing.
        push!(backends, BufferBackend())
    end

    return backends
end

function default_memory_backend(dev::Device; unified=false)
    supported_backends = supported_memory_backends(dev; unified)
    isempty(supported_backends) && return nothing

    backend_str = load_preference(OpenCL, "default_memory_backend")
    backend_str === nothing && return first(supported_backends)

    backend = if backend_str == "usm"
        USMBackend()
    elseif backend_str == "svm"
        SVMBackend()
    elseif backend_str == "buffer"
        BufferBackend()
    else
        error("Unknown memory backend '$backend_str' requested")
    end
    return in(backend, supported_backends) ? backend : nothing
end

function memory_backend()
    return get!(task_local_storage(), :CLMemoryBackend) do
        dev = device()
        backend = default_memory_backend(dev)
        if backend === nothing
            error("Device $(dev) does not support any of the available memory backends")
        end
        if backend === BufferBackend() && !bda_supported(dev)
            @warn """Your device $(dev.name) does not support the necessary extensions for OpenCL.jl's memory management (requiring either USM, coarse-grained SVM, or BDA).
                     Falling back to plain OpenCL buffers, which severely limits compatibility with other OpenCL.jl, only supporting OpenCL C kernels.""" maxlog=1 _id="memory_backend_$(dev.name)"
        end
        backend
    end
end

function unified_memory_backend()
    return get!(task_local_storage(), :CLUnifiedMemoryBackend) do
        dev = device()
        backend = default_memory_backend(dev; unified=true)
        if backend === nothing
            error("Device $(dev) does not support any of the available unified memory backends")
        end
        backend
    end
end


## per-task queues

function queue()
    get!(task_local_storage(), :CLQueue) do
        dev = device()

        # switching between devices on a task should yield the same queues
        queues = get!(task_local_storage(), :CLQueues) do
            Dict{Device, CmdQueue}()
        end

        get!(queues, dev) do
            CmdQueue()
        end
    end::CmdQueue
end

# switch the current task to a different queue
function queue!(q::CmdQueue)
    if q.device != device()
        throw(ArgumentError("Cannot switch to a queue on a different device"))
    end
    task_local_storage(:CLQueue, q)
    return q
end

# allow selecting a queue by properties
function queue!(args...)
    q = CmdQueue(args...)
    task_local_storage(:CLQueue, q)
    return q
end

# temporarily switch the current task to a different queue
function queue!(f::Base.Callable, args...)
    old = queue()
    queue!(args...)
    try
        f()
    finally
        queue!(old)
    end
end

const _cl_error_codes = Dict{Int, Symbol}(
     +0 => :CL_SUCCESS,
     -1 => :CL_DEVICE_NOT_FOUND,
     -2 => :CL_DEVICE_NOT_AVAILABLE,
     -3 => :CL_COMPILER_NOT_AVAILABLE,
     -4 => :CL_MEM_OBJECT_ALLOCATION_FAILURE,
     -5 => :CL_OUT_OF_RESOURCES,
     -6 => :CL_OUT_OF_HOST_MEMORY,
     -7 => :CL_PROFILING_INFO_NOT_AVAILABLE,
     -8 => :CL_MEM_COPY_OVERLAP,
     -9 => :CL_IMAGE_FORMAT_MISMATCH,
    -10 => :CL_IMAGE_FORMAT_NOT_SUPPORTED,
    -11 => :CL_BUILD_PROGRAM_FAILURE,
    -12 => :CL_MAP_FAILURE,
    -13 => :CL_MISALIGNED_SUB_BUFFER_OFFSET,
    -14 => :CL_EXEC_STATUS_ERROR_FOR_EVENTS_IN_WAIT_LIST,
    -15 => :CL_COMPILE_PROGRAM_FAILURE,
    -15 => :CL_LINKER_NOT_AVAILABLE,
    -17 => :CL_LINK_PROGRAM_FAILURE,
    -18 => :CL_DEVICE_PARTITION_FAILED,
    -19 => :CL_KERNEL_ARG_INFO_NOT_AVAILABLE,

    -30 => :CL_INVALID_VALUE,
    -31 => :CL_INVALID_DEVICE_TYPE,
    -32 => :CL_INVALID_PLATFORM,
    -33 => :CL_INVALID_DEVICE,
    -34 => :CL_INVALID_CONTEXT,
    -35 => :CL_INVALID_QUEUE_PROPERTIES,
    -36 => :CL_INVALID_COMMAND_QUEUE,
    -37 => :CL_INVALID_HOST_PTR,
    -38 => :CL_INVALID_MEM_OBJECT,
    -39 => :CL_INVALID_IMAGE_FORMAT_DESCRIPTOR,
    -40 => :CL_INVALID_IMAGE_SIZE,
    -41 => :CL_INVALID_SAMPLER,
    -42 => :CL_INVALID_BINARY,
    -43 => :CL_INVALID_BUILD_OPTIONS,
    -44 => :CL_INVALID_PROGRAM,
    -45 => :CL_INVALID_PROGRAM_EXECUTABLE,
    -46 => :CL_INVALID_KERNEL_NAME,
    -47 => :CL_INVALID_KERNEL_DEFINITION,
    -48 => :CL_INVALID_KERNEL,
    -49 => :CL_INVALID_ARG_INDEX,
    -50 => :CL_INVALID_ARG_VALUE,
    -51 => :CL_INVALID_ARG_SIZE,
    -52 => :CL_INVALID_KERNEL_ARGS,
    -53 => :CL_INVALID_WORK_DIMENSION,
    -54 => :CL_INVALID_WORK_GROUP_SIZE,
    -55 => :CL_INVALID_WORK_ITEM_SIZE,
    -56 => :CL_INVALID_GLOBAL_OFFSET,
    -57 => :CL_INVALID_EVENT_WAIT_LIST,
    -58 => :CL_INVALID_EVENT,
    -59 => :CL_INVALID_OPERATION,
    -60 => :CL_INVALID_GL_OBJECT,
    -61 => :CL_INVALID_BUFFER_SIZE,
    -62 => :CL_INVALID_MIP_LEVEL,
    -63 => :CL_INVALID_GLOBAL_WORK_SIZE,
    -64 => :CL_INVALID_PROPERTY,
    -65 => :CL_INVALID_IMAGE_DESCRIPTOR,
    -66 => :CL_INVALID_COMPILER_OPTIONS,
    -67 => :CL_INVALID_LINKER_OPTIONS,
    -68 => :CL_INVALID_DEVICE_PARTITION_COUNT,
    -69 => :CL_INVALID_PIPE_SIZE,
    -70 => :CL_INVALID_DEVICE_QUEUE,

    -1000 => :CL_INVALID_GL_SHAREGROUP_REFERENCE_KHR,
    -1001 => :CL_PLATFORM_NOT_FOUND_KHR,
    -1002 => :CL_INVALID_D3D10_DEVICE_KHR,
    -1003 => :CL_INVALID_D3D10_RESOURCE_KHR,
    -1004 => :CL_D3D10_RESOURCE_ALREADY_ACQUIRED_KHR,
    -1005 => :CL_D3D10_RESOURCE_NOT_ACQUIRED_KHR,
    -1006 => :CL_INVALID_D3D11_DEVICE_KHR,
    -1007 => :CL_INVALID_D3D11_RESOURCE_KHR,
    -1008 => :CL_D3D11_RESOURCE_ALREADY_ACQUIRED_KHR,
    -1009 => :CL_D3D11_RESOURCE_NOT_ACQUIRED_KHR,
    -1010 => :CL_INVALID_DX9_MEDIA_ADAPTER_KHR,
    -1011 => :CL_INVALID_DX9_MEDIA_SURFACE_KHR,
    -1012 => :CL_DX9_MEDIA_SURFACE_ALREADY_ACQUIRED_KHR,
    -1013 => :CL_DX9_MEDIA_SURFACE_NOT_ACQUIRED_KHR,

    -1057 => :CL_DEVICE_PARTITION_FAILED_EXT,
    -1058 => :CL_INVALID_PARTITION_COUNT_EXT,
    -1059 => :CL_INVALID_PARTITION_NAME_EXT,

    -1092 => :CL_EGL_RESOURCE_NOT_ACQUIRED_KHR,
    -1093 => :CL_INVALID_EGL_OBJECT_KHR,
)

const _cl_err_desc = Dict{Integer, String}(
    CL_INVALID_CONTEXT =>
    "Context is not a valid context.",

    CL_INVALID_BUFFER_SIZE =>
    "Buffer size is 0",

    CL_INVALID_EVENT =>
    "Event objects specified in event_list are not valid event objects",

    CL_INVALID_HOST_PTR =>
    string("If host_ptr is NULL and CL_MEM_USE_HOST_PTR or ",
           "CL_MEM_COPY_HOST_PTR are set in flags or if host_ptr is not NULL but ",
           "CL_MEM_COPY_HOST_PTR or CL_MEM_USE_HOST_PTR are not set in flags."),

    CL_MEM_OBJECT_ALLOCATION_FAILURE =>
    "Failure to allocate memory for buffer object.",

    CL_OUT_OF_RESOURCES =>
    "Failure to allocate resources required by the OpenCL implementation on the device.",

    CL_OUT_OF_HOST_MEMORY =>
    "Failure to allocate resources required by the OpenCL implementation on the host",

    CL_INVALID_PROGRAM =>
    "Program is not a valid program object.",

    CL_INVALID_VALUE =>
    "CL_INVALID_VALUE: this one should have been caught by julia!",

    CL_INVALID_DEVICE =>
    "OpenCL devices listed in device_list are not in the list of devices associated with program.",

    CL_INVALID_BINARY =>
    string("program is created with clCreateWithProgramBinary and devices listed in ",
           "device_list do not have a valid program binary loaded."),

    CL_INVALID_BUILD_OPTIONS =>
    "The build options specified by options are invalid.",

    CL_INVALID_OPERATION =>
    string("The build of a program executable for any of the devices listed in device_list by a ",
           "previous call to clBuildProgram for program has not  completed."),

    CL_COMPILER_NOT_AVAILABLE =>
    "Program is created with clCreateProgramWithSource and a compiler is not available",

    CL_BUILD_PROGRAM_FAILURE =>
    string("Failure to build the program executable. ",
           "This error will be returned if clBuildProgram ",
           "does not return until the build has completed"),

    CL_INVALID_OPERATION =>
    "There are kernel objects attached to program.",

    CL_OUT_OF_HOST_MEMORY =>
    "if there is a failure to allocate resources required by the OpenCL implementation on the host.",

    CL_EXEC_STATUS_ERROR_FOR_EVENTS_IN_WAIT_LIST =>
    "The execution status of any of the events in event_list is a negative integer value",

    CL_INVALID_PROGRAM_EXECUTABLE =>
    "there is no successfully built executable for program",

    CL_INVALID_KERNEL_NAME =>
    "kernel_name is not found in program.",

    CL_INVALID_KERNEL_DEFINITION =>
    string("The function definition for __kernel  function ",
           "given by kernel_name such as the number of arguments, the argument types are not the ",
           "same for all devices for which the program executable has been built"),

    CL_PROFILING_INFO_NOT_AVAILABLE =>
    string("The CL_QUEUE_PROFILING_ENABLE flag ",
           "is not set for the command-queue, if the execution status of the command identified by ",
           "event is not CL_COMPLETE or if event is a user event objec"),
)

struct CLMemoryError <: Exception
    msg::String
end

Base.show(io::IO, err::CLMemoryError) = Base.print(io, "OpenCL.MemObject: $(err.msg)")

struct OpenCLException <: Exception
    msg::String
end

Base.show(io::IO, err::OpenCLException) = Base.print(io, "OpenCL Error: $(err.msg)")

struct CLError <: Exception
    code::Cint
    desc::Symbol

    function CLError(c::Integer)
        new(c, get(_cl_error_codes, Int(c), :CL_UNKNOWN_ERROR_CODE))
    end
end

Base.show(io::IO, err::CLError) =
        Base.print(io, "CLError(code=$(err.code), $(err.desc))")

function error_description(err::CLError)
    get(_cl_err_desc, err.code, "no description for error $(err.code)")
end

let
    @test_throws ArgumentError cl.Program()
    @test_throws ArgumentError cl.Program(source="", il="")
end

test_source = "
__kernel void sum(__global const float *a,
                  __global const float *b,
                  __global float *c)
{
  uint gid = get_global_id(0);
  c[gid] = a[gid] + b[gid];
}
"

function create_test_program()
    cl.Program(source=test_source)
end

@testset "source constructor" begin
    prg = cl.Program(source=test_source)
    @test prg != nothing
end
@testset "info" begin
    prg = cl.Program(source=test_source)

    @test prg.context == cl.context()

    @test typeof(prg.devices) == Vector{cl.Device}
    @test length(prg.devices) > 0
    @test cl.device() in prg.devices

    @test typeof(prg.source) == String
    @test prg.source == test_source

    @test prg.reference_count > 0
    @test isempty(strip(prg.build_log[cl.device()]))
end

@testset "build" begin
    prg = cl.Program(source=test_source)
    @test cl.build!(prg) != nothing

    @test prg.build_status[cl.device()] == cl.CL_BUILD_SUCCESS
    @test prg.build_log[cl.device()] isa String
end

@testset "source code" begin
   prg = cl.Program(source=test_source)
   @test prg.source == test_source
end

if contains(cl.platform().vendor, "pocl")
    @warn "Skipping binary program tests on $(cl.platform().name)"
else
    @testset "binaries" begin
        prg = cl.Program(source=test_source) |> cl.build!

        @test cl.device() in collect(keys(prg.binaries))
        binaries = prg.binaries
        @test cl.device() in collect(keys(binaries))
        @test binaries[cl.device()] != nothing
        @test length(binaries[cl.device()]) > 0
        prg2 = cl.Program(binaries=binaries)
        @test prg2.binaries == binaries
        @test prg2.source === nothing
    end
end

using SIMD

function call_on_device(f, args...)
    function kernel(res, f, args...)
        res[] = f(args...)
        return
    end
    T = OpenCL.code_typed(() -> f(args...), ())[][2]
    res = CLArray{T, 0}(undef)
    @opencl kernel(res, f, args...)
    return OpenCL.@allowscalar res[]
end

const float_types = filter(x -> x <: Base.IEEEFloat, GPUArraysTestSuite.supported_eltypes(CLArray))
const ispocl = cl.platform().name == "Portable Computing Language"
# XXX: Why does pocl on windows not support vectors of size 2, 8, 16?
const simd_ns = (Sys.iswindows() && ispocl) ? [3, 4] : [2, 3, 4, 8, 16]

@testset "barrier" begin

# work-group
@on_device barrier(OpenCL.LOCAL_MEM_FENCE)
@on_device barrier(OpenCL.GLOBAL_MEM_FENCE)
@on_device barrier(OpenCL.LOCAL_MEM_FENCE | OpenCL.GLOBAL_MEM_FENCE)

@on_device work_group_barrier(OpenCL.LOCAL_MEM_FENCE)
@on_device work_group_barrier(OpenCL.GLOBAL_MEM_FENCE)
@on_device work_group_barrier(OpenCL.IMAGE_MEM_FENCE)

@on_device work_group_barrier(OpenCL.LOCAL_MEM_FENCE | OpenCL.GLOBAL_MEM_FENCE)
@on_device work_group_barrier(OpenCL.LOCAL_MEM_FENCE | OpenCL.IMAGE_MEM_FENCE)
@on_device work_group_barrier(OpenCL.GLOBAL_MEM_FENCE | OpenCL.LOCAL_MEM_FENCE | OpenCL.IMAGE_MEM_FENCE)

@on_device work_group_barrier(OpenCL.LOCAL_MEM_FENCE, OpenCL.memory_scope_work_item)
@on_device work_group_barrier(OpenCL.LOCAL_MEM_FENCE, OpenCL.memory_scope_work_group)
@on_device work_group_barrier(OpenCL.LOCAL_MEM_FENCE, OpenCL.memory_scope_device)
cl.memory_backend() isa cl.SVMBackend && @on_device work_group_barrier(OpenCL.LOCAL_MEM_FENCE, OpenCL.memory_scope_all_svm_devices)
cl.sub_groups_supported(cl.device()) && @on_device work_group_barrier(OpenCL.LOCAL_MEM_FENCE, OpenCL.memory_scope_sub_group)

# sub-group (only when the device supports subgroups)
if cl.sub_groups_supported(cl.device())
    @on_device sub_group_barrier(OpenCL.LOCAL_MEM_FENCE)
    @on_device sub_group_barrier(OpenCL.GLOBAL_MEM_FENCE)
    @on_device sub_group_barrier(OpenCL.LOCAL_MEM_FENCE | OpenCL.GLOBAL_MEM_FENCE)
end
end

@testset "mem_fence" begin

@on_device mem_fence(OpenCL.LOCAL_MEM_FENCE)
@on_device mem_fence(OpenCL.GLOBAL_MEM_FENCE)
@on_device mem_fence(OpenCL.LOCAL_MEM_FENCE | OpenCL.GLOBAL_MEM_FENCE)

@on_device read_mem_fence(OpenCL.LOCAL_MEM_FENCE)
@on_device read_mem_fence(OpenCL.GLOBAL_MEM_FENCE)
@on_device read_mem_fence(OpenCL.LOCAL_MEM_FENCE | OpenCL.GLOBAL_MEM_FENCE)

@on_device write_mem_fence(OpenCL.LOCAL_MEM_FENCE)
@on_device write_mem_fence(OpenCL.GLOBAL_MEM_FENCE)
@on_device write_mem_fence(OpenCL.LOCAL_MEM_FENCE | OpenCL.GLOBAL_MEM_FENCE)

end

@testset "atomic_work_item_fence" begin

@on_device atomic_work_item_fence(OpenCL.LOCAL_MEM_FENCE, OpenCL.memory_order_relaxed, OpenCL.memory_scope_work_item)
@on_device atomic_work_item_fence(OpenCL.GLOBAL_MEM_FENCE, OpenCL.memory_order_acquire, OpenCL.memory_scope_work_group)
@on_device atomic_work_item_fence(OpenCL.IMAGE_MEM_FENCE, OpenCL.memory_order_release, OpenCL.memory_scope_device)
cl.memory_backend() isa cl.SVMBackend && @on_device atomic_work_item_fence(OpenCL.LOCAL_MEM_FENCE, OpenCL.memory_order_acq_rel, OpenCL.memory_scope_all_svm_devices)
@on_device atomic_work_item_fence(OpenCL.GLOBAL_MEM_FENCE, OpenCL.memory_order_seq_cst, OpenCL.memory_scope_sub_group)
@on_device atomic_work_item_fence(OpenCL.IMAGE_MEM_FENCE | OpenCL.LOCAL_MEM_FENCE, OpenCL.memory_order_acquire, OpenCL.memory_scope_sub_group)

end

@testset "math" begin

@testset "unary - $T" for T in float_types
    @testset "$f" for f in [
            acos, acosh,
            asin, asinh,
            atan, atanh,
            cbrt,
            ceil,
            cos, cosh, cospi,
            exp, exp2, exp10, expm1,
            abs,
            floor,
            log, log2, log10, log1p,
            round,
            sin, sinh, sinpi,
            sqrt,
            tan, tanh, tanpi,
            trunc,
        ]
        x = rand(T)
        if f == acosh
            x += 1
        end
        @test call_on_device(f, x) ≈ f(x)
    end
end

@testset "binary - $T" for T in float_types
    @testset "$f" for f in [
            atan,
            copysign,
            max,
            min,
            hypot,
            (^),
        ]
        x = rand(T)
        y = rand(T)
        @test call_on_device(f, x, y) ≈ f(x, y)
    end
end

@testset "ternary - $T" for T in float_types
    @testset "$f" for f in [
            fma,
        ]
        x = rand(T)
        y = rand(T)
        z = rand(T)
        @test call_on_device(f, x, y, z) ≈ f(x, y, z)
    end
end

# Regression test for #428: `^(::Float, ::Int64)` must not truncate the
# exponent through Int32, since `y % Int32` wraps for |y| ≥ 2^31 and would
# flip the sign of the exponent (producing 0 instead of Inf, etc.).
@testset "^(::$T, ::Int64) with out-of-Int32 exponent" for T in float_types
    y = Int64(typemax(Int32)) + Int64(1)  # smallest Int64 not representable as Int32
    for x in (T(1.5), T(0.5))
        @test call_on_device(^, x, y) === x ^ y
        @test call_on_device(^, x, -y) === x ^ -y
    end
end

@testset "OpenCL-specific unary - $T" for T in float_types
    @testset "$f" for f in [
            OpenCL.acospi,
            OpenCL.asinpi,
            OpenCL.atanpi,
            OpenCL.logb,
            OpenCL.rint,
            OpenCL.rsqrt,
        ]
        x = rand(T)
        @test call_on_device(f, x) isa Real  # Just check it doesn't error
    end
    @test call_on_device(OpenCL.ilogb, T(8.0)) isa Int32
    @test call_on_device(OpenCL.nan, Base.uinttype(T)(0)) isa T
end

@testset "OpenCL-specific binary - $T" for T in float_types
    @testset "$f" for f in [
            OpenCL.atanpi,
            OpenCL.dim,
            OpenCL.maxmag,
            OpenCL.minmag,
            OpenCL.nextafter,
            OpenCL.powr,
        ]
        x = rand(T)
        y = rand(T)
        @test call_on_device(f, x, y) isa Real  # Just check it doesn't error
    end
    @test call_on_device(OpenCL.rootn, T(8.0), Int32(3)) ≈ T(2.0)
end

@testset "OpenCL-specific ternary - $T" for T in float_types
    x = rand(T)
    y = rand(T)
    z = rand(T)
    @test call_on_device(OpenCL.mad, x, y, z) ≈ x * y + z
end

if cl.sub_groups_supported(cl.device())

struct SubgroupData
    sub_group_size::UInt32
    max_sub_group_size::UInt32
    num_sub_groups::UInt32
    sub_group_id::UInt32
    sub_group_local_id::UInt32
end
function test_subgroup_kernel(results)
    i = get_global_id(1)

    if i <= length(results)
        @inbounds results[i] = SubgroupData(
            get_sub_group_size(),
            get_max_sub_group_size(),
            get_num_sub_groups(),
            get_sub_group_id(),
            get_sub_group_local_id()
        )
    end
    return
end

cl.sub_groups_supported(cl.device()) && @testset "Sub-groups" begin
    sg_size = cl.sub_group_size(cl.device())

    @testset "Indexing intrinsics" begin
        # Test with small kernel
        sg_n = 2
        local_size = sg_size * sg_n
        numworkgroups = 2
        N = local_size * numworkgroups

        results = CLVector{SubgroupData}(undef, N)
        kernel = @opencl launch = false test_subgroup_kernel(results)

        kernel(results; local_size, global_size=N)

        host_results = Array(results)

        # Verify results make sense
        for (i, sg_data) in enumerate(host_results)
            @test sg_data.sub_group_size == sg_size
            @test sg_data.max_sub_group_size == sg_size
            @test sg_data.num_sub_groups == sg_n

            # Group ID should be 1-based
            expected_sub_group = div(((i - 1) % local_size), sg_size) + 1
            @test sg_data.sub_group_id == expected_sub_group

            # Local ID should be 1-based within group
            expected_sg_local = ((i - 1) % sg_size) + 1
            @test sg_data.sub_group_local_id == expected_sg_local
        end
    end

    @testset "shuffle idx" begin
        function shfl_idx_kernel(d)
            i = get_sub_group_local_id()
            j = get_sub_group_size() - i + 0x1

            d[i] = sub_group_shuffle(d[i], j)

            return
        end

        @testset for T in cl.sub_group_shuffle_supported_types(cl.device())
            a = rand(T, sg_size)
            d_a = CLArray(a)
            @opencl local_size = sg_size global_size = sg_size shfl_idx_kernel(d_a)
            @test Array(d_a) == reverse(a)
        end
    end
    @testset "shuffle xor" begin
        function shfl_xor_kernel(in)
            i = get_sub_group_local_id()

            new_val = sub_group_shuffle_xor(in[i], 1)

            in[i] = new_val
            return
        end

        # tests that each pair of values a get swapped using sub_group_shuffle_xor
        @testset for T in cl.sub_group_shuffle_supported_types(cl.device())
            in = rand(T, sg_size)
            idxs = xor.(0:(sg_size - 1), 1) .+ 1
            d_in = CLArray(in)
            @opencl local_size = sg_size global_size = sg_size shfl_xor_kernel(d_in)
            @test Array(d_in) == in[idxs]
        end
    end
end
end # if cl.sub_groups_supported(cl.device())

@testset "SIMD - $N x $T" for N in simd_ns, T in float_types
    # codegen emits i48 here, which SPIR-V doesn't support
    # XXX: fix upstream?
    T == Float16 && N == 3 && continue

    v = Vec{N, T}(ntuple(_ -> rand(T), N))

    # unary ops: sin, cos, sqrt
    a = call_on_device(sin, v)
    @test all(a[i] ≈ sin(v[i]) for i in 1:N)

    b = call_on_device(cos, v)
    @test all(b[i] ≈ cos(v[i]) for i in 1:N)

    c = call_on_device(sqrt, v)
    @test all(c[i] ≈ sqrt(v[i]) for i in 1:N)

    # binary ops: max, hypot
    w = Vec{N, T}(ntuple(_ -> rand(T), N))
    d = call_on_device(max, v, w)
    @test all(d[i] == max(v[i], w[i]) for i in 1:N)

    h = call_on_device(hypot, v, w)
    @test all(h[i] ≈ hypot(v[i], w[i]) for i in 1:N)

    # ternary op: fma
    x = Vec{N, T}(ntuple(_ -> rand(T), N))
    e = call_on_device(fma, v, w, x)
    @test all(e[i] ≈ fma(v[i], w[i], x[i]) for i in 1:N)

    # special cases: ilogb, ldexp, ^ with Int32, rootn
    v_pos = Vec{N, T}(ntuple(_ -> rand(T) + T(1), N))
    @test call_on_device(OpenCL.ilogb, v_pos) isa Vec{N, Int32}

    k = Vec{N, Int32}(ntuple(_ -> rand(Int32.(-5:5)), N))
    @test let
        ldexp_result = call_on_device(ldexp, v_pos, k)
        all(ldexp_result[i] ≈ ldexp(v_pos[i], k[i]) for i in 1:N)
    end

    base = Vec{N, T}(ntuple(_ -> rand(T) + T(0.5), N))
    exp_int = Vec{N, Int32}(ntuple(_ -> rand(Int32.(0:3)), N))
    @test let
        pow_result = call_on_device(^, base, exp_int)
        all(pow_result[i] ≈ base[i] ^ exp_int[i] for i in 1:N)
    end

    rootn_base = Vec{N, T}(ntuple(_ -> rand(T) * T(10) + T(1), N))
    rootn_n = Vec{N, Int32}(ntuple(_ -> rand(Int32.(2:4)), N))
    @test call_on_device(OpenCL.rootn, rootn_base, rootn_n) isa Vec{N, T}

    # special cases: nan
    nan_code = Vec{N, Base.uinttype(T)}(ntuple(_ -> rand(Base.uinttype(T)), N))
    nan_result = call_on_device(OpenCL.nan, nan_code)
    @test all(isnan(nan_result[i]) for i in 1:N)
end

end

# Math Functions

using Base: @assume_effects

# TODO: vector types
const generic_types = [Float16, Float32, Float64]
const generic_types_float = [Float32]
const generic_types_double = [Float64]


# generically typed

for gentype in generic_types
@eval begin

@device_override Base.acos(x::$gentype) = @builtin_ccall("acos", $gentype, ($gentype,), x)
@device_override Base.acosh(x::$gentype) = @builtin_ccall("acosh", $gentype, ($gentype,), x)
@device_function acospi(x::$gentype) = @builtin_ccall("acospi", $gentype, ($gentype,), x)

@device_override Base.asin(x::$gentype) = @builtin_ccall("asin", $gentype, ($gentype,), x)
@device_override Base.asinh(x::$gentype) = @builtin_ccall("asinh", $gentype, ($gentype,), x)
@device_function asinpi(x::$gentype) = @builtin_ccall("asinpi", $gentype, ($gentype,), x)

@device_override Base.atan(y_over_x::$gentype) = @builtin_ccall("atan", $gentype, ($gentype,), y_over_x)
@device_override Base.atan(y::$gentype, x::$gentype) = @builtin_ccall("atan2", $gentype, ($gentype, $gentype), y, x)
@device_override Base.atanh(x::$gentype) = @builtin_ccall("atanh", $gentype, ($gentype,), x)
@device_function atanpi(x::$gentype) = @builtin_ccall("atanpi", $gentype, ($gentype,), x)
@device_function atanpi(y::$gentype, x::$gentype) = @builtin_ccall("atan2pi", $gentype, ($gentype, $gentype), y, x)

@device_override Base.cbrt(x::$gentype) = @builtin_ccall("cbrt", $gentype, ($gentype,), x)

@device_override Base.ceil(x::$gentype) = @builtin_ccall("ceil", $gentype, ($gentype,), x)

@device_override Base.copysign(x::$gentype, y::$gentype) = @builtin_ccall("copysign", $gentype, ($gentype, $gentype), x, y)

@device_override Base.cos(x::$gentype) = @builtin_ccall("cos", $gentype, ($gentype,), x)
@device_override Base.cosh(x::$gentype) = @builtin_ccall("cosh", $gentype, ($gentype,), x)
@device_override Base.cospi(x::$gentype) = @builtin_ccall("cospi", $gentype, ($gentype,), x)

@device_override SpecialFunctions.erfc(x::$gentype) = @builtin_ccall("erfc", $gentype, ($gentype,), x)
@device_override SpecialFunctions.erf(x::$gentype) = @builtin_ccall("erf", $gentype, ($gentype,), x)

@device_override Base.exp(x::$gentype) = @builtin_ccall("exp", $gentype, ($gentype,), x)
@device_override Base.exp2(x::$gentype) = @builtin_ccall("exp2", $gentype, ($gentype,), x)
@device_override Base.exp10(x::$gentype) = @builtin_ccall("exp10", $gentype, ($gentype,), x)
@device_override Base.expm1(x::$gentype) = @builtin_ccall("expm1", $gentype, ($gentype,), x)

@device_override Base.abs(x::$gentype) = @builtin_ccall("fabs", $gentype, ($gentype,), x)

@device_function dim(x::$gentype, y::$gentype) = @builtin_ccall("fdim", $gentype, ($gentype, $gentype), x, y)

@device_override Base.floor(x::$gentype) = @builtin_ccall("floor", $gentype, ($gentype,), x)

@device_override Base.fma(a::$gentype, b::$gentype, c::$gentype) = @builtin_ccall("fma", $gentype, ($gentype, $gentype, $gentype), a, b, c)

@device_override Base.max(x::$gentype, y::$gentype) = @builtin_ccall("fmax", $gentype, ($gentype, $gentype), x, y)

@device_override Base.min(x::$gentype, y::$gentype) = @builtin_ccall("fmin", $gentype, ($gentype, $gentype), x, y)

# NOTE: Julia's mod behaves differently than fmod
#@device_override Base.mod(x::$gentype, y::$gentype) = @builtin_ccall("fmod", $gentype, ($gentype, $gentype), x, y)
# fract(x::$gentype, $gentype *iptr) = @builtin_ccall("fract", $gentype, ($gentype, $gentype *), x, iptr)

# TODO: remove once https://github.com/pocl/pocl/issues/2034 is addressed
if $gentype != Float16
    @device_override Base.hypot(x::$gentype, y::$gentype) = @builtin_ccall("hypot", $gentype, ($gentype, $gentype), x, y)
end

@device_override SpecialFunctions.loggamma(x::$gentype) = @builtin_ccall("lgamma", $gentype, ($gentype,), x)

@device_override Base.log(x::$gentype) = @builtin_ccall("log", $gentype, ($gentype,), x)
@device_override Base.log2(x::$gentype) = @builtin_ccall("log2", $gentype, ($gentype,), x)
@device_override Base.log10(x::$gentype) = @builtin_ccall("log10", $gentype, ($gentype,), x)
@device_override Base.log1p(x::$gentype) = @builtin_ccall("log1p", $gentype, ($gentype,), x)
@device_function logb(x::$gentype) = @builtin_ccall("logb", $gentype, ($gentype,), x)

@device_function mad(a::$gentype, b::$gentype, c::$gentype) = @builtin_ccall("mad", $gentype, ($gentype, $gentype, $gentype), a, b, c)

@device_function maxmag(x::$gentype, y::$gentype) = @builtin_ccall("maxmag", $gentype, ($gentype, $gentype), x, y)
@device_function minmag(x::$gentype, y::$gentype) = @builtin_ccall("minmag", $gentype, ($gentype, $gentype), x, y)

# modf(x::$gentype, $gentype *iptr) = @builtin_ccall("modf", $gentype, ($gentype, $gentype *), x, iptr)

@device_function nextafter(x::$gentype, y::$gentype) = @builtin_ccall("nextafter", $gentype, ($gentype, $gentype), x, y)

@device_override Base.:(^)(x::$gentype, y::$gentype) = @builtin_ccall("pow", $gentype, ($gentype, $gentype), x, y)
@device_function powr(x::$gentype, y::$gentype) = @builtin_ccall("powr", $gentype, ($gentype, $gentype), x, y)

@device_function rint(x::$gentype) = @builtin_ccall("rint", $gentype, ($gentype,), x)

@device_override Base.round(x::$gentype) = @builtin_ccall("round", $gentype, ($gentype,), x)

@device_function rsqrt(x::$gentype) = @builtin_ccall("rsqrt", $gentype, ($gentype,), x)

@device_override Base.sin(x::$gentype) = @builtin_ccall("sin", $gentype, ($gentype,), x)
@device_override function Base.sincos(x::$gentype)
    cosval = Ref{$gentype}()
    sinval = GC.@preserve cosval begin
        ptr = Base.unsafe_convert(Ptr{$gentype}, cosval)
        llvm_ptr = reinterpret(LLVMPtr{$gentype, AS.Function}, ptr)
        @builtin_ccall("sincos", $gentype, ($gentype, LLVMPtr{$gentype, AS.Function}), x, llvm_ptr)
    end
    return sinval, cosval[]
end
@device_override Base.sinh(x::$gentype) = @builtin_ccall("sinh", $gentype, ($gentype,), x)
@device_override Base.sinpi(x::$gentype) = @builtin_ccall("sinpi", $gentype, ($gentype,), x)

@device_override Base.sqrt(x::$gentype) = @builtin_ccall("sqrt", $gentype, ($gentype,), x)

@device_override Base.tan(x::$gentype) = @builtin_ccall("tan", $gentype, ($gentype,), x)
@device_override Base.tanh(x::$gentype) = @builtin_ccall("tanh", $gentype, ($gentype,), x)
@device_override Base.tanpi(x::$gentype) = @builtin_ccall("tanpi", $gentype, ($gentype,), x)

@device_override SpecialFunctions.gamma(x::$gentype) = @builtin_ccall("tgamma", $gentype, ($gentype,), x)

@device_override Base.trunc(x::$gentype) = @builtin_ccall("trunc", $gentype, ($gentype,), x)

end
end


# generically typed -- only floats

for gentypef in generic_types_float

if gentypef !== Float32
@eval begin
@device_override Base.max(x::$gentypef, y::Float32) = @builtin_ccall("fmax", $gentypef, ($gentypef, Float32), x, y)
@device_override Base.min(x::$gentypef, y::Float32) = @builtin_ccall("fmin", $gentypef, ($gentypef, Float32), x, y)
end
end

end


# generically typed -- only doubles

for gentyped in generic_types_double

if gentyped !== Float64
@eval begin
@device_override Base.min(x::$gentyped, y::Float64) = @builtin_ccall("fmin", $gentyped, ($gentyped, Float64), x, y)
@device_override Base.max(x::$gentyped, y::Float64) = @builtin_ccall("fmax", $gentyped, ($gentyped, Float64), x, y)
end
end

end


# specifically typed

# frexp(x::Float32{n}, Int32{n} *exp) = @builtin_ccall("frexp", Float32{n}, (Float32{n}, Int32{n} *), x, exp)
# frexp(x::Float32, Int32 *exp) = @builtin_ccall("frexp", Float32, (Float32, Int32 *), x, exp)
# frexp(x::Float64{n}, Int32{n} *exp) = @builtin_ccall("frexp", Float64{n}, (Float64{n}, Int32{n} *), x, exp)
# frexp(x::Float64, Int32 *exp) = @builtin_ccall("frexp", Float64, (Float64, Int32 *), x, exp)

@device_function ilogb(x::Float16) = @builtin_ccall("ilogb", Int32, (Float16,), x)
# ilogb(x::Float32{n}) = @builtin_ccall("ilogb", Int32{n}, (Float32{n},), x)
@device_function ilogb(x::Float32) = @builtin_ccall("ilogb", Int32, (Float32,), x)
# ilogb(x::Float64{n}) = @builtin_ccall("ilogb", Int32{n}, (Float64{n},), x)
@device_function ilogb(x::Float64) = @builtin_ccall("ilogb", Int32, (Float64,), x)

@device_override Base.ldexp(x::Float16, k::Int32) = @builtin_ccall("ldexp", Float16, (Float16, Int32), x, k)
# ldexp(x::Float32{n}, k::Int32{n}) = @builtin_ccall("ldexp", Float32{n}, (Float32{n}, Int32{n}), x, k)
# ldexp(x::Float32{n}, k::Int32) = @builtin_ccall("ldexp", Float32{n}, (Float32{n}, Int32), x, k)
@device_override Base.ldexp(x::Float32, k::Int32) = @builtin_ccall("ldexp", Float32, (Float32, Int32), x, k)
# ldexp(x::Float64{n}, k::Int32{n}) = @builtin_ccall("ldexp", Float64{n}, (Float64{n}, Int32{n}), x, k)
# ldexp(x::Float64{n}, k::Int32) = @builtin_ccall("ldexp", Float64{n}, (Float64{n}, Int32), x, k)
@device_override Base.ldexp(x::Float64, k::Int32) = @builtin_ccall("ldexp", Float64, (Float64, Int32), x, k)

# lgamma_r(x::Float32{n}, Int32{n} *signp) = @builtin_ccall("lgamma_r", Float32{n}, (Float32{n}, Int32{n} *), x, signp)
# lgamma_r(x::Float32, Int32 *signp) = @builtin_ccall("lgamma_r", Float32, (Float32, Int32 *), x, signp)
# lgamma_r(x::Float64{n}, Int32{n} *signp) = @builtin_ccall("lgamma_r", Float64{n}, (Float64{n}, Int32{n} *), x, signp)
# Float64 lgamma_r(x::Float64, Int32 *signp) = @builtin_ccall("lgamma_r", Float64, (Float64, Int32 *), x, signp)

@device_function nan(nancode::UInt16) = @builtin_ccall("nan", Float16, (UInt16,), nancode)
# nan(nancode::uintn) = @builtin_ccall("nan", Float32{n}, (uintn,), nancode)
@device_function nan(nancode::UInt32) = @builtin_ccall("nan", Float32, (UInt32,), nancode)
# nan(nancode::UInt64{n}) = @builtin_ccall("nan", Float64{n}, (UInt64{n},), nancode)
@device_function nan(nancode::UInt64) = @builtin_ccall("nan", Float64, (UInt64,), nancode)

@device_override Base.:(^)(x::Float16, y::Int32) = @builtin_ccall("pown", Float16, (Float16, Int32), x, y)
# pown(x::Float32{n}, y::Int32{n}) = @builtin_ccall("pown", Float32{n}, (Float32{n}, Int32{n}), x, y)
@device_override Base.:(^)(x::Float32, y::Int32) = @builtin_ccall("pown", Float32, (Float32, Int32), x, y)
# pown(x::Float64{n}, y::Int32{n}) = @builtin_ccall("pown", Float64{n}, (Float64{n}, Int32{n}), x, y)
@device_override Base.:(^)(x::Float64, y::Int32) = @builtin_ccall("pown", Float64, (Float64, Int32), x, y)

# Base's `^(::Union{Float16,Float32,Float64}, ::Int64)` widens Float32/16
# through Float64 (broken on backends without FP64) and in all cases leaves a
# runtime `pown` in the generated code. Mark the override `:foldable` so
# literal expressions like `Float32(2)^(-32)` const-fold to a compile-time
# constant, and fall back to the float-exponent `pow` for the tail (matches
# Base's own fallback for out-of-range integer exponents since 1.12; see
# `base/special/pow.jl`).
@device_override @assume_effects :foldable @inline function Base.:(^)(x::Float16, y::Int64)
    y == -1 && return inv(x)
    y == 0  && return one(x)
    y == 1  && return x
    y == 2  && return x * x
    y == 3  && return x * x * x
    x ^ Float16(y)
end
@device_override @assume_effects :foldable @inline function Base.:(^)(x::Float32, y::Int64)
    y == -1 && return inv(x)
    y == 0  && return one(x)
    y == 1  && return x
    y == 2  && return x * x
    y == 3  && return x * x * x
    x ^ Float32(y)
end
@device_override @assume_effects :foldable @inline function Base.:(^)(x::Float64, y::Int64)
    y == -1 && return inv(x)
    y == 0  && return one(x)
    y == 1  && return x
    y == 2  && return x * x
    y == 3  && return x * x * x
    x ^ Float64(y)
end

# remquo(x::Float32{n}, y::Float32{n}, Int32{n} *quo) = @builtin_ccall("remquo", Float32{n}, (Float32{n}, Float32{n}, Int32{n} *), x, y, quo)
# remquo(x::Float32, y::Float32, Int32 *quo) = @builtin_ccall("remquo", Float32, (Float32, Float32, Int32 *), x::Float32, y, quo)
# remquo(x::Float64{n}, y::Float64{n}, Int32{n} *quo) = @builtin_ccall("remquo", Float64{n}, (Float64{n}, Float64{n}, Int32{n} *), x, y, quo)
# remquo(x::Float64, y::Float64, Int32 *quo) = @builtin_ccall("remquo", Float64, (Float64, Float64, Int32 *), x, y, quo)

@device_function rootn(x::Float16, y::Int32) = @builtin_ccall("rootn", Float16, (Float16, Int32), x, y)
# rootn(x::Float32{n}, y::Int32{n}) = @builtin_ccall("rootn", Float32{n}, (Float32{n}, Int32{n}), x, y)
@device_function rootn(x::Float32, y::Int32) = @builtin_ccall("rootn", Float32, (Float32, Int32), x, y)
# rootn(x::Float64{n}, y::Int32{n}) = @builtin_ccall("rootn", Float64{n}, (Float64{n}, Int32{n}), x, y)
@device_function rootn(x::Float64, y::Int32) = @builtin_ccall("rootn", Float64, (Float64, Int32), x, y)


# TODO: half and native

function _mulhi(a::Int64, b::Int64)
    shift = sizeof(a) * 4
    mask = typemax(UInt32)
    a1, a2 = (a >> shift), a & mask
    b1, b2 = (b >> shift), b & mask
    a1b1, a1b2, a2b1 = a1*b1, a1*b2, a2*b1
    t1 = a1b2 + _mulhi(a2 % UInt32, b2 % UInt32)
    t2 = a2b1 + (t1 & mask)
    a1b1 + (t1 >> shift) + (t2 >> shift)
end
@static if isdefined(Base.MultiplicativeInverses, :_mul_high)
    _mulhi(a::T, b::T) where {T<:Union{Signed, Unsigned}} = Base.MultiplicativeInverses._mul_high(a, b)
    @device_override Base.MultiplicativeInverses._mul_high(a::Int64, b::Int64) = _mulhi(a, b)
else
    _mulhi(a::T, b::T) where {T<:Union{Signed, Unsigned}} = ((widen(a)*b) >>> (sizeof(a)*8)) % T
    @device_override function Base.div(a::Int64, b::Base.MultiplicativeInverses.SignedMultiplicativeInverse{Int64})
        x = _mulhi(a, b.multiplier)
        x += (a*b.addmul) % Int64
        ifelse(abs(b.divisor) == 1, a*b.divisor, (signbit(x) + (x >> b.shift)) % Int64)
    end
end

export CLArray, CLVector, CLMatrix, CLVecOrMat,
       device_accessible, host_accessible


## array type

function hasfieldcount(@nospecialize(dt))
    try
        fieldcount(dt)
    catch
        return false
    end
    return true
end

function contains_eltype(T, X)
    if T === X
        return true
    elseif T isa Union
        for U in Base.uniontypes(T)
            contains_eltype(U, X) && return true
        end
    elseif hasfieldcount(T)
        for U in fieldtypes(T)
            contains_eltype(U, X) && return true
        end
    end
    return false
end

function check_eltype(T)
    Base.allocatedinline(T) || error("CLArray only supports element types that are stored inline")
    Base.isbitsunion(T) && error("CLArray does not yet support isbits-union arrays")
    !("cl_khr_fp16" in cl.device().extensions) && contains_eltype(T, Float16) && error("Float16 is not supported on this device")
    return !("cl_khr_fp64" in cl.device().extensions) && contains_eltype(T, Float64) && error("Float64 is not supported on this device")
end

mutable struct CLArray{T, N, M} <: AbstractGPUArray{T, N}
    data::DataRef{Managed{M}}

    maxsize::Int  # maximum data size; excluding any selector bytes
    offset::Int   # offset of the data in memory, in bytes

    dims::Dims{N}

    function CLArray{T, N, M}(::UndefInitializer, dims::Dims{N}) where {T, N, M}
        check_eltype(T)
        maxsize = prod(dims) * sizeof(T)
        bufsize = if Base.isbitsunion(T)
            # type tag array past the data
            maxsize + prod(dims)
        else
            maxsize
        end
        data = GPUArrays.cached_alloc((CLArray, cl.context(), M, bufsize)) do
            buf = managed_alloc(M, bufsize; alignment=Base.datatype_alignment(T))
            DataRef(free, buf)
        end
        obj = new{T, N, M}(data, maxsize, 0, dims)
        finalizer(unsafe_free!, obj)
        return obj
    end

    function CLArray{T, N}(
            data::DataRef{Managed{M}}, dims::Dims{N};
            maxsize::Int = prod(dims) * sizeof(T), offset::Int = 0
        ) where {T, N, M}
        check_eltype(T)
        obj = new{T, N, M}(data, maxsize, offset, dims)
        return finalizer(unsafe_free!, obj)
    end
end

GPUArrays.storage(a::CLArray) = a.data


## alias detection

Base.dataids(A::CLArray) = (UInt(pointer(A)),)

Base.unaliascopy(A::CLArray) = copy(A)

function Base.mightalias(A::CLArray, B::CLArray)
    rA = pointer(A):(pointer(A) + sizeof(A))
    rB = pointer(B):(pointer(B) + sizeof(B))
    return first(rA) <= first(rB) < last(rA) || first(rB) <= first(rA) < last(rB)
end


## convenience constructors

const CLVector{T} = CLArray{T, 1}
const CLMatrix{T} = CLArray{T, 2}
const CLVecOrMat{T} = Union{CLVector{T}, CLMatrix{T}}

# default to non-unified memory
function memory_type()
    if cl.memory_backend() == cl.USMBackend()
        return cl.UnifiedDeviceMemory
    elseif cl.memory_backend() == cl.SVMBackend()
        return cl.SharedVirtualMemory
    elseif cl.memory_backend() == cl.BufferBackend()
        return cl.Buffer
    end
end
CLArray{T, N}(::UndefInitializer, dims::Dims{N}) where {T, N} =
    CLArray{T, N, memory_type()}(undef, dims)

# buffer, type and dimensionality specified
CLArray{T, N, M}(::UndefInitializer, dims::NTuple{N, Integer}) where {T, N, M} =
    CLArray{T, N, M}(undef, convert(Tuple{Vararg{Int}}, dims))
CLArray{T, N, M}(::UndefInitializer, dims::Vararg{Integer, N}) where {T, N, M} =
    CLArray{T, N, M}(undef, convert(Tuple{Vararg{Int}}, dims))

# type and dimensionality specified
CLArray{T, N}(::UndefInitializer, dims::NTuple{N, Integer}) where {T, N} =
    CLArray{T, N}(undef, convert(Tuple{Vararg{Int}}, dims))
CLArray{T, N}(::UndefInitializer, dims::Vararg{Integer, N}) where {T, N} =
    CLArray{T, N}(undef, convert(Tuple{Vararg{Int}}, dims))

# type but not dimensionality specified
CLArray{T}(::UndefInitializer, dims::NTuple{N, Integer}) where {T, N} =
    CLArray{T, N}(undef, convert(Tuple{Vararg{Int}}, dims))
CLArray{T}(::UndefInitializer, dims::Vararg{Integer, N}) where {T, N} =
    CLArray{T, N}(undef, convert(Tuple{Vararg{Int}}, dims))

# empty vector constructor
CLArray{T, 1, M}() where {T, M} = CLArray{T, 1, M}(undef, 0)
CLArray{T, 1}() where {T} = CLArray{T, 1}(undef, 0)

# do-block constructors
for (ctor, tvars) in (
        :CLArray => (),
        :(CLArray{T}) => (:T,),
        :(CLArray{T, N}) => (:T, :N),
        :(CLArray{T, N, M}) => (:T, :N, :M),
    )
    @eval begin
        function $ctor(f::Function, args...) where {$(tvars...)}
            xs = $ctor(args...)
            return try
                f(xs)
            finally
                unsafe_free!(xs)
            end
        end
    end
end

Base.similar(a::CLArray{T, N, M}) where {T, N, M} =
    CLArray{T, N, M}(undef, size(a))
Base.similar(a::CLArray{T, <:Any, M}, dims::Base.Dims{N}) where {T, N, M} =
    CLArray{T, N, M}(undef, dims)
Base.similar(a::CLArray{<:Any, <:Any, M}, ::Type{T}, dims::Base.Dims{N}) where {T, N, M} =
    CLArray{T, N, M}(undef, dims)

function Base.copy(a::CLArray{T, N}) where {T, N}
    b = similar(a)
    return @inbounds copyto!(b, a)
end

function Base.deepcopy_internal(x::CLArray, dict::IdDict)
    haskey(dict, x) && return dict[x]::typeof(x)
    return dict[x] = copy(x)
end

## array interface

Base.elsize(::Type{<:CLArray{T}}) where {T} = sizeof(T)

Base.size(x::CLArray) = x.dims
Base.sizeof(x::CLArray) = Base.elsize(x) * length(x)

context(A::CLArray) = cl.context(A.data[].mem)

memtype(x::CLArray) = memtype(typeof(x))
memtype(::Type{<:CLArray{<:Any, <:Any, M}}) where {M} = @isdefined(M) ? M : Any

# can we read this array from the device (i.e. derive a CLPtr)?
device_accessible(a::CLArray) =
    memtype(a) in (cl.UnifiedDeviceMemory, cl.UnifiedSharedMemory, cl.SharedVirtualMemory, cl.Buffer)
host_accessible(a::CLArray) =
    memtype(a) in (cl.UnifiedHostMemory, cl.UnifiedSharedMemory, cl.SharedVirtualMemory)


## derived types

export DenseCLArray, DenseCLVector, DenseCLMatrix, DenseCLVecOrMat,
    StridedCLArray, StridedCLVector, StridedCLMatrix, StridedCLVecOrMat,
    WrappedCLArray, WrappedCLVector, WrappedCLMatrix, WrappedCLVecOrMat

# dense arrays: stored contiguously in memory
#
# all common dense wrappers are currently represented as CLArray objects.
# this simplifies common use cases, and greatly improves load time.
# cl.jl 2.0 experimented with using ReshapedArray/ReinterpretArray/SubArray,
# but that proved much too costly. TODO: revisit when we have better Base support.
const DenseCLArray{T, N} = CLArray{T, N}
const DenseCLVector{T} = DenseCLArray{T, 1}
const DenseCLMatrix{T} = DenseCLArray{T, 2}
const DenseCLVecOrMat{T} = Union{DenseCLVector{T}, DenseCLMatrix{T}}
# XXX: these dummy aliases (DenseCLArray=CLArray) break alias printing, as
#      `Base.print_without_params` only handles the case of a single alias.

# strided arrays
const StridedSubCLArray{
    T, N, M, I <: Tuple{
        Vararg{
            Union{
                Base.RangeIndex, Base.ReshapedUnitRange,
                Base.AbstractCartesianIndex,
            },
        },
    },
} =
    SubArray{T, N, <:CLArray{<:Any,<:Any,M}, I}
const StridedCLArray{T, N, M} = Union{CLArray{T, N, M}, StridedSubCLArray{T, N, M}}
const StridedCLVector{T, M} = StridedCLArray{T, 1, M}
const StridedCLMatrix{T, M} = StridedCLArray{T, 2, M}
const StridedCLVecOrMat{T, M} = Union{StridedCLVector{T, M}, StridedCLMatrix{T, M}}

@inline device_pointer(x::StridedCLArray{T}, i::Integer = 1) where {T} =
    Base.unsafe_convert(CLPtr{T}, x) + Base._memory_offset(x, i)
@inline host_pointer(x::StridedCLArray{T}, i::Integer = 1) where {T} =
    Base.unsafe_convert(Ptr{T}, x) + Base._memory_offset(x, i)

@inline Base.pointer(x::StridedCLArray, i::Integer = 1) = device_pointer(x, i)
@inline Base.pointer(x::StridedCLArray{<:Any,<:Any,cl.UnifiedHostMemory}, i::Integer = 1) =
    host_pointer(x, i)

# anything that's (secretly) backed by a CLArray
const WrappedCLArray{T, N} = Union{CLArray{T, N}, WrappedArray{T, N, CLArray, CLArray{T, N}}}
const WrappedCLVector{T} = WrappedCLArray{T, 1}
const WrappedCLMatrix{T} = WrappedCLArray{T, 2}
const WrappedCLVecOrMat{T} = Union{WrappedCLVector{T}, WrappedCLMatrix{T}}


## interop with other arrays

@inline function CLArray{T, N, B}(xs::AbstractArray{<:Any, N}) where {T, N, B}
    A = CLArray{T, N, B}(undef, size(xs))
    copyto!(A, convert(Array{T}, xs))
    return A
end

@inline CLArray{T, N}(xs::AbstractArray{<:Any, N}) where {T, N} =
    CLArray{T, N, memory_type()}(xs)

@inline CLArray{T, N}(xs::CLArray{<:Any, N, B}) where {T, N, B} =
    CLArray{T, N, B}(xs)

# underspecified constructors
CLArray{T}(xs::AbstractArray{S, N}) where {T, N, S} = CLArray{T, N}(xs)
(::Type{CLArray{T, N} where {T}})(x::AbstractArray{S, N}) where {S, N} = CLArray{S, N}(x)
CLArray(A::AbstractArray{T, N}) where {T, N} = CLArray{T, N}(A)

# idempotency
CLArray{T, N, B}(xs::CLArray{T, N, B}) where {T, N, B} = xs
CLArray{T, N}(xs::CLArray{T, N, B}) where {T, N, B} = xs

# Level CLro references
cl.CLRef(x::Any) = cl.CLRefArray(CLArray([x]))
cl.CLRef{T}(x) where {T} = cl.CLRefArray{T}(CLArray(T[x]))
cl.CLRef{T}() where {T} = cl.CLRefArray(CLArray{T}(undef, 1))


## conversions

Base.convert(::Type{T}, x::T) where {T <: CLArray} = x


## indexing

function Base.getindex(x::CLArray{<:Any, <:Any, <:Union{cl.UnifiedHostMemory, cl.UnifiedSharedMemory, cl.SharedVirtualMemory}}, I::Int)
    @boundscheck checkbounds(x, I)
    return GC.@preserve x unsafe_load(host_pointer(x, I))
end

function Base.setindex!(x::CLArray{<:Any, <:Any, <:Union{cl.UnifiedHostMemory, cl.UnifiedSharedMemory, cl.SharedVirtualMemory}}, v, I::Int)
    @boundscheck checkbounds(x, I)
    return GC.@preserve x unsafe_store!(host_pointer(x, I), v)
end


## interop with libraries

function Base.unsafe_convert(::Type{Ptr{T}}, x::CLArray{T}) where {T}
    if !host_accessible(x)
        throw(ArgumentError("cannot take the CPU address of a $(typeof(x))"))
    end
    return convert(Ptr{T}, x.data[]) + x.offset
end

function Base.unsafe_convert(::Type{CLPtr{T}}, x::CLArray{T}) where {T}
    if !device_accessible(x)
        throw(ArgumentError("cannot take the device address of a $(typeof(x))"))
    end
    return convert(CLPtr{T}, x.data[]) + x.offset
end

# when passing to OpenCL kernels with `clcall`, don't convert directly to a pointer,
# but keep the underlying memory around so that we can configure the kernel correctly.
function cl.clconvert(::Type{<:Union{Ptr, CLPtr}}, x::CLArray)
    return x.data[].mem
end


## interop with GPU arrays

function Base.unsafe_convert(::Type{CLDeviceArray{T, N, AS.CrossWorkgroup}},
                             a::CLArray{T, N}) where {T, N}
    return CLDeviceArray{T, N, AS.CrossWorkgroup}(
        size(a), reinterpret(LLVMPtr{T, AS.CrossWorkgroup}, pointer(a)),
        a.maxsize - a.offset
    )
end


## memory copying

synchronize(x::CLArray) = synchronize(x.data[])

typetagdata(a::Array, i = 1) = ccall(:jl_array_typetagdata, Ptr{UInt8}, (Any,), a) + i - 1
function typetagdata(a::CLArray, i = 1)
    # for zero-size element types (e.g. singleton unions), the byte offset
    # is always zero, so the corresponding element offset is also zero
    elem_offset = iszero(Base.elsize(a)) ? 0 : a.offset ÷ Base.elsize(a)
    return convert(CLPtr{UInt8}, a.data[]) + a.maxsize + elem_offset + i - 1
end

function Base.copyto!(
        dest::CLArray{T}, doffs::Integer, src::Array{T}, soffs::Integer,
        n::Integer
    ) where {T}
    (n == 0 || sizeof(T) == 0) && return dest
    @boundscheck checkbounds(dest, doffs)
    @boundscheck checkbounds(dest, doffs + n - 1)
    @boundscheck checkbounds(src, soffs)
    @boundscheck checkbounds(src, soffs + n - 1)
    unsafe_copyto!(dest, doffs, src, soffs, n)
    return dest
end

Base.copyto!(dest::DenseCLArray{T}, src::Array{T}) where {T} =
    copyto!(dest, 1, src, 1, length(src))

function Base.copyto!(
        dest::Array{T}, doffs::Integer, src::DenseCLArray{T}, soffs::Integer,
        n::Integer
    ) where {T}
    (n == 0 || sizeof(T) == 0) && return dest
    @boundscheck checkbounds(dest, doffs)
    @boundscheck checkbounds(dest, doffs + n - 1)
    @boundscheck checkbounds(src, soffs)
    @boundscheck checkbounds(src, soffs + n - 1)
    unsafe_copyto!(dest, doffs, src, soffs, n)
    return dest
end

Base.copyto!(dest::Array{T}, src::DenseCLArray{T}) where {T} =
    copyto!(dest, 1, src, 1, length(src))

function Base.copyto!(
        dest::DenseCLArray{T}, doffs::Integer, src::DenseCLArray{T}, soffs::Integer,
        n::Integer
    ) where {T}
    (n == 0 || sizeof(T) == 0) && return dest
    @boundscheck checkbounds(dest, doffs)
    @boundscheck checkbounds(dest, doffs + n - 1)
    @boundscheck checkbounds(src, soffs)
    @boundscheck checkbounds(src, soffs + n - 1)
    @assert context(dest) == context(src)
    unsafe_copyto!(dest, doffs, src, soffs, n)
    return dest
end

Base.copyto!(dest::DenseCLArray{T}, src::DenseCLArray{T}) where {T} =
    copyto!(dest, 1, src, 1, length(src))

for (srcty, dstty) in [(:Array, :CLArray), (:CLArray, :Array), (:CLArray, :CLArray)]
    @eval begin
        function Base.unsafe_copyto!(
                dst::$dstty{T}, dst_off::Int,
                src::$srcty{T}, src_off::Int,
                N::Int; blocking::Bool = true
            ) where {T}
            nbytes = N * sizeof(T)
            nbytes == 0 && return

            device_array = $dstty == CLArray ? dst : src
            cl.context!(context(device_array)) do
                if memtype(device_array) == cl.SharedVirtualMemory
                    cl.enqueue_svm_copy(pointer(dst, dst_off), pointer(src, src_off), nbytes; blocking)
                elseif memtype(device_array) <: cl.UnifiedMemory
                    cl.enqueue_usm_copy(pointer(dst, dst_off), pointer(src, src_off), nbytes; blocking)
                else
                    if src isa CLArray && dst isa CLArray
                        cl.enqueue_copy(convert(cl.Buffer, dst.data[]),
                            dst.offset + (dst_off - 1) * sizeof(T),
                            convert(cl.Buffer, src.data[]),
                            src.offset + (src_off - 1) * sizeof(T),
                            nbytes; blocking)
                    elseif dst isa CLArray
                        cl.enqueue_write(convert(cl.Buffer, dst.data[]),
                            dst.offset + (dst_off - 1) * sizeof(T),
                            pointer(src, src_off), nbytes; blocking)
                    elseif src isa CLArray
                        cl.enqueue_read(pointer(dst, dst_off),
                            convert(cl.Buffer, src.data[]),
                            src.offset + (src_off - 1) * sizeof(T),
                            nbytes; blocking)
                    end
                end
            end
        end
        Base.unsafe_copyto!(dst::$dstty, src::$srcty, N; kwargs...) =
            unsafe_copyto!(dst, 1, src, 1, N; kwargs...)
    end
end


## gpu array adaptor

# We don't convert isbits types in `adapt`, since they are already
# considered GPU-compatible.

Adapt.adapt_storage(::Type{CLArray}, xs::AT) where {AT <: AbstractArray} =
    isbitstype(AT) ? xs : convert(CLArray, xs)

# if specific type parameters are specified, preserve those
Adapt.adapt_storage(::Type{<:CLArray{T}}, xs::AT) where {T, AT <: AbstractArray} =
    isbitstype(AT) ? xs : convert(CLArray{T}, xs)
Adapt.adapt_storage(::Type{<:CLArray{T, N}}, xs::AT) where {T, N, AT <: AbstractArray} =
    isbitstype(AT) ? xs : convert(CLArray{T, N}, xs)
Adapt.adapt_storage(::Type{<:CLArray{T, N, M}}, xs::AT) where {T, N, M, AT <: AbstractArray} =
    isbitstype(AT) ? xs : convert(CLArray{T, N, M}, xs)


## utilities

zeros(T::Type, dims...) = fill!(CLArray{T}(undef, dims...), zero(T))
ones(T::Type, dims...) = fill!(CLArray{T}(undef, dims...), one(T))
zeros(dims...) = zeros(Float32, dims...)
ones(dims...) = ones(Float32, dims...)
fill(v, dims...) = fill!(CLArray{typeof(v)}(undef, dims...), v)
fill(v, dims::Dims) = fill!(CLArray{typeof(v)}(undef, dims...), v)

function Base.fill!(A::DenseCLArray{T}, val) where {T}
    isempty(A) && return A
    cl.context!(context(A)) do
        GC.@preserve A begin
            if memtype(A) == cl.SharedVirtualMemory
                cl.enqueue_svm_fill(pointer(A), convert(T, val), length(A))
            elseif memtype(A) <: cl.UnifiedMemory
                cl.enqueue_usm_fill(pointer(A), convert(T, val), length(A))
            else
                cl.enqueue_fill(convert(cl.Buffer, A.data[]), A.offset, convert(T, val), length(A))
            end
        end
    end
    return A
end


## views

context(a::SubArray) = context(parent(a))

# pointer conversions
function Base.unsafe_convert(::Type{CLPtr{T}}, V::SubArray{T, N, P, <:Tuple{Vararg{Base.RangeIndex}}}) where {T, N, P}
    return Base.unsafe_convert(CLPtr{T}, parent(V)) +
        Base._memory_offset(V.parent, map(first, V.indices)...)
end
function Base.unsafe_convert(::Type{CLPtr{T}}, V::SubArray{T, N, P, <:Tuple{Vararg{Union{Base.RangeIndex, Base.ReshapedUnitRange}}}}) where {T, N, P}
    return Base.unsafe_convert(CLPtr{T}, parent(V)) +
        (Base.first_index(V) - 1) * sizeof(T)
end


## PermutedDimsArray

context(a::Base.PermutedDimsArray) = context(parent(a))

Base.unsafe_convert(::Type{CLPtr{T}}, A::PermutedDimsArray) where {T} =
    Base.unsafe_convert(CLPtr{T}, parent(A))


## unsafe_wrap

"""
    unsafe_wrap(Array, arr::CLArray)

Wrap a Julia `Array` around the buffer that backs a `CLArray`. This is only possible if the
GPU array is backed by host memory, such as unified (host or shared) memory, or shared
virtual memory.
"""
function Base.unsafe_wrap(::Type{Array}, arr::CLArray{T, N}) where {T, N}
    return unsafe_wrap(Array, host_pointer(arr), size(arr))
end


## resizing

"""
  resize!(a::CLVector, n::Integer)

Resize `a` to contain `n` elements. If `n` is smaller than the current collection length,
the first `n` elements will be retained. If `n` is larger, the new elements are not
guaranteed to be initialized.
"""
function Base.resize!(a::CLVector{T}, n::Integer) where {T}
    n == length(a) && return a

    # TODO: add additional space to allow for quicker resizing
    maxsize = n * sizeof(T)
    bufsize = if isbitstype(T)
        maxsize
    else
        # type tag array past the data
        maxsize + n
    end

    # replace the data with a new CL. this 'unshares' the array.
    # as a result, we can safely support resizing unowned buffers.
    new_data = cl.context!(context(a)) do
        mem = managed_alloc(memtype(a), bufsize; alignment=Base.datatype_alignment(T))
        ptr = convert(CLPtr{T}, mem)
        m = min(length(a), n)
        if m > 0
            GC.@preserve a begin
                if memtype(a) == cl.SharedVirtualMemory
                    cl.enqueue_svm_copy(ptr, pointer(a), m*sizeof(T); blocking=false)
                elseif memtype(a) <: cl.UnifiedMemory
                    cl.enqueue_usm_copy(ptr, pointer(a), m*sizeof(T); blocking=false)
                else
                    cl.enqueue_copy(convert(cl.Buffer, mem), 0, convert(cl.Buffer, a.data[]), a.offset, m*sizeof(T); blocking=false)
                end
            end
        end
        DataRef(free, mem)
    end
    unsafe_free!(a)

    a.data = new_data
    a.dims = (n,)
    a.maxsize = maxsize
    a.offset = 0

    return a
end

@testset "Buffer" begin
    # simple buffer
    let buf = cl.Buffer(sizeof(Int))
        @test sizeof(buf) == sizeof(Int)
    end

    # memory copy
    let buf = cl.Buffer(sizeof(Int))
        src = [42]
        cl.enqueue_write(buf, pointer(src), sizeof(src); blocking=true)

        dst = [0]
        cl.enqueue_read(pointer(dst), buf, sizeof(dst); blocking=true)
        @test dst == [42]
    end

    # host accessible, mapped
    let buf = cl.Buffer(sizeof(Int); host_accessible=true)
        src = [42]
        cl.enqueue_write(buf, pointer(src), sizeof(src); blocking=true)

        ptr, evt = cl.enqueue_map(buf, sizeof(buf), :rw)
        wait(evt)
        mapped = unsafe_wrap(Array, convert(Ptr{Int}, ptr), 1; own=false)
        @test mapped[] == 42
        cl.enqueue_unmap(buf, ptr) |> wait
    end

    # re-use host buffer, without copy
    let arr = [1,2,3]
        buf = cl.Buffer(arr; copy=false)

        dst = similar(arr)
        cl.enqueue_read(pointer(dst), buf, sizeof(dst); blocking=true)
        @test dst == arr

        # we still need to map, despite copy=false
        ptr, evt = cl.enqueue_map(buf, sizeof(buf), :rw)
        wait(evt)
        mapped_arr = unsafe_wrap(Array, convert(Ptr{Int}, ptr), 3; own=false)
        mapped_arr .= 42
        cl.enqueue_unmap(buf, ptr) |> wait

        # but our pre-allocated buffer should have been updated too
        @test arr == [42,42,42]

        # and we can read it back
        cl.enqueue_read(pointer(dst), buf, sizeof(dst); blocking=true)
        @test dst == arr
    end

    # re-use host buffer, but copy
    let arr = [1,2,3]
        buf = cl.Buffer(arr; copy=true)

        dst = similar(arr)
        cl.enqueue_read(pointer(dst), buf, sizeof(dst); blocking=true)
        @test dst == arr

        arr .= 42

        # but our pre-allocated buffer should not have been updated
        cl.enqueue_read(pointer(dst), buf, sizeof(dst); blocking=true)
        @test dst == [1,2,3]
    end

    # fill
    let buf = cl.Buffer(3*sizeof(Int))
        cl.enqueue_fill(buf, 42, 3)

        arr = Vector{Int}(undef, 3)
        cl.enqueue_read(pointer(arr), buf, sizeof(arr); blocking=true)
        @test arr == [42,42,42]
    end
end

if cl.SVMBackend() in cl.supported_memory_backends(cl.device())
@testset "SVM Buffer" begin
    # simple buffer
    let buf = cl.svm_alloc(sizeof(Int))
        @test sizeof(buf) == sizeof(Int)
    end

    # memory copy
    let buf = cl.svm_alloc(sizeof(Int))
        ptr = pointer(buf)

        src = [42]
        cl.enqueue_svm_copy(ptr, pointer(src), sizeof(src))

        dst = [0]
        cl.enqueue_svm_copy(pointer(dst), ptr, sizeof(dst); blocking = true)
        @test dst == [42]
    end

    # memory map

    let buf = cl.svm_alloc(sizeof(Int))
        ptr = pointer(buf)

        src = [42]
        cl.enqueue_svm_copy(ptr, pointer(src), sizeof(src))

        evt = cl.enqueue_svm_map(ptr, sizeof(src), :rw)
        wait(evt)
        mapped = unsafe_wrap(Array, Ptr{Int}(UInt(ptr)), 1; own = false)
        @test mapped[] == 42
        mapped[] = 100
        cl.enqueue_svm_unmap(ptr) |> cl.wait

        dst = [0]
        cl.enqueue_svm_copy(pointer(dst), ptr, sizeof(dst); blocking = true)
        @test dst == [100]
    end

    # fill
    let buf = cl.svm_alloc(3 * sizeof(Int))
        ptr = pointer(buf)

        cl.enqueue_svm_fill(ptr, 42, 3)

        dst = Vector{Int}(undef, 3)
        cl.enqueue_svm_copy(pointer(dst), ptr, sizeof(dst); blocking = true)
        @test dst == [42,42,42]
    end
end
end

export @opencl, clfunction


## high-level @opencl interface

const MACRO_KWARGS = [:launch]
const COMPILER_KWARGS = [:kernel, :name, :always_inline, :extensions, :backend, :validate, :sub_group_size]
const LAUNCH_KWARGS = [:global_size, :local_size, :queue]

macro opencl(ex...)
    call = ex[end]
    kwargs = map(ex[1:end-1]) do kwarg
        if kwarg isa Symbol
            :($kwarg = $kwarg)
        elseif Meta.isexpr(kwarg, :(=))
            kwarg
        else
            throw(ArgumentError("Invalid keyword argument '$kwarg'"))
        end
    end

    # destructure the kernel call
    Meta.isexpr(call, :call) || throw(ArgumentError("second argument to @opencl should be a function call"))
    f = call.args[1]
    args = call.args[2:end]

    code = quote end
    vars, var_exprs = assign_args!(code, args)

    # group keyword argument
    macro_kwargs, compiler_kwargs, call_kwargs, other_kwargs =
        split_kwargs(kwargs, MACRO_KWARGS, COMPILER_KWARGS, LAUNCH_KWARGS)
    if !isempty(other_kwargs)
        key,val = first(other_kwargs).args
        throw(ArgumentError("Unsupported keyword argument '$key'"))
    end

    # handle keyword arguments that influence the macro's behavior
    launch = true
    for kwarg in macro_kwargs
        key,val = kwarg.args
        if key == :launch
            isa(val, Bool) || throw(ArgumentError("`launch` keyword argument to @opencl should be a constant value"))
            launch = val::Bool
        else
            throw(ArgumentError("Unsupported keyword argument '$key'"))
        end
    end
    if !launch && !isempty(call_kwargs)
        error("@opencl with launch=false does not support launch-time keyword arguments; use them when calling the kernel")
    end

    # FIXME: macro hygiene wrt. escaping kwarg values (this broke with 1.5)
    #        we esc() the whole thing now, necessitating gensyms...
    @gensym f_var kernel_f kernel_args kernel_tt kernel

    # convert the arguments, call the compiler and launch the kernel
    # while keeping the original arguments alive
    push!(code.args,
        quote
            $f_var = $f
            GC.@preserve $(vars...) $f_var begin
                $kernel_f = $kernel_convert($f_var)
                $kernel_args = map($kernel_convert, ($(var_exprs...),))
                $kernel_tt = Tuple{map(Core.Typeof, $kernel_args)...}
                $kernel = $clfunction($kernel_f, $kernel_tt; $(compiler_kwargs...))
                if $launch
                    $kernel($(var_exprs...); $(call_kwargs...))
                end
                $kernel
            end
         end)

    return esc(quote
        let
            $code
        end
    end)
end

## argument conversion

struct KernelAdaptor
    indirect_memory::Vector{cl.AbstractMemory}
end

# when converting to pointers, we need to keep track of the underlying memory type
function Adapt.adapt_storage(to::KernelAdaptor, buf::cl.AbstractMemory)
    ptr = pointer(buf)
    push!(to.indirect_memory, buf)
    return ptr
end
function Adapt.adapt_storage(to::KernelAdaptor, arr::CLArray{T, N}) where {T, N}
    push!(to.indirect_memory, arr.data[].mem)
    return Base.unsafe_convert(CLDeviceArray{T, N, AS.CrossWorkgroup}, arr)
end

# Base.RefValue isn't GPU compatible, so provide a compatible alternative
# TODO: port improvements from CUDA.jl
struct CLRefValue{T} <: Ref{T}
  x::T
end
Base.getindex(r::CLRefValue) = r.x
Adapt.adapt_structure(to::KernelAdaptor, r::Base.RefValue) = CLRefValue(adapt(to, r[]))

# broadcast sometimes passes a ref(type), resulting in a GPU-incompatible DataType box.
# avoid that by using a special kind of ref that knows about the boxed type.
struct CLRefType{T} <: Ref{DataType} end
Base.getindex(r::CLRefType{T}) where T = T
Adapt.adapt_structure(to::KernelAdaptor, r::Base.RefValue{<:Union{DataType,Type}}) =
    CLRefType{r[]}()

# case where type is the function being broadcasted
Adapt.adapt_structure(to::KernelAdaptor,
                      bc::Broadcast.Broadcasted{Style, <:Any, Type{T}}) where {Style, T} =
    Broadcast.Broadcasted{Style}((x...) -> T(x...), adapt(to, bc.args), bc.axes)

"""
    kernel_convert(x)

This function is called for every argument to be passed to a kernel, allowing it to be
converted to a GPU-friendly format. By default, the function does nothing and returns the
input object `x` as-is.

Do not add methods to this function, but instead extend the underlying Adapt.jl package and
register methods for the the `OpenCL.KernelAdaptor` type.
"""
kernel_convert(arg, indirect_memory::Vector{cl.AbstractMemory} = cl.AbstractMemory[]) =
    adapt(KernelAdaptor(indirect_memory), arg)

## abstract kernel functionality

abstract type AbstractKernel{F, TT} end

pass_arg(@nospecialize dt) = !(isghosttype(dt) || Core.Compiler.isconstType(dt))

@inline @generated function (kernel::AbstractKernel{F,TT})(args...;
                                                           call_kwargs...) where {F,TT}
    sig = Tuple{F, TT.parameters...}    # Base.signature_type with a function type
    args = (:(kernel.f), (:(kernel_convert(args[$i], indirect_memory)) for i in 1:length(args))...)

    # filter out ghost arguments that shouldn't be passed
    to_pass = map(pass_arg, sig.parameters)
    call_t =                  Type[x[1] for x in zip(sig.parameters,  to_pass) if x[2]]
    call_args = Union{Expr,Symbol}[x[1] for x in zip(args, to_pass)            if x[2]]

    # replace non-isbits arguments (they should be unused, or compilation would have failed)
    for (i,dt) in enumerate(call_t)
        if !isbitstype(dt)
            call_t[i] = Ptr{Any}
            call_args[i] = :C_NULL
        end
    end

    pushfirst!(call_t, KernelState)
    pushfirst!(call_args, :(KernelState(kernel.rng_state ? Base.rand(UInt32) : UInt32(0))))

    # finalize types
    call_tt = Base.to_tuple_type(call_t)

    quote
        indirect_memory = cl.AbstractMemory[]
        clcall(kernel.fun, $call_tt, $(call_args...); indirect_memory, kernel.rng_state, call_kwargs...)
    end
end



## host-side kernels

struct HostKernel{F,TT} <: AbstractKernel{F,TT}
    f::F
    fun::cl.Kernel
    rng_state::Bool
end


## host-side API

const clfunction_lock = ReentrantLock()

function clfunction(f::F, tt::TT=Tuple{}; kwargs...) where {F,TT}
    ctx = cl.context()
    dev = cl.device()

    Base.@lock clfunction_lock begin
        # compile the function
        cache = compiler_cache(ctx)
        source = methodinstance(F, tt)
        config = compiler_config(dev; kwargs...)::OpenCLCompilerConfig
        linked = GPUCompiler.cached_compilation(cache, source, config, compile, link)

        # create a callable object that captures the function instance. we don't need to think
        # about world age here, as GPUCompiler already does and will return a different object
        h = hash(linked.kernel, hash(f, hash(tt)))
        kernel = get(_kernel_instances, h, nothing)
        if kernel === nothing
            # create the kernel state object
            kernel = HostKernel{F,tt}(f, linked.kernel, linked.device_rng)
            _kernel_instances[h] = kernel
        end
        return kernel::HostKernel{F,tt}
    end
end

# cache of kernel instances
const _kernel_instances = Dict{UInt, Any}()

# GPUArrays.jl interface

function GPUArrays.derive(::Type{T}, a::CLArray, dims::Dims{N}, offset::Int) where {T,N}
    ref = copy(a.data)
    offset = a.offset + offset * sizeof(T)
    CLArray{T,N}(ref, dims; offset)
end

const GLOBAL_RNGs = Dict{cl.Device,GPUArrays.RNG}()
function GPUArrays.default_rng(::Type{<:CLArray})
    dev = cl.device()
    get!(GLOBAL_RNGs, dev) do
        N = dev.max_work_group_size
        state = CLArray{NTuple{4, UInt32}}(undef, N)
        rng = GPUArrays.RNG(state)
        Random.seed!(rng)
        rng
    end
end

# Raw memory management

abstract type AbstractMemoryObject <: CLObject end
abstract type AbstractPointerMemory end
const AbstractMemory = Union{AbstractMemoryObject, AbstractPointerMemory}

# this will be specialized for each memory type
Base.convert(T::Type{<:Union{Ptr, CLPtr}}, mem::AbstractMemory) =
    throw(ArgumentError("Illegal conversion of a $(typeof(mem)) to a $T"))

# ccall integration
#
# taking the pointer of a memory object means returning the underlying pointer,
# and not the pointer of the object itself.
Base.unsafe_convert(P::Type{<:Union{Ptr, CLPtr}}, mem::AbstractMemory) = convert(P, mem)


## opaque memory objects

# This should be implemented by all subtypes
#type MemoryType <: AbstractMemoryObject
#    id::cl_mem
#    ...
#end

Base.sizeof(mem::AbstractMemoryObject) = mem.size

release(mem::AbstractMemoryObject) = clReleaseMemObject(mem)

function Base.getproperty(mem::AbstractMemoryObject, s::Symbol)
    if s == :type
        result = Ref{cl_mem_object_type}()
        clGetMemObjectInfo(mem, CL_MEM_TYPE, sizeof(cl_mem_object_type), result, C_NULL)
        return result[]
    elseif s == :flags
        result = Ref{cl_mem_flags}()
        clGetMemObjectInfo(mem, CL_MEM_FLAGS, sizeof(cl_mem_flags), result, C_NULL)
        mf = result[]
        flags = Symbol[]
        if (mf & CL_MEM_READ_WRITE) != 0
            push!(flags, :rw)
        end
        if (mf & CL_MEM_WRITE_ONLY) != 0
            push!(flags, :w)
        end
        if (mf & CL_MEM_READ_ONLY) != 0
            push!(flags, :r)
        end
        if (mf & CL_MEM_USE_HOST_PTR) != 0
            push!(flags, :use)
        end
        if (mf & CL_MEM_ALLOC_HOST_PTR) != 0
            push!(flags, :alloc)
        end
        if (mf & CL_MEM_COPY_HOST_PTR) != 0
            push!(flags, :copy)
        end
        return tuple(flags...)
    elseif s == :size
        result = Ref{Csize_t}()
        clGetMemObjectInfo(mem, CL_MEM_SIZE, sizeof(Csize_t), result, C_NULL)
        return result[]
    elseif s == :reference_count
        result = Ref{Cuint}()
        clGetMemObjectInfo(mem, CL_MEM_REFERENCE_COUNT, sizeof(Cuint), result, C_NULL)
        return Int(result[])
    elseif s == :map_count
        result = Ref{Cuint}()
        clGetMemObjectInfo(mem, CL_MEM_MAP_COUNT, sizeof(Cuint), result, C_NULL)
        return Int(result[])
    elseif s == :device_address
        result = Ref{cl_mem_device_address_ext}()
        clGetMemObjectInfo(mem, CL_MEM_DEVICE_ADDRESS_EXT, sizeof(cl_mem_device_address_ext), result, C_NULL)
        return CLPtr{Cvoid}(result[])
    else
        return getfield(mem, s)
    end
end

# for passing buffers to OpenCL APIs: use the underlying handle
Base.unsafe_convert(::Type{cl_mem}, mem::AbstractMemoryObject) = mem.id

# for passing buffers to kernels: pass the private device pointer
Base.convert(::Type{CLPtr{T}}, mem::AbstractMemoryObject) where {T} =
    convert(CLPtr{T}, pointer(mem))

include("memory/buffer.jl")

#TODO: enqueue_migrate_mem_objects(queue, mem_objects, flags=0, wait_for=None)
#TODO: enqueue_migrate_mem_objects_ext(queue, mem_objects, flags=0, wait_for=None)


## pointer-based memory

include("memory/usm.jl")
include("memory/svm.jl")

function error(Mdim::Int, Ndim::Int, Pdim::Int, C::Array{T}) where T
    cval  = Float32(Pdim * AVAL * BVAL)
    errsq = 0f0
    for i in 1:Ndim
        for j in 1:Mdim
            err = C[(i-1)*Ndim+j] - cval
            if isnan(err)
                println((i,j))
            end
            errsq += err^2
        end
    end
    return errsq
end

function results(Mdim::Int, Ndim::Int, Pdim::Int, C::Array{T}, run_time) where T
    mflops = 2.0 * Mdim * Ndim * Pdim/(1000000.0* run_time)
    println("$run_time seconds at $mflops MFLOPS")
    errsq = error(Mdim, Ndim, Pdim, C)
    if isnan(errsq) || errsq > TOL
        println("Errors in multiplication: $errsq")
    end
end

## random number generation

using Random
import RandomNumbers

# RNG state lives in work-group-local memory. With subgroups, one (key, counter) slot per subgroup
# indexed by subgroup id; without, one slot per work-item indexed by its linear id in the work-group.
# `has_feature(:subgroups)` folds at compile time, so only one layout is emitted; the host sizes the
# local memory to match (see `enqueue_kernel`).
@inline rng_nslots() =
    has_feature(:subgroups) ? Int(get_num_sub_groups()) :
                              Int(get_local_size(1) * get_local_size(2) * get_local_size(3))
@inline function rng_slot()   # 1-based slot index for this work-item
    if has_feature(:subgroups)
        return Int(get_sub_group_id())
    else
        lx = get_local_id(1) - 1; ly = get_local_id(2) - 1; lz = get_local_id(3) - 1
        return lx + get_local_size(1) * (ly + get_local_size(2) * lz) + 1
    end
end
# global linear id from get_global_id/get_global_size (always available), avoiding the OpenCL 2.0
# get_global_linear_id builtin.
@inline function global_linear_id()
    gx = get_global_id(1) - 1; gy = get_global_id(2) - 1; gz = get_global_id(3) - 1
    return gx + get_global_size(1) * (gy + get_global_size(2) * gz) + 1
end

# local memory with the actual seed, set by `initialize_rng_state` or overridden by `seed!`
@inline function global_random_keys()
    ptr = random_keys()::LLVMPtr{UInt32, AS.Workgroup}
    return CLDeviceArray{UInt32, 1, AS.Workgroup}((rng_nslots(),), ptr)
end

# local memory with per-slot counters, incremented when generating numbers
@inline function global_random_counters()
    ptr = random_counters()::LLVMPtr{UInt32, AS.Workgroup}
    return CLDeviceArray{UInt32, 1, AS.Workgroup}((rng_nslots(),), ptr)
end

# initialization function, called automatically at the start of each kernel
function initialize_rng_state()
    slot = rng_slot()
    @inbounds global_random_keys()[slot] = kernel_state().random_seed
    @inbounds global_random_counters()[slot] = 0
end

# generators

using Random123: philox2x_round, philox2x_bumpkey

# GPU-compatible/optimized version of the generator from Random123.jl
struct Philox2x32{R} <: RandomNumbers.AbstractRNG{UInt64} end

# default to 7 rounds; enough to pass SmallCrush
@inline Philox2x32() = Philox2x32{7}()

@inline function Base.getproperty(rng::Philox2x32, field::Symbol)
    if field === :key
        @inbounds global_random_keys()[rng_slot()]
    elseif field === :ctr1
        @inbounds global_random_counters()[rng_slot()]
    elseif field === :ctr2
        unsafe_trunc(UInt32, global_linear_id())
    end
end

@inline function Base.setproperty!(rng::Philox2x32, field::Symbol, x)
    if field === :key
        @inbounds global_random_keys()[rng_slot()] = x
    elseif field === :ctr1
        @inbounds global_random_counters()[rng_slot()] = x
    end
    return rng
end

@device_override @inline Random.default_rng() = Philox2x32()

"""
    Random.seed!(rng::Philox2x32, seed::Integer, [counter::Integer=0])

Seed the on-device Philox2x32 generator with an UInt32 number.
Should be called by at least one thread per warp.
"""
function Random.seed!(rng::Philox2x32, seed::Integer, counter::Integer=UInt32(0))
    rng.key = seed % UInt32
    rng.ctr1 = counter
    return
end

# seeding the implicit default RNG
@static if VERSION >= v"1.11-"
    @device_override Random.seed!(seed) =
        Random.seed!(Random.default_rng(), seed)
else
    @device_override Random.seed!(::Random._GLOBAL_RNG, seed) =
        Random.seed!(Random.default_rng(), seed)
end

@static if VERSION >= v"1.11-"
    # `Random.seed!(::AbstractRNG)` now passes a `nothing` seed value
    # TODO: I don't think there is any way in OpenCL to make this nondeterministic
    Random.seed!(rng::Philox2x32, seed::Nothing) =
        Random.seed!(rng, kernel_state().random_seed)
else
    # ... where it used to call `Random_make_seed()`
    @device_override Random.make_seed() = kernel_state().random_seed
end

"""
    Random.rand(rng::Philox2x32, UInt32)

Generate a byte of random data using the on-device Tausworthe generator.
"""
function Random.rand(rng::Philox2x32{R},::Type{UInt64}) where {R}
    ctr1, ctr2, key = rng.ctr1, rng.ctr2, rng.key

    if R > 0                               ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 1  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 2  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 3  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 4  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 5  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 6  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 7  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 8  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 9  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 10 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 11 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 12 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 13 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 14 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 15 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end

    # update the warp counter
    # NOTE: this performs the same update on every thread in the warp, but each warp writes
    #       to a unique location so the duplicate writes are innocuous
    # XXX: what if this overflows? we can't increment ctr2. bump the key?
    rng.ctr1 += Int32(1)

    # NOTE: it's too expensive to keep both numbers around in case the user only wanted one,
    #       so just make our 2x32 generator return 64-bit numbers by default.
    return (ctr1 % UInt64) << 32 | (ctr2 % UInt64)
end



# normally distributed random numbers using Ziggurat algorithm
#
# copied from Base because we don't support its global tables

# a hacky method of exposing constant tables as constant GPU memory
function emit_constant_array(name::Symbol, data::AbstractArray{T}) where {T}
    @dispose ctx=Context() begin
        T_val = convert(LLVMType, T)
        T_ptr = convert(LLVMType, LLVMPtr{T,AS.UniformConstant})

        # define function and get LLVM module
        llvm_f, _ = create_function(T_ptr)
        mod = LLVM.parent(llvm_f)

        # create a global memory global variable
        # TODO: global_var alignment?
        T_global = LLVM.ArrayType(T_val, length(data))
        # XXX: why can't we use a single name like emit_shmem
        gv = GlobalVariable(mod, T_global, "gpu_$(name)_data", AS.UniformConstant)
        linkage!(gv, LLVM.API.LLVMInternalLinkage)
        initializer!(gv, ConstantArray(data))
        alignment!(gv, 16)

        # generate IR
        @dispose builder=IRBuilder() begin
            entry = BasicBlock(llvm_f, "entry")
            position!(builder, entry)

            ptr = gep!(builder, T_global, gv, [ConstantInt(0), ConstantInt(0)])

            untyped_ptr = bitcast!(builder, ptr, T_ptr)

            ret!(builder, untyped_ptr)
        end

        call_function(llvm_f, LLVMPtr{T,AS.UniformConstant})
    end
end

for var in [:ki, :wi, :fi, :ke, :we, :fe]
    val = getfield(Random, var)
    gpu_var = Symbol("gpu_$var")
    arr_typ = :(CLDeviceArray{$(eltype(val)),$(ndims(val)),AS.UniformConstant})
    @eval @inline @generated function $gpu_var()
        ptr = emit_constant_array($(QuoteNode(var)), $val)
        Expr(:call, $arr_typ, $(size(val)), ptr)
    end
end

## randn

@device_override @inline function Random.randn(rng::AbstractRNG)
    @label retry
    r = Random.rand(rng, Random.UInt52Raw())
    @inbounds begin
        r &= 0x000fffffffffffff
        rabs = Int64(r >> 1) # One bit for the sign
        idx = rabs & 0xFF
        x = ifelse(r % Bool, -rabs, rabs)*gpu_wi()[idx+1]
        rabs < gpu_ki()[idx+1] && return x # 99.3% of the time we return here 1st try
        # TODO: This code could be outlined once LLVM supports LDS access in recursively-called functions
        @inbounds if idx == 0
            while true
                xx = -Random.ziggurat_nor_inv_r*log(Random.rand(rng))
                yy = -log(Random.rand(rng))
                yy+yy > xx*xx &&
                    return (rabs >> 8) % Bool ? -Random.ziggurat_nor_r-xx : Random.ziggurat_nor_r+xx
            end
        elseif (gpu_fi()[idx] - gpu_fi()[idx+1])*Random.rand(rng) + gpu_fi()[idx+1] < exp(-0.5*x*x)
            return x # return from the triangular area
        else
            @goto retry
        end
    end
end

@device_override @inline function Random.randn(rng::AbstractRNG, ::Type{T}) where {T <: Union{Float16, Float32}}
    @invoke Random.randn(rng::AbstractRNG, T::Type{<:AbstractFloat})
end

## randexp

@device_override @inline function Random.randexp(rng::AbstractRNG)
    @label retry
    ri = Random.rand(rng, Random.UInt52Raw())
    @inbounds begin
        ri &= 0x000fffffffffffff
        idx = ri & 0xFF
        x = ri*gpu_we()[idx+1]
        ri < gpu_ke()[idx+1] && return x # 98.9% of the time we return here 1st try
        # TODO: This code could be outlined once LLVM supports LDS access in recursively-called functions
        @inbounds if idx == 0
            return Random.ziggurat_exp_r - log(Random.rand(rng))
        elseif (gpu_fe()[idx] - gpu_fe()[idx+1])*Random.rand(rng) + gpu_fe()[idx+1] < exp(-x)
            return x # return from the triangular area
        else
            @goto retry
        end
    end
end

@device_override @inline function Random.randexp(rng::AbstractRNG, ::Type{T}) where {T <: Union{Float16, Float32}}
    @invoke Random.randexp(rng::AbstractRNG, T::Type{<:AbstractFloat})
end

@device_override Random.Sampler(::Type{<:AbstractRNG}, r::AbstractUnitRange{T},
                                ::Random.Repetition) where {T<:Union{Int64, UInt64}} = Random.SamplerRangeFast(r)

using OpenCL.cl

# constructors
voidptr_a = CLPtr{Cvoid}(Int(0xDEADBEEF))
@test reinterpret(Ptr{Cvoid}, voidptr_a) == Ptr{Cvoid}(Int(0xDEADBEEF))

# getters
@test eltype(voidptr_a) == Cvoid

# comparisons
voidptr_b = CLPtr{Cvoid}(Int(0xCAFEBABE))
@test voidptr_a != voidptr_b


@testset "conversions" begin

    # between host and device pointers
    @test_throws ArgumentError convert(Ptr{Cvoid}, voidptr_a)

    # between device pointers
    intptr_a = CLPtr{Int}(Int(0xDEADBEEF))
    @test convert(typeof(intptr_a), voidptr_a) == intptr_a

    # convert back and forth from UInt
    intptr_b = CLPtr{Int}(Int(0xDEADBEEF))
    @test convert(UInt, intptr_b) == 0xDEADBEEF
    @test convert(CLPtr{Int}, Int(0xDEADBEEF)) == intptr_b
    @test Int(intptr_b) == Int(0xDEADBEEF)

    # pointer arithmetic
    intptr_c = CLPtr{Int}(Int(0xDEADBEEF))
    intptr_d = 2 + intptr_c
    @test isless(intptr_c, intptr_d)
    @test intptr_d - intptr_c == 2
    @test intptr_d - 2 == intptr_c
end


@testset "GPU or CPU integration" begin
    a = [1]
    ccall(:clock, Nothing, (Ptr{Int},), a)
    @test_throws Exception ccall(:clock, Nothing, (CLPtr{Int},), a)
    ccall(:clock, Nothing, (PtrOrCLPtr{Int},), a)

    b = CLArray{eltype(a), ndims(a), cl.Buffer}(undef, size(a))
    @test device_accessible(b)
    @test !host_accessible(b)
    if cl.bda_supported(cl.device())
        ccall(:clock, Nothing, (CLPtr{Int},), b)
        @test_throws Exception ccall(:clock, Nothing, (Ptr{Int},), b)
        ccall(:clock, Nothing, (PtrOrCLPtr{Int},), b)
    end
end


@testset "reference values" begin
    # Ref

    @test typeof(Base.cconvert(Ref{Int}, 1)) == typeof(Ref(1))
    @test Base.unsafe_convert(Ref{Int}, Base.cconvert(Ref{Int}, 1)) isa Ptr{Int}

    ptr = reinterpret(Ptr{Int}, C_NULL)
    @test Base.cconvert(Ref{Int}, ptr) == ptr
    @test Base.unsafe_convert(Ref{Int}, Base.cconvert(Ref{Int}, ptr)) == ptr

    arr = [1]
    @test Base.cconvert(Ref{Int}, arr) isa Base.RefArray{Int, typeof(arr)}
    @test Base.unsafe_convert(Ref{Int}, Base.cconvert(Ref{Int}, arr)) == pointer(arr)


    # CLRef

    @test typeof(Base.cconvert(CLRef{Int}, 1)) == typeof(CLRef(1))
    @test Base.unsafe_convert(CLRef{Int}, Base.cconvert(CLRef{Int}, 1)) isa CLRef{Int}

    clptr = reinterpret(CLPtr{Int}, C_NULL)
    @test Base.cconvert(CLRef{Int}, clptr) == clptr
    @test Base.unsafe_convert(CLRef{Int}, Base.cconvert(CLRef{Int}, clptr)) == Base.bitcast(CLRef{Int}, clptr)

    clarr = OpenCL.CLArray([1])
    @test Base.cconvert(CLRef{Int}, clarr) isa cl.CLRefArray{Int, typeof(clarr)}
    @test Base.unsafe_convert(CLRef{Int}, Base.cconvert(CLRef{Int}, clarr)) == Base.bitcast(CLRef{Int}, pointer(clarr))


    # RefOrCLRef

    @test typeof(Base.cconvert(RefOrCLRef{Int}, 1)) == typeof(Ref(1))
    @test Base.unsafe_convert(RefOrCLRef{Int}, Base.cconvert(RefOrCLRef{Int}, 1)) isa RefOrCLRef{Int}

    @test Base.cconvert(RefOrCLRef{Int}, ptr) == ptr
    @test Base.unsafe_convert(RefOrCLRef{Int}, Base.cconvert(RefOrCLRef{Int}, ptr)) == Base.bitcast(RefOrCLRef{Int}, ptr)

    @test Base.cconvert(RefOrCLRef{Int}, clptr) == clptr
    @test Base.unsafe_convert(RefOrCLRef{Int}, Base.cconvert(RefOrCLRef{Int}, clptr)) == Base.bitcast(RefOrCLRef{Int}, clptr)

    @test Base.cconvert(RefOrCLRef{Int}, arr) isa Base.RefArray{Int, typeof(arr)}
    @test Base.unsafe_convert(RefOrCLRef{Int}, Base.cconvert(RefOrCLRef{Int}, arr)) == Base.bitcast(RefOrCLRef{Int}, pointer(arr))

    @test Base.cconvert(RefOrCLRef{Int}, clarr) isa cl.CLRefArray{Int, typeof(clarr)}
    @test Base.unsafe_convert(RefOrCLRef{Int}, Base.cconvert(RefOrCLRef{Int}, clarr)) == Base.bitcast(RefOrCLRef{Int}, pointer(clarr))
end

using Random

const n = 256

function apply_seed(seed)
    if seed === missing
        # should result in different numbers across launches
        Random.seed!()
        # XXX: this currently doesn't work, because of the definition in Base,
        #      `seed!(r::MersenneTwister=default_rng())`, which breaks overriding
        #      `default_rng` with a non-MersenneTwister RNG.
    elseif seed !== nothing
        # should result in the same numbers
        Random.seed!(seed)
    elseif seed === nothing
        # should result in different numbers across launches,
        # as determined by the seed set during module loading.
    end
end

eltypes = [filter(x -> !(x <: Complex), GPUArraysTestSuite.supported_eltypes(CLArray)); Bool; UInt16; UInt32; UInt64]

@testset "rand($T), seed $seed" for T in eltypes, seed in (nothing, #=missing,=# 1234)
    # different kernel invocations should get different numbers
    @testset "across launches" begin
        function kernel(A::AbstractArray{T}, seed) where {T}
            apply_seed(seed)
            tid = get_global_id(1)
            A[tid] = rand(T)
            return nothing
        end

        a = OpenCL.zeros(T, n)
        b = OpenCL.zeros(T, n)

        @opencl global_size=n local_size=n kernel(a, seed)
        @opencl global_size=n local_size=n kernel(b, seed)

        if seed === nothing || seed === missing
            @test Array(a) != Array(b)
        else
            @test Array(a) == Array(b)
        end
    end

    # multiple calls to rand should get different numbers
    @testset "across calls" begin
        function kernel(A::AbstractArray{T}, B::AbstractArray{T}, seed) where {T}
            apply_seed(seed)
            tid = get_global_id(1)
            A[tid] = rand(T)
            B[tid] = rand(T)
            return nothing
        end

        a = OpenCL.zeros(T, n)
        b = OpenCL.zeros(T, n)

        @opencl global_size=n local_size=n kernel(a, b, seed)

        @test Array(a) != Array(b)
    end

    if T != Bool
        # different threads should get different numbers
        @testset "across threads, dim $active_dim" for active_dim in 1:6
            function kernel(A::AbstractArray{T}, seed) where {T}
                apply_seed(seed)
                id = get_local_id(1) * get_local_id(2) * get_local_id(3) *
                     get_group_id(1) * get_group_id(2) * get_group_id(3)
                if 1 <= id <= length(A)
                    A[id] = rand(T)
                end
                return nothing
            end

            tx, ty, tz, bx, by, bz = [dim == active_dim ? 3 : 1 for dim in 1:6]
            gx, gy, gz = tx*bx, ty*by, tz*bz
            a = OpenCL.zeros(T, 3)

            @opencl local_size=(tx, ty, tz) global_size=(gx, gy, gz) kernel(a, seed)

            # NOTE: we don't just generate two numbers and compare them, instead generating a
            #       couple more and checking they're not all the same, in order to avoid
            #       occasional collisions with lower-precision types (i.e., Float16).
            @test length(unique(Array(a))) > 1
        end
    end
end

@testset "basic randn($T), seed $seed" for T in filter(x -> x <: Base.IEEEFloat, eltypes), seed in (nothing, #=missing,=# 1234)
    function kernel(A::AbstractArray{T}, seed) where {T}
        apply_seed(seed)
        tid = get_global_id(1)
        A[tid] = randn(T)
        return
    end

    a = OpenCL.zeros(T, n)
    b = OpenCL.zeros(T, n)

    @opencl global_size=n local_size=n kernel(a, seed)
    @opencl global_size=n local_size=n kernel(b, seed)

    if seed === nothing || seed === missing
        @test Array(a) != Array(b)
    else
        @test Array(a) == Array(b)
    end
end

randexp_eltypes = filter(x -> x <: Base.IEEEFloat, eltypes)
if cl.platform().name == "Portable Computing Language"
    # POCL doesn't support log1p for Float16
    filter!(x -> x != Float16, randexp_eltypes)
end

@testset "basic randexp($T), seed $seed" for T in randexp_eltypes, seed in (nothing, #=missing,=# 1234)
    function kernel(A::AbstractArray{T}, seed) where {T}
        apply_seed(seed)
        tid = get_global_id(1)
        A[tid] = randexp(T)
        return
    end

    a = OpenCL.zeros(T, n)
    b = OpenCL.zeros(T, n)

    @opencl global_size=n local_size=n kernel(a, seed)
    @opencl global_size=n local_size=n kernel(b, seed)

    if seed === nothing || seed === missing
        @test Array(a) != Array(b)
    else
        @test Array(a) == Array(b)
    end
end

@testset "rand(::AbstractRange{$T}), seed $seed" for T in (Int32, Int64, UInt32, UInt64), seed in (nothing, #=missing,=# 1234)
    function kernel(A::AbstractArray{T}, seed) where {T}
        apply_seed(seed)
        tid = get_global_id(1)
        A[tid] = rand(T(10):T(20))
        return
    end

    a = OpenCL.zeros(T, n)
    b = OpenCL.zeros(T, n)

    @opencl global_size=n local_size=n kernel(a, seed)
    @opencl global_size=n local_size=n kernel(b, seed)

    if seed === nothing || seed === missing
        @test Array(a) != Array(b)
    else
        @test Array(a) == Array(b)
    end
end

@testset "Hello World Test" begin
    hello_world_kernel = "
        #pragma OPENCL EXTENSION cl_khr_byte_addressable_store : enable

        __constant char hw[] = \"hello world\";

        __kernel void hello(__global char *out) {
            int tid = get_global_id(0);
            out[tid] = hw[tid];
        }"

    hello_world_str = "hello world"


    str_len  = length(hello_world_str) + 1
    out_arr = CLArray{Cchar}(undef, str_len)

    prg   = cl.Program(source=hello_world_kernel) |> cl.build!
    kern  = cl.Kernel(prg, "hello")

    clcall(kern, Tuple{CLPtr{Cchar}}, out_arr; global_size = str_len)
    h = Array(out_arr)

    @test hello_world_str == GC.@preserve h unsafe_string(pointer(h))
end

@testset "Low Level API Test" begin

  test_source = "
    __kernel void sum(__global const float *a,
                      __global const float *b,
                      __global float *c,
                      const unsigned int count)
    {
      unsigned int gid = get_global_id(0);
      if (gid < count) {
          c[gid] = a[gid] + b[gid];
      }
    }
    "

    len = 1024
    h_a = Vector{Cfloat}(undef, len)
    h_b = Vector{Cfloat}(undef, len)
    h_c = Vector{Cfloat}(undef, len)
    h_d = Vector{Cfloat}(undef, len)
    h_e = Vector{Cfloat}(undef, len)
    h_f = Vector{Cfloat}(undef, len)
    h_g = Vector{Cfloat}(undef, len)

    for i in 1:len
        h_a[i] = Cfloat(rand())
        h_b[i] = Cfloat(rand())
        h_e[i] = Cfloat(rand())
        h_g[i] = Cfloat(rand())
    end

    err_code = Ref{cl.Cint}()

    # create compute context (TODO: fails if function ptr's not passed...)
    ctx_id = cl.clCreateContext(C_NULL, 1, [cl.device().id], C_NULL, C_NULL, err_code)
    if err_code[] != cl.CL_SUCCESS
        throw(cl.CLError(err_code[]))
    end

    q_id = cl.clCreateCommandQueue(ctx_id, cl.device(), 0, err_code)
    if err_code[] != cl.CL_SUCCESS
        error("Failed to create command queue")
    end

    # create program
    bytesource = String(test_source)
    prg_id = cl.clCreateProgramWithSource(ctx_id, 1, [bytesource], C_NULL, err_code)
    if err_code[] != cl.CL_SUCCESS
        error("Failed to create program")
    end

    # build program
    cl.clBuildProgram(prg_id, 0, C_NULL, C_NULL, C_NULL, C_NULL)

    # create compute kernel
    k_id = cl.clCreateKernel(prg_id, "sum", err_code)
    if err_code[] != cl.CL_SUCCESS
        error("Failed to create compute kernel")
    end

    # create input array in device memory
    Aid = cl.clCreateBuffer(ctx_id, cl.CL_MEM_READ_ONLY | cl.CL_MEM_COPY_HOST_PTR,
                                sizeof(Cfloat) * len, h_a, err_code)
    if err_code[] != cl.CL_SUCCESS
        error("Error creating buffer A")
    end
    Bid = cl.clCreateBuffer(ctx_id, cl.CL_MEM_READ_ONLY | cl.CL_MEM_COPY_HOST_PTR,
                                sizeof(Cfloat) * len, h_b, err_code)
    if err_code[] != cl.CL_SUCCESS
        error("Error creating buffer B")
    end
    Eid = cl.clCreateBuffer(ctx_id, cl.CL_MEM_WRITE_ONLY | cl.CL_MEM_COPY_HOST_PTR,
                                sizeof(Cfloat) * len, h_e, err_code)
    if err_code[] != cl.CL_SUCCESS
        error("Error creating buffer E")
    end
    Gid = cl.clCreateBuffer(ctx_id, cl.CL_MEM_WRITE_ONLY | cl.CL_MEM_COPY_HOST_PTR,
                                sizeof(Cfloat) * len, h_g, err_code)
    if err_code[] != cl.CL_SUCCESS
        error("Error creating buffer G")
    end

    # create output arrays in device memory

    Cid = cl.clCreateBuffer(ctx_id, cl.CL_MEM_READ_WRITE,
                                sizeof(Cfloat) * len, C_NULL, err_code)
    if err_code[] != cl.CL_SUCCESS
        error("Error creating buffer C")
    end
    Did = cl.clCreateBuffer(ctx_id, cl.CL_MEM_READ_WRITE,
                                sizeof(Cfloat) * len, C_NULL, err_code)
    if err_code[] != cl.CL_SUCCESS
        error("Error creating buffer D")
    end
    Fid = cl.clCreateBuffer(ctx_id, cl.CL_MEM_WRITE_ONLY,
                                sizeof(Cfloat) * len, C_NULL, err_code)
    if err_code[] != cl.CL_SUCCESS
        error("Error creating buffer F")
    end

    cl.clSetKernelArg(k_id, 0, sizeof(cl.cl_mem), [Aid])
    cl.clSetKernelArg(k_id, 1, sizeof(cl.cl_mem), [Bid])
    cl.clSetKernelArg(k_id, 2, sizeof(cl.cl_mem), [Cid])
    cl.clSetKernelArg(k_id, 3, sizeof(cl.Cuint), cl.Cuint[len])

    nglobal = Ref{Csize_t}(len)
    cl.clEnqueueNDRangeKernel(q_id, k_id,  1, C_NULL,
                                  nglobal, C_NULL, 0, C_NULL, C_NULL)

    cl.clSetKernelArg(k_id, 0, sizeof(cl.cl_mem), [Eid])
    cl.clSetKernelArg(k_id, 1, sizeof(cl.cl_mem), [Cid])
    cl.clSetKernelArg(k_id, 2, sizeof(cl.cl_mem), [Did])
    cl.clEnqueueNDRangeKernel(q_id, k_id,  1, C_NULL,
                                  nglobal, C_NULL, 0, C_NULL, C_NULL)

    cl.clSetKernelArg(k_id, 0, sizeof(cl.cl_mem), [Gid])
    cl.clSetKernelArg(k_id, 1, sizeof(cl.cl_mem), [Did])
    cl.clSetKernelArg(k_id, 2, sizeof(cl.cl_mem), [Fid])
    cl.clEnqueueNDRangeKernel(q_id, k_id,  1, C_NULL,
                                  nglobal, C_NULL, 0, C_NULL, C_NULL)

    # read back the result from compute device...
    cl.clEnqueueReadBuffer(q_id, Fid, cl.CL_TRUE, 0,
                               sizeof(Cfloat) * len, h_f, 0, C_NULL, C_NULL)

    # test results
    for i in 1:len
        tmp = h_a[i] + h_b[i] + h_e[i] + h_g[i]
        @test tmp ≈ h_f[i]
    end
end

@testset "Struct Buffer Test" begin
    test_struct = "
        typedef struct Params
        {
            float A;
            float B;
            float x[2];  //padding
            int C;
        } Params;


        __kernel void part3(__global const float *a,
                            __global const float *b,
                            __global float *c,
                            __global struct Params* test)
        {
            int gid = get_global_id(0);
            c[gid] = test->A * a[gid] + test->B * b[gid] + test->C;
        }
    "

    Params = @eval(module $(gensym("KernelTest"))
            struct Params
                A::Float32
                B::Float32
                #TODO: fixed size arrays?
                X1::Float32
                X2::Float32
                C::Int32
                Params(a, b, x, c) = begin
                    new(Float32(a),
                        Float32(b),
                        Float32(x[1]),
                        Float32(x[2]),
                        Int32(c))
                end
            end
        end).Params

    p   = cl.Program(source=test_struct) |> cl.build!

    part3 = cl.Kernel(p, "part3")

    X = fill(1f0, 10)
    Y = fill(1f0, 10)

    P = [Params(0.5, 10.0, [0.0, 0.0], 3)]

    #TODO: constructor for single immutable types.., check if passed parameter isbits
    P_arr = CLArray(P)

    X_arr = CLArray(X)
    Y_arr = CLArray(Y)
    R_arr = CLArray{Float32}(undef, 10)

    global_size = size(X)
    clcall(
        part3, Tuple{CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}, CLPtr{Params}},
                  X_arr, Y_arr, R_arr, P_arr; global_size)

    r = Array(R_arr)
    @test all(x -> x == 13.5, r)
end


@testset "Struct Buffer Test" begin
    test_mutable_pointerfree = "
        typedef struct Params
        {
            float A;
            float B;
        } Params;


        __kernel void part3(
            __global float *a,
            Params test
        ){
            a[0] = test.A;
            a[1] = test.B;
        }
    "

    MutableParams = @eval(module $(gensym("KernelTest"))
            mutable struct MutableParams
                A::Float32
                B::Float32
            end
        end).MutableParams

    p   = cl.Program(source=test_mutable_pointerfree) |> cl.build!

    part3 = cl.Kernel(p, "part3")

    P = MutableParams(0.5, 10.0)
    P_arr = CLArray{Float32}(undef, 2)
    clcall(part3, Tuple{CLPtr{Float32}, MutableParams}, P_arr, P)

    r = Array(P_arr)

    @test r[1] == 0.5
    @test r[2] == 10.0
end

@testset "constructor" begin
    @test_throws MethodError (cl.Context([]))

    ctx = cl.Context(cl.device())
    @test ctx != nothing
    @test ctx.reference_count == 1
    ctx_id = pointer(ctx)

    ctx2 = cl.Context(ctx_id; retain=true)
    @test ctx.reference_count == 2
    finalize(ctx2)
    @test ctx.reference_count == 1

    # TODO: support switching contexts
    #@testset "Context callback" begin
    #    function context_test_callback(arg1, arg2, arg3)
    #        # We're not really testing it because, nvidia doesn't seem to care about this functionality:
    #        # https://devtalk.nvidia.com/default/topic/497433/context-callback-never-called/
    #        OpenCL.cl.log_error("Callback works")
    #        return
    #    end
    #
    #    function create_context_error()
    #        empty_kernel = "
    #        __kernel void test() {
    #            int c = 1 + 1;
    #        };"
    #        try
    #            p = cl.Program(source = empty_kernel) |> cl.build!
    #            k = cl.Kernel(p, "test")
    #            cl.call(k; global_size=1, local_size=10000000)
    #        catch
    #        end
    #    end
    #
    #    ctx = cl.Context(cl.device(), callback = context_test_callback)
    #    context!(ctx) do
    #        create_context_error()
    #    end
    #end
end


@testset "platform properties" begin
    try
        cl.Context(cl.CL_DEVICE_TYPE_CPU)
    catch err
        @test typeof(err) == cl.CLError
        # CL_DEVICE_NOT_FOUND could be throw for GPU only drivers
        @test err.desc in (:CL_INVALID_PLATFORM,
                                 :CL_DEVICE_NOT_FOUND)
    end

    properties = [(cl.CL_CONTEXT_PLATFORM, cl.platform())]
    for (cl_dev_type, sym_dev_type) in [(cl.CL_DEVICE_TYPE_CPU, :cpu),
                                        (cl.CL_DEVICE_TYPE_GPU, :gpu)]
        if !cl.has_device_type(cl.platform(), sym_dev_type)
            continue
        end
        @test cl.Context(sym_dev_type; properties) != nothing
        @test cl.Context(cl_dev_type; properties) != nothing
        ctx = cl.Context(cl_dev_type; properties)
        @test !isempty(ctx.properties)
        test_properties = ctx.properties

        @test test_properties == properties

        platform_in_properties = false
        for (t, v) in test_properties
            if t == cl.CL_CONTEXT_PLATFORM
                @test v.name == cl.platform().name
                @test v == cl.platform()
                platform_in_properties = true
                break
            end
        end
        @test platform_in_properties
    end
    try
        ctx2 = cl.Context(cl.CL_DEVICE_TYPE_ACCELERATOR; properties)
    catch err
        @test typeof(err) == cl.CLError
        @test err.desc == :CL_DEVICE_NOT_FOUND
    end
end

# printf

# Formatted Output (B.17)

@generated function promote_c_argument(arg)
    # > When a function with a variable-length argument list is called, the variable
    # > arguments are passed using C's old ``default argument promotions.'' These say that
    # > types char and short int are automatically promoted to int, and type float is
    # > automatically promoted to double. Therefore, varargs functions will never receive
    # > arguments of type char, short int, or float.

    if arg == Cchar || arg == Cshort || arg == Cuchar || arg == Cushort
        return :(Cint(arg))
    elseif arg == Cfloat
        return :(Cdouble(arg))
    else
        return :(arg)
    end
end

macro printf(fmt::String, args...)
    fmt_val = Val(Symbol(fmt))

    return :(emit_printf($fmt_val, $(map(arg -> :(promote_c_argument($arg)), esc.(args))...)))
end

@generated function emit_printf(::Val{fmt}, argspec...) where {fmt}
    arg_exprs = [:( argspec[$i] ) for i in 1:length(argspec)]
    arg_types = [argspec...]

    Context() do ctx
        T_void = LLVM.VoidType()
        T_int32 = LLVM.Int32Type()
        T_pint8 = LLVM.PointerType(LLVM.Int8Type(), AS.UniformConstant)

        # create functions
        param_types = LLVMType[convert(LLVMType, typ) for typ in arg_types]
        llvm_f, _ = create_function(T_int32, param_types)
        mod = LLVM.parent(llvm_f)

        IRBuilder() do builder
            entry = BasicBlock(llvm_f, "entry")
            position!(builder, entry)

            # `printf` needs to be invoked very specifically, e.g., the format string needs
            # to be a pointer to a string, and arguments need to match exactly what is
            # expected by the format string, so we cannot rely on how the arguments to this
            # function have been passed in (by `llvmcall`).
            T_actual_args = LLVMType[]
            actual_args = LLVM.Value[]
            for (_, (arg, argtyp)) in enumerate(zip(parameters(llvm_f), arg_types))
                if argtyp <: LLVMPtr
                    # passed as i8*
                    T,AS = argtyp.parameters
                    actual_typ = LLVM.PointerType(convert(LLVMType, T), AS)
                    actual_arg = bitcast!(builder, arg, actual_typ)
                elseif argtyp <: Ptr
                    T = eltype(argtyp)
                    if T === Nothing
                        T = Int8
                    end
                    actual_typ = LLVM.PointerType(convert(LLVMType, T))
                    actual_arg = if value_type(arg) isa LLVM.PointerType
                        # passed as i8* or ptr
                        bitcast!(builder, arg, actual_typ)
                    else
                        # passed as i64
                        inttoptr!(builder, arg, actual_typ)
                    end
                elseif argtyp <: Bool
                    # passed as i8
                    T = eltype(argtyp)
                    actual_typ = LLVM.Int1Type()
                    actual_arg = trunc!(builder, arg, actual_typ)
                else
                    actual_typ = convert(LLVMType, argtyp)
                    actual_arg = arg
                end
                push!(T_actual_args, actual_typ)
                push!(actual_args, actual_arg)
            end

            str = globalstring_ptr!(builder, String(fmt); addrspace=AS.UniformConstant)

            # invoke printf and return
            printf_typ = LLVM.FunctionType(T_int32, [T_pint8]; vararg=true)
            printf = LLVM.Function(mod, "printf", printf_typ)
            push!(function_attributes(printf), EnumAttribute("nobuiltin"))
            chars = call!(builder, printf_typ, printf, [str, actual_args...])

            ret!(builder, chars)
        end

        call_function(llvm_f, Int32, Tuple{arg_types...}, arg_exprs...)
    end
end


## print-like functionality

# simple conversions, defining an expression and the resulting argument type. nothing fancy,
# `@print` pretty directly maps to `@printf`; we should just support `write(::IO)`.
const print_conversions = Dict(
    Float32     => (x->:(Float64($x)),             Float64),
    Ptr{<:Any}  => (x->:(convert(Ptr{Cvoid}, $x)), Ptr{Cvoid}),
    Bool        => (x->:(Int32($x)),               Int32),
)

# format specifiers
const print_specifiers = Dict(
    # integers
    Int16       => "%hd",
    Int32       => "%d",
    Int64       => Sys.iswindows() ? "%lld" : "%ld",
    UInt16      => "%hu",
    UInt32      => "%u",
    UInt64      => Sys.iswindows() ? "%llu" : "%lu",

    # floating-point
    Float64     => "%f",

    # other
    Cchar       => "%c",
    Ptr{Cvoid}  => "%p",
)

@generated function _print(parts...)
    fmt = ""
    args = Expr[]

    for i in 1:length(parts)
        part = :(parts[$i])
        T = parts[i]

        # put literals directly in the format string
        if T <: Val
            fmt *= string(T.parameters[1])
            continue
        end

        # try to convert arguments if they are not supported directly
        if !haskey(print_specifiers, T)
            for Tmatch in keys(print_conversions)
                if T <: Tmatch
                    conv, T = print_conversions[Tmatch]
                    part = conv(part)
                    break
                end
            end
        end

        # render the argument
        if haskey(print_specifiers, T)
            fmt *= print_specifiers[T]
            push!(args, part)
        elseif T <: String
            @error("@print does not support non-literal strings")
        else
            @error("@print does not support values of type $T")
        end
    end

    quote
        Base.@_inline_meta
        @printf($fmt, $(args...))
    end
end

"""
    @print(xs...)
    @println(xs...)

Print a textual representation of values `xs` to standard output from the GPU. The
functionality builds on `@printf`, and is intended as a more use friendly alternative of
that API. However, that also means there's only limited support for argument types, handling
16/32/64 signed and unsigned integers, 32 and 64-bit floating point numbers, `Cchar`s and
pointers. For more complex output, use `@printf` directly.

Limited string interpolation is also possible:

```julia
    @print("Hello, World ", 42, "\\n")
    @print "Hello, World \$(42)\\n"
```
"""
macro print(parts...)
    args = Union{Val,Expr,Symbol}[]

    parts = [parts...]
    while true
        isempty(parts) && break

        part = popfirst!(parts)

        # handle string interpolation
        if isa(part, Expr) && part.head == :string
            parts = vcat(part.args, parts)
            continue
        end

        # expose literals to the generator by using Val types
        if isbits(part) # literal numbers, etc
            push!(args, Val(part))
        elseif isa(part, QuoteNode) # literal symbols
            push!(args, Val(part.value))
        elseif isa(part, String) # literal strings need to be interned
            push!(args, Val(Symbol(part)))
        else # actual values that will be passed to printf
            push!(args, part)
        end
    end

    quote
        _print($(map(esc, args)...))
    end
end

@doc (@doc @print) ->
macro println(parts...)
    esc(quote
        $SPIRVIntrinsics.@print($(parts...), "\n")
    end)
end

"""
    @show(ex)

GPU analog of `Base.@show`. It comes with the same type restrictions as [`@printf`](@ref).

```julia
@show threadIdx().x
```
"""
macro show(exs...)
    blk = Expr(:block)
    for ex in exs
        push!(blk.args, :($SPIRVIntrinsics.@println($(sprint(Base.show_unquoted,ex)*" = "),
                                                    begin local value = $(esc(ex)) end)))
    end
    isempty(exs) || push!(blk.args, :value)
    blk
end

# This file is automatically generated. Do not edit!
# To re-generate, execute res/wrap/wrap.jl

# outlined functionality to avoid GC frame allocation
@noinline function throw_api_error(res)
    throw(CLError(res))
end

function check(f)
    res = retry_reclaim(err -> err == CL_OUT_OF_RESOURCES ||
                               err == CL_MEM_OBJECT_ALLOCATION_FAILURE ||
                               err == CL_OUT_OF_HOST_MEMORY) do
        return f()
    end

    if res != CL_SUCCESS
        throw_api_error(res)
    end

    return
end

macro CL_MAKE_VERSION(major, minor, patch)
    return quote
        VersionNumber($major, $minor, $patch)
    end
end

const intptr_t = Cssize_t

const cl_int = Int32

const cl_uint = UInt32

const cl_ulong = UInt64

mutable struct _cl_platform_id end

mutable struct _cl_device_id end

mutable struct _cl_context end

mutable struct _cl_command_queue end

mutable struct _cl_mem end

mutable struct _cl_program end

mutable struct _cl_kernel end

mutable struct _cl_event end

mutable struct _cl_sampler end

const cl_platform_id = Ptr{_cl_platform_id}

const cl_device_id = Ptr{_cl_device_id}

const cl_context = Ptr{_cl_context}

const cl_command_queue = Ptr{_cl_command_queue}

const cl_mem = Ptr{_cl_mem}

const cl_program = Ptr{_cl_program}

const cl_kernel = Ptr{_cl_kernel}

const cl_event = Ptr{_cl_event}

const cl_sampler = Ptr{_cl_sampler}

const cl_bool = cl_uint

const cl_bitfield = cl_ulong

const cl_properties = cl_ulong

const cl_device_type = cl_bitfield

const cl_platform_info = cl_uint

const cl_device_info = cl_uint

const cl_device_fp_config = cl_bitfield

const cl_device_mem_cache_type = cl_uint

const cl_device_local_mem_type = cl_uint

const cl_device_exec_capabilities = cl_bitfield

const cl_device_svm_capabilities = cl_bitfield

const cl_command_queue_properties = cl_bitfield

const cl_device_partition_property = intptr_t

const cl_device_affinity_domain = cl_bitfield

const cl_context_properties = intptr_t

const cl_context_info = cl_uint

const cl_queue_properties = cl_properties

const cl_command_queue_info = cl_uint

const cl_channel_order = cl_uint

const cl_channel_type = cl_uint

const cl_mem_flags = cl_bitfield

const cl_svm_mem_flags = cl_bitfield

const cl_mem_object_type = cl_uint

const cl_mem_info = cl_uint

const cl_mem_migration_flags = cl_bitfield

const cl_image_info = cl_uint

const cl_buffer_create_type = cl_uint

const cl_addressing_mode = cl_uint

const cl_filter_mode = cl_uint

const cl_sampler_info = cl_uint

const cl_map_flags = cl_bitfield

const cl_pipe_properties = intptr_t

const cl_pipe_info = cl_uint

const cl_program_info = cl_uint

const cl_program_build_info = cl_uint

const cl_program_binary_type = cl_uint

const cl_build_status = cl_int

const cl_kernel_info = cl_uint

const cl_kernel_arg_info = cl_uint

const cl_kernel_arg_address_qualifier = cl_uint

const cl_kernel_arg_access_qualifier = cl_uint

const cl_kernel_arg_type_qualifier = cl_bitfield

const cl_kernel_work_group_info = cl_uint

const cl_kernel_sub_group_info = cl_uint

const cl_event_info = cl_uint

const cl_command_type = cl_uint

const cl_profiling_info = cl_uint

const cl_sampler_properties = cl_properties

const cl_kernel_exec_info = cl_uint

const cl_device_atomic_capabilities = cl_bitfield

const cl_device_device_enqueue_capabilities = cl_bitfield

const cl_khronos_vendor_id = cl_uint

const cl_mem_properties = cl_properties

const cl_version = cl_uint

struct _cl_image_format
    image_channel_order::cl_channel_order
    image_channel_data_type::cl_channel_type
end

const cl_image_format = _cl_image_format

struct _cl_image_desc
    data::NTuple{72,UInt8}
end

function Base.getproperty(x::Ptr{_cl_image_desc}, f::Symbol)
    f === :image_type && return Ptr{cl_mem_object_type}(x + 0)
    f === :image_width && return Ptr{Csize_t}(x + 8)
    f === :image_height && return Ptr{Csize_t}(x + 16)
    f === :image_depth && return Ptr{Csize_t}(x + 24)
    f === :image_array_size && return Ptr{Csize_t}(x + 32)
    f === :image_row_pitch && return Ptr{Csize_t}(x + 40)
    f === :image_slice_pitch && return Ptr{Csize_t}(x + 48)
    f === :num_mip_levels && return Ptr{cl_uint}(x + 56)
    f === :num_samples && return Ptr{cl_uint}(x + 60)
    f === :buffer && return Ptr{cl_mem}(x + 64)
    f === :mem_object && return Ptr{cl_mem}(x + 64)
    return getfield(x, f)
end

function Base.getproperty(x::_cl_image_desc, f::Symbol)
    r = Ref{_cl_image_desc}(x)
    ptr = Base.unsafe_convert(Ptr{_cl_image_desc}, r)
    fptr = getproperty(ptr, f)
    GC.@preserve r unsafe_load(fptr)
end

function Base.setproperty!(x::Ptr{_cl_image_desc}, f::Symbol, v)
    return unsafe_store!(getproperty(x, f), v)
end

const cl_image_desc = _cl_image_desc

struct _cl_buffer_region
    origin::Csize_t
    size::Csize_t
end

const cl_buffer_region = _cl_buffer_region

struct _cl_name_version
    version::cl_version
    name::NTuple{64,Cchar}
end

const cl_name_version = _cl_name_version

@checked function clGetPlatformIDs(num_entries, platforms, num_platforms)
    @ccall libopencl.clGetPlatformIDs(num_entries::cl_uint, platforms::Ptr{cl_platform_id},
                                      num_platforms::Ptr{cl_uint})::cl_int
end

@checked function clGetPlatformInfo(platform, param_name, param_value_size, param_value,
                                    param_value_size_ret)
    @ccall libopencl.clGetPlatformInfo(platform::cl_platform_id,
                                       param_name::cl_platform_info,
                                       param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                       param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clGetDeviceIDs(platform, device_type, num_entries, devices, num_devices)
    @ccall libopencl.clGetDeviceIDs(platform::cl_platform_id, device_type::cl_device_type,
                                    num_entries::cl_uint, devices::Ptr{cl_device_id},
                                    num_devices::Ptr{cl_uint})::cl_int
end

@checked function clGetDeviceInfo(device, param_name, param_value_size, param_value,
                                  param_value_size_ret)
    @ccall libopencl.clGetDeviceInfo(device::cl_device_id, param_name::cl_device_info,
                                     param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                     param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clCreateSubDevices(in_device, properties, num_devices, out_devices,
                                     num_devices_ret)
    @ccall libopencl.clCreateSubDevices(in_device::cl_device_id,
                                        properties::Ptr{cl_device_partition_property},
                                        num_devices::cl_uint,
                                        out_devices::Ptr{cl_device_id},
                                        num_devices_ret::Ptr{cl_uint})::cl_int
end

@checked function clRetainDevice(device)
    @ccall libopencl.clRetainDevice(device::cl_device_id)::cl_int
end

@checked function clReleaseDevice(device)
    @ccall libopencl.clReleaseDevice(device::cl_device_id)::cl_int
end

@checked function clSetDefaultDeviceCommandQueue(context, device, command_queue)
    @ccall libopencl.clSetDefaultDeviceCommandQueue(context::cl_context,
                                                    device::cl_device_id,
                                                    command_queue::cl_command_queue)::cl_int
end

@checked function clGetDeviceAndHostTimer(device, device_timestamp, host_timestamp)
    @ccall libopencl.clGetDeviceAndHostTimer(device::cl_device_id,
                                             device_timestamp::Ptr{cl_ulong},
                                             host_timestamp::Ptr{cl_ulong})::cl_int
end

@checked function clGetHostTimer(device, host_timestamp)
    @ccall libopencl.clGetHostTimer(device::cl_device_id,
                                    host_timestamp::Ptr{cl_ulong})::cl_int
end

function clCreateContext(properties, num_devices, devices, pfn_notify, user_data,
                         errcode_ret)
    @ccall libopencl.clCreateContext(properties::Ptr{cl_context_properties},
                                     num_devices::cl_uint, devices::Ptr{cl_device_id},
                                     pfn_notify::Ptr{Cvoid}, user_data::Ptr{Cvoid},
                                     errcode_ret::Ptr{cl_int})::cl_context
end

function clCreateContextFromType(properties, device_type, pfn_notify, user_data,
                                 errcode_ret)
    @ccall libopencl.clCreateContextFromType(properties::Ptr{cl_context_properties},
                                             device_type::cl_device_type,
                                             pfn_notify::Ptr{Cvoid}, user_data::Ptr{Cvoid},
                                             errcode_ret::Ptr{cl_int})::cl_context
end

@checked function clRetainContext(context)
    @ccall libopencl.clRetainContext(context::cl_context)::cl_int
end

@checked function clReleaseContext(context)
    @ccall libopencl.clReleaseContext(context::cl_context)::cl_int
end

@checked function clGetContextInfo(context, param_name, param_value_size, param_value,
                                   param_value_size_ret)
    @ccall libopencl.clGetContextInfo(context::cl_context, param_name::cl_context_info,
                                      param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                      param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clSetContextDestructorCallback(context, pfn_notify, user_data)
    @ccall libopencl.clSetContextDestructorCallback(context::cl_context,
                                                    pfn_notify::Ptr{Cvoid},
                                                    user_data::Ptr{Cvoid})::cl_int
end

function clCreateCommandQueueWithProperties(context, device, properties, errcode_ret)
    @ccall libopencl.clCreateCommandQueueWithProperties(context::cl_context,
                                                        device::cl_device_id,
                                                        properties::Ptr{cl_queue_properties},
                                                        errcode_ret::Ptr{cl_int})::cl_command_queue
end

@checked function clRetainCommandQueue(command_queue)
    @ccall libopencl.clRetainCommandQueue(command_queue::cl_command_queue)::cl_int
end

@checked function clReleaseCommandQueue(command_queue)
    @ccall libopencl.clReleaseCommandQueue(command_queue::cl_command_queue)::cl_int
end

@checked function clGetCommandQueueInfo(command_queue, param_name, param_value_size,
                                        param_value, param_value_size_ret)
    @ccall libopencl.clGetCommandQueueInfo(command_queue::cl_command_queue,
                                           param_name::cl_command_queue_info,
                                           param_value_size::Csize_t,
                                           param_value::Ptr{Cvoid},
                                           param_value_size_ret::Ptr{Csize_t})::cl_int
end

function clCreateBuffer(context, flags, size, host_ptr, errcode_ret)
    @ccall libopencl.clCreateBuffer(context::cl_context, flags::cl_mem_flags, size::Csize_t,
                                    host_ptr::Ptr{Cvoid}, errcode_ret::Ptr{cl_int})::cl_mem
end

function clCreateSubBuffer(buffer, flags, buffer_create_type, buffer_create_info,
                           errcode_ret)
    @ccall libopencl.clCreateSubBuffer(buffer::cl_mem, flags::cl_mem_flags,
                                       buffer_create_type::cl_buffer_create_type,
                                       buffer_create_info::Ptr{Cvoid},
                                       errcode_ret::Ptr{cl_int})::cl_mem
end

function clCreateImage(context, flags, image_format, image_desc, host_ptr, errcode_ret)
    @ccall libopencl.clCreateImage(context::cl_context, flags::cl_mem_flags,
                                   image_format::Ptr{cl_image_format},
                                   image_desc::Ptr{cl_image_desc}, host_ptr::Ptr{Cvoid},
                                   errcode_ret::Ptr{cl_int})::cl_mem
end

function clCreatePipe(context, flags, pipe_packet_size, pipe_max_packets, properties,
                      errcode_ret)
    @ccall libopencl.clCreatePipe(context::cl_context, flags::cl_mem_flags,
                                  pipe_packet_size::cl_uint, pipe_max_packets::cl_uint,
                                  properties::Ptr{cl_pipe_properties},
                                  errcode_ret::Ptr{cl_int})::cl_mem
end

function clCreateBufferWithProperties(context, properties, flags, size, host_ptr,
                                      errcode_ret)
    @ccall libopencl.clCreateBufferWithProperties(context::cl_context,
                                                  properties::Ptr{cl_mem_properties},
                                                  flags::cl_mem_flags, size::Csize_t,
                                                  host_ptr::Ptr{Cvoid},
                                                  errcode_ret::Ptr{cl_int})::cl_mem
end

function clCreateImageWithProperties(context, properties, flags, image_format, image_desc,
                                     host_ptr, errcode_ret)
    @ccall libopencl.clCreateImageWithProperties(context::cl_context,
                                                 properties::Ptr{cl_mem_properties},
                                                 flags::cl_mem_flags,
                                                 image_format::Ptr{cl_image_format},
                                                 image_desc::Ptr{cl_image_desc},
                                                 host_ptr::Ptr{Cvoid},
                                                 errcode_ret::Ptr{cl_int})::cl_mem
end

@checked function clRetainMemObject(memobj)
    @ccall libopencl.clRetainMemObject(memobj::cl_mem)::cl_int
end

@checked function clReleaseMemObject(memobj)
    @ccall libopencl.clReleaseMemObject(memobj::cl_mem)::cl_int
end

@checked function clGetSupportedImageFormats(context, flags, image_type, num_entries,
                                             image_formats, num_image_formats)
    @ccall libopencl.clGetSupportedImageFormats(context::cl_context, flags::cl_mem_flags,
                                                image_type::cl_mem_object_type,
                                                num_entries::cl_uint,
                                                image_formats::Ptr{cl_image_format},
                                                num_image_formats::Ptr{cl_uint})::cl_int
end

@checked function clGetMemObjectInfo(memobj, param_name, param_value_size, param_value,
                                     param_value_size_ret)
    @ccall libopencl.clGetMemObjectInfo(memobj::cl_mem, param_name::cl_mem_info,
                                        param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                        param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clGetImageInfo(image, param_name, param_value_size, param_value,
                                 param_value_size_ret)
    @ccall libopencl.clGetImageInfo(image::cl_mem, param_name::cl_image_info,
                                    param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                    param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clGetPipeInfo(pipe, param_name, param_value_size, param_value,
                                param_value_size_ret)
    @ccall libopencl.clGetPipeInfo(pipe::cl_mem, param_name::cl_pipe_info,
                                   param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                   param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clSetMemObjectDestructorCallback(memobj, pfn_notify, user_data)
    @ccall libopencl.clSetMemObjectDestructorCallback(memobj::cl_mem,
                                                      pfn_notify::Ptr{Cvoid},
                                                      user_data::Ptr{Cvoid})::cl_int
end

function clSVMAlloc(context, flags, size, alignment)
    @ccall libopencl.clSVMAlloc(context::cl_context, flags::cl_svm_mem_flags, size::Csize_t,
                                alignment::cl_uint)::CLPtr{Cvoid}
end

function clSVMFree(context, svm_pointer)
    @ccall libopencl.clSVMFree(context::cl_context, svm_pointer::PtrOrCLPtr{Cvoid})::Cvoid
end

function clCreateSamplerWithProperties(context, sampler_properties, errcode_ret)
    @ccall libopencl.clCreateSamplerWithProperties(context::cl_context,
                                                   sampler_properties::Ptr{cl_sampler_properties},
                                                   errcode_ret::Ptr{cl_int})::cl_sampler
end

@checked function clRetainSampler(sampler)
    @ccall libopencl.clRetainSampler(sampler::cl_sampler)::cl_int
end

@checked function clReleaseSampler(sampler)
    @ccall libopencl.clReleaseSampler(sampler::cl_sampler)::cl_int
end

@checked function clGetSamplerInfo(sampler, param_name, param_value_size, param_value,
                                   param_value_size_ret)
    @ccall libopencl.clGetSamplerInfo(sampler::cl_sampler, param_name::cl_sampler_info,
                                      param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                      param_value_size_ret::Ptr{Csize_t})::cl_int
end

function clCreateProgramWithSource(context, count, strings, lengths, errcode_ret)
    @ccall libopencl.clCreateProgramWithSource(context::cl_context, count::cl_uint,
                                               strings::Ptr{Ptr{Cchar}},
                                               lengths::Ptr{Csize_t},
                                               errcode_ret::Ptr{cl_int})::cl_program
end

function clCreateProgramWithBinary(context, num_devices, device_list, lengths, binaries,
                                   binary_status, errcode_ret)
    @ccall libopencl.clCreateProgramWithBinary(context::cl_context, num_devices::cl_uint,
                                               device_list::Ptr{cl_device_id},
                                               lengths::Ptr{Csize_t},
                                               binaries::Ptr{Ptr{Cuchar}},
                                               binary_status::Ptr{cl_int},
                                               errcode_ret::Ptr{cl_int})::cl_program
end

function clCreateProgramWithBuiltInKernels(context, num_devices, device_list, kernel_names,
                                           errcode_ret)
    @ccall libopencl.clCreateProgramWithBuiltInKernels(context::cl_context,
                                                       num_devices::cl_uint,
                                                       device_list::Ptr{cl_device_id},
                                                       kernel_names::Ptr{Cchar},
                                                       errcode_ret::Ptr{cl_int})::cl_program
end

function clCreateProgramWithIL(context, il, length, errcode_ret)
    @ccall libopencl.clCreateProgramWithIL(context::cl_context, il::Ptr{Cvoid},
                                           length::Csize_t,
                                           errcode_ret::Ptr{cl_int})::cl_program
end

@checked function clRetainProgram(program)
    @ccall libopencl.clRetainProgram(program::cl_program)::cl_int
end

@checked function clReleaseProgram(program)
    @ccall libopencl.clReleaseProgram(program::cl_program)::cl_int
end

@checked function clBuildProgram(program, num_devices, device_list, options, pfn_notify,
                                 user_data)
    @ccall libopencl.clBuildProgram(program::cl_program, num_devices::cl_uint,
                                    device_list::Ptr{cl_device_id}, options::Ptr{Cchar},
                                    pfn_notify::Ptr{Cvoid}, user_data::Ptr{Cvoid})::cl_int
end

@checked function clCompileProgram(program, num_devices, device_list, options,
                                   num_input_headers, input_headers, header_include_names,
                                   pfn_notify, user_data)
    @ccall libopencl.clCompileProgram(program::cl_program, num_devices::cl_uint,
                                      device_list::Ptr{cl_device_id}, options::Ptr{Cchar},
                                      num_input_headers::cl_uint,
                                      input_headers::Ptr{cl_program},
                                      header_include_names::Ptr{Ptr{Cchar}},
                                      pfn_notify::Ptr{Cvoid}, user_data::Ptr{Cvoid})::cl_int
end

function clLinkProgram(context, num_devices, device_list, options, num_input_programs,
                       input_programs, pfn_notify, user_data, errcode_ret)
    @ccall libopencl.clLinkProgram(context::cl_context, num_devices::cl_uint,
                                   device_list::Ptr{cl_device_id}, options::Ptr{Cchar},
                                   num_input_programs::cl_uint,
                                   input_programs::Ptr{cl_program}, pfn_notify::Ptr{Cvoid},
                                   user_data::Ptr{Cvoid},
                                   errcode_ret::Ptr{cl_int})::cl_program
end

@checked function clSetProgramReleaseCallback(program, pfn_notify, user_data)
    @ccall libopencl.clSetProgramReleaseCallback(program::cl_program,
                                                 pfn_notify::Ptr{Cvoid},
                                                 user_data::Ptr{Cvoid})::cl_int
end

@checked function clSetProgramSpecializationConstant(program, spec_id, spec_size,
                                                     spec_value)
    @ccall libopencl.clSetProgramSpecializationConstant(program::cl_program,
                                                        spec_id::cl_uint,
                                                        spec_size::Csize_t,
                                                        spec_value::Ptr{Cvoid})::cl_int
end

@checked function clUnloadPlatformCompiler(platform)
    @ccall libopencl.clUnloadPlatformCompiler(platform::cl_platform_id)::cl_int
end

@checked function clGetProgramInfo(program, param_name, param_value_size, param_value,
                                   param_value_size_ret)
    @ccall libopencl.clGetProgramInfo(program::cl_program, param_name::cl_program_info,
                                      param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                      param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clGetProgramBuildInfo(program, device, param_name, param_value_size,
                                        param_value, param_value_size_ret)
    @ccall libopencl.clGetProgramBuildInfo(program::cl_program, device::cl_device_id,
                                           param_name::cl_program_build_info,
                                           param_value_size::Csize_t,
                                           param_value::Ptr{Cvoid},
                                           param_value_size_ret::Ptr{Csize_t})::cl_int
end

function clCreateKernel(program, kernel_name, errcode_ret)
    @ccall libopencl.clCreateKernel(program::cl_program, kernel_name::Ptr{Cchar},
                                    errcode_ret::Ptr{cl_int})::cl_kernel
end

@checked function clCreateKernelsInProgram(program, num_kernels, kernels, num_kernels_ret)
    @ccall libopencl.clCreateKernelsInProgram(program::cl_program, num_kernels::cl_uint,
                                              kernels::Ptr{cl_kernel},
                                              num_kernels_ret::Ptr{cl_uint})::cl_int
end

function clCloneKernel(source_kernel, errcode_ret)
    @ccall libopencl.clCloneKernel(source_kernel::cl_kernel,
                                   errcode_ret::Ptr{cl_int})::cl_kernel
end

@checked function clRetainKernel(kernel)
    @ccall libopencl.clRetainKernel(kernel::cl_kernel)::cl_int
end

@checked function clReleaseKernel(kernel)
    @ccall libopencl.clReleaseKernel(kernel::cl_kernel)::cl_int
end

@checked function clSetKernelArg(kernel, arg_index, arg_size, arg_value)
    @ccall libopencl.clSetKernelArg(kernel::cl_kernel, arg_index::cl_uint,
                                    arg_size::Csize_t, arg_value::Ptr{Cvoid})::cl_int
end

@checked function clSetKernelArgSVMPointer(kernel, arg_index, arg_value)
    @ccall libopencl.clSetKernelArgSVMPointer(kernel::cl_kernel, arg_index::cl_uint,
                                              arg_value::PtrOrCLPtr{Cvoid})::cl_int
end

@checked function clSetKernelExecInfo(kernel, param_name, param_value_size, param_value)
    @ccall libopencl.clSetKernelExecInfo(kernel::cl_kernel, param_name::cl_kernel_exec_info,
                                         param_value_size::Csize_t,
                                         param_value::Ptr{Cvoid})::cl_int
end

@checked function clGetKernelInfo(kernel, param_name, param_value_size, param_value,
                                  param_value_size_ret)
    @ccall libopencl.clGetKernelInfo(kernel::cl_kernel, param_name::cl_kernel_info,
                                     param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                     param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clGetKernelArgInfo(kernel, arg_indx, param_name, param_value_size,
                                     param_value, param_value_size_ret)
    @ccall libopencl.clGetKernelArgInfo(kernel::cl_kernel, arg_indx::cl_uint,
                                        param_name::cl_kernel_arg_info,
                                        param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                        param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clGetKernelWorkGroupInfo(kernel, device, param_name, param_value_size,
                                           param_value, param_value_size_ret)
    @ccall libopencl.clGetKernelWorkGroupInfo(kernel::cl_kernel, device::cl_device_id,
                                              param_name::cl_kernel_work_group_info,
                                              param_value_size::Csize_t,
                                              param_value::Ptr{Cvoid},
                                              param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clGetKernelSubGroupInfo(kernel, device, param_name, input_value_size,
                                          input_value, param_value_size, param_value,
                                          param_value_size_ret)
    @ccall libopencl.clGetKernelSubGroupInfo(kernel::cl_kernel, device::cl_device_id,
                                             param_name::cl_kernel_sub_group_info,
                                             input_value_size::Csize_t,
                                             input_value::Ptr{Cvoid},
                                             param_value_size::Csize_t,
                                             param_value::Ptr{Cvoid},
                                             param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clWaitForEvents(num_events, event_list)
    @ccall libopencl.clWaitForEvents(num_events::cl_uint, event_list::Ptr{cl_event})::cl_int
end

@checked function clGetEventInfo(event, param_name, param_value_size, param_value,
                                 param_value_size_ret)
    @ccall libopencl.clGetEventInfo(event::cl_event, param_name::cl_event_info,
                                    param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                    param_value_size_ret::Ptr{Csize_t})::cl_int
end

function clCreateUserEvent(context, errcode_ret)
    @ccall libopencl.clCreateUserEvent(context::cl_context,
                                       errcode_ret::Ptr{cl_int})::cl_event
end

@checked function clRetainEvent(event)
    @ccall libopencl.clRetainEvent(event::cl_event)::cl_int
end

@checked function clReleaseEvent(event)
    @ccall libopencl.clReleaseEvent(event::cl_event)::cl_int
end

@checked function clSetUserEventStatus(event, execution_status)
    @ccall libopencl.clSetUserEventStatus(event::cl_event, execution_status::cl_int)::cl_int
end

@checked function clSetEventCallback(event, command_exec_callback_type, pfn_notify,
                                     user_data)
    @ccall libopencl.clSetEventCallback(event::cl_event, command_exec_callback_type::cl_int,
                                        pfn_notify::Ptr{Cvoid},
                                        user_data::Ptr{Cvoid})::cl_int
end

@checked function clGetEventProfilingInfo(event, param_name, param_value_size, param_value,
                                          param_value_size_ret)
    @ccall libopencl.clGetEventProfilingInfo(event::cl_event, param_name::cl_profiling_info,
                                             param_value_size::Csize_t,
                                             param_value::Ptr{Cvoid},
                                             param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clFlush(command_queue)
    @ccall libopencl.clFlush(command_queue::cl_command_queue)::cl_int
end

@checked function clFinish(command_queue)
    @ccall libopencl.clFinish(command_queue::cl_command_queue)::cl_int
end

@checked function clEnqueueReadBuffer(command_queue, buffer, blocking_read, offset, size,
                                      ptr, num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueReadBuffer(command_queue::cl_command_queue, buffer::cl_mem,
                                         blocking_read::cl_bool, offset::Csize_t,
                                         size::Csize_t, ptr::Ptr{Cvoid},
                                         num_events_in_wait_list::cl_uint,
                                         event_wait_list::Ptr{cl_event},
                                         event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueReadBufferRect(command_queue, buffer, blocking_read,
                                          buffer_origin, host_origin, region,
                                          buffer_row_pitch, buffer_slice_pitch,
                                          host_row_pitch, host_slice_pitch, ptr,
                                          num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueReadBufferRect(command_queue::cl_command_queue,
                                             buffer::cl_mem, blocking_read::cl_bool,
                                             buffer_origin::Ptr{Csize_t},
                                             host_origin::Ptr{Csize_t},
                                             region::Ptr{Csize_t},
                                             buffer_row_pitch::Csize_t,
                                             buffer_slice_pitch::Csize_t,
                                             host_row_pitch::Csize_t,
                                             host_slice_pitch::Csize_t, ptr::Ptr{Cvoid},
                                             num_events_in_wait_list::cl_uint,
                                             event_wait_list::Ptr{cl_event},
                                             event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueWriteBuffer(command_queue, buffer, blocking_write, offset, size,
                                       ptr, num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueWriteBuffer(command_queue::cl_command_queue, buffer::cl_mem,
                                          blocking_write::cl_bool, offset::Csize_t,
                                          size::Csize_t, ptr::Ptr{Cvoid},
                                          num_events_in_wait_list::cl_uint,
                                          event_wait_list::Ptr{cl_event},
                                          event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueWriteBufferRect(command_queue, buffer, blocking_write,
                                           buffer_origin, host_origin, region,
                                           buffer_row_pitch, buffer_slice_pitch,
                                           host_row_pitch, host_slice_pitch, ptr,
                                           num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueWriteBufferRect(command_queue::cl_command_queue,
                                              buffer::cl_mem, blocking_write::cl_bool,
                                              buffer_origin::Ptr{Csize_t},
                                              host_origin::Ptr{Csize_t},
                                              region::Ptr{Csize_t},
                                              buffer_row_pitch::Csize_t,
                                              buffer_slice_pitch::Csize_t,
                                              host_row_pitch::Csize_t,
                                              host_slice_pitch::Csize_t, ptr::Ptr{Cvoid},
                                              num_events_in_wait_list::cl_uint,
                                              event_wait_list::Ptr{cl_event},
                                              event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueFillBuffer(command_queue, buffer, pattern, pattern_size, offset,
                                      size, num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueFillBuffer(command_queue::cl_command_queue, buffer::cl_mem,
                                         pattern::Ptr{Cvoid}, pattern_size::Csize_t,
                                         offset::Csize_t, size::Csize_t,
                                         num_events_in_wait_list::cl_uint,
                                         event_wait_list::Ptr{cl_event},
                                         event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueCopyBuffer(command_queue, src_buffer, dst_buffer, src_offset,
                                      dst_offset, size, num_events_in_wait_list,
                                      event_wait_list, event)
    @ccall libopencl.clEnqueueCopyBuffer(command_queue::cl_command_queue,
                                         src_buffer::cl_mem, dst_buffer::cl_mem,
                                         src_offset::Csize_t, dst_offset::Csize_t,
                                         size::Csize_t, num_events_in_wait_list::cl_uint,
                                         event_wait_list::Ptr{cl_event},
                                         event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueCopyBufferRect(command_queue, src_buffer, dst_buffer, src_origin,
                                          dst_origin, region, src_row_pitch,
                                          src_slice_pitch, dst_row_pitch, dst_slice_pitch,
                                          num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueCopyBufferRect(command_queue::cl_command_queue,
                                             src_buffer::cl_mem, dst_buffer::cl_mem,
                                             src_origin::Ptr{Csize_t},
                                             dst_origin::Ptr{Csize_t}, region::Ptr{Csize_t},
                                             src_row_pitch::Csize_t,
                                             src_slice_pitch::Csize_t,
                                             dst_row_pitch::Csize_t,
                                             dst_slice_pitch::Csize_t,
                                             num_events_in_wait_list::cl_uint,
                                             event_wait_list::Ptr{cl_event},
                                             event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueReadImage(command_queue, image, blocking_read, origin, region,
                                     row_pitch, slice_pitch, ptr, num_events_in_wait_list,
                                     event_wait_list, event)
    @ccall libopencl.clEnqueueReadImage(command_queue::cl_command_queue, image::cl_mem,
                                        blocking_read::cl_bool, origin::Ptr{Csize_t},
                                        region::Ptr{Csize_t}, row_pitch::Csize_t,
                                        slice_pitch::Csize_t, ptr::Ptr{Cvoid},
                                        num_events_in_wait_list::cl_uint,
                                        event_wait_list::Ptr{cl_event},
                                        event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueWriteImage(command_queue, image, blocking_write, origin, region,
                                      input_row_pitch, input_slice_pitch, ptr,
                                      num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueWriteImage(command_queue::cl_command_queue, image::cl_mem,
                                         blocking_write::cl_bool, origin::Ptr{Csize_t},
                                         region::Ptr{Csize_t}, input_row_pitch::Csize_t,
                                         input_slice_pitch::Csize_t, ptr::Ptr{Cvoid},
                                         num_events_in_wait_list::cl_uint,
                                         event_wait_list::Ptr{cl_event},
                                         event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueFillImage(command_queue, image, fill_color, origin, region,
                                     num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueFillImage(command_queue::cl_command_queue, image::cl_mem,
                                        fill_color::Ptr{Cvoid}, origin::Ptr{Csize_t},
                                        region::Ptr{Csize_t},
                                        num_events_in_wait_list::cl_uint,
                                        event_wait_list::Ptr{cl_event},
                                        event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueCopyImage(command_queue, src_image, dst_image, src_origin,
                                     dst_origin, region, num_events_in_wait_list,
                                     event_wait_list, event)
    @ccall libopencl.clEnqueueCopyImage(command_queue::cl_command_queue, src_image::cl_mem,
                                        dst_image::cl_mem, src_origin::Ptr{Csize_t},
                                        dst_origin::Ptr{Csize_t}, region::Ptr{Csize_t},
                                        num_events_in_wait_list::cl_uint,
                                        event_wait_list::Ptr{cl_event},
                                        event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueCopyImageToBuffer(command_queue, src_image, dst_buffer,
                                             src_origin, region, dst_offset,
                                             num_events_in_wait_list, event_wait_list,
                                             event)
    @ccall libopencl.clEnqueueCopyImageToBuffer(command_queue::cl_command_queue,
                                                src_image::cl_mem, dst_buffer::cl_mem,
                                                src_origin::Ptr{Csize_t},
                                                region::Ptr{Csize_t}, dst_offset::Csize_t,
                                                num_events_in_wait_list::cl_uint,
                                                event_wait_list::Ptr{cl_event},
                                                event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueCopyBufferToImage(command_queue, src_buffer, dst_image,
                                             src_offset, dst_origin, region,
                                             num_events_in_wait_list, event_wait_list,
                                             event)
    @ccall libopencl.clEnqueueCopyBufferToImage(command_queue::cl_command_queue,
                                                src_buffer::cl_mem, dst_image::cl_mem,
                                                src_offset::Csize_t,
                                                dst_origin::Ptr{Csize_t},
                                                region::Ptr{Csize_t},
                                                num_events_in_wait_list::cl_uint,
                                                event_wait_list::Ptr{cl_event},
                                                event::Ptr{cl_event})::cl_int
end

function clEnqueueMapBuffer(command_queue, buffer, blocking_map, map_flags, offset, size,
                            num_events_in_wait_list, event_wait_list, event, errcode_ret)
    @ccall libopencl.clEnqueueMapBuffer(command_queue::cl_command_queue, buffer::cl_mem,
                                        blocking_map::cl_bool, map_flags::cl_map_flags,
                                        offset::Csize_t, size::Csize_t,
                                        num_events_in_wait_list::cl_uint,
                                        event_wait_list::Ptr{cl_event},
                                        event::Ptr{cl_event},
                                        errcode_ret::Ptr{cl_int})::Ptr{Cvoid}
end

function clEnqueueMapImage(command_queue, image, blocking_map, map_flags, origin, region,
                           image_row_pitch, image_slice_pitch, num_events_in_wait_list,
                           event_wait_list, event, errcode_ret)
    @ccall libopencl.clEnqueueMapImage(command_queue::cl_command_queue, image::cl_mem,
                                       blocking_map::cl_bool, map_flags::cl_map_flags,
                                       origin::Ptr{Csize_t}, region::Ptr{Csize_t},
                                       image_row_pitch::Ptr{Csize_t},
                                       image_slice_pitch::Ptr{Csize_t},
                                       num_events_in_wait_list::cl_uint,
                                       event_wait_list::Ptr{cl_event}, event::Ptr{cl_event},
                                       errcode_ret::Ptr{cl_int})::Ptr{Cvoid}
end

@checked function clEnqueueUnmapMemObject(command_queue, memobj, mapped_ptr,
                                          num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueUnmapMemObject(command_queue::cl_command_queue,
                                             memobj::cl_mem, mapped_ptr::Ptr{Cvoid},
                                             num_events_in_wait_list::cl_uint,
                                             event_wait_list::Ptr{cl_event},
                                             event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueMigrateMemObjects(command_queue, num_mem_objects, mem_objects,
                                             flags, num_events_in_wait_list,
                                             event_wait_list, event)
    @ccall libopencl.clEnqueueMigrateMemObjects(command_queue::cl_command_queue,
                                                num_mem_objects::cl_uint,
                                                mem_objects::Ptr{cl_mem},
                                                flags::cl_mem_migration_flags,
                                                num_events_in_wait_list::cl_uint,
                                                event_wait_list::Ptr{cl_event},
                                                event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueNDRangeKernel(command_queue, kernel, work_dim,
                                         global_work_offset, global_work_size,
                                         local_work_size, num_events_in_wait_list,
                                         event_wait_list, event)
    @ccall libopencl.clEnqueueNDRangeKernel(command_queue::cl_command_queue,
                                            kernel::cl_kernel, work_dim::cl_uint,
                                            global_work_offset::Ptr{Csize_t},
                                            global_work_size::Ptr{Csize_t},
                                            local_work_size::Ptr{Csize_t},
                                            num_events_in_wait_list::cl_uint,
                                            event_wait_list::Ptr{cl_event},
                                            event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueNativeKernel(command_queue, user_func, args, cb_args,
                                        num_mem_objects, mem_list, args_mem_loc,
                                        num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueNativeKernel(command_queue::cl_command_queue,
                                           user_func::Ptr{Cvoid}, args::Ptr{Cvoid},
                                           cb_args::Csize_t, num_mem_objects::cl_uint,
                                           mem_list::Ptr{cl_mem},
                                           args_mem_loc::Ptr{Ptr{Cvoid}},
                                           num_events_in_wait_list::cl_uint,
                                           event_wait_list::Ptr{cl_event},
                                           event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueMarkerWithWaitList(command_queue, num_events_in_wait_list,
                                              event_wait_list, event)
    @ccall libopencl.clEnqueueMarkerWithWaitList(command_queue::cl_command_queue,
                                                 num_events_in_wait_list::cl_uint,
                                                 event_wait_list::Ptr{cl_event},
                                                 event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueBarrierWithWaitList(command_queue, num_events_in_wait_list,
                                               event_wait_list, event)
    @ccall libopencl.clEnqueueBarrierWithWaitList(command_queue::cl_command_queue,
                                                  num_events_in_wait_list::cl_uint,
                                                  event_wait_list::Ptr{cl_event},
                                                  event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSVMFree(command_queue, num_svm_pointers, svm_pointers,
                                   pfn_free_func, user_data, num_events_in_wait_list,
                                   event_wait_list, event)
    @ccall libopencl.clEnqueueSVMFree(command_queue::cl_command_queue,
                                      num_svm_pointers::cl_uint,
                                      svm_pointers::Ptr{Ptr{Cvoid}},
                                      pfn_free_func::Ptr{Cvoid}, user_data::Ptr{Cvoid},
                                      num_events_in_wait_list::cl_uint,
                                      event_wait_list::Ptr{cl_event},
                                      event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSVMMemcpy(command_queue, blocking_copy, dst_ptr, src_ptr, size,
                                     num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueSVMMemcpy(command_queue::cl_command_queue,
                                        blocking_copy::cl_bool, dst_ptr::PtrOrCLPtr{Cvoid},
                                        src_ptr::PtrOrCLPtr{Cvoid}, size::Csize_t,
                                        num_events_in_wait_list::cl_uint,
                                        event_wait_list::Ptr{cl_event},
                                        event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSVMMemFill(command_queue, svm_ptr, pattern, pattern_size, size,
                                      num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueSVMMemFill(command_queue::cl_command_queue,
                                         svm_ptr::CLPtr{Cvoid}, pattern::Ptr{Cvoid},
                                         pattern_size::Csize_t, size::Csize_t,
                                         num_events_in_wait_list::cl_uint,
                                         event_wait_list::Ptr{cl_event},
                                         event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSVMMap(command_queue, blocking_map, flags, svm_ptr, size,
                                  num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueSVMMap(command_queue::cl_command_queue, blocking_map::cl_bool,
                                     flags::cl_map_flags, svm_ptr::CLPtr{Cvoid},
                                     size::Csize_t, num_events_in_wait_list::cl_uint,
                                     event_wait_list::Ptr{cl_event},
                                     event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSVMUnmap(command_queue, svm_ptr, num_events_in_wait_list,
                                    event_wait_list, event)
    @ccall libopencl.clEnqueueSVMUnmap(command_queue::cl_command_queue,
                                       svm_ptr::CLPtr{Cvoid},
                                       num_events_in_wait_list::cl_uint,
                                       event_wait_list::Ptr{cl_event},
                                       event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSVMMigrateMem(command_queue, num_svm_pointers, svm_pointers,
                                         sizes, flags, num_events_in_wait_list,
                                         event_wait_list, event)
    @ccall libopencl.clEnqueueSVMMigrateMem(command_queue::cl_command_queue,
                                            num_svm_pointers::cl_uint,
                                            svm_pointers::Ptr{CLPtr{Cvoid}},
                                            sizes::Ptr{Csize_t},
                                            flags::cl_mem_migration_flags,
                                            num_events_in_wait_list::cl_uint,
                                            event_wait_list::Ptr{cl_event},
                                            event::Ptr{cl_event})::cl_int
end

function clGetExtensionFunctionAddressForPlatform(platform, func_name)
    @ccall libopencl.clGetExtensionFunctionAddressForPlatform(platform::cl_platform_id,
                                                              func_name::Ptr{Cchar})::Ptr{Cvoid}
end

function clCreateImage2D(context, flags, image_format, image_width, image_height,
                         image_row_pitch, host_ptr, errcode_ret)
    @ccall libopencl.clCreateImage2D(context::cl_context, flags::cl_mem_flags,
                                     image_format::Ptr{cl_image_format},
                                     image_width::Csize_t, image_height::Csize_t,
                                     image_row_pitch::Csize_t, host_ptr::Ptr{Cvoid},
                                     errcode_ret::Ptr{cl_int})::cl_mem
end

function clCreateImage3D(context, flags, image_format, image_width, image_height,
                         image_depth, image_row_pitch, image_slice_pitch, host_ptr,
                         errcode_ret)
    @ccall libopencl.clCreateImage3D(context::cl_context, flags::cl_mem_flags,
                                     image_format::Ptr{cl_image_format},
                                     image_width::Csize_t, image_height::Csize_t,
                                     image_depth::Csize_t, image_row_pitch::Csize_t,
                                     image_slice_pitch::Csize_t, host_ptr::Ptr{Cvoid},
                                     errcode_ret::Ptr{cl_int})::cl_mem
end

@checked function clEnqueueMarker(command_queue, event)
    @ccall libopencl.clEnqueueMarker(command_queue::cl_command_queue,
                                     event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueWaitForEvents(command_queue, num_events, event_list)
    @ccall libopencl.clEnqueueWaitForEvents(command_queue::cl_command_queue,
                                            num_events::cl_uint,
                                            event_list::Ptr{cl_event})::cl_int
end

@checked function clEnqueueBarrier(command_queue)
    @ccall libopencl.clEnqueueBarrier(command_queue::cl_command_queue)::cl_int
end

@checked function clUnloadCompiler()
    @ccall libopencl.clUnloadCompiler()::cl_int
end

function clGetExtensionFunctionAddress(func_name)
    @ccall libopencl.clGetExtensionFunctionAddress(func_name::Ptr{Cchar})::Ptr{Cvoid}
end

function clCreateCommandQueue(context, device, properties, errcode_ret)
    @ccall libopencl.clCreateCommandQueue(context::cl_context, device::cl_device_id,
                                          properties::cl_command_queue_properties,
                                          errcode_ret::Ptr{cl_int})::cl_command_queue
end

function clCreateSampler(context, normalized_coords, addressing_mode, filter_mode,
                         errcode_ret)
    @ccall libopencl.clCreateSampler(context::cl_context, normalized_coords::cl_bool,
                                     addressing_mode::cl_addressing_mode,
                                     filter_mode::cl_filter_mode,
                                     errcode_ret::Ptr{cl_int})::cl_sampler
end

@checked function clEnqueueTask(command_queue, kernel, num_events_in_wait_list,
                                event_wait_list, event)
    @ccall libopencl.clEnqueueTask(command_queue::cl_command_queue, kernel::cl_kernel,
                                   num_events_in_wait_list::cl_uint,
                                   event_wait_list::Ptr{cl_event},
                                   event::Ptr{cl_event})::cl_int
end

const cl_GLint = Cint

const cl_GLenum = Cuint

const cl_GLuint = Cuint

const cl_gl_context_info = cl_uint

const cl_gl_object_type = cl_uint

const cl_gl_texture_info = cl_uint

const cl_gl_platform_info = cl_uint

# typedef cl_int CL_API_CALL clGetGLContextInfoKHR_t ( const cl_context_properties * properties , cl_gl_context_info param_name , size_t param_value_size , void * param_value , size_t * param_value_size_ret )
const clGetGLContextInfoKHR_t = Cvoid

const clGetGLContextInfoKHR_fn = Ptr{clGetGLContextInfoKHR_t}

# typedef cl_mem CL_API_CALL clCreateFromGLBuffer_t ( cl_context context , cl_mem_flags flags , cl_GLuint bufobj , cl_int * errcode_ret )
const clCreateFromGLBuffer_t = Cvoid

const clCreateFromGLBuffer_fn = Ptr{clCreateFromGLBuffer_t}

@checked function clGetGLContextInfoKHR(properties, param_name, param_value_size,
                                        param_value, param_value_size_ret)
    @ccall libopencl.clGetGLContextInfoKHR(properties::Ptr{cl_context_properties},
                                           param_name::cl_gl_context_info,
                                           param_value_size::Csize_t,
                                           param_value::Ptr{Cvoid},
                                           param_value_size_ret::Ptr{Csize_t})::cl_int
end

function clCreateFromGLBuffer(context, flags, bufobj, errcode_ret)
    @ccall libopencl.clCreateFromGLBuffer(context::cl_context, flags::cl_mem_flags,
                                          bufobj::cl_GLuint,
                                          errcode_ret::Ptr{cl_int})::cl_mem
end

# typedef cl_mem CL_API_CALL clCreateFromGLTexture_t ( cl_context context , cl_mem_flags flags , cl_GLenum target , cl_GLint miplevel , cl_GLuint texture , cl_int * errcode_ret )
const clCreateFromGLTexture_t = Cvoid

const clCreateFromGLTexture_fn = Ptr{clCreateFromGLTexture_t}

function clCreateFromGLTexture(context, flags, target, miplevel, texture, errcode_ret)
    @ccall libopencl.clCreateFromGLTexture(context::cl_context, flags::cl_mem_flags,
                                           target::cl_GLenum, miplevel::cl_GLint,
                                           texture::cl_GLuint,
                                           errcode_ret::Ptr{cl_int})::cl_mem
end

# typedef cl_mem CL_API_CALL clCreateFromGLRenderbuffer_t ( cl_context context , cl_mem_flags flags , cl_GLuint renderbuffer , cl_int * errcode_ret )
const clCreateFromGLRenderbuffer_t = Cvoid

const clCreateFromGLRenderbuffer_fn = Ptr{clCreateFromGLRenderbuffer_t}

# typedef cl_int CL_API_CALL clGetGLObjectInfo_t ( cl_mem memobj , cl_gl_object_type * gl_object_type , cl_GLuint * gl_object_name )
const clGetGLObjectInfo_t = Cvoid

const clGetGLObjectInfo_fn = Ptr{clGetGLObjectInfo_t}

# typedef cl_int CL_API_CALL clGetGLTextureInfo_t ( cl_mem memobj , cl_gl_texture_info param_name , size_t param_value_size , void * param_value , size_t * param_value_size_ret )
const clGetGLTextureInfo_t = Cvoid

const clGetGLTextureInfo_fn = Ptr{clGetGLTextureInfo_t}

# typedef cl_int CL_API_CALL clEnqueueAcquireGLObjects_t ( cl_command_queue command_queue , cl_uint num_objects , const cl_mem * mem_objects , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueAcquireGLObjects_t = Cvoid

const clEnqueueAcquireGLObjects_fn = Ptr{clEnqueueAcquireGLObjects_t}

# typedef cl_int CL_API_CALL clEnqueueReleaseGLObjects_t ( cl_command_queue command_queue , cl_uint num_objects , const cl_mem * mem_objects , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueReleaseGLObjects_t = Cvoid

const clEnqueueReleaseGLObjects_fn = Ptr{clEnqueueReleaseGLObjects_t}

function clCreateFromGLRenderbuffer(context, flags, renderbuffer, errcode_ret)
    @ccall libopencl.clCreateFromGLRenderbuffer(context::cl_context, flags::cl_mem_flags,
                                                renderbuffer::cl_GLuint,
                                                errcode_ret::Ptr{cl_int})::cl_mem
end

@checked function clGetGLObjectInfo(memobj, gl_object_type, gl_object_name)
    @ccall libopencl.clGetGLObjectInfo(memobj::cl_mem,
                                       gl_object_type::Ptr{cl_gl_object_type},
                                       gl_object_name::Ptr{cl_GLuint})::cl_int
end

@checked function clGetGLTextureInfo(memobj, param_name, param_value_size, param_value,
                                     param_value_size_ret)
    @ccall libopencl.clGetGLTextureInfo(memobj::cl_mem, param_name::cl_gl_texture_info,
                                        param_value_size::Csize_t, param_value::Ptr{Cvoid},
                                        param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clEnqueueAcquireGLObjects(command_queue, num_objects, mem_objects,
                                            num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueAcquireGLObjects(command_queue::cl_command_queue,
                                               num_objects::cl_uint,
                                               mem_objects::Ptr{cl_mem},
                                               num_events_in_wait_list::cl_uint,
                                               event_wait_list::Ptr{cl_event},
                                               event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueReleaseGLObjects(command_queue, num_objects, mem_objects,
                                            num_events_in_wait_list, event_wait_list, event)
    @ccall libopencl.clEnqueueReleaseGLObjects(command_queue::cl_command_queue,
                                               num_objects::cl_uint,
                                               mem_objects::Ptr{cl_mem},
                                               num_events_in_wait_list::cl_uint,
                                               event_wait_list::Ptr{cl_event},
                                               event::Ptr{cl_event})::cl_int
end

# typedef cl_mem CL_API_CALL clCreateFromGLTexture2D_t ( cl_context context , cl_mem_flags flags , cl_GLenum target , cl_GLint miplevel , cl_GLuint texture , cl_int * errcode_ret )
const clCreateFromGLTexture2D_t = Cvoid

const clCreateFromGLTexture2D_fn = Ptr{clCreateFromGLTexture2D_t}

# typedef cl_mem CL_API_CALL clCreateFromGLTexture3D_t ( cl_context context , cl_mem_flags flags , cl_GLenum target , cl_GLint miplevel , cl_GLuint texture , cl_int * errcode_ret )
const clCreateFromGLTexture3D_t = Cvoid

const clCreateFromGLTexture3D_fn = Ptr{clCreateFromGLTexture3D_t}

function clCreateFromGLTexture2D(context, flags, target, miplevel, texture, errcode_ret)
    @ccall libopencl.clCreateFromGLTexture2D(context::cl_context, flags::cl_mem_flags,
                                             target::cl_GLenum, miplevel::cl_GLint,
                                             texture::cl_GLuint,
                                             errcode_ret::Ptr{cl_int})::cl_mem
end

function clCreateFromGLTexture3D(context, flags, target, miplevel, texture, errcode_ret)
    @ccall libopencl.clCreateFromGLTexture3D(context::cl_context, flags::cl_mem_flags,
                                             target::cl_GLenum, miplevel::cl_GLint,
                                             texture::cl_GLuint,
                                             errcode_ret::Ptr{cl_int})::cl_mem
end

mutable struct __GLsync end

const cl_GLsync = Ptr{__GLsync}

# typedef cl_event CL_API_CALL clCreateEventFromGLsyncKHR_t ( cl_context context , cl_GLsync sync , cl_int * errcode_ret )
const clCreateEventFromGLsyncKHR_t = Cvoid

const clCreateEventFromGLsyncKHR_fn = Ptr{clCreateEventFromGLsyncKHR_t}

function clCreateEventFromGLsyncKHR(context, sync, errcode_ret)
    @ccall libopencl.clCreateEventFromGLsyncKHR(context::cl_context, sync::cl_GLsync,
                                                errcode_ret::Ptr{cl_int})::cl_event
end

# typedef cl_int CL_API_CALL clGetSupportedGLTextureFormatsINTEL_t ( cl_context context , cl_mem_flags flags , cl_mem_object_type image_type , cl_uint num_entries , cl_GLenum * gl_formats , cl_uint * num_texture_formats )
const clGetSupportedGLTextureFormatsINTEL_t = Cvoid

const clGetSupportedGLTextureFormatsINTEL_fn = Ptr{clGetSupportedGLTextureFormatsINTEL_t}

@checked function clGetSupportedGLTextureFormatsINTEL(context, flags, image_type,
                                                      num_entries, gl_formats,
                                                      num_texture_formats)
    @ccall libopencl.clGetSupportedGLTextureFormatsINTEL(context::cl_context,
                                                         flags::cl_mem_flags,
                                                         image_type::cl_mem_object_type,
                                                         num_entries::cl_uint,
                                                         gl_formats::Ptr{cl_GLenum},
                                                         num_texture_formats::Ptr{cl_uint})::cl_int
end

const cl_device_partition_property_ext = cl_ulong

# typedef cl_int CL_API_CALL clSetMemObjectDestructorAPPLE_t ( cl_mem memobj , void ( CL_CALLBACK * pfn_notify ) ( cl_mem memobj , void * user_data ) , void * user_data )
const clSetMemObjectDestructorAPPLE_t = Cvoid

const clSetMemObjectDestructorAPPLE_fn = Ptr{clSetMemObjectDestructorAPPLE_t}

@checked function clSetMemObjectDestructorAPPLE(memobj, pfn_notify, user_data)
    @ext_ccall libopencl.clSetMemObjectDestructorAPPLE(memobj::cl_mem,
                                                       pfn_notify::Ptr{Cvoid},
                                                       user_data::Ptr{Cvoid})::cl_int
end

# typedef void CL_API_CALL clLogMessagesToSystemLogAPPLE_t ( const char * errstr , const void * private_info , size_t cb , void * user_data )
const clLogMessagesToSystemLogAPPLE_t = Cvoid

const clLogMessagesToSystemLogAPPLE_fn = Ptr{clLogMessagesToSystemLogAPPLE_t}

# typedef void CL_API_CALL clLogMessagesToStdoutAPPLE_t ( const char * errstr , const void * private_info , size_t cb , void * user_data )
const clLogMessagesToStdoutAPPLE_t = Cvoid

const clLogMessagesToStdoutAPPLE_fn = Ptr{clLogMessagesToStdoutAPPLE_t}

# typedef void CL_API_CALL clLogMessagesToStderrAPPLE_t ( const char * errstr , const void * private_info , size_t cb , void * user_data )
const clLogMessagesToStderrAPPLE_t = Cvoid

const clLogMessagesToStderrAPPLE_fn = Ptr{clLogMessagesToStderrAPPLE_t}

function clLogMessagesToSystemLogAPPLE(errstr, private_info, cb, user_data)
    @ext_ccall libopencl.clLogMessagesToSystemLogAPPLE(errstr::Ptr{Cchar},
                                                       private_info::Ptr{Cvoid},
                                                       cb::Csize_t,
                                                       user_data::Ptr{Cvoid})::Cvoid
end

function clLogMessagesToStdoutAPPLE(errstr, private_info, cb, user_data)
    @ext_ccall libopencl.clLogMessagesToStdoutAPPLE(errstr::Ptr{Cchar},
                                                    private_info::Ptr{Cvoid}, cb::Csize_t,
                                                    user_data::Ptr{Cvoid})::Cvoid
end

function clLogMessagesToStderrAPPLE(errstr, private_info, cb, user_data)
    @ext_ccall libopencl.clLogMessagesToStderrAPPLE(errstr::Ptr{Cchar},
                                                    private_info::Ptr{Cvoid}, cb::Csize_t,
                                                    user_data::Ptr{Cvoid})::Cvoid
end

# typedef cl_int CL_API_CALL clIcdGetPlatformIDsKHR_t ( cl_uint num_entries , cl_platform_id * platforms , cl_uint * num_platforms )
const clIcdGetPlatformIDsKHR_t = Cvoid

const clIcdGetPlatformIDsKHR_fn = Ptr{clIcdGetPlatformIDsKHR_t}

# typedef void * CL_API_CALL clIcdGetFunctionAddressForPlatformKHR_t ( cl_platform_id platform , const char * func_name )
const clIcdGetFunctionAddressForPlatformKHR_t = Cvoid

const clIcdGetFunctionAddressForPlatformKHR_fn = Ptr{clIcdGetFunctionAddressForPlatformKHR_t}

# typedef cl_int CL_API_CALL clIcdSetPlatformDispatchDataKHR_t ( cl_platform_id platform , void * dispatch_data )
const clIcdSetPlatformDispatchDataKHR_t = Cvoid

const clIcdSetPlatformDispatchDataKHR_fn = Ptr{clIcdSetPlatformDispatchDataKHR_t}

@checked function clIcdGetPlatformIDsKHR(num_entries, platforms, num_platforms)
    @ext_ccall libopencl.clIcdGetPlatformIDsKHR(num_entries::cl_uint,
                                                platforms::Ptr{cl_platform_id},
                                                num_platforms::Ptr{cl_uint})::cl_int
end

function clIcdGetFunctionAddressForPlatformKHR(platform, func_name)
    @ext_ccall libopencl.clIcdGetFunctionAddressForPlatformKHR(platform::cl_platform_id,
                                                               func_name::Ptr{Cchar})::Ptr{Cvoid}
end

@checked function clIcdSetPlatformDispatchDataKHR(platform, dispatch_data)
    @ext_ccall libopencl.clIcdSetPlatformDispatchDataKHR(platform::cl_platform_id,
                                                         dispatch_data::Ptr{Cvoid})::cl_int
end

# typedef cl_program CL_API_CALL clCreateProgramWithILKHR_t ( cl_context context , const void * il , size_t length , cl_int * errcode_ret )
const clCreateProgramWithILKHR_t = Cvoid

const clCreateProgramWithILKHR_fn = Ptr{clCreateProgramWithILKHR_t}

function clCreateProgramWithILKHR(context, il, length, errcode_ret)
    @ext_ccall libopencl.clCreateProgramWithILKHR(context::cl_context, il::Ptr{Cvoid},
                                                  length::Csize_t,
                                                  errcode_ret::Ptr{cl_int})::cl_program
end

const cl_context_memory_initialize_khr = cl_bitfield

const cl_device_terminate_capability_khr = cl_bitfield

# typedef cl_int CL_API_CALL clTerminateContextKHR_t ( cl_context context )
const clTerminateContextKHR_t = Cvoid

const clTerminateContextKHR_fn = Ptr{clTerminateContextKHR_t}

@checked function clTerminateContextKHR(context)
    @ext_ccall libopencl.clTerminateContextKHR(context::cl_context)::cl_int
end

const cl_queue_properties_khr = cl_properties

# typedef cl_command_queue CL_API_CALL clCreateCommandQueueWithPropertiesKHR_t ( cl_context context , cl_device_id device , const cl_queue_properties_khr * properties , cl_int * errcode_ret )
const clCreateCommandQueueWithPropertiesKHR_t = Cvoid

const clCreateCommandQueueWithPropertiesKHR_fn = Ptr{clCreateCommandQueueWithPropertiesKHR_t}

function clCreateCommandQueueWithPropertiesKHR(context, device, properties, errcode_ret)
    @ext_ccall libopencl.clCreateCommandQueueWithPropertiesKHR(context::cl_context,
                                                               device::cl_device_id,
                                                               properties::Ptr{cl_queue_properties_khr},
                                                               errcode_ret::Ptr{cl_int})::cl_command_queue
end

# typedef cl_int CL_API_CALL clReleaseDeviceEXT_t ( cl_device_id device )
const clReleaseDeviceEXT_t = Cvoid

const clReleaseDeviceEXT_fn = Ptr{clReleaseDeviceEXT_t}

# typedef cl_int CL_API_CALL clRetainDeviceEXT_t ( cl_device_id device )
const clRetainDeviceEXT_t = Cvoid

const clRetainDeviceEXT_fn = Ptr{clRetainDeviceEXT_t}

# typedef cl_int CL_API_CALL clCreateSubDevicesEXT_t ( cl_device_id in_device , const cl_device_partition_property_ext * properties , cl_uint num_entries , cl_device_id * out_devices , cl_uint * num_devices )
const clCreateSubDevicesEXT_t = Cvoid

const clCreateSubDevicesEXT_fn = Ptr{clCreateSubDevicesEXT_t}

@checked function clReleaseDeviceEXT(device)
    @ext_ccall libopencl.clReleaseDeviceEXT(device::cl_device_id)::cl_int
end

@checked function clRetainDeviceEXT(device)
    @ext_ccall libopencl.clRetainDeviceEXT(device::cl_device_id)::cl_int
end

@checked function clCreateSubDevicesEXT(in_device, properties, num_entries, out_devices,
                                        num_devices)
    @ext_ccall libopencl.clCreateSubDevicesEXT(in_device::cl_device_id,
                                               properties::Ptr{cl_device_partition_property_ext},
                                               num_entries::cl_uint,
                                               out_devices::Ptr{cl_device_id},
                                               num_devices::Ptr{cl_uint})::cl_int
end

const cl_mem_migration_flags_ext = cl_bitfield

# typedef cl_int CL_API_CALL clEnqueueMigrateMemObjectEXT_t ( cl_command_queue command_queue , cl_uint num_mem_objects , const cl_mem * mem_objects , cl_mem_migration_flags_ext flags , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueMigrateMemObjectEXT_t = Cvoid

const clEnqueueMigrateMemObjectEXT_fn = Ptr{clEnqueueMigrateMemObjectEXT_t}

@checked function clEnqueueMigrateMemObjectEXT(command_queue, num_mem_objects, mem_objects,
                                               flags, num_events_in_wait_list,
                                               event_wait_list, event)
    @ext_ccall libopencl.clEnqueueMigrateMemObjectEXT(command_queue::cl_command_queue,
                                                      num_mem_objects::cl_uint,
                                                      mem_objects::Ptr{cl_mem},
                                                      flags::cl_mem_migration_flags_ext,
                                                      num_events_in_wait_list::cl_uint,
                                                      event_wait_list::Ptr{cl_event},
                                                      event::Ptr{cl_event})::cl_int
end

const cl_image_pitch_info_qcom = cl_uint

struct _cl_mem_ext_host_ptr
    allocation_type::cl_uint
    host_cache_policy::cl_uint
end

const cl_mem_ext_host_ptr = _cl_mem_ext_host_ptr

# typedef cl_int CL_API_CALL clGetDeviceImageInfoQCOM_t ( cl_device_id device , size_t image_width , size_t image_height , const cl_image_format * image_format , cl_image_pitch_info_qcom param_name , size_t param_value_size , void * param_value , size_t * param_value_size_ret )
const clGetDeviceImageInfoQCOM_t = Cvoid

const clGetDeviceImageInfoQCOM_fn = Ptr{clGetDeviceImageInfoQCOM_t}

@checked function clGetDeviceImageInfoQCOM(device, image_width, image_height, image_format,
                                           param_name, param_value_size, param_value,
                                           param_value_size_ret)
    @ext_ccall libopencl.clGetDeviceImageInfoQCOM(device::cl_device_id,
                                                  image_width::Csize_t,
                                                  image_height::Csize_t,
                                                  image_format::Ptr{cl_image_format},
                                                  param_name::cl_image_pitch_info_qcom,
                                                  param_value_size::Csize_t,
                                                  param_value::Ptr{Cvoid},
                                                  param_value_size_ret::Ptr{Csize_t})::cl_int
end

struct _cl_mem_ion_host_ptr
    ext_host_ptr::cl_mem_ext_host_ptr
    ion_filedesc::Cint
    ion_hostptr::Ptr{Cvoid}
end

const cl_mem_ion_host_ptr = _cl_mem_ion_host_ptr

struct _cl_mem_android_native_buffer_host_ptr
    ext_host_ptr::cl_mem_ext_host_ptr
    anb_ptr::Ptr{Cvoid}
end

const cl_mem_android_native_buffer_host_ptr = _cl_mem_android_native_buffer_host_ptr

# typedef cl_int CL_API_CALL clEnqueueAcquireGrallocObjectsIMG_t ( cl_command_queue command_queue , cl_uint num_objects , const cl_mem * mem_objects , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueAcquireGrallocObjectsIMG_t = Cvoid

const clEnqueueAcquireGrallocObjectsIMG_fn = Ptr{clEnqueueAcquireGrallocObjectsIMG_t}

# typedef cl_int CL_API_CALL clEnqueueReleaseGrallocObjectsIMG_t ( cl_command_queue command_queue , cl_uint num_objects , const cl_mem * mem_objects , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueReleaseGrallocObjectsIMG_t = Cvoid

const clEnqueueReleaseGrallocObjectsIMG_fn = Ptr{clEnqueueReleaseGrallocObjectsIMG_t}

@checked function clEnqueueAcquireGrallocObjectsIMG(command_queue, num_objects, mem_objects,
                                                    num_events_in_wait_list,
                                                    event_wait_list, event)
    @ext_ccall libopencl.clEnqueueAcquireGrallocObjectsIMG(command_queue::cl_command_queue,
                                                           num_objects::cl_uint,
                                                           mem_objects::Ptr{cl_mem},
                                                           num_events_in_wait_list::cl_uint,
                                                           event_wait_list::Ptr{cl_event},
                                                           event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueReleaseGrallocObjectsIMG(command_queue, num_objects, mem_objects,
                                                    num_events_in_wait_list,
                                                    event_wait_list, event)
    @ext_ccall libopencl.clEnqueueReleaseGrallocObjectsIMG(command_queue::cl_command_queue,
                                                           num_objects::cl_uint,
                                                           mem_objects::Ptr{cl_mem},
                                                           num_events_in_wait_list::cl_uint,
                                                           event_wait_list::Ptr{cl_event},
                                                           event::Ptr{cl_event})::cl_int
end

const cl_mipmap_filter_mode_img = cl_uint

# typedef cl_int CL_API_CALL clEnqueueGenerateMipmapIMG_t ( cl_command_queue command_queue , cl_mem src_image , cl_mem dst_image , cl_mipmap_filter_mode_img mipmap_filter_mode , const size_t * array_region , const size_t * mip_region , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueGenerateMipmapIMG_t = Cvoid

const clEnqueueGenerateMipmapIMG_fn = Ptr{clEnqueueGenerateMipmapIMG_t}

@checked function clEnqueueGenerateMipmapIMG(command_queue, src_image, dst_image,
                                             mipmap_filter_mode, array_region, mip_region,
                                             num_events_in_wait_list, event_wait_list,
                                             event)
    @ext_ccall libopencl.clEnqueueGenerateMipmapIMG(command_queue::cl_command_queue,
                                                    src_image::cl_mem, dst_image::cl_mem,
                                                    mipmap_filter_mode::cl_mipmap_filter_mode_img,
                                                    array_region::Ptr{Csize_t},
                                                    mip_region::Ptr{Csize_t},
                                                    num_events_in_wait_list::cl_uint,
                                                    event_wait_list::Ptr{cl_event},
                                                    event::Ptr{cl_event})::cl_int
end

# typedef cl_int CL_API_CALL clGetKernelSubGroupInfoKHR_t ( cl_kernel in_kernel , cl_device_id in_device , cl_kernel_sub_group_info param_name , size_t input_value_size , const void * input_value , size_t param_value_size , void * param_value , size_t * param_value_size_ret )
const clGetKernelSubGroupInfoKHR_t = Cvoid

const clGetKernelSubGroupInfoKHR_fn = Ptr{clGetKernelSubGroupInfoKHR_t}

@checked function clGetKernelSubGroupInfoKHR(in_kernel, in_device, param_name,
                                             input_value_size, input_value,
                                             param_value_size, param_value,
                                             param_value_size_ret)
    @ext_ccall libopencl.clGetKernelSubGroupInfoKHR(in_kernel::cl_kernel,
                                                    in_device::cl_device_id,
                                                    param_name::cl_kernel_sub_group_info,
                                                    input_value_size::Csize_t,
                                                    input_value::Ptr{Cvoid},
                                                    param_value_size::Csize_t,
                                                    param_value::Ptr{Cvoid},
                                                    param_value_size_ret::Ptr{Csize_t})::cl_int
end

const cl_queue_priority_khr = cl_uint

const cl_queue_throttle_khr = cl_uint

const cl_version_khr = cl_uint

struct _cl_name_version_khr
    version::cl_version_khr
    name::NTuple{64,Cchar}
end

const cl_name_version_khr = _cl_name_version_khr

struct _cl_device_pci_bus_info_khr
    pci_domain::cl_uint
    pci_bus::cl_uint
    pci_device::cl_uint
    pci_function::cl_uint
end

const cl_device_pci_bus_info_khr = _cl_device_pci_bus_info_khr

# typedef cl_int CL_API_CALL clGetKernelSuggestedLocalWorkSizeKHR_t ( cl_command_queue command_queue , cl_kernel kernel , cl_uint work_dim , const size_t * global_work_offset , const size_t * global_work_size , size_t * suggested_local_work_size )
const clGetKernelSuggestedLocalWorkSizeKHR_t = Cvoid

const clGetKernelSuggestedLocalWorkSizeKHR_fn = Ptr{clGetKernelSuggestedLocalWorkSizeKHR_t}

@checked function clGetKernelSuggestedLocalWorkSizeKHR(command_queue, kernel, work_dim,
                                                       global_work_offset, global_work_size,
                                                       suggested_local_work_size)
    @ext_ccall libopencl.clGetKernelSuggestedLocalWorkSizeKHR(command_queue::cl_command_queue,
                                                              kernel::cl_kernel,
                                                              work_dim::cl_uint,
                                                              global_work_offset::Ptr{Csize_t},
                                                              global_work_size::Ptr{Csize_t},
                                                              suggested_local_work_size::Ptr{Csize_t})::cl_int
end

const cl_device_integer_dot_product_capabilities_khr = cl_bitfield

struct _cl_device_integer_dot_product_acceleration_properties_khr
    signed_accelerated::cl_bool
    unsigned_accelerated::cl_bool
    mixed_signedness_accelerated::cl_bool
    accumulating_saturating_signed_accelerated::cl_bool
    accumulating_saturating_unsigned_accelerated::cl_bool
    accumulating_saturating_mixed_signedness_accelerated::cl_bool
end

const cl_device_integer_dot_product_acceleration_properties_khr = _cl_device_integer_dot_product_acceleration_properties_khr

const cl_external_memory_handle_type_khr = cl_uint

# typedef cl_int CL_API_CALL clEnqueueAcquireExternalMemObjectsKHR_t ( cl_command_queue command_queue , cl_uint num_mem_objects , const cl_mem * mem_objects , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueAcquireExternalMemObjectsKHR_t = Cvoid

const clEnqueueAcquireExternalMemObjectsKHR_fn = Ptr{clEnqueueAcquireExternalMemObjectsKHR_t}

# typedef cl_int CL_API_CALL clEnqueueReleaseExternalMemObjectsKHR_t ( cl_command_queue command_queue , cl_uint num_mem_objects , const cl_mem * mem_objects , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueReleaseExternalMemObjectsKHR_t = Cvoid

const clEnqueueReleaseExternalMemObjectsKHR_fn = Ptr{clEnqueueReleaseExternalMemObjectsKHR_t}

@checked function clEnqueueAcquireExternalMemObjectsKHR(command_queue, num_mem_objects,
                                                        mem_objects,
                                                        num_events_in_wait_list,
                                                        event_wait_list, event)
    @ext_ccall libopencl.clEnqueueAcquireExternalMemObjectsKHR(command_queue::cl_command_queue,
                                                               num_mem_objects::cl_uint,
                                                               mem_objects::Ptr{cl_mem},
                                                               num_events_in_wait_list::cl_uint,
                                                               event_wait_list::Ptr{cl_event},
                                                               event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueReleaseExternalMemObjectsKHR(command_queue, num_mem_objects,
                                                        mem_objects,
                                                        num_events_in_wait_list,
                                                        event_wait_list, event)
    @ext_ccall libopencl.clEnqueueReleaseExternalMemObjectsKHR(command_queue::cl_command_queue,
                                                               num_mem_objects::cl_uint,
                                                               mem_objects::Ptr{cl_mem},
                                                               num_events_in_wait_list::cl_uint,
                                                               event_wait_list::Ptr{cl_event},
                                                               event::Ptr{cl_event})::cl_int
end

mutable struct _cl_semaphore_khr end

const cl_semaphore_khr = Ptr{_cl_semaphore_khr}

const cl_external_semaphore_handle_type_khr = cl_uint

# typedef cl_int CL_API_CALL clGetSemaphoreHandleForTypeKHR_t ( cl_semaphore_khr sema_object , cl_device_id device , cl_external_semaphore_handle_type_khr handle_type , size_t handle_size , void * handle_ptr , size_t * handle_size_ret )
const clGetSemaphoreHandleForTypeKHR_t = Cvoid

const clGetSemaphoreHandleForTypeKHR_fn = Ptr{clGetSemaphoreHandleForTypeKHR_t}

@checked function clGetSemaphoreHandleForTypeKHR(sema_object, device, handle_type,
                                                 handle_size, handle_ptr, handle_size_ret)
    @ext_ccall libopencl.clGetSemaphoreHandleForTypeKHR(sema_object::cl_semaphore_khr,
                                                        device::cl_device_id,
                                                        handle_type::cl_external_semaphore_handle_type_khr,
                                                        handle_size::Csize_t,
                                                        handle_ptr::Ptr{Cvoid},
                                                        handle_size_ret::Ptr{Csize_t})::cl_int
end

const cl_semaphore_reimport_properties_khr = cl_properties

# typedef cl_int CL_API_CALL clReImportSemaphoreSyncFdKHR_t ( cl_semaphore_khr sema_object , cl_semaphore_reimport_properties_khr * reimport_props , int fd )
const clReImportSemaphoreSyncFdKHR_t = Cvoid

const clReImportSemaphoreSyncFdKHR_fn = Ptr{clReImportSemaphoreSyncFdKHR_t}

@checked function clReImportSemaphoreSyncFdKHR(sema_object, reimport_props, fd)
    @ext_ccall libopencl.clReImportSemaphoreSyncFdKHR(sema_object::cl_semaphore_khr,
                                                      reimport_props::Ptr{cl_semaphore_reimport_properties_khr},
                                                      fd::Cint)::cl_int
end

const cl_semaphore_properties_khr = cl_properties

const cl_semaphore_info_khr = cl_uint

const cl_semaphore_type_khr = cl_uint

const cl_semaphore_payload_khr = cl_ulong

# typedef cl_semaphore_khr CL_API_CALL clCreateSemaphoreWithPropertiesKHR_t ( cl_context context , const cl_semaphore_properties_khr * sema_props , cl_int * errcode_ret )
const clCreateSemaphoreWithPropertiesKHR_t = Cvoid

const clCreateSemaphoreWithPropertiesKHR_fn = Ptr{clCreateSemaphoreWithPropertiesKHR_t}

# typedef cl_int CL_API_CALL clEnqueueWaitSemaphoresKHR_t ( cl_command_queue command_queue , cl_uint num_sema_objects , const cl_semaphore_khr * sema_objects , const cl_semaphore_payload_khr * sema_payload_list , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueWaitSemaphoresKHR_t = Cvoid

const clEnqueueWaitSemaphoresKHR_fn = Ptr{clEnqueueWaitSemaphoresKHR_t}

# typedef cl_int CL_API_CALL clEnqueueSignalSemaphoresKHR_t ( cl_command_queue command_queue , cl_uint num_sema_objects , const cl_semaphore_khr * sema_objects , const cl_semaphore_payload_khr * sema_payload_list , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueSignalSemaphoresKHR_t = Cvoid

const clEnqueueSignalSemaphoresKHR_fn = Ptr{clEnqueueSignalSemaphoresKHR_t}

# typedef cl_int CL_API_CALL clGetSemaphoreInfoKHR_t ( cl_semaphore_khr sema_object , cl_semaphore_info_khr param_name , size_t param_value_size , void * param_value , size_t * param_value_size_ret )
const clGetSemaphoreInfoKHR_t = Cvoid

const clGetSemaphoreInfoKHR_fn = Ptr{clGetSemaphoreInfoKHR_t}

# typedef cl_int CL_API_CALL clReleaseSemaphoreKHR_t ( cl_semaphore_khr sema_object )
const clReleaseSemaphoreKHR_t = Cvoid

const clReleaseSemaphoreKHR_fn = Ptr{clReleaseSemaphoreKHR_t}

# typedef cl_int CL_API_CALL clRetainSemaphoreKHR_t ( cl_semaphore_khr sema_object )
const clRetainSemaphoreKHR_t = Cvoid

const clRetainSemaphoreKHR_fn = Ptr{clRetainSemaphoreKHR_t}

function clCreateSemaphoreWithPropertiesKHR(context, sema_props, errcode_ret)
    @ext_ccall libopencl.clCreateSemaphoreWithPropertiesKHR(context::cl_context,
                                                            sema_props::Ptr{cl_semaphore_properties_khr},
                                                            errcode_ret::Ptr{cl_int})::cl_semaphore_khr
end

@checked function clEnqueueWaitSemaphoresKHR(command_queue, num_sema_objects, sema_objects,
                                             sema_payload_list, num_events_in_wait_list,
                                             event_wait_list, event)
    @ext_ccall libopencl.clEnqueueWaitSemaphoresKHR(command_queue::cl_command_queue,
                                                    num_sema_objects::cl_uint,
                                                    sema_objects::Ptr{cl_semaphore_khr},
                                                    sema_payload_list::Ptr{cl_semaphore_payload_khr},
                                                    num_events_in_wait_list::cl_uint,
                                                    event_wait_list::Ptr{cl_event},
                                                    event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSignalSemaphoresKHR(command_queue, num_sema_objects,
                                               sema_objects, sema_payload_list,
                                               num_events_in_wait_list, event_wait_list,
                                               event)
    @ext_ccall libopencl.clEnqueueSignalSemaphoresKHR(command_queue::cl_command_queue,
                                                      num_sema_objects::cl_uint,
                                                      sema_objects::Ptr{cl_semaphore_khr},
                                                      sema_payload_list::Ptr{cl_semaphore_payload_khr},
                                                      num_events_in_wait_list::cl_uint,
                                                      event_wait_list::Ptr{cl_event},
                                                      event::Ptr{cl_event})::cl_int
end

@checked function clGetSemaphoreInfoKHR(sema_object, param_name, param_value_size,
                                        param_value, param_value_size_ret)
    @ext_ccall libopencl.clGetSemaphoreInfoKHR(sema_object::cl_semaphore_khr,
                                               param_name::cl_semaphore_info_khr,
                                               param_value_size::Csize_t,
                                               param_value::Ptr{Cvoid},
                                               param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clReleaseSemaphoreKHR(sema_object)
    @ext_ccall libopencl.clReleaseSemaphoreKHR(sema_object::cl_semaphore_khr)::cl_int
end

@checked function clRetainSemaphoreKHR(sema_object)
    @ext_ccall libopencl.clRetainSemaphoreKHR(sema_object::cl_semaphore_khr)::cl_int
end

const cl_import_properties_arm = intptr_t

# typedef cl_mem CL_API_CALL clImportMemoryARM_t ( cl_context context , cl_mem_flags flags , const cl_import_properties_arm * properties , void * memory , size_t size , cl_int * errcode_ret )
const clImportMemoryARM_t = Cvoid

const clImportMemoryARM_fn = Ptr{clImportMemoryARM_t}

function clImportMemoryARM(context, flags, properties, memory, size, errcode_ret)
    @ext_ccall libopencl.clImportMemoryARM(context::cl_context, flags::cl_mem_flags,
                                           properties::Ptr{cl_import_properties_arm},
                                           memory::Ptr{Cvoid}, size::Csize_t,
                                           errcode_ret::Ptr{cl_int})::cl_mem
end

const cl_svm_mem_flags_arm = cl_bitfield

const cl_kernel_exec_info_arm = cl_uint

const cl_device_svm_capabilities_arm = cl_bitfield

# typedef void * CL_API_CALL clSVMAllocARM_t ( cl_context context , cl_svm_mem_flags_arm flags , size_t size , cl_uint alignment )
const clSVMAllocARM_t = Cvoid

const clSVMAllocARM_fn = Ptr{clSVMAllocARM_t}

# typedef void CL_API_CALL clSVMFreeARM_t ( cl_context context , void * svm_pointer )
const clSVMFreeARM_t = Cvoid

const clSVMFreeARM_fn = Ptr{clSVMFreeARM_t}

# typedef cl_int CL_API_CALL clEnqueueSVMFreeARM_t ( cl_command_queue command_queue , cl_uint num_svm_pointers , void * svm_pointers [ ] , void ( CL_CALLBACK * pfn_free_func ) ( cl_command_queue queue , cl_uint num_svm_pointers , void * svm_pointers [ ] , void * user_data ) , void * user_data , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueSVMFreeARM_t = Cvoid

const clEnqueueSVMFreeARM_fn = Ptr{clEnqueueSVMFreeARM_t}

# typedef cl_int CL_API_CALL clEnqueueSVMMemcpyARM_t ( cl_command_queue command_queue , cl_bool blocking_copy , void * dst_ptr , const void * src_ptr , size_t size , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueSVMMemcpyARM_t = Cvoid

const clEnqueueSVMMemcpyARM_fn = Ptr{clEnqueueSVMMemcpyARM_t}

# typedef cl_int CL_API_CALL clEnqueueSVMMemFillARM_t ( cl_command_queue command_queue , void * svm_ptr , const void * pattern , size_t pattern_size , size_t size , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueSVMMemFillARM_t = Cvoid

const clEnqueueSVMMemFillARM_fn = Ptr{clEnqueueSVMMemFillARM_t}

# typedef cl_int CL_API_CALL clEnqueueSVMMapARM_t ( cl_command_queue command_queue , cl_bool blocking_map , cl_map_flags flags , void * svm_ptr , size_t size , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueSVMMapARM_t = Cvoid

const clEnqueueSVMMapARM_fn = Ptr{clEnqueueSVMMapARM_t}

# typedef cl_int CL_API_CALL clEnqueueSVMUnmapARM_t ( cl_command_queue command_queue , void * svm_ptr , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueSVMUnmapARM_t = Cvoid

const clEnqueueSVMUnmapARM_fn = Ptr{clEnqueueSVMUnmapARM_t}

# typedef cl_int CL_API_CALL clSetKernelArgSVMPointerARM_t ( cl_kernel kernel , cl_uint arg_index , const void * arg_value )
const clSetKernelArgSVMPointerARM_t = Cvoid

const clSetKernelArgSVMPointerARM_fn = Ptr{clSetKernelArgSVMPointerARM_t}

# typedef cl_int CL_API_CALL clSetKernelExecInfoARM_t ( cl_kernel kernel , cl_kernel_exec_info_arm param_name , size_t param_value_size , const void * param_value )
const clSetKernelExecInfoARM_t = Cvoid

const clSetKernelExecInfoARM_fn = Ptr{clSetKernelExecInfoARM_t}

function clSVMAllocARM(context, flags, size, alignment)
    @ext_ccall libopencl.clSVMAllocARM(context::cl_context, flags::cl_svm_mem_flags_arm,
                                       size::Csize_t, alignment::cl_uint)::Ptr{Cvoid}
end

function clSVMFreeARM(context, svm_pointer)
    @ext_ccall libopencl.clSVMFreeARM(context::cl_context, svm_pointer::Ptr{Cvoid})::Cvoid
end

@checked function clEnqueueSVMFreeARM(command_queue, num_svm_pointers, svm_pointers,
                                      pfn_free_func, user_data, num_events_in_wait_list,
                                      event_wait_list, event)
    @ext_ccall libopencl.clEnqueueSVMFreeARM(command_queue::cl_command_queue,
                                             num_svm_pointers::cl_uint,
                                             svm_pointers::Ptr{Ptr{Cvoid}},
                                             pfn_free_func::Ptr{Cvoid},
                                             user_data::Ptr{Cvoid},
                                             num_events_in_wait_list::cl_uint,
                                             event_wait_list::Ptr{cl_event},
                                             event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSVMMemcpyARM(command_queue, blocking_copy, dst_ptr, src_ptr,
                                        size, num_events_in_wait_list, event_wait_list,
                                        event)
    @ext_ccall libopencl.clEnqueueSVMMemcpyARM(command_queue::cl_command_queue,
                                               blocking_copy::cl_bool, dst_ptr::Ptr{Cvoid},
                                               src_ptr::Ptr{Cvoid}, size::Csize_t,
                                               num_events_in_wait_list::cl_uint,
                                               event_wait_list::Ptr{cl_event},
                                               event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSVMMemFillARM(command_queue, svm_ptr, pattern, pattern_size,
                                         size, num_events_in_wait_list, event_wait_list,
                                         event)
    @ext_ccall libopencl.clEnqueueSVMMemFillARM(command_queue::cl_command_queue,
                                                svm_ptr::Ptr{Cvoid}, pattern::Ptr{Cvoid},
                                                pattern_size::Csize_t, size::Csize_t,
                                                num_events_in_wait_list::cl_uint,
                                                event_wait_list::Ptr{cl_event},
                                                event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSVMMapARM(command_queue, blocking_map, flags, svm_ptr, size,
                                     num_events_in_wait_list, event_wait_list, event)
    @ext_ccall libopencl.clEnqueueSVMMapARM(command_queue::cl_command_queue,
                                            blocking_map::cl_bool, flags::cl_map_flags,
                                            svm_ptr::Ptr{Cvoid}, size::Csize_t,
                                            num_events_in_wait_list::cl_uint,
                                            event_wait_list::Ptr{cl_event},
                                            event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueSVMUnmapARM(command_queue, svm_ptr, num_events_in_wait_list,
                                       event_wait_list, event)
    @ext_ccall libopencl.clEnqueueSVMUnmapARM(command_queue::cl_command_queue,
                                              svm_ptr::Ptr{Cvoid},
                                              num_events_in_wait_list::cl_uint,
                                              event_wait_list::Ptr{cl_event},
                                              event::Ptr{cl_event})::cl_int
end

@checked function clSetKernelArgSVMPointerARM(kernel, arg_index, arg_value)
    @ext_ccall libopencl.clSetKernelArgSVMPointerARM(kernel::cl_kernel, arg_index::cl_uint,
                                                     arg_value::Ptr{Cvoid})::cl_int
end

@checked function clSetKernelExecInfoARM(kernel, param_name, param_value_size, param_value)
    @ext_ccall libopencl.clSetKernelExecInfoARM(kernel::cl_kernel,
                                                param_name::cl_kernel_exec_info_arm,
                                                param_value_size::Csize_t,
                                                param_value::Ptr{Cvoid})::cl_int
end

const cl_device_scheduling_controls_capabilities_arm = cl_bitfield

const cl_device_controlled_termination_capabilities_arm = cl_bitfield

const cl_device_feature_capabilities_intel = cl_bitfield

mutable struct _cl_accelerator_intel end

const cl_accelerator_intel = Ptr{_cl_accelerator_intel}

const cl_accelerator_type_intel = cl_uint

const cl_accelerator_info_intel = cl_uint

# typedef cl_accelerator_intel CL_API_CALL clCreateAcceleratorINTEL_t ( cl_context context , cl_accelerator_type_intel accelerator_type , size_t descriptor_size , const void * descriptor , cl_int * errcode_ret )
const clCreateAcceleratorINTEL_t = Cvoid

const clCreateAcceleratorINTEL_fn = Ptr{clCreateAcceleratorINTEL_t}

# typedef cl_int CL_API_CALL clGetAcceleratorInfoINTEL_t ( cl_accelerator_intel accelerator , cl_accelerator_info_intel param_name , size_t param_value_size , void * param_value , size_t * param_value_size_ret )
const clGetAcceleratorInfoINTEL_t = Cvoid

const clGetAcceleratorInfoINTEL_fn = Ptr{clGetAcceleratorInfoINTEL_t}

# typedef cl_int CL_API_CALL clRetainAcceleratorINTEL_t ( cl_accelerator_intel accelerator )
const clRetainAcceleratorINTEL_t = Cvoid

const clRetainAcceleratorINTEL_fn = Ptr{clRetainAcceleratorINTEL_t}

# typedef cl_int CL_API_CALL clReleaseAcceleratorINTEL_t ( cl_accelerator_intel accelerator )
const clReleaseAcceleratorINTEL_t = Cvoid

const clReleaseAcceleratorINTEL_fn = Ptr{clReleaseAcceleratorINTEL_t}

function clCreateAcceleratorINTEL(context, accelerator_type, descriptor_size, descriptor,
                                  errcode_ret)
    @ext_ccall libopencl.clCreateAcceleratorINTEL(context::cl_context,
                                                  accelerator_type::cl_accelerator_type_intel,
                                                  descriptor_size::Csize_t,
                                                  descriptor::Ptr{Cvoid},
                                                  errcode_ret::Ptr{cl_int})::cl_accelerator_intel
end

@checked function clGetAcceleratorInfoINTEL(accelerator, param_name, param_value_size,
                                            param_value, param_value_size_ret)
    @ext_ccall libopencl.clGetAcceleratorInfoINTEL(accelerator::cl_accelerator_intel,
                                                   param_name::cl_accelerator_info_intel,
                                                   param_value_size::Csize_t,
                                                   param_value::Ptr{Cvoid},
                                                   param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clRetainAcceleratorINTEL(accelerator)
    @ext_ccall libopencl.clRetainAcceleratorINTEL(accelerator::cl_accelerator_intel)::cl_int
end

@checked function clReleaseAcceleratorINTEL(accelerator)
    @ext_ccall libopencl.clReleaseAcceleratorINTEL(accelerator::cl_accelerator_intel)::cl_int
end

struct _cl_motion_estimation_desc_intel
    mb_block_type::cl_uint
    subpixel_mode::cl_uint
    sad_adjust_mode::cl_uint
    search_path_type::cl_uint
end

const cl_motion_estimation_desc_intel = _cl_motion_estimation_desc_intel

const cl_diagnostic_verbose_level_intel = cl_bitfield

const cl_device_unified_shared_memory_capabilities_intel = cl_bitfield

const cl_mem_properties_intel = cl_properties

const cl_mem_alloc_flags_intel = cl_bitfield

const cl_mem_info_intel = cl_uint

const cl_unified_shared_memory_type_intel = cl_uint

const cl_mem_advice_intel = cl_uint

# typedef void * CL_API_CALL clHostMemAllocINTEL_t ( cl_context context , const cl_mem_properties_intel * properties , size_t size , cl_uint alignment , cl_int * errcode_ret )
const clHostMemAllocINTEL_t = Cvoid

const clHostMemAllocINTEL_fn = Ptr{clHostMemAllocINTEL_t}

# typedef void * CL_API_CALL clDeviceMemAllocINTEL_t ( cl_context context , cl_device_id device , const cl_mem_properties_intel * properties , size_t size , cl_uint alignment , cl_int * errcode_ret )
const clDeviceMemAllocINTEL_t = Cvoid

const clDeviceMemAllocINTEL_fn = Ptr{clDeviceMemAllocINTEL_t}

# typedef void * CL_API_CALL clSharedMemAllocINTEL_t ( cl_context context , cl_device_id device , const cl_mem_properties_intel * properties , size_t size , cl_uint alignment , cl_int * errcode_ret )
const clSharedMemAllocINTEL_t = Cvoid

const clSharedMemAllocINTEL_fn = Ptr{clSharedMemAllocINTEL_t}

# typedef cl_int CL_API_CALL clMemFreeINTEL_t ( cl_context context , void * ptr )
const clMemFreeINTEL_t = Cvoid

const clMemFreeINTEL_fn = Ptr{clMemFreeINTEL_t}

# typedef cl_int CL_API_CALL clMemBlockingFreeINTEL_t ( cl_context context , void * ptr )
const clMemBlockingFreeINTEL_t = Cvoid

const clMemBlockingFreeINTEL_fn = Ptr{clMemBlockingFreeINTEL_t}

# typedef cl_int CL_API_CALL clGetMemAllocInfoINTEL_t ( cl_context context , const void * ptr , cl_mem_info_intel param_name , size_t param_value_size , void * param_value , size_t * param_value_size_ret )
const clGetMemAllocInfoINTEL_t = Cvoid

const clGetMemAllocInfoINTEL_fn = Ptr{clGetMemAllocInfoINTEL_t}

# typedef cl_int CL_API_CALL clSetKernelArgMemPointerINTEL_t ( cl_kernel kernel , cl_uint arg_index , const void * arg_value )
const clSetKernelArgMemPointerINTEL_t = Cvoid

const clSetKernelArgMemPointerINTEL_fn = Ptr{clSetKernelArgMemPointerINTEL_t}

# typedef cl_int CL_API_CALL clEnqueueMemFillINTEL_t ( cl_command_queue command_queue , void * dst_ptr , const void * pattern , size_t pattern_size , size_t size , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueMemFillINTEL_t = Cvoid

const clEnqueueMemFillINTEL_fn = Ptr{clEnqueueMemFillINTEL_t}

# typedef cl_int CL_API_CALL clEnqueueMemcpyINTEL_t ( cl_command_queue command_queue , cl_bool blocking , void * dst_ptr , const void * src_ptr , size_t size , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueMemcpyINTEL_t = Cvoid

const clEnqueueMemcpyINTEL_fn = Ptr{clEnqueueMemcpyINTEL_t}

# typedef cl_int CL_API_CALL clEnqueueMemAdviseINTEL_t ( cl_command_queue command_queue , const void * ptr , size_t size , cl_mem_advice_intel advice , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueMemAdviseINTEL_t = Cvoid

const clEnqueueMemAdviseINTEL_fn = Ptr{clEnqueueMemAdviseINTEL_t}

function clHostMemAllocINTEL(context, properties, size, alignment, errcode_ret)
    @ext_ccall libopencl.clHostMemAllocINTEL(context::cl_context,
                                             properties::Ptr{cl_mem_properties_intel},
                                             size::Csize_t, alignment::cl_uint,
                                             errcode_ret::Ptr{cl_int})::Ptr{Cvoid}
end

function clDeviceMemAllocINTEL(context, device, properties, size, alignment, errcode_ret)
    @ext_ccall libopencl.clDeviceMemAllocINTEL(context::cl_context, device::cl_device_id,
                                               properties::Ptr{cl_mem_properties_intel},
                                               size::Csize_t, alignment::cl_uint,
                                               errcode_ret::Ptr{cl_int})::CLPtr{Cvoid}
end

function clSharedMemAllocINTEL(context, device, properties, size, alignment, errcode_ret)
    @ext_ccall libopencl.clSharedMemAllocINTEL(context::cl_context, device::cl_device_id,
                                               properties::Ptr{cl_mem_properties_intel},
                                               size::Csize_t, alignment::cl_uint,
                                               errcode_ret::Ptr{cl_int})::CLPtr{Cvoid}
end

@checked function clMemFreeINTEL(context, ptr)
    @ext_ccall libopencl.clMemFreeINTEL(context::cl_context, ptr::PtrOrCLPtr{Cvoid})::cl_int
end

@checked function clMemBlockingFreeINTEL(context, ptr)
    @ext_ccall libopencl.clMemBlockingFreeINTEL(context::cl_context,
                                                ptr::PtrOrCLPtr{Cvoid})::cl_int
end

@checked function clGetMemAllocInfoINTEL(context, ptr, param_name, param_value_size,
                                         param_value, param_value_size_ret)
    @ext_ccall libopencl.clGetMemAllocInfoINTEL(context::cl_context, ptr::PtrOrCLPtr{Cvoid},
                                                param_name::cl_mem_info_intel,
                                                param_value_size::Csize_t,
                                                param_value::Ptr{Cvoid},
                                                param_value_size_ret::Ptr{Csize_t})::cl_int
end

@checked function clSetKernelArgMemPointerINTEL(kernel, arg_index, arg_value)
    @ext_ccall libopencl.clSetKernelArgMemPointerINTEL(kernel::cl_kernel,
                                                       arg_index::cl_uint,
                                                       arg_value::PtrOrCLPtr{Cvoid})::cl_int
end

@checked function clEnqueueMemFillINTEL(command_queue, dst_ptr, pattern, pattern_size, size,
                                        num_events_in_wait_list, event_wait_list, event)
    @ext_ccall libopencl.clEnqueueMemFillINTEL(command_queue::cl_command_queue,
                                               dst_ptr::PtrOrCLPtr{Cvoid},
                                               pattern::Ptr{Cvoid}, pattern_size::Csize_t,
                                               size::Csize_t,
                                               num_events_in_wait_list::cl_uint,
                                               event_wait_list::Ptr{cl_event},
                                               event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueMemcpyINTEL(command_queue, blocking, dst_ptr, src_ptr, size,
                                       num_events_in_wait_list, event_wait_list, event)
    @ext_ccall libopencl.clEnqueueMemcpyINTEL(command_queue::cl_command_queue,
                                              blocking::cl_bool, dst_ptr::PtrOrCLPtr{Cvoid},
                                              src_ptr::PtrOrCLPtr{Cvoid}, size::Csize_t,
                                              num_events_in_wait_list::cl_uint,
                                              event_wait_list::Ptr{cl_event},
                                              event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueMemAdviseINTEL(command_queue, ptr, size, advice,
                                          num_events_in_wait_list, event_wait_list, event)
    @ext_ccall libopencl.clEnqueueMemAdviseINTEL(command_queue::cl_command_queue,
                                                 ptr::PtrOrCLPtr{Cvoid}, size::Csize_t,
                                                 advice::cl_mem_advice_intel,
                                                 num_events_in_wait_list::cl_uint,
                                                 event_wait_list::Ptr{cl_event},
                                                 event::Ptr{cl_event})::cl_int
end

# typedef cl_int CL_API_CALL clEnqueueMigrateMemINTEL_t ( cl_command_queue command_queue , const void * ptr , size_t size , cl_mem_migration_flags flags , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueMigrateMemINTEL_t = Cvoid

const clEnqueueMigrateMemINTEL_fn = Ptr{clEnqueueMigrateMemINTEL_t}

@checked function clEnqueueMigrateMemINTEL(command_queue, ptr, size, flags,
                                           num_events_in_wait_list, event_wait_list, event)
    @ext_ccall libopencl.clEnqueueMigrateMemINTEL(command_queue::cl_command_queue,
                                                  ptr::PtrOrCLPtr{Cvoid}, size::Csize_t,
                                                  flags::cl_mem_migration_flags,
                                                  num_events_in_wait_list::cl_uint,
                                                  event_wait_list::Ptr{cl_event},
                                                  event::Ptr{cl_event})::cl_int
end

# typedef cl_int CL_API_CALL clEnqueueMemsetINTEL_t ( cl_command_queue command_queue , void * dst_ptr , cl_int value , size_t size , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueMemsetINTEL_t = Cvoid

const clEnqueueMemsetINTEL_fn = Ptr{clEnqueueMemsetINTEL_t}

@checked function clEnqueueMemsetINTEL(command_queue, dst_ptr, value, size,
                                       num_events_in_wait_list, event_wait_list, event)
    @ext_ccall libopencl.clEnqueueMemsetINTEL(command_queue::cl_command_queue,
                                              dst_ptr::Ptr{Cvoid}, value::cl_int,
                                              size::Csize_t,
                                              num_events_in_wait_list::cl_uint,
                                              event_wait_list::Ptr{cl_event},
                                              event::Ptr{cl_event})::cl_int
end

# typedef cl_mem CL_API_CALL clCreateBufferWithPropertiesINTEL_t ( cl_context context , const cl_mem_properties_intel * properties , cl_mem_flags flags , size_t size , void * host_ptr , cl_int * errcode_ret )
const clCreateBufferWithPropertiesINTEL_t = Cvoid

const clCreateBufferWithPropertiesINTEL_fn = Ptr{clCreateBufferWithPropertiesINTEL_t}

function clCreateBufferWithPropertiesINTEL(context, properties, flags, size, host_ptr,
                                           errcode_ret)
    @ext_ccall libopencl.clCreateBufferWithPropertiesINTEL(context::cl_context,
                                                           properties::Ptr{cl_mem_properties_intel},
                                                           flags::cl_mem_flags,
                                                           size::Csize_t,
                                                           host_ptr::Ptr{Cvoid},
                                                           errcode_ret::Ptr{cl_int})::cl_mem
end

# typedef cl_int CL_API_CALL clEnqueueReadHostPipeINTEL_t ( cl_command_queue command_queue , cl_program program , const char * pipe_symbol , cl_bool blocking_read , void * ptr , size_t size , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueReadHostPipeINTEL_t = Cvoid

const clEnqueueReadHostPipeINTEL_fn = Ptr{clEnqueueReadHostPipeINTEL_t}

# typedef cl_int CL_API_CALL clEnqueueWriteHostPipeINTEL_t ( cl_command_queue command_queue , cl_program program , const char * pipe_symbol , cl_bool blocking_write , const void * ptr , size_t size , cl_uint num_events_in_wait_list , const cl_event * event_wait_list , cl_event * event )
const clEnqueueWriteHostPipeINTEL_t = Cvoid

const clEnqueueWriteHostPipeINTEL_fn = Ptr{clEnqueueWriteHostPipeINTEL_t}

@checked function clEnqueueReadHostPipeINTEL(command_queue, program, pipe_symbol,
                                             blocking_read, ptr, size,
                                             num_events_in_wait_list, event_wait_list,
                                             event)
    @ext_ccall libopencl.clEnqueueReadHostPipeINTEL(command_queue::cl_command_queue,
                                                    program::cl_program,
                                                    pipe_symbol::Ptr{Cchar},
                                                    blocking_read::cl_bool, ptr::Ptr{Cvoid},
                                                    size::Csize_t,
                                                    num_events_in_wait_list::cl_uint,
                                                    event_wait_list::Ptr{cl_event},
                                                    event::Ptr{cl_event})::cl_int
end

@checked function clEnqueueWriteHostPipeINTEL(command_queue, program, pipe_symbol,
                                              blocking_write, ptr, size,
                                              num_events_in_wait_list, event_wait_list,
                                              event)
    @ext_ccall libopencl.clEnqueueWriteHostPipeINTEL(command_queue::cl_command_queue,
                                                     program::cl_program,
                                                     pipe_symbol::Ptr{Cchar},
                                                     blocking_write::cl_bool,
                                                     ptr::Ptr{Cvoid}, size::Csize_t,
                                                     num_events_in_wait_list::cl_uint,
                                                     event_wait_list::Ptr{cl_event},
                                                     event::Ptr{cl_event})::cl_int
end

const cl_command_queue_capabilities_intel = cl_bitfield

struct _cl_queue_family_properties_intel
    properties::cl_command_queue_properties
    capabilities::cl_command_queue_capabilities_intel
    count::cl_uint
    name::NTuple{64,Cchar}
end

const cl_queue_family_properties_intel = _cl_queue_family_properties_intel

const cl_image_requirements_info_ext = cl_uint

# typedef cl_int CL_API_CALL clGetImageRequirementsInfoEXT_t ( cl_context context , const cl_mem_properties * properties , cl_mem_flags flags , const cl_image_format * image_format , const cl_image_desc * image_desc , cl_image_requirements_info_ext param_name , size_t param_value_size , void * param_value , size_t * param_value_size_ret )
const clGetImageRequirementsInfoEXT_t = Cvoid

const clGetImageRequirementsInfoEXT_fn = Ptr{clGetImageRequirementsInfoEXT_t}

@checked function clGetImageRequirementsInfoEXT(context, properties, flags, image_format,
                                                image_desc, param_name, param_value_size,
                                                param_value, param_value_size_ret)
    @ext_ccall libopencl.clGetImageRequirementsInfoEXT(context::cl_context,
                                                       properties::Ptr{cl_mem_properties},
                                                       flags::cl_mem_flags,
                                                       image_format::Ptr{cl_image_format},
                                                       image_desc::Ptr{cl_image_desc},
                                                       param_name::cl_image_requirements_info_ext,
                                                       param_value_size::Csize_t,
                                                       param_value::Ptr{Cvoid},
                                                       param_value_size_ret::Ptr{Csize_t})::cl_int
end

const cl_icdl_info = cl_uint

# typedef cl_int CL_API_CALL clGetICDLoaderInfoOCLICD_t ( cl_icdl_info param_name , size_t param_value_size , void * param_value , size_t * param_value_size_ret )
const clGetICDLoaderInfoOCLICD_t = Cvoid

const clGetICDLoaderInfoOCLICD_fn = Ptr{clGetICDLoaderInfoOCLICD_t}

@checked function clGetICDLoaderInfoOCLICD(param_name, param_value_size, param_value,
                                           param_value_size_ret)
    @ext_ccall libopencl.clGetICDLoaderInfoOCLICD(param_name::cl_icdl_info,
                                                  param_value_size::Csize_t,
                                                  param_value::Ptr{Cvoid},
                                                  param_value_size_ret::Ptr{Csize_t})::cl_int
end

const cl_device_fp_atomic_capabilities_ext = cl_bitfield

# typedef cl_int CL_API_CALL clSetContentSizeBufferPoCL_t ( cl_mem buffer , cl_mem content_size_buffer )
const clSetContentSizeBufferPoCL_t = Cvoid

const clSetContentSizeBufferPoCL_fn = Ptr{clSetContentSizeBufferPoCL_t}

@checked function clSetContentSizeBufferPoCL(buffer, content_size_buffer)
    @ext_ccall libopencl.clSetContentSizeBufferPoCL(buffer::cl_mem,
                                                    content_size_buffer::cl_mem)::cl_int
end

const cl_device_kernel_clock_capabilities_khr = cl_bitfield

const cl_mem_device_address_ext = cl_ulong

# typedef cl_int CL_API_CALL clSetKernelArgDevicePointerEXT_t ( cl_kernel kernel , cl_uint arg_index , cl_mem_device_address_ext arg_value )
const clSetKernelArgDevicePointerEXT_t = Cvoid

const clSetKernelArgDevicePointerEXT_fn = Ptr{clSetKernelArgDevicePointerEXT_t}

@checked function clSetKernelArgDevicePointerEXT(kernel, arg_index, arg_value)
    @ext_ccall libopencl.clSetKernelArgDevicePointerEXT(kernel::cl_kernel,
                                                        arg_index::cl_uint,
                                                        arg_value::cl_mem_device_address_ext)::cl_int
end

# typedef cl_int CL_API_CALL clCancelCommandsIMG_t ( const cl_event * event_list , size_t num_events_in_list )
const clCancelCommandsIMG_t = Cvoid

const clCancelCommandsIMG_fn = Ptr{clCancelCommandsIMG_t}

@checked function clCancelCommandsIMG(event_list, num_events_in_list)
    @ext_ccall libopencl.clCancelCommandsIMG(event_list::Ptr{cl_event},
                                             num_events_in_list::Csize_t)::cl_int
end

const cl_perf_hint_qcom = cl_uint

# typedef cl_int CL_API_CALL clSetPerfHintQCOM_t ( cl_context context , cl_perf_hint_qcom perf_hint )
const clSetPerfHintQCOM_t = Cvoid

const clSetPerfHintQCOM_fn = Ptr{clSetPerfHintQCOM_t}

@checked function clSetPerfHintQCOM(context, perf_hint)
    @ext_ccall libopencl.clSetPerfHintQCOM(context::cl_context,
                                           perf_hint::cl_perf_hint_qcom)::cl_int
end

const CL_NAME_VERSION_MAX_NAME_SIZE = 64

const CL_SUCCESS = 0

const CL_DEVICE_NOT_FOUND = -1

const CL_DEVICE_NOT_AVAILABLE = -2

const CL_COMPILER_NOT_AVAILABLE = -3

const CL_MEM_OBJECT_ALLOCATION_FAILURE = -4

const CL_OUT_OF_RESOURCES = -5

const CL_OUT_OF_HOST_MEMORY = -6

const CL_PROFILING_INFO_NOT_AVAILABLE = -7

const CL_MEM_COPY_OVERLAP = -8

const CL_IMAGE_FORMAT_MISMATCH = -9

const CL_IMAGE_FORMAT_NOT_SUPPORTED = -10

const CL_BUILD_PROGRAM_FAILURE = -11

const CL_MAP_FAILURE = -12

const CL_MISALIGNED_SUB_BUFFER_OFFSET = -13

const CL_EXEC_STATUS_ERROR_FOR_EVENTS_IN_WAIT_LIST = -14

const CL_COMPILE_PROGRAM_FAILURE = -15

const CL_LINKER_NOT_AVAILABLE = -16

const CL_LINK_PROGRAM_FAILURE = -17

const CL_DEVICE_PARTITION_FAILED = -18

const CL_KERNEL_ARG_INFO_NOT_AVAILABLE = -19

const CL_INVALID_VALUE = -30

const CL_INVALID_DEVICE_TYPE = -31

const CL_INVALID_PLATFORM = -32

const CL_INVALID_DEVICE = -33

const CL_INVALID_CONTEXT = -34

const CL_INVALID_QUEUE_PROPERTIES = -35

const CL_INVALID_COMMAND_QUEUE = -36

const CL_INVALID_HOST_PTR = -37

const CL_INVALID_MEM_OBJECT = -38

const CL_INVALID_IMAGE_FORMAT_DESCRIPTOR = -39

const CL_INVALID_IMAGE_SIZE = -40

const CL_INVALID_SAMPLER = -41

const CL_INVALID_BINARY = -42

const CL_INVALID_BUILD_OPTIONS = -43

const CL_INVALID_PROGRAM = -44

const CL_INVALID_PROGRAM_EXECUTABLE = -45

const CL_INVALID_KERNEL_NAME = -46

const CL_INVALID_KERNEL_DEFINITION = -47

const CL_INVALID_KERNEL = -48

const CL_INVALID_ARG_INDEX = -49

const CL_INVALID_ARG_VALUE = -50

const CL_INVALID_ARG_SIZE = -51

const CL_INVALID_KERNEL_ARGS = -52

const CL_INVALID_WORK_DIMENSION = -53

const CL_INVALID_WORK_GROUP_SIZE = -54

const CL_INVALID_WORK_ITEM_SIZE = -55

const CL_INVALID_GLOBAL_OFFSET = -56

const CL_INVALID_EVENT_WAIT_LIST = -57

const CL_INVALID_EVENT = -58

const CL_INVALID_OPERATION = -59

const CL_INVALID_GL_OBJECT = -60

const CL_INVALID_BUFFER_SIZE = -61

const CL_INVALID_MIP_LEVEL = -62

const CL_INVALID_GLOBAL_WORK_SIZE = -63

const CL_INVALID_PROPERTY = -64

const CL_INVALID_IMAGE_DESCRIPTOR = -65

const CL_INVALID_COMPILER_OPTIONS = -66

const CL_INVALID_LINKER_OPTIONS = -67

const CL_INVALID_DEVICE_PARTITION_COUNT = -68

const CL_INVALID_PIPE_SIZE = -69

const CL_INVALID_DEVICE_QUEUE = -70

const CL_INVALID_SPEC_ID = -71

const CL_MAX_SIZE_RESTRICTION_EXCEEDED = -72

const CL_FALSE = 0

const CL_TRUE = 1

const CL_BLOCKING = CL_TRUE

const CL_NON_BLOCKING = CL_FALSE

const CL_PLATFORM_PROFILE = 0x0900

const CL_PLATFORM_VERSION = 0x0901

const CL_PLATFORM_NAME = 0x0902

const CL_PLATFORM_VENDOR = 0x0903

const CL_PLATFORM_EXTENSIONS = 0x0904

const CL_PLATFORM_HOST_TIMER_RESOLUTION = 0x0905

const CL_PLATFORM_NUMERIC_VERSION = 0x0906

const CL_PLATFORM_EXTENSIONS_WITH_VERSION = 0x0907

const CL_DEVICE_TYPE_DEFAULT = 1 << 0

const CL_DEVICE_TYPE_CPU = 1 << 1

const CL_DEVICE_TYPE_GPU = 1 << 2

const CL_DEVICE_TYPE_ACCELERATOR = 1 << 3

const CL_DEVICE_TYPE_CUSTOM = 1 << 4

const CL_DEVICE_TYPE_ALL = 0xffffffff

const CL_DEVICE_TYPE = 0x1000

const CL_DEVICE_VENDOR_ID = 0x1001

const CL_DEVICE_MAX_COMPUTE_UNITS = 0x1002

const CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS = 0x1003

const CL_DEVICE_MAX_WORK_GROUP_SIZE = 0x1004

const CL_DEVICE_MAX_WORK_ITEM_SIZES = 0x1005

const CL_DEVICE_PREFERRED_VECTOR_WIDTH_CHAR = 0x1006

const CL_DEVICE_PREFERRED_VECTOR_WIDTH_SHORT = 0x1007

const CL_DEVICE_PREFERRED_VECTOR_WIDTH_INT = 0x1008

const CL_DEVICE_PREFERRED_VECTOR_WIDTH_LONG = 0x1009

const CL_DEVICE_PREFERRED_VECTOR_WIDTH_FLOAT = 0x100a

const CL_DEVICE_PREFERRED_VECTOR_WIDTH_DOUBLE = 0x100b

const CL_DEVICE_MAX_CLOCK_FREQUENCY = 0x100c

const CL_DEVICE_ADDRESS_BITS = 0x100d

const CL_DEVICE_MAX_READ_IMAGE_ARGS = 0x100e

const CL_DEVICE_MAX_WRITE_IMAGE_ARGS = 0x100f

const CL_DEVICE_MAX_MEM_ALLOC_SIZE = 0x1010

const CL_DEVICE_IMAGE2D_MAX_WIDTH = 0x1011

const CL_DEVICE_IMAGE2D_MAX_HEIGHT = 0x1012

const CL_DEVICE_IMAGE3D_MAX_WIDTH = 0x1013

const CL_DEVICE_IMAGE3D_MAX_HEIGHT = 0x1014

const CL_DEVICE_IMAGE3D_MAX_DEPTH = 0x1015

const CL_DEVICE_IMAGE_SUPPORT = 0x1016

const CL_DEVICE_MAX_PARAMETER_SIZE = 0x1017

const CL_DEVICE_MAX_SAMPLERS = 0x1018

const CL_DEVICE_MEM_BASE_ADDR_ALIGN = 0x1019

const CL_DEVICE_MIN_DATA_TYPE_ALIGN_SIZE = 0x101a

const CL_DEVICE_SINGLE_FP_CONFIG = 0x101b

const CL_DEVICE_GLOBAL_MEM_CACHE_TYPE = 0x101c

const CL_DEVICE_GLOBAL_MEM_CACHELINE_SIZE = 0x101d

const CL_DEVICE_GLOBAL_MEM_CACHE_SIZE = 0x101e

const CL_DEVICE_GLOBAL_MEM_SIZE = 0x101f

const CL_DEVICE_MAX_CONSTANT_BUFFER_SIZE = 0x1020

const CL_DEVICE_MAX_CONSTANT_ARGS = 0x1021

const CL_DEVICE_LOCAL_MEM_TYPE = 0x1022

const CL_DEVICE_LOCAL_MEM_SIZE = 0x1023

const CL_DEVICE_ERROR_CORRECTION_SUPPORT = 0x1024

const CL_DEVICE_PROFILING_TIMER_RESOLUTION = 0x1025

const CL_DEVICE_ENDIAN_LITTLE = 0x1026

const CL_DEVICE_AVAILABLE = 0x1027

const CL_DEVICE_COMPILER_AVAILABLE = 0x1028

const CL_DEVICE_EXECUTION_CAPABILITIES = 0x1029

const CL_DEVICE_QUEUE_PROPERTIES = 0x102a

const CL_DEVICE_QUEUE_ON_HOST_PROPERTIES = 0x102a

const CL_DEVICE_NAME = 0x102b

const CL_DEVICE_VENDOR = 0x102c

const CL_DRIVER_VERSION = 0x102d

const CL_DEVICE_PROFILE = 0x102e

const CL_DEVICE_VERSION = 0x102f

const CL_DEVICE_EXTENSIONS = 0x1030

const CL_DEVICE_PLATFORM = 0x1031

const CL_DEVICE_DOUBLE_FP_CONFIG = 0x1032

const CL_DEVICE_PREFERRED_VECTOR_WIDTH_HALF = 0x1034

const CL_DEVICE_HOST_UNIFIED_MEMORY = 0x1035

const CL_DEVICE_NATIVE_VECTOR_WIDTH_CHAR = 0x1036

const CL_DEVICE_NATIVE_VECTOR_WIDTH_SHORT = 0x1037

const CL_DEVICE_NATIVE_VECTOR_WIDTH_INT = 0x1038

const CL_DEVICE_NATIVE_VECTOR_WIDTH_LONG = 0x1039

const CL_DEVICE_NATIVE_VECTOR_WIDTH_FLOAT = 0x103a

const CL_DEVICE_NATIVE_VECTOR_WIDTH_DOUBLE = 0x103b

const CL_DEVICE_NATIVE_VECTOR_WIDTH_HALF = 0x103c

const CL_DEVICE_OPENCL_C_VERSION = 0x103d

const CL_DEVICE_LINKER_AVAILABLE = 0x103e

const CL_DEVICE_BUILT_IN_KERNELS = 0x103f

const CL_DEVICE_IMAGE_MAX_BUFFER_SIZE = 0x1040

const CL_DEVICE_IMAGE_MAX_ARRAY_SIZE = 0x1041

const CL_DEVICE_PARENT_DEVICE = 0x1042

const CL_DEVICE_PARTITION_MAX_SUB_DEVICES = 0x1043

const CL_DEVICE_PARTITION_PROPERTIES = 0x1044

const CL_DEVICE_PARTITION_AFFINITY_DOMAIN = 0x1045

const CL_DEVICE_PARTITION_TYPE = 0x1046

const CL_DEVICE_REFERENCE_COUNT = 0x1047

const CL_DEVICE_PREFERRED_INTEROP_USER_SYNC = 0x1048

const CL_DEVICE_PRINTF_BUFFER_SIZE = 0x1049

const CL_DEVICE_IMAGE_PITCH_ALIGNMENT = 0x104a

const CL_DEVICE_IMAGE_BASE_ADDRESS_ALIGNMENT = 0x104b

const CL_DEVICE_MAX_READ_WRITE_IMAGE_ARGS = 0x104c

const CL_DEVICE_MAX_GLOBAL_VARIABLE_SIZE = 0x104d

const CL_DEVICE_QUEUE_ON_DEVICE_PROPERTIES = 0x104e

const CL_DEVICE_QUEUE_ON_DEVICE_PREFERRED_SIZE = 0x104f

const CL_DEVICE_QUEUE_ON_DEVICE_MAX_SIZE = 0x1050

const CL_DEVICE_MAX_ON_DEVICE_QUEUES = 0x1051

const CL_DEVICE_MAX_ON_DEVICE_EVENTS = 0x1052

const CL_DEVICE_SVM_CAPABILITIES = 0x1053

const CL_DEVICE_GLOBAL_VARIABLE_PREFERRED_TOTAL_SIZE = 0x1054

const CL_DEVICE_MAX_PIPE_ARGS = 0x1055

const CL_DEVICE_PIPE_MAX_ACTIVE_RESERVATIONS = 0x1056

const CL_DEVICE_PIPE_MAX_PACKET_SIZE = 0x1057

const CL_DEVICE_PREFERRED_PLATFORM_ATOMIC_ALIGNMENT = 0x1058

const CL_DEVICE_PREFERRED_GLOBAL_ATOMIC_ALIGNMENT = 0x1059

const CL_DEVICE_PREFERRED_LOCAL_ATOMIC_ALIGNMENT = 0x105a

const CL_DEVICE_IL_VERSION = 0x105b

const CL_DEVICE_MAX_NUM_SUB_GROUPS = 0x105c

const CL_DEVICE_SUB_GROUP_INDEPENDENT_FORWARD_PROGRESS = 0x105d

const CL_DEVICE_NUMERIC_VERSION = 0x105e

const CL_DEVICE_EXTENSIONS_WITH_VERSION = 0x1060

const CL_DEVICE_ILS_WITH_VERSION = 0x1061

const CL_DEVICE_BUILT_IN_KERNELS_WITH_VERSION = 0x1062

const CL_DEVICE_ATOMIC_MEMORY_CAPABILITIES = 0x1063

const CL_DEVICE_ATOMIC_FENCE_CAPABILITIES = 0x1064

const CL_DEVICE_NON_UNIFORM_WORK_GROUP_SUPPORT = 0x1065

const CL_DEVICE_OPENCL_C_ALL_VERSIONS = 0x1066

const CL_DEVICE_PREFERRED_WORK_GROUP_SIZE_MULTIPLE = 0x1067

const CL_DEVICE_WORK_GROUP_COLLECTIVE_FUNCTIONS_SUPPORT = 0x1068

const CL_DEVICE_GENERIC_ADDRESS_SPACE_SUPPORT = 0x1069

const CL_DEVICE_OPENCL_C_FEATURES = 0x106f

const CL_DEVICE_DEVICE_ENQUEUE_CAPABILITIES = 0x1070

const CL_DEVICE_PIPE_SUPPORT = 0x1071

const CL_DEVICE_LATEST_CONFORMANCE_VERSION_PASSED = 0x1072

const CL_FP_DENORM = 1 << 0

const CL_FP_INF_NAN = 1 << 1

const CL_FP_ROUND_TO_NEAREST = 1 << 2

const CL_FP_ROUND_TO_ZERO = 1 << 3

const CL_FP_ROUND_TO_INF = 1 << 4

const CL_FP_FMA = 1 << 5

const CL_FP_SOFT_FLOAT = 1 << 6

const CL_FP_CORRECTLY_ROUNDED_DIVIDE_SQRT = 1 << 7

const CL_NONE = 0x00

const CL_READ_ONLY_CACHE = 0x01

const CL_READ_WRITE_CACHE = 0x02

const CL_LOCAL = 0x01

const CL_GLOBAL = 0x02

const CL_EXEC_KERNEL = 1 << 0

const CL_EXEC_NATIVE_KERNEL = 1 << 1

const CL_QUEUE_OUT_OF_ORDER_EXEC_MODE_ENABLE = 1 << 0

const CL_QUEUE_PROFILING_ENABLE = 1 << 1

const CL_QUEUE_ON_DEVICE = 1 << 2

const CL_QUEUE_ON_DEVICE_DEFAULT = 1 << 3

const CL_CONTEXT_REFERENCE_COUNT = 0x1080

const CL_CONTEXT_DEVICES = 0x1081

const CL_CONTEXT_PROPERTIES = 0x1082

const CL_CONTEXT_NUM_DEVICES = 0x1083

const CL_CONTEXT_PLATFORM = 0x1084

const CL_CONTEXT_INTEROP_USER_SYNC = 0x1085

const CL_DEVICE_PARTITION_EQUALLY = 0x1086

const CL_DEVICE_PARTITION_BY_COUNTS = 0x1087

const CL_DEVICE_PARTITION_BY_COUNTS_LIST_END = 0x00

const CL_DEVICE_PARTITION_BY_AFFINITY_DOMAIN = 0x1088

const CL_DEVICE_AFFINITY_DOMAIN_NUMA = 1 << 0

const CL_DEVICE_AFFINITY_DOMAIN_L4_CACHE = 1 << 1

const CL_DEVICE_AFFINITY_DOMAIN_L3_CACHE = 1 << 2

const CL_DEVICE_AFFINITY_DOMAIN_L2_CACHE = 1 << 3

const CL_DEVICE_AFFINITY_DOMAIN_L1_CACHE = 1 << 4

const CL_DEVICE_AFFINITY_DOMAIN_NEXT_PARTITIONABLE = 1 << 5

const CL_DEVICE_SVM_COARSE_GRAIN_BUFFER = 1 << 0

const CL_DEVICE_SVM_FINE_GRAIN_BUFFER = 1 << 1

const CL_DEVICE_SVM_FINE_GRAIN_SYSTEM = 1 << 2

const CL_DEVICE_SVM_ATOMICS = 1 << 3

const CL_QUEUE_CONTEXT = 0x1090

const CL_QUEUE_DEVICE = 0x1091

const CL_QUEUE_REFERENCE_COUNT = 0x1092

const CL_QUEUE_PROPERTIES = 0x1093

const CL_QUEUE_SIZE = 0x1094

const CL_QUEUE_DEVICE_DEFAULT = 0x1095

const CL_QUEUE_PROPERTIES_ARRAY = 0x1098

const CL_MEM_READ_WRITE = 1 << 0

const CL_MEM_WRITE_ONLY = 1 << 1

const CL_MEM_READ_ONLY = 1 << 2

const CL_MEM_USE_HOST_PTR = 1 << 3

const CL_MEM_ALLOC_HOST_PTR = 1 << 4

const CL_MEM_COPY_HOST_PTR = 1 << 5

const CL_MEM_HOST_WRITE_ONLY = 1 << 7

const CL_MEM_HOST_READ_ONLY = 1 << 8

const CL_MEM_HOST_NO_ACCESS = 1 << 9

const CL_MEM_SVM_FINE_GRAIN_BUFFER = 1 << 10

const CL_MEM_SVM_ATOMICS = 1 << 11

const CL_MEM_KERNEL_READ_AND_WRITE = 1 << 12

const CL_MIGRATE_MEM_OBJECT_HOST = 1 << 0

const CL_MIGRATE_MEM_OBJECT_CONTENT_UNDEFINED = 1 << 1

const CL_R = 0x10b0

const CL_A = 0x10b1

const CL_RG = 0x10b2

const CL_RA = 0x10b3

const CL_RGB = 0x10b4

const CL_RGBA = 0x10b5

const CL_BGRA = 0x10b6

const CL_ARGB = 0x10b7

const CL_INTENSITY = 0x10b8

const CL_LUMINANCE = 0x10b9

const CL_Rx = 0x10ba

const CL_RGx = 0x10bb

const CL_RGBx = 0x10bc

const CL_DEPTH = 0x10bd

const CL_sRGB = 0x10bf

const CL_sRGBx = 0x10c0

const CL_sRGBA = 0x10c1

const CL_sBGRA = 0x10c2

const CL_ABGR = 0x10c3

const CL_SNORM_INT8 = 0x10d0

const CL_SNORM_INT16 = 0x10d1

const CL_UNORM_INT8 = 0x10d2

const CL_UNORM_INT16 = 0x10d3

const CL_UNORM_SHORT_565 = 0x10d4

const CL_UNORM_SHORT_555 = 0x10d5

const CL_UNORM_INT_101010 = 0x10d6

const CL_SIGNED_INT8 = 0x10d7

const CL_SIGNED_INT16 = 0x10d8

const CL_SIGNED_INT32 = 0x10d9

const CL_UNSIGNED_INT8 = 0x10da

const CL_UNSIGNED_INT16 = 0x10db

const CL_UNSIGNED_INT32 = 0x10dc

const CL_HALF_FLOAT = 0x10dd

const CL_FLOAT = 0x10de

const CL_UNORM_INT_101010_2 = 0x10e0

const CL_MEM_OBJECT_BUFFER = 0x10f0

const CL_MEM_OBJECT_IMAGE2D = 0x10f1

const CL_MEM_OBJECT_IMAGE3D = 0x10f2

const CL_MEM_OBJECT_IMAGE2D_ARRAY = 0x10f3

const CL_MEM_OBJECT_IMAGE1D = 0x10f4

const CL_MEM_OBJECT_IMAGE1D_ARRAY = 0x10f5

const CL_MEM_OBJECT_IMAGE1D_BUFFER = 0x10f6

const CL_MEM_OBJECT_PIPE = 0x10f7

const CL_MEM_TYPE = 0x1100

const CL_MEM_FLAGS = 0x1101

const CL_MEM_SIZE = 0x1102

const CL_MEM_HOST_PTR = 0x1103

const CL_MEM_MAP_COUNT = 0x1104

const CL_MEM_REFERENCE_COUNT = 0x1105

const CL_MEM_CONTEXT = 0x1106

const CL_MEM_ASSOCIATED_MEMOBJECT = 0x1107

const CL_MEM_OFFSET = 0x1108

const CL_MEM_USES_SVM_POINTER = 0x1109

const CL_MEM_PROPERTIES = 0x110a

const CL_IMAGE_FORMAT = 0x1110

const CL_IMAGE_ELEMENT_SIZE = 0x1111

const CL_IMAGE_ROW_PITCH = 0x1112

const CL_IMAGE_SLICE_PITCH = 0x1113

const CL_IMAGE_WIDTH = 0x1114

const CL_IMAGE_HEIGHT = 0x1115

const CL_IMAGE_DEPTH = 0x1116

const CL_IMAGE_ARRAY_SIZE = 0x1117

const CL_IMAGE_BUFFER = 0x1118

const CL_IMAGE_NUM_MIP_LEVELS = 0x1119

const CL_IMAGE_NUM_SAMPLES = 0x111a

const CL_PIPE_PACKET_SIZE = 0x1120

const CL_PIPE_MAX_PACKETS = 0x1121

const CL_PIPE_PROPERTIES = 0x1122

const CL_ADDRESS_NONE = 0x1130

const CL_ADDRESS_CLAMP_TO_EDGE = 0x1131

const CL_ADDRESS_CLAMP = 0x1132

const CL_ADDRESS_REPEAT = 0x1133

const CL_ADDRESS_MIRRORED_REPEAT = 0x1134

const CL_FILTER_NEAREST = 0x1140

const CL_FILTER_LINEAR = 0x1141

const CL_SAMPLER_REFERENCE_COUNT = 0x1150

const CL_SAMPLER_CONTEXT = 0x1151

const CL_SAMPLER_NORMALIZED_COORDS = 0x1152

const CL_SAMPLER_ADDRESSING_MODE = 0x1153

const CL_SAMPLER_FILTER_MODE = 0x1154

const CL_SAMPLER_MIP_FILTER_MODE = 0x1155

const CL_SAMPLER_LOD_MIN = 0x1156

const CL_SAMPLER_LOD_MAX = 0x1157

const CL_SAMPLER_PROPERTIES = 0x1158

const CL_MAP_READ = 1 << 0

const CL_MAP_WRITE = 1 << 1

const CL_MAP_WRITE_INVALIDATE_REGION = 1 << 2

const CL_PROGRAM_REFERENCE_COUNT = 0x1160

const CL_PROGRAM_CONTEXT = 0x1161

const CL_PROGRAM_NUM_DEVICES = 0x1162

const CL_PROGRAM_DEVICES = 0x1163

const CL_PROGRAM_SOURCE = 0x1164

const CL_PROGRAM_BINARY_SIZES = 0x1165

const CL_PROGRAM_BINARIES = 0x1166

const CL_PROGRAM_NUM_KERNELS = 0x1167

const CL_PROGRAM_KERNEL_NAMES = 0x1168

const CL_PROGRAM_IL = 0x1169

const CL_PROGRAM_SCOPE_GLOBAL_CTORS_PRESENT = 0x116a

const CL_PROGRAM_SCOPE_GLOBAL_DTORS_PRESENT = 0x116b

const CL_PROGRAM_BUILD_STATUS = 0x1181

const CL_PROGRAM_BUILD_OPTIONS = 0x1182

const CL_PROGRAM_BUILD_LOG = 0x1183

const CL_PROGRAM_BINARY_TYPE = 0x1184

const CL_PROGRAM_BUILD_GLOBAL_VARIABLE_TOTAL_SIZE = 0x1185

const CL_PROGRAM_BINARY_TYPE_NONE = 0x00

const CL_PROGRAM_BINARY_TYPE_COMPILED_OBJECT = 0x01

const CL_PROGRAM_BINARY_TYPE_LIBRARY = 0x02

const CL_PROGRAM_BINARY_TYPE_EXECUTABLE = 0x04

const CL_BUILD_SUCCESS = 0

const CL_BUILD_NONE = -1

const CL_BUILD_ERROR = -2

const CL_BUILD_IN_PROGRESS = -3

const CL_KERNEL_FUNCTION_NAME = 0x1190

const CL_KERNEL_NUM_ARGS = 0x1191

const CL_KERNEL_REFERENCE_COUNT = 0x1192

const CL_KERNEL_CONTEXT = 0x1193

const CL_KERNEL_PROGRAM = 0x1194

const CL_KERNEL_ATTRIBUTES = 0x1195

const CL_KERNEL_ARG_ADDRESS_QUALIFIER = 0x1196

const CL_KERNEL_ARG_ACCESS_QUALIFIER = 0x1197

const CL_KERNEL_ARG_TYPE_NAME = 0x1198

const CL_KERNEL_ARG_TYPE_QUALIFIER = 0x1199

const CL_KERNEL_ARG_NAME = 0x119a

const CL_KERNEL_ARG_ADDRESS_GLOBAL = 0x119b

const CL_KERNEL_ARG_ADDRESS_LOCAL = 0x119c

const CL_KERNEL_ARG_ADDRESS_CONSTANT = 0x119d

const CL_KERNEL_ARG_ADDRESS_PRIVATE = 0x119e

const CL_KERNEL_ARG_ACCESS_READ_ONLY = 0x11a0

const CL_KERNEL_ARG_ACCESS_WRITE_ONLY = 0x11a1

const CL_KERNEL_ARG_ACCESS_READ_WRITE = 0x11a2

const CL_KERNEL_ARG_ACCESS_NONE = 0x11a3

const CL_KERNEL_ARG_TYPE_NONE = 0

const CL_KERNEL_ARG_TYPE_CONST = 1 << 0

const CL_KERNEL_ARG_TYPE_RESTRICT = 1 << 1

const CL_KERNEL_ARG_TYPE_VOLATILE = 1 << 2

const CL_KERNEL_ARG_TYPE_PIPE = 1 << 3

const CL_KERNEL_WORK_GROUP_SIZE = 0x11b0

const CL_KERNEL_COMPILE_WORK_GROUP_SIZE = 0x11b1

const CL_KERNEL_LOCAL_MEM_SIZE = 0x11b2

const CL_KERNEL_PREFERRED_WORK_GROUP_SIZE_MULTIPLE = 0x11b3

const CL_KERNEL_PRIVATE_MEM_SIZE = 0x11b4

const CL_KERNEL_GLOBAL_WORK_SIZE = 0x11b5

const CL_KERNEL_MAX_SUB_GROUP_SIZE_FOR_NDRANGE = 0x2033

const CL_KERNEL_SUB_GROUP_COUNT_FOR_NDRANGE = 0x2034

const CL_KERNEL_LOCAL_SIZE_FOR_SUB_GROUP_COUNT = 0x11b8

const CL_KERNEL_MAX_NUM_SUB_GROUPS = 0x11b9

const CL_KERNEL_COMPILE_NUM_SUB_GROUPS = 0x11ba

const CL_KERNEL_EXEC_INFO_SVM_PTRS = 0x11b6

const CL_KERNEL_EXEC_INFO_SVM_FINE_GRAIN_SYSTEM = 0x11b7

const CL_EVENT_COMMAND_QUEUE = 0x11d0

const CL_EVENT_COMMAND_TYPE = 0x11d1

const CL_EVENT_REFERENCE_COUNT = 0x11d2

const CL_EVENT_COMMAND_EXECUTION_STATUS = 0x11d3

const CL_EVENT_CONTEXT = 0x11d4

const CL_COMMAND_NDRANGE_KERNEL = 0x11f0

const CL_COMMAND_TASK = 0x11f1

const CL_COMMAND_NATIVE_KERNEL = 0x11f2

const CL_COMMAND_READ_BUFFER = 0x11f3

const CL_COMMAND_WRITE_BUFFER = 0x11f4

const CL_COMMAND_COPY_BUFFER = 0x11f5

const CL_COMMAND_READ_IMAGE = 0x11f6

const CL_COMMAND_WRITE_IMAGE = 0x11f7

const CL_COMMAND_COPY_IMAGE = 0x11f8

const CL_COMMAND_COPY_IMAGE_TO_BUFFER = 0x11f9

const CL_COMMAND_COPY_BUFFER_TO_IMAGE = 0x11fa

const CL_COMMAND_MAP_BUFFER = 0x11fb

const CL_COMMAND_MAP_IMAGE = 0x11fc

const CL_COMMAND_UNMAP_MEM_OBJECT = 0x11fd

const CL_COMMAND_MARKER = 0x11fe

const CL_COMMAND_ACQUIRE_GL_OBJECTS = 0x11ff

const CL_COMMAND_RELEASE_GL_OBJECTS = 0x1200

const CL_COMMAND_READ_BUFFER_RECT = 0x1201

const CL_COMMAND_WRITE_BUFFER_RECT = 0x1202

const CL_COMMAND_COPY_BUFFER_RECT = 0x1203

const CL_COMMAND_USER = 0x1204

const CL_COMMAND_BARRIER = 0x1205

const CL_COMMAND_MIGRATE_MEM_OBJECTS = 0x1206

const CL_COMMAND_FILL_BUFFER = 0x1207

const CL_COMMAND_FILL_IMAGE = 0x1208

const CL_COMMAND_SVM_FREE = 0x1209

const CL_COMMAND_SVM_MEMCPY = 0x120a

const CL_COMMAND_SVM_MEMFILL = 0x120b

const CL_COMMAND_SVM_MAP = 0x120c

const CL_COMMAND_SVM_UNMAP = 0x120d

const CL_COMMAND_SVM_MIGRATE_MEM = 0x120e

const CL_COMPLETE = 0x00

const CL_RUNNING = 0x01

const CL_SUBMITTED = 0x02

const CL_QUEUED = 0x03

const CL_BUFFER_CREATE_TYPE_REGION = 0x1220

const CL_PROFILING_COMMAND_QUEUED = 0x1280

const CL_PROFILING_COMMAND_SUBMIT = 0x1281

const CL_PROFILING_COMMAND_START = 0x1282

const CL_PROFILING_COMMAND_END = 0x1283

const CL_PROFILING_COMMAND_COMPLETE = 0x1284

const CL_DEVICE_ATOMIC_ORDER_RELAXED = 1 << 0

const CL_DEVICE_ATOMIC_ORDER_ACQ_REL = 1 << 1

const CL_DEVICE_ATOMIC_ORDER_SEQ_CST = 1 << 2

const CL_DEVICE_ATOMIC_SCOPE_WORK_ITEM = 1 << 3

const CL_DEVICE_ATOMIC_SCOPE_WORK_GROUP = 1 << 4

const CL_DEVICE_ATOMIC_SCOPE_DEVICE = 1 << 5

const CL_DEVICE_ATOMIC_SCOPE_ALL_DEVICES = 1 << 6

const CL_DEVICE_QUEUE_SUPPORTED = 1 << 0

const CL_DEVICE_QUEUE_REPLACEABLE_DEFAULT = 1 << 1

const CL_KHRONOS_VENDOR_ID_CODEPLAY = 0x00010004

const CL_VERSION_MAJOR_BITS = 10

const CL_VERSION_MINOR_BITS = 10

const CL_VERSION_PATCH_BITS = 12

const CL_VERSION_MAJOR_MASK = 1 << CL_VERSION_MAJOR_BITS - 1

const CL_VERSION_MINOR_MASK = 1 << CL_VERSION_MINOR_BITS - 1

const CL_VERSION_PATCH_MASK = 1 << CL_VERSION_PATCH_BITS - 1

const cl_khr_gl_sharing = 1

const CL_KHR_GL_SHARING_EXTENSION_NAME = "cl_khr_gl_sharing"

const CL_KHR_GL_SHARING_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_INVALID_GL_SHAREGROUP_REFERENCE_KHR = -1000

const CL_CURRENT_DEVICE_FOR_GL_CONTEXT_KHR = 0x2006

const CL_DEVICES_FOR_GL_CONTEXT_KHR = 0x2007

const CL_GL_CONTEXT_KHR = 0x2008

const CL_EGL_DISPLAY_KHR = 0x2009

const CL_GLX_DISPLAY_KHR = 0x200a

const CL_WGL_HDC_KHR = 0x200b

const CL_CGL_SHAREGROUP_KHR = 0x200c

const CL_GL_OBJECT_BUFFER = 0x2000

const CL_GL_OBJECT_TEXTURE2D = 0x2001

const CL_GL_OBJECT_TEXTURE3D = 0x2002

const CL_GL_OBJECT_RENDERBUFFER = 0x2003

const CL_GL_OBJECT_TEXTURE2D_ARRAY = 0x200e

const CL_GL_OBJECT_TEXTURE1D = 0x200f

const CL_GL_OBJECT_TEXTURE1D_ARRAY = 0x2010

const CL_GL_OBJECT_TEXTURE_BUFFER = 0x2011

const CL_GL_TEXTURE_TARGET = 0x2004

const CL_GL_MIPMAP_LEVEL = 0x2005

const cl_khr_gl_event = 1

const CL_KHR_GL_EVENT_EXTENSION_NAME = "cl_khr_gl_event"

const CL_KHR_GL_EVENT_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_COMMAND_GL_FENCE_SYNC_OBJECT_KHR = 0x200d

const cl_khr_gl_depth_images = 1

const CL_KHR_GL_DEPTH_IMAGES_EXTENSION_NAME = "cl_khr_gl_depth_images"

const CL_KHR_GL_DEPTH_IMAGES_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEPTH_STENCIL = 0x10be

const CL_UNORM_INT24 = 0x10df

const cl_khr_gl_msaa_sharing = 1

const CL_KHR_GL_MSAA_SHARING_EXTENSION_NAME = "cl_khr_gl_msaa_sharing"

const CL_KHR_GL_MSAA_SHARING_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_GL_NUM_SAMPLES = 0x2012

const cl_intel_sharing_format_query_gl = 1

const CL_INTEL_SHARING_FORMAT_QUERY_GL_EXTENSION_NAME = "cl_intel_sharing_format_query_gl"

const CL_INTEL_SHARING_FORMAT_QUERY_GL_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const cl_khr_fp64 = 1

const CL_KHR_FP64_EXTENSION_NAME = "cl_khr_fp64"

const CL_KHR_FP64_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_fp16 = 1

const CL_KHR_FP16_EXTENSION_NAME = "cl_khr_fp16"

const CL_KHR_FP16_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_HALF_FP_CONFIG = 0x1033

const cl_APPLE_SetMemObjectDestructor = 1

const CL_APPLE_SETMEMOBJECTDESTRUCTOR_EXTENSION_NAME = "cl_APPLE_SetMemObjectDestructor"

const CL_APPLE_SETMEMOBJECTDESTRUCTOR_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const cl_APPLE_ContextLoggingFunctions = 1

const CL_APPLE_CONTEXTLOGGINGFUNCTIONS_EXTENSION_NAME = "cl_APPLE_ContextLoggingFunctions"

const CL_APPLE_CONTEXTLOGGINGFUNCTIONS_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const cl_khr_icd = 1

const CL_KHR_ICD_EXTENSION_NAME = "cl_khr_icd"

const CL_KHR_ICD_EXTENSION_VERSION = @CL_MAKE_VERSION(2, 0, 0)

const CL_PLATFORM_ICD_SUFFIX_KHR = 0x0920

const CL_PLATFORM_NOT_FOUND_KHR = -1001

const CL_ICD2_TAG_KHR = intptr_t(0x4f50454e434c3331)

const cl_khr_il_program = 1

const CL_KHR_IL_PROGRAM_EXTENSION_NAME = "cl_khr_il_program"

const CL_KHR_IL_PROGRAM_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_IL_VERSION_KHR = 0x105b

const CL_PROGRAM_IL_KHR = 0x1169

const cl_khr_image2d_from_buffer = 1

const CL_KHR_IMAGE2D_FROM_BUFFER_EXTENSION_NAME = "cl_khr_image2d_from_buffer"

const CL_KHR_IMAGE2D_FROM_BUFFER_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_IMAGE_PITCH_ALIGNMENT_KHR = 0x104a

const CL_DEVICE_IMAGE_BASE_ADDRESS_ALIGNMENT_KHR = 0x104b

const cl_khr_initialize_memory = 1

const CL_KHR_INITIALIZE_MEMORY_EXTENSION_NAME = "cl_khr_initialize_memory"

const CL_KHR_INITIALIZE_MEMORY_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_CONTEXT_MEMORY_INITIALIZE_KHR = 0x2030

const CL_CONTEXT_MEMORY_INITIALIZE_LOCAL_KHR = 1 << 0

const CL_CONTEXT_MEMORY_INITIALIZE_PRIVATE_KHR = 1 << 1

const cl_khr_terminate_context = 1

const CL_KHR_TERMINATE_CONTEXT_EXTENSION_NAME = "cl_khr_terminate_context"

const CL_KHR_TERMINATE_CONTEXT_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_TERMINATE_CAPABILITY_KHR = 0x2031

const CL_CONTEXT_TERMINATE_KHR = 0x2032

const CL_DEVICE_TERMINATE_CAPABILITY_CONTEXT_KHR = 1 << 0

const CL_CONTEXT_TERMINATED_KHR = -1121

const cl_khr_spir = 1

const CL_KHR_SPIR_EXTENSION_NAME = "cl_khr_spir"

const CL_KHR_SPIR_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_SPIR_VERSIONS = 0x40e0

const CL_PROGRAM_BINARY_TYPE_INTERMEDIATE = 0x40e1

const cl_khr_create_command_queue = 1

const CL_KHR_CREATE_COMMAND_QUEUE_EXTENSION_NAME = "cl_khr_create_command_queue"

const CL_KHR_CREATE_COMMAND_QUEUE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_nv_device_attribute_query = 1

const CL_NV_DEVICE_ATTRIBUTE_QUERY_EXTENSION_NAME = "cl_nv_device_attribute_query"

const CL_NV_DEVICE_ATTRIBUTE_QUERY_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_COMPUTE_CAPABILITY_MAJOR_NV = 0x4000

const CL_DEVICE_COMPUTE_CAPABILITY_MINOR_NV = 0x4001

const CL_DEVICE_REGISTERS_PER_BLOCK_NV = 0x4002

const CL_DEVICE_WARP_SIZE_NV = 0x4003

const CL_DEVICE_GPU_OVERLAP_NV = 0x4004

const CL_DEVICE_KERNEL_EXEC_TIMEOUT_NV = 0x4005

const CL_DEVICE_INTEGRATED_MEMORY_NV = 0x4006

const cl_amd_device_attribute_query = 1

const CL_AMD_DEVICE_ATTRIBUTE_QUERY_EXTENSION_NAME = "cl_amd_device_attribute_query"

const CL_AMD_DEVICE_ATTRIBUTE_QUERY_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_PROFILING_TIMER_OFFSET_AMD = 0x4036

const CL_DEVICE_TOPOLOGY_AMD = 0x4037

const CL_DEVICE_BOARD_NAME_AMD = 0x4038

const CL_DEVICE_GLOBAL_FREE_MEMORY_AMD = 0x4039

const CL_DEVICE_SIMD_PER_COMPUTE_UNIT_AMD = 0x4040

const CL_DEVICE_SIMD_WIDTH_AMD = 0x4041

const CL_DEVICE_SIMD_INSTRUCTION_WIDTH_AMD = 0x4042

const CL_DEVICE_WAVEFRONT_WIDTH_AMD = 0x4043

const CL_DEVICE_GLOBAL_MEM_CHANNELS_AMD = 0x4044

const CL_DEVICE_GLOBAL_MEM_CHANNEL_BANKS_AMD = 0x4045

const CL_DEVICE_GLOBAL_MEM_CHANNEL_BANK_WIDTH_AMD = 0x4046

const CL_DEVICE_LOCAL_MEM_SIZE_PER_COMPUTE_UNIT_AMD = 0x4047

const CL_DEVICE_LOCAL_MEM_BANKS_AMD = 0x4048

const CL_DEVICE_THREAD_TRACE_SUPPORTED_AMD = 0x4049

const CL_DEVICE_GFXIP_MAJOR_AMD = 0x404a

const CL_DEVICE_GFXIP_MINOR_AMD = 0x404b

const CL_DEVICE_AVAILABLE_ASYNC_QUEUES_AMD = 0x404c

const CL_DEVICE_PREFERRED_WORK_GROUP_SIZE_AMD = 0x4030

const CL_DEVICE_MAX_WORK_GROUP_SIZE_AMD = 0x4031

const CL_DEVICE_PREFERRED_CONSTANT_BUFFER_SIZE_AMD = 0x4033

const CL_DEVICE_PCIE_ID_AMD = 0x4034

const cl_arm_printf = 1

const CL_ARM_PRINTF_EXTENSION_NAME = "cl_arm_printf"

const CL_ARM_PRINTF_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_PRINTF_CALLBACK_ARM = 0x40b0

const CL_PRINTF_BUFFERSIZE_ARM = 0x40b1

const cl_ext_device_fission = 1

const CL_EXT_DEVICE_FISSION_EXTENSION_NAME = "cl_ext_device_fission"

const CL_EXT_DEVICE_FISSION_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_PARTITION_FAILED_EXT = -1057

const CL_INVALID_PARTITION_COUNT_EXT = -1058

const CL_INVALID_PARTITION_NAME_EXT = -1059

const CL_DEVICE_PARENT_DEVICE_EXT = 0x4054

const CL_DEVICE_PARTITION_TYPES_EXT = 0x4055

const CL_DEVICE_AFFINITY_DOMAINS_EXT = 0x4056

const CL_DEVICE_REFERENCE_COUNT_EXT = 0x4057

const CL_DEVICE_PARTITION_STYLE_EXT = 0x4058

const CL_DEVICE_PARTITION_EQUALLY_EXT = 0x4050

const CL_DEVICE_PARTITION_BY_COUNTS_EXT = 0x4051

const CL_DEVICE_PARTITION_BY_NAMES_EXT = 0x4052

const CL_DEVICE_PARTITION_BY_AFFINITY_DOMAIN_EXT = 0x4053

const CL_AFFINITY_DOMAIN_L1_CACHE_EXT = 0x01

const CL_AFFINITY_DOMAIN_L2_CACHE_EXT = 0x02

const CL_AFFINITY_DOMAIN_L3_CACHE_EXT = 0x03

const CL_AFFINITY_DOMAIN_L4_CACHE_EXT = 0x04

const CL_AFFINITY_DOMAIN_NUMA_EXT = 0x10

const CL_AFFINITY_DOMAIN_NEXT_FISSIONABLE_EXT = 0x0100

const CL_PROPERTIES_LIST_END_EXT = cl_device_partition_property_ext(0)

const CL_PARTITION_BY_COUNTS_LIST_END_EXT = cl_device_partition_property_ext(0)

const cl_ext_migrate_memobject = 1

const CL_EXT_MIGRATE_MEMOBJECT_EXTENSION_NAME = "cl_ext_migrate_memobject"

const CL_EXT_MIGRATE_MEMOBJECT_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_MIGRATE_MEM_OBJECT_HOST_EXT = 1 << 0

const CL_COMMAND_MIGRATE_MEM_OBJECT_EXT = 0x4040

const cl_ext_cxx_for_opencl = 1

const CL_EXT_CXX_FOR_OPENCL_EXTENSION_NAME = "cl_ext_cxx_for_opencl"

const CL_EXT_CXX_FOR_OPENCL_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_CXX_FOR_OPENCL_NUMERIC_VERSION_EXT = 0x4230

const cl_qcom_ext_host_ptr = 1

const CL_QCOM_EXT_HOST_PTR_EXTENSION_NAME = "cl_qcom_ext_host_ptr"

const CL_QCOM_EXT_HOST_PTR_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_EXT_HOST_PTR_QCOM = 1 << 29

const CL_DEVICE_EXT_MEM_PADDING_IN_BYTES_QCOM = 0x40a0

const CL_DEVICE_PAGE_SIZE_QCOM = 0x40a1

const CL_IMAGE_ROW_ALIGNMENT_QCOM = 0x40a2

const CL_IMAGE_SLICE_ALIGNMENT_QCOM = 0x40a3

const CL_MEM_HOST_UNCACHED_QCOM = 0x40a4

const CL_MEM_HOST_WRITEBACK_QCOM = 0x40a5

const CL_MEM_HOST_WRITETHROUGH_QCOM = 0x40a6

const CL_MEM_HOST_WRITE_COMBINING_QCOM = 0x40a7

const cl_qcom_ext_host_ptr_iocoherent = 1

const CL_QCOM_EXT_HOST_PTR_IOCOHERENT_EXTENSION_NAME = "cl_qcom_ext_host_ptr_iocoherent"

const CL_QCOM_EXT_HOST_PTR_IOCOHERENT_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_HOST_IOCOHERENT_QCOM = 0x40a9

const cl_qcom_ion_host_ptr = 1

const CL_QCOM_ION_HOST_PTR_EXTENSION_NAME = "cl_qcom_ion_host_ptr"

const CL_QCOM_ION_HOST_PTR_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_ION_HOST_PTR_QCOM = 0x40a8

const cl_qcom_android_native_buffer_host_ptr = 1

const CL_QCOM_ANDROID_NATIVE_BUFFER_HOST_PTR_EXTENSION_NAME = "cl_qcom_android_native_buffer_host_ptr"

const CL_QCOM_ANDROID_NATIVE_BUFFER_HOST_PTR_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_ANDROID_NATIVE_BUFFER_HOST_PTR_QCOM = 0x40c6

const cl_img_yuv_image = 1

const CL_IMG_YUV_IMAGE_EXTENSION_NAME = "cl_img_yuv_image"

const CL_IMG_YUV_IMAGE_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_NV21_IMG = 0x40d0

const CL_YV12_IMG = 0x40d1

const cl_img_cached_allocations = 1

const CL_IMG_CACHED_ALLOCATIONS_EXTENSION_NAME = "cl_img_cached_allocations"

const CL_IMG_CACHED_ALLOCATIONS_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_USE_UNCACHED_CPU_MEMORY_IMG = 1 << 26

const CL_MEM_USE_CACHED_CPU_MEMORY_IMG = 1 << 27

const cl_img_use_gralloc_ptr = 1

const CL_IMG_USE_GRALLOC_PTR_EXTENSION_NAME = "cl_img_use_gralloc_ptr"

const CL_IMG_USE_GRALLOC_PTR_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_GRALLOC_RESOURCE_NOT_ACQUIRED_IMG = 0x40d4

const CL_INVALID_GRALLOC_OBJECT_IMG = 0x40d5

const CL_MEM_USE_GRALLOC_PTR_IMG = 1 << 28

const CL_COMMAND_ACQUIRE_GRALLOC_OBJECTS_IMG = 0x40d2

const CL_COMMAND_RELEASE_GRALLOC_OBJECTS_IMG = 0x40d3

const cl_img_generate_mipmap = 1

const CL_IMG_GENERATE_MIPMAP_EXTENSION_NAME = "cl_img_generate_mipmap"

const CL_IMG_GENERATE_MIPMAP_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MIPMAP_FILTER_ANY_IMG = 0x00

const CL_MIPMAP_FILTER_BOX_IMG = 0x01

const CL_COMMAND_GENERATE_MIPMAP_IMG = 0x40d6

const cl_img_mem_properties = 1

const CL_IMG_MEM_PROPERTIES_EXTENSION_NAME = "cl_img_mem_properties"

const CL_IMG_MEM_PROPERTIES_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_ALLOC_FLAGS_IMG = 0x40d7

const CL_MEM_ALLOC_RELAX_REQUIREMENTS_IMG = 1 << 0

const CL_MEM_ALLOC_GPU_WRITE_COMBINE_IMG = 1 << 1

const CL_MEM_ALLOC_GPU_CACHED_IMG = 1 << 2

const CL_MEM_ALLOC_CPU_LOCAL_IMG = 1 << 3

const CL_MEM_ALLOC_GPU_LOCAL_IMG = 1 << 4

const CL_MEM_ALLOC_GPU_PRIVATE_IMG = 1 << 5

const CL_DEVICE_MEMORY_CAPABILITIES_IMG = 0x40d8

const cl_khr_subgroups = 1

const CL_KHR_SUBGROUPS_EXTENSION_NAME = "cl_khr_subgroups"

const CL_KHR_SUBGROUPS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_KERNEL_MAX_SUB_GROUP_SIZE_FOR_NDRANGE_KHR = 0x2033

const CL_KERNEL_SUB_GROUP_COUNT_FOR_NDRANGE_KHR = 0x2034

const cl_khr_mipmap_image = 1

const CL_KHR_MIPMAP_IMAGE_EXTENSION_NAME = "cl_khr_mipmap_image"

const CL_KHR_MIPMAP_IMAGE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_SAMPLER_MIP_FILTER_MODE_KHR = 0x1155

const CL_SAMPLER_LOD_MIN_KHR = 0x1156

const CL_SAMPLER_LOD_MAX_KHR = 0x1157

const cl_khr_priority_hints = 1

const CL_KHR_PRIORITY_HINTS_EXTENSION_NAME = "cl_khr_priority_hints"

const CL_KHR_PRIORITY_HINTS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_QUEUE_PRIORITY_KHR = 0x1096

const CL_QUEUE_PRIORITY_HIGH_KHR = 1 << 0

const CL_QUEUE_PRIORITY_MED_KHR = 1 << 1

const CL_QUEUE_PRIORITY_LOW_KHR = 1 << 2

const cl_khr_throttle_hints = 1

const CL_KHR_THROTTLE_HINTS_EXTENSION_NAME = "cl_khr_throttle_hints"

const CL_KHR_THROTTLE_HINTS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_QUEUE_THROTTLE_KHR = 0x1097

const CL_QUEUE_THROTTLE_HIGH_KHR = 1 << 0

const CL_QUEUE_THROTTLE_MED_KHR = 1 << 1

const CL_QUEUE_THROTTLE_LOW_KHR = 1 << 2

const cl_khr_subgroup_named_barrier = 1

const CL_KHR_SUBGROUP_NAMED_BARRIER_EXTENSION_NAME = "cl_khr_subgroup_named_barrier"

const CL_KHR_SUBGROUP_NAMED_BARRIER_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_MAX_NAMED_BARRIER_COUNT_KHR = 0x2035

const cl_khr_extended_versioning = 1

const CL_KHR_EXTENDED_VERSIONING_EXTENSION_NAME = "cl_khr_extended_versioning"

const CL_KHR_EXTENDED_VERSIONING_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_VERSION_MAJOR_BITS_KHR = 10

const CL_VERSION_MINOR_BITS_KHR = 10

const CL_VERSION_PATCH_BITS_KHR = 12

const CL_VERSION_MAJOR_MASK_KHR = 1 << CL_VERSION_MAJOR_BITS_KHR - 1

const CL_VERSION_MINOR_MASK_KHR = 1 << CL_VERSION_MINOR_BITS_KHR - 1

const CL_VERSION_PATCH_MASK_KHR = 1 << CL_VERSION_PATCH_BITS_KHR - 1

const CL_NAME_VERSION_MAX_NAME_SIZE_KHR = 64

const CL_PLATFORM_NUMERIC_VERSION_KHR = 0x0906

const CL_PLATFORM_EXTENSIONS_WITH_VERSION_KHR = 0x0907

const CL_DEVICE_NUMERIC_VERSION_KHR = 0x105e

const CL_DEVICE_OPENCL_C_NUMERIC_VERSION_KHR = 0x105f

const CL_DEVICE_EXTENSIONS_WITH_VERSION_KHR = 0x1060

const CL_DEVICE_ILS_WITH_VERSION_KHR = 0x1061

const CL_DEVICE_BUILT_IN_KERNELS_WITH_VERSION_KHR = 0x1062

const cl_khr_device_uuid = 1

const CL_KHR_DEVICE_UUID_EXTENSION_NAME = "cl_khr_device_uuid"

const CL_KHR_DEVICE_UUID_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_UUID_SIZE_KHR = 16

const CL_LUID_SIZE_KHR = 8

const CL_DEVICE_UUID_KHR = 0x106a

const CL_DRIVER_UUID_KHR = 0x106b

const CL_DEVICE_LUID_VALID_KHR = 0x106c

const CL_DEVICE_LUID_KHR = 0x106d

const CL_DEVICE_NODE_MASK_KHR = 0x106e

const cl_khr_pci_bus_info = 1

const CL_KHR_PCI_BUS_INFO_EXTENSION_NAME = "cl_khr_pci_bus_info"

const CL_KHR_PCI_BUS_INFO_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_PCI_BUS_INFO_KHR = 0x410f

const cl_khr_suggested_local_work_size = 1

const CL_KHR_SUGGESTED_LOCAL_WORK_SIZE_EXTENSION_NAME = "cl_khr_suggested_local_work_size"

const CL_KHR_SUGGESTED_LOCAL_WORK_SIZE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_integer_dot_product = 1

const CL_KHR_INTEGER_DOT_PRODUCT_EXTENSION_NAME = "cl_khr_integer_dot_product"

const CL_KHR_INTEGER_DOT_PRODUCT_EXTENSION_VERSION = @CL_MAKE_VERSION(2, 0, 0)

const CL_DEVICE_INTEGER_DOT_PRODUCT_INPUT_4x8BIT_PACKED_KHR = 1 << 0

const CL_DEVICE_INTEGER_DOT_PRODUCT_INPUT_4x8BIT_KHR = 1 << 1

const CL_DEVICE_INTEGER_DOT_PRODUCT_CAPABILITIES_KHR = 0x1073

const CL_DEVICE_INTEGER_DOT_PRODUCT_ACCELERATION_PROPERTIES_8BIT_KHR = 0x1074

const CL_DEVICE_INTEGER_DOT_PRODUCT_ACCELERATION_PROPERTIES_4x8BIT_PACKED_KHR = 0x1075

const cl_khr_external_memory = 1

const CL_KHR_EXTERNAL_MEMORY_EXTENSION_NAME = "cl_khr_external_memory"

const CL_KHR_EXTERNAL_MEMORY_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 1)

const CL_PLATFORM_EXTERNAL_MEMORY_IMPORT_HANDLE_TYPES_KHR = 0x2044

const CL_DEVICE_EXTERNAL_MEMORY_IMPORT_HANDLE_TYPES_KHR = 0x204f

const CL_DEVICE_EXTERNAL_MEMORY_IMPORT_ASSUME_LINEAR_IMAGES_HANDLE_TYPES_KHR = 0x2052

const CL_MEM_DEVICE_HANDLE_LIST_KHR = 0x2051

const CL_MEM_DEVICE_HANDLE_LIST_END_KHR = 0

const CL_COMMAND_ACQUIRE_EXTERNAL_MEM_OBJECTS_KHR = 0x2047

const CL_COMMAND_RELEASE_EXTERNAL_MEM_OBJECTS_KHR = 0x2048

const cl_khr_external_memory_dma_buf = 1

const CL_KHR_EXTERNAL_MEMORY_DMA_BUF_EXTENSION_NAME = "cl_khr_external_memory_dma_buf"

const CL_KHR_EXTERNAL_MEMORY_DMA_BUF_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_EXTERNAL_MEMORY_HANDLE_DMA_BUF_KHR = 0x2067

const cl_khr_external_memory_opaque_fd = 1

const CL_KHR_EXTERNAL_MEMORY_OPAQUE_FD_EXTENSION_NAME = "cl_khr_external_memory_opaque_fd"

const CL_KHR_EXTERNAL_MEMORY_OPAQUE_FD_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_EXTERNAL_MEMORY_HANDLE_OPAQUE_FD_KHR = 0x2060

const cl_khr_external_memory_win32 = 1

const CL_KHR_EXTERNAL_MEMORY_WIN32_EXTENSION_NAME = "cl_khr_external_memory_win32"

const CL_KHR_EXTERNAL_MEMORY_WIN32_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 1, 0)

const CL_EXTERNAL_MEMORY_HANDLE_OPAQUE_WIN32_KHR = 0x2061

const CL_EXTERNAL_MEMORY_HANDLE_OPAQUE_WIN32_KMT_KHR = 0x2062

const CL_EXTERNAL_MEMORY_HANDLE_OPAQUE_WIN32_NAME_KHR = 0x2069

const cl_khr_external_semaphore = 1

const CL_KHR_EXTERNAL_SEMAPHORE_EXTENSION_NAME = "cl_khr_external_semaphore"

const CL_KHR_EXTERNAL_SEMAPHORE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 1)

const CL_PLATFORM_SEMAPHORE_IMPORT_HANDLE_TYPES_KHR = 0x2037

const CL_PLATFORM_SEMAPHORE_EXPORT_HANDLE_TYPES_KHR = 0x2038

const CL_DEVICE_SEMAPHORE_IMPORT_HANDLE_TYPES_KHR = 0x204d

const CL_DEVICE_SEMAPHORE_EXPORT_HANDLE_TYPES_KHR = 0x204e

const CL_SEMAPHORE_EXPORT_HANDLE_TYPES_KHR = 0x203f

const CL_SEMAPHORE_EXPORT_HANDLE_TYPES_LIST_END_KHR = 0

const CL_SEMAPHORE_EXPORTABLE_KHR = 0x2054

const cl_khr_external_semaphore_opaque_fd = 1

const CL_KHR_EXTERNAL_SEMAPHORE_OPAQUE_FD_EXTENSION_NAME = "cl_khr_external_semaphore_opaque_fd"

const CL_KHR_EXTERNAL_SEMAPHORE_OPAQUE_FD_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_SEMAPHORE_HANDLE_OPAQUE_FD_KHR = 0x2055

const cl_khr_external_semaphore_sync_fd = 1

const CL_KHR_EXTERNAL_SEMAPHORE_SYNC_FD_EXTENSION_NAME = "cl_khr_external_semaphore_sync_fd"

const CL_KHR_EXTERNAL_SEMAPHORE_SYNC_FD_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_SEMAPHORE_HANDLE_SYNC_FD_KHR = 0x2058

const cl_khr_semaphore = 1

const CL_KHR_SEMAPHORE_EXTENSION_NAME = "cl_khr_semaphore"

const CL_KHR_SEMAPHORE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_SEMAPHORE_TYPE_BINARY_KHR = 1

const CL_PLATFORM_SEMAPHORE_TYPES_KHR = 0x2036

const CL_DEVICE_SEMAPHORE_TYPES_KHR = 0x204c

const CL_SEMAPHORE_CONTEXT_KHR = 0x2039

const CL_SEMAPHORE_REFERENCE_COUNT_KHR = 0x203a

const CL_SEMAPHORE_PROPERTIES_KHR = 0x203b

const CL_SEMAPHORE_PAYLOAD_KHR = 0x203c

const CL_SEMAPHORE_TYPE_KHR = 0x203d

const CL_SEMAPHORE_DEVICE_HANDLE_LIST_KHR = 0x2053

const CL_SEMAPHORE_DEVICE_HANDLE_LIST_END_KHR = 0

const CL_COMMAND_SEMAPHORE_WAIT_KHR = 0x2042

const CL_COMMAND_SEMAPHORE_SIGNAL_KHR = 0x2043

const CL_INVALID_SEMAPHORE_KHR = -1142

const cl_arm_import_memory = 1

const CL_ARM_IMPORT_MEMORY_EXTENSION_NAME = "cl_arm_import_memory"

const CL_ARM_IMPORT_MEMORY_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_IMPORT_TYPE_ARM = 0x40b2

const CL_IMPORT_TYPE_HOST_ARM = 0x40b3

const CL_IMPORT_TYPE_DMA_BUF_ARM = 0x40b4

const CL_IMPORT_TYPE_PROTECTED_ARM = 0x40b5

const CL_IMPORT_TYPE_ANDROID_HARDWARE_BUFFER_ARM = 0x41e2

const CL_IMPORT_DMA_BUF_DATA_CONSISTENCY_WITH_HOST_ARM = 0x41e3

const CL_IMPORT_ANDROID_HARDWARE_BUFFER_PLANE_INDEX_ARM = 0x41ef

const CL_IMPORT_ANDROID_HARDWARE_BUFFER_LAYER_INDEX_ARM = 0x41f0

const cl_arm_shared_virtual_memory = 1

const CL_ARM_SHARED_VIRTUAL_MEMORY_EXTENSION_NAME = "cl_arm_shared_virtual_memory"

const CL_ARM_SHARED_VIRTUAL_MEMORY_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_SVM_CAPABILITIES_ARM = 0x40b6

const CL_MEM_USES_SVM_POINTER_ARM = 0x40b7

const CL_KERNEL_EXEC_INFO_SVM_PTRS_ARM = 0x40b8

const CL_KERNEL_EXEC_INFO_SVM_FINE_GRAIN_SYSTEM_ARM = 0x40b9

const CL_COMMAND_SVM_FREE_ARM = 0x40ba

const CL_COMMAND_SVM_MEMCPY_ARM = 0x40bb

const CL_COMMAND_SVM_MEMFILL_ARM = 0x40bc

const CL_COMMAND_SVM_MAP_ARM = 0x40bd

const CL_COMMAND_SVM_UNMAP_ARM = 0x40be

const CL_DEVICE_SVM_COARSE_GRAIN_BUFFER_ARM = 1 << 0

const CL_DEVICE_SVM_FINE_GRAIN_BUFFER_ARM = 1 << 1

const CL_DEVICE_SVM_FINE_GRAIN_SYSTEM_ARM = 1 << 2

const CL_DEVICE_SVM_ATOMICS_ARM = 1 << 3

const CL_MEM_SVM_FINE_GRAIN_BUFFER_ARM = 1 << 10

const CL_MEM_SVM_ATOMICS_ARM = 1 << 11

const cl_arm_get_core_id = 1

const CL_ARM_GET_CORE_ID_EXTENSION_NAME = "cl_arm_get_core_id"

const CL_ARM_GET_CORE_ID_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_COMPUTE_UNITS_BITFIELD_ARM = 0x40bf

const cl_arm_job_slot_selection = 1

const CL_ARM_JOB_SLOT_SELECTION_EXTENSION_NAME = "cl_arm_job_slot_selection"

const CL_ARM_JOB_SLOT_SELECTION_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_JOB_SLOTS_ARM = 0x41e0

const CL_QUEUE_JOB_SLOT_ARM = 0x41e1

const cl_arm_scheduling_controls = 1

const CL_ARM_SCHEDULING_CONTROLS_EXTENSION_NAME = "cl_arm_scheduling_controls"

const CL_ARM_SCHEDULING_CONTROLS_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_SCHEDULING_KERNEL_BATCHING_ARM = 1 << 0

const CL_DEVICE_SCHEDULING_WORKGROUP_BATCH_SIZE_ARM = 1 << 1

const CL_DEVICE_SCHEDULING_WORKGROUP_BATCH_SIZE_MODIFIER_ARM = 1 << 2

const CL_DEVICE_SCHEDULING_DEFERRED_FLUSH_ARM = 1 << 3

const CL_DEVICE_SCHEDULING_REGISTER_ALLOCATION_ARM = 1 << 4

const CL_DEVICE_SCHEDULING_WARP_THROTTLING_ARM = 1 << 5

const CL_DEVICE_SCHEDULING_COMPUTE_UNIT_BATCH_QUEUE_SIZE_ARM = 1 << 6

const CL_DEVICE_SCHEDULING_COMPUTE_UNIT_LIMIT_ARM = 1 << 7

const CL_DEVICE_SCHEDULING_CONTROLS_CAPABILITIES_ARM = 0x41e4

const CL_DEVICE_SUPPORTED_REGISTER_ALLOCATIONS_ARM = 0x41eb

const CL_DEVICE_MAX_WARP_COUNT_ARM = 0x41ea

const CL_KERNEL_EXEC_INFO_WORKGROUP_BATCH_SIZE_ARM = 0x41e5

const CL_KERNEL_EXEC_INFO_WORKGROUP_BATCH_SIZE_MODIFIER_ARM = 0x41e6

const CL_KERNEL_EXEC_INFO_WARP_COUNT_LIMIT_ARM = 0x41e8

const CL_KERNEL_EXEC_INFO_COMPUTE_UNIT_MAX_QUEUED_BATCHES_ARM = 0x41f1

const CL_KERNEL_MAX_WARP_COUNT_ARM = 0x41e9

const CL_QUEUE_KERNEL_BATCHING_ARM = 0x41e7

const CL_QUEUE_DEFERRED_FLUSH_ARM = 0x41ec

const CL_QUEUE_COMPUTE_UNIT_LIMIT_ARM = 0x41f3

const cl_arm_controlled_kernel_termination = 1

const CL_ARM_CONTROLLED_KERNEL_TERMINATION_EXTENSION_NAME = "cl_arm_controlled_kernel_termination"

const CL_ARM_CONTROLLED_KERNEL_TERMINATION_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_COMMAND_TERMINATED_ITSELF_WITH_FAILURE_ARM = -1108

const CL_DEVICE_CONTROLLED_TERMINATION_SUCCESS_ARM = 1 << 0

const CL_DEVICE_CONTROLLED_TERMINATION_FAILURE_ARM = 1 << 1

const CL_DEVICE_CONTROLLED_TERMINATION_QUERY_ARM = 1 << 2

const CL_DEVICE_CONTROLLED_TERMINATION_CAPABILITIES_ARM = 0x41ee

const CL_EVENT_COMMAND_TERMINATION_REASON_ARM = 0x41ed

const CL_COMMAND_TERMINATION_COMPLETION_ARM = 0

const CL_COMMAND_TERMINATION_CONTROLLED_SUCCESS_ARM = 1

const CL_COMMAND_TERMINATION_CONTROLLED_FAILURE_ARM = 2

const CL_COMMAND_TERMINATION_ERROR_ARM = 3

const cl_arm_protected_memory_allocation = 1

const CL_ARM_PROTECTED_MEMORY_ALLOCATION_EXTENSION_NAME = "cl_arm_protected_memory_allocation"

const CL_ARM_PROTECTED_MEMORY_ALLOCATION_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_PROTECTED_ALLOC_ARM = cl_bitfield(1) << 36

const cl_intel_exec_by_local_thread = 1

const CL_INTEL_EXEC_BY_LOCAL_THREAD_EXTENSION_NAME = "cl_intel_exec_by_local_thread"

const CL_INTEL_EXEC_BY_LOCAL_THREAD_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_QUEUE_THREAD_LOCAL_EXEC_ENABLE_INTEL = cl_bitfield(1) << 31

const cl_intel_device_attribute_query = 1

const CL_INTEL_DEVICE_ATTRIBUTE_QUERY_EXTENSION_NAME = "cl_intel_device_attribute_query"

const CL_INTEL_DEVICE_ATTRIBUTE_QUERY_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_FEATURE_FLAG_DP4A_INTEL = 1 << 0

const CL_DEVICE_FEATURE_FLAG_DPAS_INTEL = 1 << 1

const CL_DEVICE_IP_VERSION_INTEL = 0x4250

const CL_DEVICE_ID_INTEL = 0x4251

const CL_DEVICE_NUM_SLICES_INTEL = 0x4252

const CL_DEVICE_NUM_SUB_SLICES_PER_SLICE_INTEL = 0x4253

const CL_DEVICE_NUM_EUS_PER_SUB_SLICE_INTEL = 0x4254

const CL_DEVICE_NUM_THREADS_PER_EU_INTEL = 0x4255

const CL_DEVICE_FEATURE_CAPABILITIES_INTEL = 0x4256

const cl_intel_device_partition_by_names = 1

const CL_INTEL_DEVICE_PARTITION_BY_NAMES_EXTENSION_NAME = "cl_intel_device_partition_by_names"

const CL_INTEL_DEVICE_PARTITION_BY_NAMES_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_PARTITION_BY_NAMES_INTEL = 0x4052

const CL_PARTITION_BY_NAMES_LIST_END_INTEL = -1

const cl_intel_accelerator = 1

const CL_INTEL_ACCELERATOR_EXTENSION_NAME = "cl_intel_accelerator"

const CL_INTEL_ACCELERATOR_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_ACCELERATOR_DESCRIPTOR_INTEL = 0x4090

const CL_ACCELERATOR_REFERENCE_COUNT_INTEL = 0x4091

const CL_ACCELERATOR_CONTEXT_INTEL = 0x4092

const CL_ACCELERATOR_TYPE_INTEL = 0x4093

const CL_INVALID_ACCELERATOR_INTEL = -1094

const CL_INVALID_ACCELERATOR_TYPE_INTEL = -1095

const CL_INVALID_ACCELERATOR_DESCRIPTOR_INTEL = -1096

const CL_ACCELERATOR_TYPE_NOT_SUPPORTED_INTEL = -1097

const cl_intel_motion_estimation = 1

const CL_INTEL_MOTION_ESTIMATION_EXTENSION_NAME = "cl_intel_motion_estimation"

const CL_INTEL_MOTION_ESTIMATION_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_ACCELERATOR_TYPE_MOTION_ESTIMATION_INTEL = 0x00

const CL_ME_MB_TYPE_16x16_INTEL = 0x00

const CL_ME_MB_TYPE_8x8_INTEL = 0x01

const CL_ME_MB_TYPE_4x4_INTEL = 0x02

const CL_ME_SUBPIXEL_MODE_INTEGER_INTEL = 0x00

const CL_ME_SUBPIXEL_MODE_HPEL_INTEL = 0x01

const CL_ME_SUBPIXEL_MODE_QPEL_INTEL = 0x02

const CL_ME_SAD_ADJUST_MODE_NONE_INTEL = 0x00

const CL_ME_SAD_ADJUST_MODE_HAAR_INTEL = 0x01

const CL_ME_SEARCH_PATH_RADIUS_2_2_INTEL = 0x00

const CL_ME_SEARCH_PATH_RADIUS_4_4_INTEL = 0x01

const CL_ME_SEARCH_PATH_RADIUS_16_12_INTEL = 0x05

const cl_intel_advanced_motion_estimation = 1

const CL_INTEL_ADVANCED_MOTION_ESTIMATION_EXTENSION_NAME = "cl_intel_advanced_motion_estimation"

const CL_INTEL_ADVANCED_MOTION_ESTIMATION_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_ME_VERSION_INTEL = 0x407e

const CL_ME_VERSION_LEGACY_INTEL = 0x00

const CL_ME_VERSION_ADVANCED_VER_1_INTEL = 0x01

const CL_ME_VERSION_ADVANCED_VER_2_INTEL = 0x02

const CL_ME_CHROMA_INTRA_PREDICT_ENABLED_INTEL = 0x01

const CL_ME_LUMA_INTRA_PREDICT_ENABLED_INTEL = 0x02

const CL_ME_SKIP_BLOCK_TYPE_16x16_INTEL = 0x00

const CL_ME_SKIP_BLOCK_TYPE_8x8_INTEL = 0x04

const CL_ME_COST_PENALTY_NONE_INTEL = 0x00

const CL_ME_COST_PENALTY_LOW_INTEL = 0x01

const CL_ME_COST_PENALTY_NORMAL_INTEL = 0x02

const CL_ME_COST_PENALTY_HIGH_INTEL = 0x03

const CL_ME_COST_PRECISION_QPEL_INTEL = 0x00

const CL_ME_COST_PRECISION_HPEL_INTEL = 0x01

const CL_ME_COST_PRECISION_PEL_INTEL = 0x02

const CL_ME_COST_PRECISION_DPEL_INTEL = 0x03

const CL_ME_LUMA_PREDICTOR_MODE_VERTICAL_INTEL = 0x00

const CL_ME_LUMA_PREDICTOR_MODE_HORIZONTAL_INTEL = 0x01

const CL_ME_LUMA_PREDICTOR_MODE_DC_INTEL = 0x02

const CL_ME_LUMA_PREDICTOR_MODE_DIAGONAL_DOWN_LEFT_INTEL = 0x03

const CL_ME_LUMA_PREDICTOR_MODE_DIAGONAL_DOWN_RIGHT_INTEL = 0x04

const CL_ME_LUMA_PREDICTOR_MODE_PLANE_INTEL = 0x04

const CL_ME_LUMA_PREDICTOR_MODE_VERTICAL_RIGHT_INTEL = 0x05

const CL_ME_LUMA_PREDICTOR_MODE_HORIZONTAL_DOWN_INTEL = 0x06

const CL_ME_LUMA_PREDICTOR_MODE_VERTICAL_LEFT_INTEL = 0x07

const CL_ME_LUMA_PREDICTOR_MODE_HORIZONTAL_UP_INTEL = 0x08

const CL_ME_CHROMA_PREDICTOR_MODE_DC_INTEL = 0x00

const CL_ME_CHROMA_PREDICTOR_MODE_HORIZONTAL_INTEL = 0x01

const CL_ME_CHROMA_PREDICTOR_MODE_VERTICAL_INTEL = 0x02

const CL_ME_CHROMA_PREDICTOR_MODE_PLANE_INTEL = 0x03

const CL_ME_FORWARD_INPUT_MODE_INTEL = 0x01

const CL_ME_BACKWARD_INPUT_MODE_INTEL = 0x02

const CL_ME_BIDIRECTION_INPUT_MODE_INTEL = 0x03

const CL_ME_BIDIR_WEIGHT_QUARTER_INTEL = 16

const CL_ME_BIDIR_WEIGHT_THIRD_INTEL = 21

const CL_ME_BIDIR_WEIGHT_HALF_INTEL = 32

const CL_ME_BIDIR_WEIGHT_TWO_THIRD_INTEL = 43

const CL_ME_BIDIR_WEIGHT_THREE_QUARTER_INTEL = 48

const cl_intel_simultaneous_sharing = 1

const CL_INTEL_SIMULTANEOUS_SHARING_EXTENSION_NAME = "cl_intel_simultaneous_sharing"

const CL_INTEL_SIMULTANEOUS_SHARING_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_SIMULTANEOUS_INTEROPS_INTEL = 0x4104

const CL_DEVICE_NUM_SIMULTANEOUS_INTEROPS_INTEL = 0x4105

const cl_intel_egl_image_yuv = 1

const CL_INTEL_EGL_IMAGE_YUV_EXTENSION_NAME = "cl_intel_egl_image_yuv"

const CL_INTEL_EGL_IMAGE_YUV_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_EGL_YUV_PLANE_INTEL = 0x4107

const cl_intel_packed_yuv = 1

const CL_INTEL_PACKED_YUV_EXTENSION_NAME = "cl_intel_packed_yuv"

const CL_INTEL_PACKED_YUV_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_YUYV_INTEL = 0x4076

const CL_UYVY_INTEL = 0x4077

const CL_YVYU_INTEL = 0x4078

const CL_VYUY_INTEL = 0x4079

const cl_intel_required_subgroup_size = 1

const CL_INTEL_REQUIRED_SUBGROUP_SIZE_EXTENSION_NAME = "cl_intel_required_subgroup_size"

const CL_INTEL_REQUIRED_SUBGROUP_SIZE_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_SUB_GROUP_SIZES_INTEL = 0x4108

const CL_KERNEL_SPILL_MEM_SIZE_INTEL = 0x4109

const CL_KERNEL_COMPILE_SUB_GROUP_SIZE_INTEL = 0x410a

const cl_intel_driver_diagnostics = 1

const CL_INTEL_DRIVER_DIAGNOSTICS_EXTENSION_NAME = "cl_intel_driver_diagnostics"

const CL_INTEL_DRIVER_DIAGNOSTICS_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_CONTEXT_SHOW_DIAGNOSTICS_INTEL = 0x4106

const CL_CONTEXT_DIAGNOSTICS_LEVEL_ALL_INTEL = 0xff

const CL_CONTEXT_DIAGNOSTICS_LEVEL_GOOD_INTEL = 1 << 0

const CL_CONTEXT_DIAGNOSTICS_LEVEL_BAD_INTEL = 1 << 1

const CL_CONTEXT_DIAGNOSTICS_LEVEL_NEUTRAL_INTEL = 1 << 2

const cl_intel_planar_yuv = 1

const CL_INTEL_PLANAR_YUV_EXTENSION_NAME = "cl_intel_planar_yuv"

const CL_INTEL_PLANAR_YUV_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_NV12_INTEL = 0x410e

const CL_MEM_NO_ACCESS_INTEL = 1 << 24

const CL_MEM_ACCESS_FLAGS_UNRESTRICTED_INTEL = 1 << 25

const CL_DEVICE_PLANAR_YUV_MAX_WIDTH_INTEL = 0x417e

const CL_DEVICE_PLANAR_YUV_MAX_HEIGHT_INTEL = 0x417f

const cl_intel_device_side_avc_motion_estimation = 1

const CL_INTEL_DEVICE_SIDE_AVC_MOTION_ESTIMATION_EXTENSION_NAME = "cl_intel_device_side_avc_motion_estimation"

const CL_INTEL_DEVICE_SIDE_AVC_MOTION_ESTIMATION_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0,
                                                                                      0)

const CL_DEVICE_AVC_ME_VERSION_INTEL = 0x410b

const CL_DEVICE_AVC_ME_SUPPORTS_TEXTURE_SAMPLER_USE_INTEL = 0x410c

const CL_DEVICE_AVC_ME_SUPPORTS_PREEMPTION_INTEL = 0x410d

const CL_AVC_ME_VERSION_0_INTEL = 0x00

const CL_AVC_ME_VERSION_1_INTEL = 0x01

const CL_AVC_ME_MAJOR_16x16_INTEL = 0x00

const CL_AVC_ME_MAJOR_16x8_INTEL = 0x01

const CL_AVC_ME_MAJOR_8x16_INTEL = 0x02

const CL_AVC_ME_MAJOR_8x8_INTEL = 0x03

const CL_AVC_ME_MINOR_8x8_INTEL = 0x00

const CL_AVC_ME_MINOR_8x4_INTEL = 0x01

const CL_AVC_ME_MINOR_4x8_INTEL = 0x02

const CL_AVC_ME_MINOR_4x4_INTEL = 0x03

const CL_AVC_ME_MAJOR_FORWARD_INTEL = 0x00

const CL_AVC_ME_MAJOR_BACKWARD_INTEL = 0x01

const CL_AVC_ME_MAJOR_BIDIRECTIONAL_INTEL = 0x02

const CL_AVC_ME_PARTITION_MASK_ALL_INTEL = 0x00

const CL_AVC_ME_PARTITION_MASK_16x16_INTEL = 0x7e

const CL_AVC_ME_PARTITION_MASK_16x8_INTEL = 0x7d

const CL_AVC_ME_PARTITION_MASK_8x16_INTEL = 0x7b

const CL_AVC_ME_PARTITION_MASK_8x8_INTEL = 0x77

const CL_AVC_ME_PARTITION_MASK_8x4_INTEL = 0x6f

const CL_AVC_ME_PARTITION_MASK_4x8_INTEL = 0x5f

const CL_AVC_ME_PARTITION_MASK_4x4_INTEL = 0x3f

const CL_AVC_ME_SEARCH_WINDOW_EXHAUSTIVE_INTEL = 0x00

const CL_AVC_ME_SEARCH_WINDOW_SMALL_INTEL = 0x01

const CL_AVC_ME_SEARCH_WINDOW_TINY_INTEL = 0x02

const CL_AVC_ME_SEARCH_WINDOW_EXTRA_TINY_INTEL = 0x03

const CL_AVC_ME_SEARCH_WINDOW_DIAMOND_INTEL = 0x04

const CL_AVC_ME_SEARCH_WINDOW_LARGE_DIAMOND_INTEL = 0x05

const CL_AVC_ME_SEARCH_WINDOW_RESERVED0_INTEL = 0x06

const CL_AVC_ME_SEARCH_WINDOW_RESERVED1_INTEL = 0x07

const CL_AVC_ME_SEARCH_WINDOW_CUSTOM_INTEL = 0x08

const CL_AVC_ME_SEARCH_WINDOW_16x12_RADIUS_INTEL = 0x09

const CL_AVC_ME_SEARCH_WINDOW_4x4_RADIUS_INTEL = 0x02

const CL_AVC_ME_SEARCH_WINDOW_2x2_RADIUS_INTEL = 0x0a

const CL_AVC_ME_SAD_ADJUST_MODE_NONE_INTEL = 0x00

const CL_AVC_ME_SAD_ADJUST_MODE_HAAR_INTEL = 0x02

const CL_AVC_ME_SUBPIXEL_MODE_INTEGER_INTEL = 0x00

const CL_AVC_ME_SUBPIXEL_MODE_HPEL_INTEL = 0x01

const CL_AVC_ME_SUBPIXEL_MODE_QPEL_INTEL = 0x03

const CL_AVC_ME_COST_PRECISION_QPEL_INTEL = 0x00

const CL_AVC_ME_COST_PRECISION_HPEL_INTEL = 0x01

const CL_AVC_ME_COST_PRECISION_PEL_INTEL = 0x02

const CL_AVC_ME_COST_PRECISION_DPEL_INTEL = 0x03

const CL_AVC_ME_BIDIR_WEIGHT_QUARTER_INTEL = 0x10

const CL_AVC_ME_BIDIR_WEIGHT_THIRD_INTEL = 0x15

const CL_AVC_ME_BIDIR_WEIGHT_HALF_INTEL = 0x20

const CL_AVC_ME_BIDIR_WEIGHT_TWO_THIRD_INTEL = 0x2b

const CL_AVC_ME_BIDIR_WEIGHT_THREE_QUARTER_INTEL = 0x30

const CL_AVC_ME_BORDER_REACHED_LEFT_INTEL = 0x00

const CL_AVC_ME_BORDER_REACHED_RIGHT_INTEL = 0x02

const CL_AVC_ME_BORDER_REACHED_TOP_INTEL = 0x04

const CL_AVC_ME_BORDER_REACHED_BOTTOM_INTEL = 0x08

const CL_AVC_ME_SKIP_BLOCK_PARTITION_16x16_INTEL = 0x00

const CL_AVC_ME_SKIP_BLOCK_PARTITION_8x8_INTEL = 0x4000

const CL_AVC_ME_SKIP_BLOCK_16x16_FORWARD_ENABLE_INTEL = 0x01 << 24

const CL_AVC_ME_SKIP_BLOCK_16x16_BACKWARD_ENABLE_INTEL = 0x02 << 24

const CL_AVC_ME_SKIP_BLOCK_16x16_DUAL_ENABLE_INTEL = 0x03 << 24

const CL_AVC_ME_SKIP_BLOCK_8x8_FORWARD_ENABLE_INTEL = 0x55 << 24

const CL_AVC_ME_SKIP_BLOCK_8x8_BACKWARD_ENABLE_INTEL = 0xaa << 24

const CL_AVC_ME_SKIP_BLOCK_8x8_DUAL_ENABLE_INTEL = 0xff << 24

const CL_AVC_ME_SKIP_BLOCK_8x8_0_FORWARD_ENABLE_INTEL = 0x01 << 24

const CL_AVC_ME_SKIP_BLOCK_8x8_0_BACKWARD_ENABLE_INTEL = 0x02 << 24

const CL_AVC_ME_SKIP_BLOCK_8x8_1_FORWARD_ENABLE_INTEL = 0x01 << 26

const CL_AVC_ME_SKIP_BLOCK_8x8_1_BACKWARD_ENABLE_INTEL = 0x02 << 26

const CL_AVC_ME_SKIP_BLOCK_8x8_2_FORWARD_ENABLE_INTEL = 0x01 << 28

const CL_AVC_ME_SKIP_BLOCK_8x8_2_BACKWARD_ENABLE_INTEL = 0x02 << 28

const CL_AVC_ME_SKIP_BLOCK_8x8_3_FORWARD_ENABLE_INTEL = 0x01 << 30

const CL_AVC_ME_SKIP_BLOCK_8x8_3_BACKWARD_ENABLE_INTEL = 0x02 << 30

const CL_AVC_ME_BLOCK_BASED_SKIP_4x4_INTEL = 0x00

const CL_AVC_ME_BLOCK_BASED_SKIP_8x8_INTEL = 0x80

const CL_AVC_ME_INTRA_16x16_INTEL = 0x00

const CL_AVC_ME_INTRA_8x8_INTEL = 0x01

const CL_AVC_ME_INTRA_4x4_INTEL = 0x02

const CL_AVC_ME_INTRA_LUMA_PARTITION_MASK_16x16_INTEL = 0x06

const CL_AVC_ME_INTRA_LUMA_PARTITION_MASK_8x8_INTEL = 0x05

const CL_AVC_ME_INTRA_LUMA_PARTITION_MASK_4x4_INTEL = 0x03

const CL_AVC_ME_INTRA_NEIGHBOR_LEFT_MASK_ENABLE_INTEL = 0x60

const CL_AVC_ME_INTRA_NEIGHBOR_UPPER_MASK_ENABLE_INTEL = 0x10

const CL_AVC_ME_INTRA_NEIGHBOR_UPPER_RIGHT_MASK_ENABLE_INTEL = 0x08

const CL_AVC_ME_INTRA_NEIGHBOR_UPPER_LEFT_MASK_ENABLE_INTEL = 0x04

const CL_AVC_ME_LUMA_PREDICTOR_MODE_VERTICAL_INTEL = 0x00

const CL_AVC_ME_LUMA_PREDICTOR_MODE_HORIZONTAL_INTEL = 0x01

const CL_AVC_ME_LUMA_PREDICTOR_MODE_DC_INTEL = 0x02

const CL_AVC_ME_LUMA_PREDICTOR_MODE_DIAGONAL_DOWN_LEFT_INTEL = 0x03

const CL_AVC_ME_LUMA_PREDICTOR_MODE_DIAGONAL_DOWN_RIGHT_INTEL = 0x04

const CL_AVC_ME_LUMA_PREDICTOR_MODE_PLANE_INTEL = 0x04

const CL_AVC_ME_LUMA_PREDICTOR_MODE_VERTICAL_RIGHT_INTEL = 0x05

const CL_AVC_ME_LUMA_PREDICTOR_MODE_HORIZONTAL_DOWN_INTEL = 0x06

const CL_AVC_ME_LUMA_PREDICTOR_MODE_VERTICAL_LEFT_INTEL = 0x07

const CL_AVC_ME_LUMA_PREDICTOR_MODE_HORIZONTAL_UP_INTEL = 0x08

const CL_AVC_ME_CHROMA_PREDICTOR_MODE_DC_INTEL = 0x00

const CL_AVC_ME_CHROMA_PREDICTOR_MODE_HORIZONTAL_INTEL = 0x01

const CL_AVC_ME_CHROMA_PREDICTOR_MODE_VERTICAL_INTEL = 0x02

const CL_AVC_ME_CHROMA_PREDICTOR_MODE_PLANE_INTEL = 0x03

const CL_AVC_ME_FRAME_FORWARD_INTEL = 0x01

const CL_AVC_ME_FRAME_BACKWARD_INTEL = 0x02

const CL_AVC_ME_FRAME_DUAL_INTEL = 0x03

const CL_AVC_ME_SLICE_TYPE_PRED_INTEL = 0x00

const CL_AVC_ME_SLICE_TYPE_BPRED_INTEL = 0x01

const CL_AVC_ME_SLICE_TYPE_INTRA_INTEL = 0x02

const CL_AVC_ME_INTERLACED_SCAN_TOP_FIELD_INTEL = 0x00

const CL_AVC_ME_INTERLACED_SCAN_BOTTOM_FIELD_INTEL = 0x01

const cl_intel_unified_shared_memory = 1

const CL_INTEL_UNIFIED_SHARED_MEMORY_EXTENSION_NAME = "cl_intel_unified_shared_memory"

const CL_INTEL_UNIFIED_SHARED_MEMORY_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_DEVICE_HOST_MEM_CAPABILITIES_INTEL = 0x4190

const CL_DEVICE_DEVICE_MEM_CAPABILITIES_INTEL = 0x4191

const CL_DEVICE_SINGLE_DEVICE_SHARED_MEM_CAPABILITIES_INTEL = 0x4192

const CL_DEVICE_CROSS_DEVICE_SHARED_MEM_CAPABILITIES_INTEL = 0x4193

const CL_DEVICE_SHARED_SYSTEM_MEM_CAPABILITIES_INTEL = 0x4194

const CL_UNIFIED_SHARED_MEMORY_ACCESS_INTEL = 1 << 0

const CL_UNIFIED_SHARED_MEMORY_ATOMIC_ACCESS_INTEL = 1 << 1

const CL_UNIFIED_SHARED_MEMORY_CONCURRENT_ACCESS_INTEL = 1 << 2

const CL_UNIFIED_SHARED_MEMORY_CONCURRENT_ATOMIC_ACCESS_INTEL = 1 << 3

const CL_MEM_ALLOC_FLAGS_INTEL = 0x4195

const CL_MEM_ALLOC_WRITE_COMBINED_INTEL = 1 << 0

const CL_MEM_ALLOC_INITIAL_PLACEMENT_DEVICE_INTEL = 1 << 1

const CL_MEM_ALLOC_INITIAL_PLACEMENT_HOST_INTEL = 1 << 2

const CL_MEM_ALLOC_TYPE_INTEL = 0x419a

const CL_MEM_ALLOC_BASE_PTR_INTEL = 0x419b

const CL_MEM_ALLOC_SIZE_INTEL = 0x419c

const CL_MEM_ALLOC_DEVICE_INTEL = 0x419d

const CL_MEM_TYPE_UNKNOWN_INTEL = 0x4196

const CL_MEM_TYPE_HOST_INTEL = 0x4197

const CL_MEM_TYPE_DEVICE_INTEL = 0x4198

const CL_MEM_TYPE_SHARED_INTEL = 0x4199

const CL_KERNEL_EXEC_INFO_INDIRECT_HOST_ACCESS_INTEL = 0x4200

const CL_KERNEL_EXEC_INFO_INDIRECT_DEVICE_ACCESS_INTEL = 0x4201

const CL_KERNEL_EXEC_INFO_INDIRECT_SHARED_ACCESS_INTEL = 0x4202

const CL_KERNEL_EXEC_INFO_USM_PTRS_INTEL = 0x4203

const CL_COMMAND_MEMFILL_INTEL = 0x4204

const CL_COMMAND_MEMCPY_INTEL = 0x4205

const CL_COMMAND_MIGRATEMEM_INTEL = 0x4206

const CL_COMMAND_MEMADVISE_INTEL = 0x4207

const cl_intel_mem_alloc_buffer_location = 1

const CL_INTEL_MEM_ALLOC_BUFFER_LOCATION_EXTENSION_NAME = "cl_intel_mem_alloc_buffer_location"

const CL_INTEL_MEM_ALLOC_BUFFER_LOCATION_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_ALLOC_BUFFER_LOCATION_INTEL = 0x419e

const cl_intel_create_buffer_with_properties = 1

const CL_INTEL_CREATE_BUFFER_WITH_PROPERTIES_EXTENSION_NAME = "cl_intel_create_buffer_with_properties"

const CL_INTEL_CREATE_BUFFER_WITH_PROPERTIES_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const cl_intel_program_scope_host_pipe = 1

const CL_INTEL_PROGRAM_SCOPE_HOST_PIPE_EXTENSION_NAME = "cl_intel_program_scope_host_pipe"

const CL_INTEL_PROGRAM_SCOPE_HOST_PIPE_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_COMMAND_READ_HOST_PIPE_INTEL = 0x4214

const CL_COMMAND_WRITE_HOST_PIPE_INTEL = 0x4215

const CL_PROGRAM_NUM_HOST_PIPES_INTEL = 0x4216

const CL_PROGRAM_HOST_PIPE_NAMES_INTEL = 0x4217

const cl_intel_mem_channel_property = 1

const CL_INTEL_MEM_CHANNEL_PROPERTY_EXTENSION_NAME = "cl_intel_mem_channel_property"

const CL_INTEL_MEM_CHANNEL_PROPERTY_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_CHANNEL_INTEL = 0x4213

const cl_intel_mem_force_host_memory = 1

const CL_INTEL_MEM_FORCE_HOST_MEMORY_EXTENSION_NAME = "cl_intel_mem_force_host_memory"

const CL_INTEL_MEM_FORCE_HOST_MEMORY_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_FORCE_HOST_MEMORY_INTEL = 1 << 20

const cl_intel_command_queue_families = 1

const CL_INTEL_COMMAND_QUEUE_FAMILIES_EXTENSION_NAME = "cl_intel_command_queue_families"

const CL_INTEL_COMMAND_QUEUE_FAMILIES_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_QUEUE_FAMILY_MAX_NAME_SIZE_INTEL = 64

const CL_DEVICE_QUEUE_FAMILY_PROPERTIES_INTEL = 0x418b

const CL_QUEUE_FAMILY_INTEL = 0x418c

const CL_QUEUE_INDEX_INTEL = 0x418d

const CL_QUEUE_DEFAULT_CAPABILITIES_INTEL = 0

const CL_QUEUE_CAPABILITY_CREATE_SINGLE_QUEUE_EVENTS_INTEL = 1 << 0

const CL_QUEUE_CAPABILITY_CREATE_CROSS_QUEUE_EVENTS_INTEL = 1 << 1

const CL_QUEUE_CAPABILITY_SINGLE_QUEUE_EVENT_WAIT_LIST_INTEL = 1 << 2

const CL_QUEUE_CAPABILITY_CROSS_QUEUE_EVENT_WAIT_LIST_INTEL = 1 << 3

const CL_QUEUE_CAPABILITY_TRANSFER_BUFFER_INTEL = 1 << 8

const CL_QUEUE_CAPABILITY_TRANSFER_BUFFER_RECT_INTEL = 1 << 9

const CL_QUEUE_CAPABILITY_MAP_BUFFER_INTEL = 1 << 10

const CL_QUEUE_CAPABILITY_FILL_BUFFER_INTEL = 1 << 11

const CL_QUEUE_CAPABILITY_TRANSFER_IMAGE_INTEL = 1 << 12

const CL_QUEUE_CAPABILITY_MAP_IMAGE_INTEL = 1 << 13

const CL_QUEUE_CAPABILITY_FILL_IMAGE_INTEL = 1 << 14

const CL_QUEUE_CAPABILITY_TRANSFER_BUFFER_IMAGE_INTEL = 1 << 15

const CL_QUEUE_CAPABILITY_TRANSFER_IMAGE_BUFFER_INTEL = 1 << 16

const CL_QUEUE_CAPABILITY_MARKER_INTEL = 1 << 24

const CL_QUEUE_CAPABILITY_BARRIER_INTEL = 1 << 25

const CL_QUEUE_CAPABILITY_KERNEL_INTEL = 1 << 26

const cl_intel_queue_no_sync_operations = 1

const CL_INTEL_QUEUE_NO_SYNC_OPERATIONS_EXTENSION_NAME = "cl_intel_queue_no_sync_operations"

const CL_INTEL_QUEUE_NO_SYNC_OPERATIONS_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_QUEUE_NO_SYNC_OPERATIONS_INTEL = 1 << 29

const cl_intel_sharing_format_query = 1

const CL_INTEL_SHARING_FORMAT_QUERY_EXTENSION_NAME = "cl_intel_sharing_format_query"

const CL_INTEL_SHARING_FORMAT_QUERY_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const cl_ext_image_requirements_info = 1

const CL_EXT_IMAGE_REQUIREMENTS_INFO_EXTENSION_NAME = "cl_ext_image_requirements_info"

const CL_EXT_IMAGE_REQUIREMENTS_INFO_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 5, 0)

const CL_IMAGE_REQUIREMENTS_BASE_ADDRESS_ALIGNMENT_EXT = 0x1292

const CL_IMAGE_REQUIREMENTS_ROW_PITCH_ALIGNMENT_EXT = 0x1290

const CL_IMAGE_REQUIREMENTS_SIZE_EXT = 0x12b2

const CL_IMAGE_REQUIREMENTS_MAX_WIDTH_EXT = 0x12b3

const CL_IMAGE_REQUIREMENTS_MAX_HEIGHT_EXT = 0x12b4

const CL_IMAGE_REQUIREMENTS_MAX_DEPTH_EXT = 0x12b5

const CL_IMAGE_REQUIREMENTS_MAX_ARRAY_SIZE_EXT = 0x12b6

const cl_ext_image_from_buffer = 1

const CL_EXT_IMAGE_FROM_BUFFER_EXTENSION_NAME = "cl_ext_image_from_buffer"

const CL_EXT_IMAGE_FROM_BUFFER_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_IMAGE_REQUIREMENTS_SLICE_PITCH_ALIGNMENT_EXT = 0x1291

const cl_loader_info = 1

const CL_LOADER_INFO_EXTENSION_NAME = "cl_loader_info"

const CL_LOADER_INFO_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_ICDL_OCL_VERSION = 1

const CL_ICDL_VERSION = 2

const CL_ICDL_NAME = 3

const CL_ICDL_VENDOR = 4

const cl_khr_depth_images = 1

const CL_KHR_DEPTH_IMAGES_EXTENSION_NAME = "cl_khr_depth_images"

const CL_KHR_DEPTH_IMAGES_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_ext_float_atomics = 1

const CL_EXT_FLOAT_ATOMICS_EXTENSION_NAME = "cl_ext_float_atomics"

const CL_EXT_FLOAT_ATOMICS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_GLOBAL_FP_ATOMIC_LOAD_STORE_EXT = 1 << 0

const CL_DEVICE_GLOBAL_FP_ATOMIC_ADD_EXT = 1 << 1

const CL_DEVICE_GLOBAL_FP_ATOMIC_MIN_MAX_EXT = 1 << 2

const CL_DEVICE_LOCAL_FP_ATOMIC_LOAD_STORE_EXT = 1 << 16

const CL_DEVICE_LOCAL_FP_ATOMIC_ADD_EXT = 1 << 17

const CL_DEVICE_LOCAL_FP_ATOMIC_MIN_MAX_EXT = 1 << 18

const CL_DEVICE_SINGLE_FP_ATOMIC_CAPABILITIES_EXT = 0x4231

const CL_DEVICE_DOUBLE_FP_ATOMIC_CAPABILITIES_EXT = 0x4232

const CL_DEVICE_HALF_FP_ATOMIC_CAPABILITIES_EXT = 0x4233

const cl_intel_create_mem_object_properties = 1

const CL_INTEL_CREATE_MEM_OBJECT_PROPERTIES_EXTENSION_NAME = "cl_intel_create_mem_object_properties"

const CL_INTEL_CREATE_MEM_OBJECT_PROPERTIES_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_MEM_LOCALLY_UNCACHED_RESOURCE_INTEL = 0x4218

const CL_MEM_DEVICE_ID_INTEL = 0x4219

const cl_pocl_content_size = 1

const CL_POCL_CONTENT_SIZE_EXTENSION_NAME = "cl_pocl_content_size"

const CL_POCL_CONTENT_SIZE_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const cl_ext_image_raw10_raw12 = 1

const CL_EXT_IMAGE_RAW10_RAW12_EXTENSION_NAME = "cl_ext_image_raw10_raw12"

const CL_EXT_IMAGE_RAW10_RAW12_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_UNSIGNED_INT_RAW10_EXT = 0x10e3

const CL_UNSIGNED_INT_RAW12_EXT = 0x10e4

const cl_khr_3d_image_writes = 1

const CL_KHR_3D_IMAGE_WRITES_EXTENSION_NAME = "cl_khr_3d_image_writes"

const CL_KHR_3D_IMAGE_WRITES_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_async_work_group_copy_fence = 1

const CL_KHR_ASYNC_WORK_GROUP_COPY_FENCE_EXTENSION_NAME = "cl_khr_async_work_group_copy_fence"

const CL_KHR_ASYNC_WORK_GROUP_COPY_FENCE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_byte_addressable_store = 1

const CL_KHR_BYTE_ADDRESSABLE_STORE_EXTENSION_NAME = "cl_khr_byte_addressable_store"

const CL_KHR_BYTE_ADDRESSABLE_STORE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_device_enqueue_local_arg_types = 1

const CL_KHR_DEVICE_ENQUEUE_LOCAL_ARG_TYPES_EXTENSION_NAME = "cl_khr_device_enqueue_local_arg_types"

const CL_KHR_DEVICE_ENQUEUE_LOCAL_ARG_TYPES_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_expect_assume = 1

const CL_KHR_EXPECT_ASSUME_EXTENSION_NAME = "cl_khr_expect_assume"

const CL_KHR_EXPECT_ASSUME_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_extended_async_copies = 1

const CL_KHR_EXTENDED_ASYNC_COPIES_EXTENSION_NAME = "cl_khr_extended_async_copies"

const CL_KHR_EXTENDED_ASYNC_COPIES_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_extended_bit_ops = 1

const CL_KHR_EXTENDED_BIT_OPS_EXTENSION_NAME = "cl_khr_extended_bit_ops"

const CL_KHR_EXTENDED_BIT_OPS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_global_int32_base_atomics = 1

const CL_KHR_GLOBAL_INT32_BASE_ATOMICS_EXTENSION_NAME = "cl_khr_global_int32_base_atomics"

const CL_KHR_GLOBAL_INT32_BASE_ATOMICS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_global_int32_extended_atomics = 1

const CL_KHR_GLOBAL_INT32_EXTENDED_ATOMICS_EXTENSION_NAME = "cl_khr_global_int32_extended_atomics"

const CL_KHR_GLOBAL_INT32_EXTENDED_ATOMICS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_int64_base_atomics = 1

const CL_KHR_INT64_BASE_ATOMICS_EXTENSION_NAME = "cl_khr_int64_base_atomics"

const CL_KHR_INT64_BASE_ATOMICS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_int64_extended_atomics = 1

const CL_KHR_INT64_EXTENDED_ATOMICS_EXTENSION_NAME = "cl_khr_int64_extended_atomics"

const CL_KHR_INT64_EXTENDED_ATOMICS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_kernel_clock = 1

const CL_KHR_KERNEL_CLOCK_EXTENSION_NAME = "cl_khr_kernel_clock"

const CL_KHR_KERNEL_CLOCK_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_KERNEL_CLOCK_CAPABILITIES_KHR = 0x1076

const CL_DEVICE_KERNEL_CLOCK_SCOPE_DEVICE_KHR = 1 << 0

const CL_DEVICE_KERNEL_CLOCK_SCOPE_WORK_GROUP_KHR = 1 << 1

const CL_DEVICE_KERNEL_CLOCK_SCOPE_SUB_GROUP_KHR = 1 << 2

const cl_khr_local_int32_base_atomics = 1

const CL_KHR_LOCAL_INT32_BASE_ATOMICS_EXTENSION_NAME = "cl_khr_local_int32_base_atomics"

const CL_KHR_LOCAL_INT32_BASE_ATOMICS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_local_int32_extended_atomics = 1

const CL_KHR_LOCAL_INT32_EXTENDED_ATOMICS_EXTENSION_NAME = "cl_khr_local_int32_extended_atomics"

const CL_KHR_LOCAL_INT32_EXTENDED_ATOMICS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_mipmap_image_writes = 1

const CL_KHR_MIPMAP_IMAGE_WRITES_EXTENSION_NAME = "cl_khr_mipmap_image_writes"

const CL_KHR_MIPMAP_IMAGE_WRITES_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_select_fprounding_mode = 1

const CL_KHR_SELECT_FPROUNDING_MODE_EXTENSION_NAME = "cl_khr_select_fprounding_mode"

const CL_KHR_SELECT_FPROUNDING_MODE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_spirv_extended_debug_info = 1

const CL_KHR_SPIRV_EXTENDED_DEBUG_INFO_EXTENSION_NAME = "cl_khr_spirv_extended_debug_info"

const CL_KHR_SPIRV_EXTENDED_DEBUG_INFO_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_spirv_linkonce_odr = 1

const CL_KHR_SPIRV_LINKONCE_ODR_EXTENSION_NAME = "cl_khr_spirv_linkonce_odr"

const CL_KHR_SPIRV_LINKONCE_ODR_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_spirv_no_integer_wrap_decoration = 1

const CL_KHR_SPIRV_NO_INTEGER_WRAP_DECORATION_EXTENSION_NAME = "cl_khr_spirv_no_integer_wrap_decoration"

const CL_KHR_SPIRV_NO_INTEGER_WRAP_DECORATION_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_spirv_queries = 1

const CL_KHR_SPIRV_QUERIES_EXTENSION_NAME = "cl_khr_spirv_queries"

const CL_KHR_SPIRV_QUERIES_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_DEVICE_SPIRV_EXTENDED_INSTRUCTION_SETS_KHR = 0x12b9

const CL_DEVICE_SPIRV_EXTENSIONS_KHR = 0x12ba

const CL_DEVICE_SPIRV_CAPABILITIES_KHR = 0x12bb

const cl_khr_srgb_image_writes = 1

const CL_KHR_SRGB_IMAGE_WRITES_EXTENSION_NAME = "cl_khr_srgb_image_writes"

const CL_KHR_SRGB_IMAGE_WRITES_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_subgroup_ballot = 1

const CL_KHR_SUBGROUP_BALLOT_EXTENSION_NAME = "cl_khr_subgroup_ballot"

const CL_KHR_SUBGROUP_BALLOT_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_subgroup_clustered_reduce = 1

const CL_KHR_SUBGROUP_CLUSTERED_REDUCE_EXTENSION_NAME = "cl_khr_subgroup_clustered_reduce"

const CL_KHR_SUBGROUP_CLUSTERED_REDUCE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_subgroup_extended_types = 1

const CL_KHR_SUBGROUP_EXTENDED_TYPES_EXTENSION_NAME = "cl_khr_subgroup_extended_types"

const CL_KHR_SUBGROUP_EXTENDED_TYPES_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_subgroup_non_uniform_arithmetic = 1

const CL_KHR_SUBGROUP_NON_UNIFORM_ARITHMETIC_EXTENSION_NAME = "cl_khr_subgroup_non_uniform_arithmetic"

const CL_KHR_SUBGROUP_NON_UNIFORM_ARITHMETIC_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_subgroup_non_uniform_vote = 1

const CL_KHR_SUBGROUP_NON_UNIFORM_VOTE_EXTENSION_NAME = "cl_khr_subgroup_non_uniform_vote"

const CL_KHR_SUBGROUP_NON_UNIFORM_VOTE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_subgroup_rotate = 1

const CL_KHR_SUBGROUP_ROTATE_EXTENSION_NAME = "cl_khr_subgroup_rotate"

const CL_KHR_SUBGROUP_ROTATE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_subgroup_shuffle = 1

const CL_KHR_SUBGROUP_SHUFFLE_EXTENSION_NAME = "cl_khr_subgroup_shuffle"

const CL_KHR_SUBGROUP_SHUFFLE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_subgroup_shuffle_relative = 1

const CL_KHR_SUBGROUP_SHUFFLE_RELATIVE_EXTENSION_NAME = "cl_khr_subgroup_shuffle_relative"

const CL_KHR_SUBGROUP_SHUFFLE_RELATIVE_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_khr_work_group_uniform_arithmetic = 1

const CL_KHR_WORK_GROUP_UNIFORM_ARITHMETIC_EXTENSION_NAME = "cl_khr_work_group_uniform_arithmetic"

const CL_KHR_WORK_GROUP_UNIFORM_ARITHMETIC_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const cl_ext_buffer_device_address = 1

const CL_EXT_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME = "cl_ext_buffer_device_address"

const CL_EXT_BUFFER_DEVICE_ADDRESS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 2)

const CL_MEM_DEVICE_PRIVATE_ADDRESS_EXT = 0x5000

const CL_MEM_DEVICE_ADDRESS_EXT = 0x5001

const CL_KERNEL_EXEC_INFO_DEVICE_PTRS_EXT = 0x5002

const cl_ext_image_unorm_int_2_101010 = 1

const CL_EXT_IMAGE_UNORM_INT_2_101010_EXTENSION_NAME = "cl_ext_image_unorm_int_2_101010"

const CL_EXT_IMAGE_UNORM_INT_2_101010_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_UNORM_INT_2_101010_EXT = 0x10e5

const cl_ext_image_unsigned_10x6_12x4_14x2 = 1

const CL_EXT_IMAGE_UNSIGNED_10X6_12X4_14X2_EXTENSION_NAME = "cl_ext_image_unsigned_10x6_12x4_14x2"

const CL_EXT_IMAGE_UNSIGNED_10X6_12X4_14X2_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_UNSIGNED_INT10X6_EXT = 0x10e6

const CL_UNSIGNED_INT12X4_EXT = 0x10e7

const CL_UNSIGNED_INT14X2_EXT = 0x10e8

const CL_UNORM_INT10X6_EXT = 0x10e1

const CL_UNORM_INT12X4_EXT = 0x10e9

const CL_UNORM_INT14X2_EXT = 0x10ea

const cl_ext_immutable_memory_objects = 1

const CL_EXT_IMMUTABLE_MEMORY_OBJECTS_EXTENSION_NAME = "cl_ext_immutable_memory_objects"

const CL_EXT_IMMUTABLE_MEMORY_OBJECTS_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 0)

const CL_MEM_IMMUTABLE_EXT = 1 << 6

const cl_img_cancel_command = 1

const CL_IMG_CANCEL_COMMAND_EXTENSION_NAME = "cl_img_cancel_command"

const CL_IMG_CANCEL_COMMAND_EXTENSION_VERSION = @CL_MAKE_VERSION(0, 0, 0)

const CL_CANCELLED_IMG = -1126

const cl_qcom_perf_hint = 1

const CL_QCOM_PERF_HINT_EXTENSION_NAME = "cl_qcom_perf_hint"

const CL_QCOM_PERF_HINT_EXTENSION_VERSION = @CL_MAKE_VERSION(1, 0, 5)

const CL_PERF_HINT_HIGH_QCOM = 0x40c3

const CL_PERF_HINT_NORMAL_QCOM = 0x40c4

const CL_PERF_HINT_LOW_QCOM = 0x40c5

const CL_CONTEXT_PERF_HINT_QCOM = 0x40c2

# OpenCL.Device

struct Device <: CLObject
    id::cl_device_id
end

Base.unsafe_convert(::Type{cl_device_id}, d::Device) = d.id

function Base.show(io::IO, d::Device)
    strip_extra_whitespace = r"\s+"
    device_name = replace(d.name, strip_extra_whitespace => " ")
    platform_name = replace(d.platform.name, strip_extra_whitespace => " ")
    ptr_val = convert(UInt, pointer(d))
    ptr_address = "0x$(string(ptr_val, base = 16, pad = Sys.WORD_SIZE>>2))"
    print(io, "OpenCL.Device($device_name on $platform_name @$ptr_address)")
end

@inline function Base.getproperty(d::Device, s::Symbol)
    # simple string properties
    version_re = r"OpenCL (?<major>\d+)\.(?<minor>\d+)(?<vendor>.+)"
    @inline function get_string(prop)
        sz = Ref{Csize_t}()
        clGetDeviceInfo(d, prop, 0, C_NULL, sz)
        chars = Vector{Cchar}(undef, sz[])
        clGetDeviceInfo(d, prop, sz[], chars, C_NULL)
        return GC.@preserve chars unsafe_string(pointer(chars))
    end
    if s === :profile
        return get_string(CL_DEVICE_PROFILE)
    elseif s === :version
        str = get_string(CL_DEVICE_VERSION)
        m = match(version_re, str)
        if m === nothing
            error("Could not parse OpenCL version string: $str")
        end
        return strip(m["vendor"])
    elseif s === :opencl_version
        str = get_string(CL_DEVICE_VERSION)
        m = match(version_re, str)
        if m === nothing
            error("Could not parse OpenCL version string: $str")
        end
        return VersionNumber(parse(Int, m["major"]), parse(Int, m["minor"]))
    elseif s === :driver_version
        return get_string(CL_DRIVER_VERSION)
    elseif s === :name
        return get_string(CL_DEVICE_NAME)
    end

    # scalar values
    @inline function get_scalar(prop, typ)
        scalar = Ref{typ}()
        clGetDeviceInfo(d, prop, sizeof(typ), scalar, C_NULL)
        return Int(scalar[])
    end
    if s === :vendor_id
        return get_scalar(CL_DEVICE_VENDOR_ID, cl_uint)
    elseif s === :max_compute_units
        return get_scalar(CL_DEVICE_MAX_COMPUTE_UNITS, cl_uint)
    elseif s === :max_work_item_dims
        return get_scalar(CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS, cl_uint)
    elseif s === :max_clock_frequency
        return get_scalar(CL_DEVICE_MAX_CLOCK_FREQUENCY, cl_uint)
    elseif s === :address_bits
        return get_scalar(CL_DEVICE_ADDRESS_BITS, cl_uint)
    elseif s === :max_read_image_args
        return get_scalar(CL_DEVICE_MAX_READ_IMAGE_ARGS, cl_uint)
    elseif s === :max_write_image_args
        return get_scalar(CL_DEVICE_MAX_WRITE_IMAGE_ARGS, cl_uint)
    elseif s === :global_mem_size
        return get_scalar(CL_DEVICE_GLOBAL_MEM_SIZE, cl_ulong)
    elseif s === :max_mem_alloc_size
        return get_scalar(CL_DEVICE_MAX_MEM_ALLOC_SIZE, cl_ulong)
    elseif s === :max_const_buffer_size
        return get_scalar(CL_DEVICE_MAX_CONSTANT_BUFFER_SIZE, cl_ulong)
    elseif s === :local_mem_size
        return get_scalar(CL_DEVICE_LOCAL_MEM_SIZE, cl_ulong)
    elseif s === :max_work_group_size
        return get_scalar(CL_DEVICE_MAX_WORK_GROUP_SIZE, Csize_t)
    elseif s === :max_parameter_size
        return get_scalar(CL_DEVICE_MAX_PARAMETER_SIZE, Csize_t)
    elseif s === :profiling_timer_resolution
        return get_scalar(CL_DEVICE_PROFILING_TIMER_RESOLUTION, Csize_t)
    end

    # boolean properties
    @inline function get_bool(prop)
        bool = Ref{cl_bool}()
        clGetDeviceInfo(d, prop, sizeof(cl_bool), bool, C_NULL)
        return bool[] == CL_TRUE
    end
    if s === :has_image_support
        return get_bool(CL_DEVICE_IMAGE_SUPPORT)
    elseif s === :has_local_mem
        return get_bool(CL_DEVICE_LOCAL_MEM_TYPE)
    elseif s === :host_unified_memory
        return get_bool(CL_DEVICE_HOST_UNIFIED_MEMORY)
    elseif s === :available
        return get_bool(CL_DEVICE_AVAILABLE)
    elseif s === :compiler_available
        return get_bool(CL_DEVICE_COMPILER_AVAILABLE)
    end

    if s == :extensions
        size = Ref{Csize_t}()
        clGetDeviceInfo(d, CL_DEVICE_EXTENSIONS, 0, C_NULL, size)
        result = Vector{Cchar}(undef, size[])
        clGetDeviceInfo(d, CL_DEVICE_EXTENSIONS, size[], result, C_NULL)
        bs = GC.@preserve result unsafe_string(pointer(result))
        return String[string(s) for s in split(bs)]
    end

    if s == :platform
        result = Ref{cl_platform_id}()
        clGetDeviceInfo(d, CL_DEVICE_PLATFORM, sizeof(cl_platform_id), result, C_NULL)
        return Platform(result[])
    end

    if s == :device_type
        result = Ref{cl_device_type}()
        clGetDeviceInfo(d, CL_DEVICE_TYPE, sizeof(cl_device_type), result, C_NULL)
        result = result[]
        if result == CL_DEVICE_TYPE_GPU
            return :gpu
        elseif result == CL_DEVICE_TYPE_CPU
            return :cpu
        elseif result == CL_DEVICE_TYPE_ACCELERATOR
            return :accelerator
        elseif result == CL_DEVICE_TYPE_CUSTOM
            return :custom
        else
            return :unknown
        end
    end

    if s == :max_work_item_size
        result = Vector{Csize_t}(undef, d.max_work_item_dims)
        clGetDeviceInfo(d, CL_DEVICE_MAX_WORK_ITEM_SIZES, sizeof(result), result, C_NULL)
        return tuple([Int(r) for r in result]...)
    end

    # error handling inspired by rusticl
    # https://gitlab.freedesktop.org/mesa/mesa/-/blob/c4385d6fb0938231114eb3023082cd33788b89b4/src/gallium/frontends/rusticl/api/device.rs#L314-320
    if s == :sub_group_sizes
        res_size = Ref{Csize_t}()
        err = unchecked_clGetDeviceInfo(d, CL_DEVICE_SUB_GROUP_SIZES_INTEL, C_NULL, C_NULL, res_size)
        if err == CL_SUCCESS && res_size[] > 1
            result = Vector{Csize_t}(undef, res_size[] ÷ sizeof(Csize_t))
            clGetDeviceInfo(d, CL_DEVICE_SUB_GROUP_SIZES_INTEL, sizeof(result), result, C_NULL)
            return tuple([Int(r) for r in result]...)
        else
            return tuple(0, 1)
        end
    end

    if s == :max_image2d_shape
        width  = Ref{Csize_t}()
        height = Ref{Csize_t}()
        clGetDeviceInfo(d, CL_DEVICE_IMAGE2D_MAX_WIDTH, sizeof(Csize_t), width,  C_NULL)
        clGetDeviceInfo(d, CL_DEVICE_IMAGE2D_MAX_HEIGHT, sizeof(Csize_t), height, C_NULL)
        return (width[], height[])
    end

    if s == :max_image3d_shape
        width  = Ref{Csize_t}()
        height = Ref{Csize_t}()
        depth =  Ref{Csize_t}()
        clGetDeviceInfo(d, CL_DEVICE_IMAGE3D_MAX_WIDTH, sizeof(Csize_t), width, C_NULL)
        clGetDeviceInfo(d, CL_DEVICE_IMAGE3D_MAX_HEIGHT, sizeof(Csize_t), height, C_NULL)
        clGetDeviceInfo(d, CL_DEVICE_IMAGE3D_MAX_DEPTH, sizeof(Csize_t), depth, C_NULL)
        return (width[], height[], depth[])
    end

    return getfield(d, s)
end

function queue_properties(d::Device, type=:host)
    result = Ref{cl_command_queue_properties}()
    if type === :host
        clGetDeviceInfo(d, CL_DEVICE_QUEUE_ON_HOST_PROPERTIES,
                        sizeof(cl_command_queue_properties), result, C_NULL)
    elseif type === :device
        clGetDeviceInfo(d, CL_DEVICE_QUEUE_ON_DEVICE_PROPERTIES,
                        sizeof(cl_command_queue_properties), result, C_NULL)
    else
        throw(ArgumentError("Unknown queue type: $type"))
    end
    mask = result[]

    return (;
        out_of_order_exec = mask & CL_QUEUE_OUT_OF_ORDER_EXEC_MODE_ENABLE != 0,
        profiling = mask & CL_QUEUE_PROFILING_ENABLE != 0
    )
end

function exec_capabilities(d::Device)
    result = Ref{cl_device_exec_capabilities}()
    clGetDeviceInfo(d, CL_DEVICE_EXECUTION_CAPABILITIES,
                    sizeof(cl_device_exec_capabilities), result, C_NULL)
    mask = result[]

    return (;
        native_kernel = mask & CL_EXEC_NATIVE_KERNEL != 0,
    )
end

usm_supported(d::Device) = "cl_intel_unified_shared_memory" in d.extensions

function usm_capabilities(d::Device)
    usm_supported(d) || throw(ArgumentError("Unified Shared Memory not supported on this device"))

    function check_capability_bits(mask::cl_device_unified_shared_memory_capabilities_intel)
        (;
            access = mask & CL_UNIFIED_SHARED_MEMORY_ACCESS_INTEL != 0,
            atomic_access = mask & CL_UNIFIED_SHARED_MEMORY_ATOMIC_ACCESS_INTEL != 0,
            concurrent_access = mask & CL_UNIFIED_SHARED_MEMORY_CONCURRENT_ACCESS_INTEL != 0,
            concurrent_atomic_access = mask & CL_UNIFIED_SHARED_MEMORY_CONCURRENT_ATOMIC_ACCESS_INTEL != 0,
        )
    end

    host = Ref{cl_device_unified_shared_memory_capabilities_intel}()
    device = Ref{cl_device_unified_shared_memory_capabilities_intel}()
    single_device = Ref{cl_device_unified_shared_memory_capabilities_intel}()
    shared = Ref{cl_device_unified_shared_memory_capabilities_intel}()
    cross_device = Ref{cl_device_unified_shared_memory_capabilities_intel}()

    clGetDeviceInfo(
        d, CL_DEVICE_HOST_MEM_CAPABILITIES_INTEL,
        sizeof(cl_device_unified_shared_memory_capabilities_intel), host, C_NULL
    )
    clGetDeviceInfo(
        d, CL_DEVICE_DEVICE_MEM_CAPABILITIES_INTEL,
        sizeof(cl_device_unified_shared_memory_capabilities_intel), device, C_NULL
    )
    clGetDeviceInfo(
        d, CL_DEVICE_SINGLE_DEVICE_SHARED_MEM_CAPABILITIES_INTEL,
        sizeof(cl_device_unified_shared_memory_capabilities_intel), single_device, C_NULL
    )
    clGetDeviceInfo(
        d, CL_DEVICE_SHARED_SYSTEM_MEM_CAPABILITIES_INTEL,
        sizeof(cl_device_unified_shared_memory_capabilities_intel), shared, C_NULL
    )
    clGetDeviceInfo(
        d, CL_DEVICE_CROSS_DEVICE_SHARED_MEM_CAPABILITIES_INTEL,
        sizeof(cl_device_unified_shared_memory_capabilities_intel), cross_device, C_NULL
    )

    return (;
        host = check_capability_bits(host[]),
        device = check_capability_bits(device[]),
        single_device = check_capability_bits(single_device[]),
        shared = check_capability_bits(shared[]),
        cross_device = check_capability_bits(cross_device[]),
    )
end

function svm_capabilities(d::Device)
    result = Ref{cl_device_svm_capabilities}()
    clGetDeviceInfo(d, CL_DEVICE_SVM_CAPABILITIES,
                    sizeof(cl_device_svm_capabilities), result, C_NULL)
    mask = result[]

    return (;
        coarse_grain_buffer = mask & CL_DEVICE_SVM_COARSE_GRAIN_BUFFER != 0,
        fine_grain_buffer = mask & CL_DEVICE_SVM_FINE_GRAIN_BUFFER != 0,
        fine_grain_system = mask & CL_DEVICE_SVM_FINE_GRAIN_SYSTEM != 0,
    )
end

bda_supported(d::Device) = "cl_ext_buffer_device_address" in d.extensions

function cl_device_type(dtype::Symbol)
    if dtype == :all
        cl_dtype = CL_DEVICE_TYPE_ALL
    elseif dtype == :cpu
        cl_dtype = CL_DEVICE_TYPE_CPU
    elseif dtype == :gpu
        cl_dtype = CL_DEVICE_TYPE_GPU
    elseif dtype == :accelerator
        cl_dtype = CL_DEVICE_TYPE_ACCELERATOR
    elseif dtype == :custom
        cl_dtype = CL_DEVICE_TYPE_CUSTOM
    elseif dtype == :default
        cl_dtype = CL_DEVICE_TYPE_DEFAULT
    else
        throw(ArgumentError("Unknown device type: $dtype"))
    end
    return cl_dtype
end

sub_groups_supported(d::Device) = "cl_khr_subgroups" in d.extensions || "cl_intel_subgroups" in d.extensions
function sub_group_size(d::Device)
    sub_groups_supported(d) || 0
    if "cl_amd_device_attribute_query" in d.extensions
        scalar = Ref{cl_uint}()
        clGetDeviceInfo(d, CL_DEVICE_WAVEFRONT_WIDTH_AMD, sizeof(cl_uint), scalar, C_NULL)
        return Int(scalar[])
    elseif "cl_nv_device_attribute_query" in d.extensions
        scalar = Ref{cl_uint}()
        clGetDeviceInfo(d, CL_DEVICE_WARP_SIZE_NV, sizeof(cl_uint), scalar, C_NULL)
        return Int(scalar[])
    else
        sg_sizes = d.sub_group_sizes
        return if length(sg_sizes) == 1
            Int(only(sg_sizes))
        elseif 32 in sg_sizes
            32
        elseif 64 in sg_sizes
            64
        elseif 16 in sg_sizes
            16
        else
            Int(first(sg_sizes))
        end
    end
end
function sub_group_shuffle_supported_types(d::Device)
    if "cl_khr_subgroup_shuffle" in d.extensions
        res = [Int8, UInt8, Int16, UInt16, Int32, UInt32, Int64, UInt64, Float32]
        "cl_khr_fp16" in d.extensions && push!(res, Float16)
        "cl_khr_fp64" in d.extensions && push!(res, Float64)
        res
    else
        DataType[]
    end
end

# OpenCL.Platform

struct Platform <: CLObject
    id::cl_platform_id
end

Base.unsafe_convert(::Type{cl_platform_id}, p::Platform) = p.id

function Base.getproperty(p::Platform, s::Symbol)
    # simple string properties
    version_re = r"OpenCL (?<major>\d+)\.(?<minor>\d+)(?<vendor>.+)"
    @inline function get_string(prop)
        sz = Ref{Csize_t}()
        clGetPlatformInfo(p, prop, 0, C_NULL, sz)
        chars = Vector{Cchar}(undef, sz[])
        clGetPlatformInfo(p, prop, sz[], chars, C_NULL)
        return GC.@preserve chars unsafe_string(pointer(chars))
    end
    if s === :profile
        return get_string(CL_PLATFORM_PROFILE)
    elseif s === :version
        str = get_string(CL_PLATFORM_VERSION)
        m = match(version_re, str)
        if m === nothing
            error("Could not parse OpenCL version string: $str")
        end
        return strip(m["vendor"])
    elseif s === :opencl_version
        str = get_string(CL_PLATFORM_VERSION)
        m = match(version_re, str)
        if m === nothing
            error("Could not parse OpenCL version string: $str")
        end
        return VersionNumber(parse(Int, m["major"]), parse(Int, m["minor"]))
    elseif s === :name
        return get_string(CL_PLATFORM_NAME)
    elseif s === :vendor
        return get_string(CL_PLATFORM_VENDOR)
    end

    if s == :extensions
        size = Ref{Csize_t}()
        clGetPlatformInfo(p, CL_PLATFORM_EXTENSIONS, 0, C_NULL, size)
        result = Vector{Cchar}(undef, size[])
        clGetPlatformInfo(p, CL_PLATFORM_EXTENSIONS, size[], result, C_NULL)
        return GC.@preserve result split(unsafe_string(pointer(result)))
    end

    return getfield(p, s)
end

function Base.show(io::IO, p::Platform)
    strip_extra_whitespace = r"\s+"
    platform_name = replace(p.name, strip_extra_whitespace => " ")
    ptr_val = convert(UInt, pointer(p))
    ptr_address = "0x$(string(ptr_val, base = 16, pad = Sys.WORD_SIZE>>2))"
    print(io, "OpenCL.Platform('$platform_name' @$ptr_address)")
end

function platforms()
    nplatforms = Ref{Cuint}()
    res = unchecked_clGetPlatformIDs(0, C_NULL, nplatforms)
    if res == CL_PLATFORM_NOT_FOUND_KHR || nplatforms[] == 0
        return Platform[]
    elseif res != CL_SUCCESS
        throw(CLError(res))
    end
    cl_platform_ids = Vector{cl_platform_id}(undef, nplatforms[])
    clGetPlatformIDs(nplatforms[], cl_platform_ids, C_NULL)
    return [Platform(id) for id in cl_platform_ids]
end

function num_platforms()
    nplatforms = Ref{Cuint}()
    clGetPlatformIDs(0, C_NULL, nplatforms)
    return Int(nplatforms[])
end

function devices(p::Platform, dtype)
    ndevices = Ref{Cuint}()
    ret = unchecked_clGetDeviceIDs(p, dtype, 0, C_NULL, ndevices)
    if ret == CL_DEVICE_NOT_FOUND || ndevices[] == 0
        return Device[]
    elseif ret != CL_SUCCESS
        throw(CLError(ret))
    end
    result = Vector{cl_device_id}(undef, ndevices[])
    clGetDeviceIDs(p, dtype, ndevices[], result, C_NULL)
    return Device[Device(id) for id in result]
end

devices(p::Platform) = devices(p, CL_DEVICE_TYPE_ALL)

function devices(p::Platform, dtype::Symbol)
    devices(p, cl_device_type(dtype))
end

has_device_type(p::Platform, dtype) = length(devices(p, dtype)) > 0

available_devices(p::Platform, dtype::Symbol) = filter(d -> d.available,  devices(p, dtype))
available_devices(p::Platform) = available_devices(p, :all)

# code reflection entry-points

#
# code_* replacements
#

# function to split off certain kwargs for selective forwarding, at run time.
# `@opencl` does something similar at parse time, using `GPUCompiler.split_kwargs`.
function split_kwargs_runtime(kwargs, wanted::Vector{Symbol})
    remaining = Dict{Symbol, Any}()
    extracted = Dict{Symbol, Any}()
    for (key, value) in kwargs
        if key in wanted
            extracted[key] = value
        else
            remaining[key] = value
        end
    end
    return extracted, remaining
end

for method in (:code_typed, :code_warntype, :code_llvm, :code_native)
    # only code_typed doesn't take a io argument
    args = method == :code_typed ? (:job,) : (:io, :job)

    @eval begin
        function $method(io::IO, @nospecialize(func), @nospecialize(types);
                         kernel::Bool=false, kwargs...)
            compiler_kwargs, kwargs = split_kwargs_runtime(kwargs, COMPILER_KWARGS)
            source = methodinstance(typeof(func), Base.to_tuple_type(types))
            config = compiler_config(cl.device(); kernel, compiler_kwargs...)
            job = CompilerJob(source, config)
            GPUCompiler.$method($(args...); kwargs...)
        end
        $method(@nospecialize(func), @nospecialize(types); kwargs...) =
            $method(stdout, func, types; kwargs...)
    end
end



#
# @device_code_* functions
#

export @device_code_lowered, @device_code_typed, @device_code_warntype, @device_code_llvm,
       @device_code_native, @device_code

# forward to GPUCompiler
@eval $(Symbol("@device_code_lowered")) = $(getfield(GPUCompiler, Symbol("@device_code_lowered")))
@eval $(Symbol("@device_code_typed")) = $(getfield(GPUCompiler, Symbol("@device_code_typed")))
@eval $(Symbol("@device_code_warntype")) = $(getfield(GPUCompiler, Symbol("@device_code_warntype")))
@eval $(Symbol("@device_code_llvm")) = $(getfield(GPUCompiler, Symbol("@device_code_llvm")))
@eval $(Symbol("@device_code_native")) = $(getfield(GPUCompiler, Symbol("@device_code_native")))
@eval $(Symbol("@device_code")) = $(getfield(GPUCompiler, Symbol("@device_code")))


#
# other
#

"""
    OpenCL.return_type(f, tt) -> r::Type

Return a type `r` such that `f(args...)::r` where `args::tt`.
"""
function return_type(@nospecialize(func), @nospecialize(tt))
    source = methodinstance(typeof(func), tt)
    config = compiler_config(cl.device())
    job = CompilerJob(source, config)
    interp = GPUCompiler.get_interpreter(job)
    sig = Base.signature_type(func, tt)
    Core.Compiler._return_type(interp, sig)
end

# outlined functionality to avoid GC frame allocation
@noinline function throw_api_error(res)
    throw(CLError(res))
end

function check(f)
    res = retry_reclaim(err -> err == CL_OUT_OF_RESOURCES ||
                               err == CL_MEM_OBJECT_ALLOCATION_FAILURE ||
                               err == CL_OUT_OF_HOST_MEMORY) do
        f()
    end

    if res != CL_SUCCESS
        throw_api_error(res)
    end

    return
end

macro CL_MAKE_VERSION(major, minor, patch)
    quote
        VersionNumber($major, $minor, $patch)
    end
end

const intptr_t = Cssize_t

abstract type UnifiedMemory <: AbstractPointerMemory end

usm_alloc_properties(flags::Integer) =
    flags == 0 ? C_NULL : cl_mem_properties_intel[CL_MEM_ALLOC_FLAGS_INTEL, flags, 0]

function usm_free(mem::UnifiedMemory; blocking::Bool = false)
    if blocking
        clMemBlockingFreeINTEL(context(mem), mem)
    else
        clMemFreeINTEL(context(mem), mem)
    end
end


## device buffer

"""
    UnifiedDeviceMemory

A buffer of device memory, owned by a specific device. Generally, may only be accessed by
the device that owns it.
"""
struct UnifiedDeviceMemory <: UnifiedMemory
    ptr::CLPtr{Cvoid}
    bytesize::Int
    context::Context
end

UnifiedDeviceMemory() = UnifiedDeviceMemory(CL_NULL, 0, context())

function device_alloc(bytesize::Integer;
        alignment::Integer = 0, write_combined::Bool = false
    )

    flags = 0
    if write_combined
        flags |= CL_MEM_ALLOC_WRITE_COMBINED_INTEL
    end

    error_code = Ref{Cint}()
    props = usm_alloc_properties(flags)
    ptr = clDeviceMemAllocINTEL(context(), device(), props, bytesize, alignment, error_code)
    if error_code[] != CL_SUCCESS
        throw(CLError(error_code[]))
    end

    return UnifiedDeviceMemory(ptr, bytesize, context())
end

Base.pointer(mem::UnifiedDeviceMemory) = mem.ptr
Base.sizeof(mem::UnifiedDeviceMemory) = mem.bytesize
context(mem::UnifiedDeviceMemory) = mem.context

Base.show(io::IO, mem::UnifiedDeviceMemory) =
    @printf(io, "UnifiedDeviceMemory(%s at %p)", Base.format_bytes(sizeof(mem)), pointer(mem))

Base.convert(::Type{CLPtr{T}}, mem::UnifiedDeviceMemory) where {T} =
    convert(CLPtr{T}, pointer(mem))


## host buffer

"""
    UnifiedHostMemory

A buffer of memory on the host. May be accessed by the host, and all devices within the
host driver. Frequently used as staging areas to transfer data to or from devices.
"""
struct UnifiedHostMemory <: UnifiedMemory
    ptr::Ptr{Cvoid}
    bytesize::Int
    context::Context
end

UnifiedHostMemory() = UnifiedHostMemory(C_NULL, 0, context())

function host_alloc(bytesize::Integer;
        alignment::Integer = 0, write_combined::Bool = false
    )

    flags = 0
    if write_combined
        flags |= CL_MEM_ALLOC_WRITE_COMBINED_INTEL
    end

    error_code = Ref{Cint}()
    props = usm_alloc_properties(flags)
    ptr = clHostMemAllocINTEL(context(), props, bytesize, alignment, error_code)
    if error_code[] != CL_SUCCESS
        throw(CLError(error_code[]))
    end

    return UnifiedHostMemory(ptr, bytesize, context())
end

Base.pointer(mem::UnifiedHostMemory) = mem.ptr
Base.sizeof(mem::UnifiedHostMemory) = mem.bytesize
context(mem::UnifiedHostMemory) = mem.context

Base.show(io::IO, mem::UnifiedHostMemory) =
    @printf(io, "UnifiedHostMemory(%s at %p)", Base.format_bytes(sizeof(mem)), Int(pointer(mem)))

Base.convert(::Type{Ptr{T}}, mem::UnifiedHostMemory) where {T} =
    convert(Ptr{T}, pointer(mem))


## shared buffer

"""
    UnifiedSharedMemory

A managed buffer that is shared between the host and one or more devices.
"""
struct UnifiedSharedMemory <: UnifiedMemory
    ptr::CLPtr{Cvoid}
    bytesize::Int
    context::Context
end

UnifiedSharedMemory() = UnifiedSharedMemory(CL_NULL, 0, context())

function shared_alloc(bytesize::Integer;
        alignment::Integer = 0, write_combined = false, placement = nothing
    )

    flags = 0
    if write_combined
        flags |= CL_MEM_ALLOC_WRITE_COMBINED_INTEL
    end
    if placement !== nothing
        if placement == :host
            flags |= CL_MEM_ALLOC_INITIAL_PLACEMENT_HOST_INTEL
        elseif placement == :device
            flags |= CL_MEM_ALLOC_INITIAL_PLACEMENT_DEVICE_INTEL
        else
            error("Invalid placement, the only allowed values for placement are :host and :device")
        end
    end

    error_code = Ref{Cint}()
    props = usm_alloc_properties(flags)
    ptr = clSharedMemAllocINTEL(context(), device(), props, bytesize, alignment, error_code)
    if error_code[] != CL_SUCCESS
        throw(CLError(error_code[]))
    end

    return UnifiedSharedMemory(ptr, bytesize, context())
end

Base.pointer(mem::UnifiedSharedMemory) = mem.ptr
Base.sizeof(mem::UnifiedSharedMemory) = mem.bytesize
context(mem::UnifiedSharedMemory) = mem.context

Base.show(io::IO, mem::UnifiedSharedMemory) =
    @printf(io, "UnifiedSharedMemory(%s at %p)", Base.format_bytes(sizeof(mem)), Int(pointer(mem)))

Base.convert(::Type{Ptr{T}}, mem::UnifiedSharedMemory) where {T} =
    convert(Ptr{T}, reinterpret(Ptr{Cvoid}, pointer(mem)))

Base.convert(::Type{CLPtr{T}}, mem::UnifiedSharedMemory) where {T} =
    convert(CLPtr{T}, pointer(mem))


## memory operations

function enqueue_usm_copy(
        dst::Union{CLPtr, Ptr}, src::Union{CLPtr, Ptr}, nbytes::Integer; queue::CmdQueue = queue(), blocking::Bool = false,
        wait_for::Vector{Event} = Event[]
    )::Union{Event, Nothing}
    n_evts = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    return GC.@preserve wait_for begin
        com = (CL_NULL, C_NULL)
        ret_evt = (dst in com || src in com) ? C_NULL : Ref{cl_event}()
        clEnqueueMemcpyINTEL(queue, blocking, dst, src, nbytes, n_evts, evt_ids, ret_evt)
        @return_event ret_evt[]
    end
end

# fill a buffer with a pattern, returning an event
function enqueue_usm_fill(ptr::Union{Ptr, CLPtr}, pattern::T, N::Integer;
                          wait_for::Vector{Event}=Event[]) where {T}
    nbytes = N * sizeof(T)
    pattern_size = sizeof(T)
    n_evts  = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueMemFillINTEL(queue(), ptr, Ref(pattern),
                              pattern_size, nbytes,
                              n_evts, evt_ids, ret_evt)
        @return_event ret_evt[]
    end
end

function enqueue_usm_migrate(
        ptr::Union{CLPtr, Ptr}, nbytes::Integer;
        queue::CmdQueue = queue(),
        wait_for::Vector{Event} = Event[],
        properties::Vector{Symbol} = Symbol[]
    )
    flag = 0
    if !isempty(properties)
        for i in properties
            if i == :host
                flag |= CL_MIGRATE_MEM_OBJECT_HOST
            elseif i == :undefined
                flag |= CL_MIGRATE_MEM_OBJECT_CONTENT_UNDEFINED
            else
                error("Invalid flag, the only allowed values for properties are :host and :undefined")
            end
        end
    end
    n_evts = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    return GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueMigrateMemINTEL(queue, ptr, nbytes, flag, n_evts, evt_ids, ret_evt)
        @return_event ret_evt[]
    end
end

function enqueue_usm_advise(
        ptr::Union{CLPtr, Ptr}, nbytes::Integer;
        queue::CmdQueue = queue(),
        wait_for::Vector{Event} = Event[],
        properties::Vector{Symbol} = Symbol[]
    )
    flag = 0
    if !isempty(properties)
        error("Invalid flag, no advise for memory according to USM yet, this parameter is for the future.")
    end
    n_evts = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    return GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueMemAdviseINTEL(queue, ptr, nbytes, flag, n_evts, evt_ids, ret_evt)
        @return_event ret_evt[]
    end
end

# OpenCL.Buffer

struct Buffer <: AbstractMemoryObject
    id::cl_mem
    ptr::Union{Nothing,CLPtr{Cvoid}}
    bytesize::Int
    context::Context
end

Buffer() = Buffer(C_NULL, CL_NULL, 0, context())

Base.pointer(buf::Buffer) = @something buf.ptr error("Conversion of a buffer to a pointer is not supported by this device")
Base.sizeof(buf::Buffer) = buf.bytesize
context(buf::Buffer) = buf.context


## constructors

# for internal use
function Buffer(sz::Int, flags::Integer, hostbuf=nothing;
                device=:rw, host=:rw, device_private_address=bda_supported(cl.device()))
    if device == :rw
        flags |= CL_MEM_READ_WRITE
    elseif device == :r
        flags |= CL_MEM_READ_ONLY
    elseif device == :w
        flags |= CL_MEM_WRITE_ONLY
    else
        throw(ArgumentError("Device access flag must be one of :rw, :r, or :w"))
    end

    if host == :rw
        # nothing to do
    elseif host == :r
        flags |= CL_MEM_HOST_READ_ONLY
    elseif host == :w
        flags |= CL_MEM_HOST_WRITE_ONLY
    elseif host == :none
        flags |= CL_MEM_HOST_NO_ACCESS
    else
        throw(ArgumentError("Host access flag must be one of :rw, :r, or :w"))
    end

    err_code = Ref{Cint}()
    properties = cl_mem_properties[]
    if device_private_address
        append!(properties, [CL_MEM_DEVICE_PRIVATE_ADDRESS_EXT, CL_TRUE])
    end
    mem_id = if isempty(properties)
        clCreateBuffer(context(), flags, sz, something(hostbuf, C_NULL), err_code)
    else
        push!(properties, 0)
        clCreateBufferWithProperties(context(), properties, flags, sz, something(hostbuf, C_NULL), err_code)
    end
    if err_code[] != CL_SUCCESS
        throw(CLError(err_code[]))
    end

    ptr = if device_private_address
        ptr_ref = Ref{cl_mem_device_address_ext}()
        clGetMemObjectInfo(mem_id, CL_MEM_DEVICE_ADDRESS_EXT, sizeof(cl_mem_device_address_ext), ptr_ref, C_NULL)
        CLPtr{Cvoid}(ptr_ref[])
    else
        nothing
    end

    return Buffer(mem_id, ptr, sz, context())
end

# allocated buffer
function Buffer(sz::Integer; host_accessible=false, kwargs...)
    flags = host_accessible ? CL_MEM_ALLOC_HOST_PTR : 0
    Buffer(sz, flags, nothing; kwargs...)
end

# from host memory
function Buffer(hostbuf::Array; copy::Bool=true, kwargs...)
    flags = copy ? CL_MEM_COPY_HOST_PTR : CL_MEM_USE_HOST_PTR
    Buffer(sizeof(hostbuf), flags, hostbuf; kwargs...)
end


## memory operations

# reading from buffer to host array, return an event
function enqueue_read(dst::Ptr, src::Buffer, src_off::Int, nbytes::Int;
                      blocking::Bool=false, wait_for::Vector{Event}=Event[])
    n_evts  = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueReadBuffer(queue(), src, blocking, src_off, nbytes, dst,
                            n_evts, evt_ids, ret_evt)
        @return_nanny_event(ret_evt[], dst)
    end
end
enqueue_read(dst::Ptr, src::Buffer, nbytes; kwargs...) =
    enqueue_read(dst, src, 0, nbytes; kwargs...)

# writing from host array to buffer, return an event
function enqueue_write(dst::Buffer, dst_off::Int, src::Ptr, nbytes::Int;
                       blocking::Bool=false, wait_for::Vector{Event}=Event[])
    n_evts  = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueWriteBuffer(queue(), dst, blocking, dst_off, nbytes, src,
                             n_evts, evt_ids, ret_evt)
        @return_nanny_event(ret_evt[], dst)
    end
end
enqueue_write(dst::Buffer, src::Ptr, nbytes; kwargs...) =
    enqueue_write(dst, 0, src, nbytes; kwargs...)

# copying between two buffers, return an event
function enqueue_copy(dst::Buffer, dst_off::Int, src::Buffer, src_off::Int,
                      nbytes::Int; blocking::Bool=false,
                      wait_for::Vector{Event}=Event[])
    n_evts  = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueCopyBuffer(queue(), src, dst, src_off, dst_off, nbytes,
                            n_evts, evt_ids, ret_evt)
        @return_event ret_evt[]
    end
end
enqueue_copy(dst::Buffer, src::Buffer, N; kwargs...) =
    enqueue_copy(dst, 0, src, 0, N; kwargs...)

# map a buffer into the host address space, returning a pointer and an event
function enqueue_map(buf::Buffer, offset::Integer, nbytes::Int, flags=:rw;
                     blocking::Bool=false, wait_for::Vector{Event}=Event[])
    flags = if flags == :rw
        CL_MAP_READ | CL_MAP_WRITE
    elseif flags == :r
        CL_MAP_READ
    elseif flags == :w
        CL_MAP_WRITE
    else
        throw(ArgumentError("enqueue_unmap can have flags of :r, :w, or :rw, got :$flags"))
    end

    ret_evt = Ref{cl_event}()
    n_evts  = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve wait_for begin
        status  = Ref{Cint}()
        ptr = clEnqueueMapBuffer(queue(), buf, blocking, flags, offset, nbytes,
                                 n_evts, evt_ids, ret_evt, status)
        if status[] != CL_SUCCESS
            throw(CLError(status[]))
        end

        return ptr, Event(ret_evt[])
    end
end
enqueue_map(buf::Buffer, nbytes::Int, flags=:rw; kwargs...) =
    enqueue_map(buf, 0, nbytes, flags; kwargs...)

# unmap a buffer, return an event
function enqueue_unmap(buf::Buffer, ptr::Ptr; wait_for::Vector{Event}=Event[])
    n_evts  = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueUnmapMemObject(queue(), buf, ptr, n_evts, evt_ids, ret_evt)
        return Event(ret_evt[])
    end
end

# fill a buffer with a pattern, returning an event
function enqueue_fill(buf::Buffer, offset::Integer, pattern::T, N::Integer;
                      wait_for::Vector{Event}=Event[]) where {T}
    nbytes = N * sizeof(T)
    nbytes_pattern = sizeof(T)
    @assert nbytes_pattern > 0
    n_evts  = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve begin
        ret_evt = Ref{cl_event}()
        clEnqueueFillBuffer(queue(), buf, [pattern],
                            nbytes_pattern, offset, nbytes,
                            n_evts, evt_ids, ret_evt)
        @return_event ret_evt[]
    end
end
enqueue_fill(buf::Buffer, pattern, N::Integer) = enqueue_fill(buf, 0, pattern, N)

import OpenCL_jll

const libopencl = OpenCL_jll.libopencl

"""
    @checked function foo(...)
        rv = ...
        return rv
    end

Macro for wrapping a function definition returning a status code. Two versions of the
function will be generated: `foo`, with the function body wrapped by an invocation of the
`check` function (to be implemented by the caller of this macro), and `unchecked_foo` where no
such invocation is present and the status code is returned to the caller.
"""
macro checked(ex)
    # parse the function definition
    @assert Meta.isexpr(ex, :function)
    sig = ex.args[1]
    @assert Meta.isexpr(sig, :call)
    body = ex.args[2]
    @assert Meta.isexpr(body, :block)

    # we need to detect the first API call, so add an initialization check
    body = quote
        if !initialized[]
            initialize()
        end
        $body
    end

    # generate a "safe" version that performs a check
    safe_body = quote
        check() do
            $body
        end
    end
    safe_sig = Expr(:call, sig.args[1], sig.args[2:end]...)
    safe_def = Expr(:function, safe_sig, safe_body)

    # generate a "unchecked" version that returns the error code instead
    unchecked_sig = Expr(:call, Symbol("unchecked_", sig.args[1]), sig.args[2:end]...)
    unchecked_def = Expr(:function, unchecked_sig, body)

    return esc(:($safe_def, $unchecked_def))
end

function retry_reclaim(f, isfailed)
    ret = f()

    # slow path, incrementally reclaiming more memory until we succeed
    if isfailed(ret)
        phase = 1
        while true
            if phase == 1
                GC.gc(false)
            elseif phase == 2
                GC.gc(true)
            else
                break
            end
            phase += 1

            ret = f()
            isfailed(ret) || break
        end
    end

    ret
end

macro ext_ccall(ex)
    # decode the expression
    @assert Meta.isexpr(ex, :(::))
    call, ret = ex.args
    @assert Meta.isexpr(call, :call)
    target, argexprs... = call.args
    @assert Meta.isexpr(target, :(.))
    _, fn = target.args

    @gensym fptr
    esc(quote
        $fptr = $clGetExtensionFunctionAddressForPlatform(platform(), $fn)
        @ccall $(Expr(:($), fptr))($(argexprs...))::$ret
    end)
end

include("libopencl.jl")

@static if Sys.iswindows()
    # Windows type aliases
    const BOOL = Int32
    const DWORD = UInt32
    const PDWORD = Ptr{DWORD}
    const HANDLE = Ptr{Cvoid}
    const PHANDLE = Ptr{HANDLE}
    const BYTE = UInt8
    const PBYTE = Ptr{BYTE}
    const PVOID = Ptr{Cvoid}
    const PSID = PVOID
    const PSID_AND_ATTRIBUTES = PVOID
    struct SID_AND_ATTRIBUTES
        Sid::PSID
        Attributes::DWORD
    end
    struct TOKEN_MANDATORY_LABEL
        Label::SID_AND_ATTRIBUTES
    end

    # Windows constants
    const TOKEN_QUERY = DWORD(0x0008)
    const TOKEN_QUERY_SOURCE = DWORD(0x0010)
    const SECURITY_MAX_SID_SIZE = 68
    const SECURITY_MANDATORY_MEDIUM_RID = DWORD(0x2000)
    const TokenIntegrityLevel = 25  # TOKEN_INFORMATION_CLASS enum value

    const kernel32 = "kernel32.dll"
    GetCurrentProcess() = @ccall kernel32.GetCurrentProcess()::HANDLE
    CloseHandle(hObject) = @ccall kernel32.CloseHandle(hObject::HANDLE)::BOOL

    const advapi32 = "advapi32.dll"
    OpenProcessToken(ProcessHandle, DesiredAccess, TokenHandle) =
        @ccall advapi32.OpenProcessToken(ProcessHandle::HANDLE, DesiredAccess::DWORD, TokenHandle::PHANDLE)::BOOL
    GetTokenInformation(TokenHandle, TokenInformationClass, TokenInformation, TokenInformationLength, ReturnLength) =
        @ccall advapi32.GetTokenInformation(TokenHandle::HANDLE, TokenInformationClass::Int32, TokenInformation::PBYTE, TokenInformationLength::DWORD, ReturnLength::PDWORD)::BOOL
    GetSidSubAuthorityCount(pSid) =
        @ccall advapi32.GetSidSubAuthorityCount(pSid::PSID)::PBYTE
    GetSidSubAuthority(pSid, nSubAuthority) =
        @ccall advapi32.GetSidSubAuthority(pSid::PSID, nSubAuthority::DWORD)::PDWORD

    # mimics `khrIcd_IsHighIntegrityLevel`, which determines if we can specify
    # drivers through environment variables
    function is_high_integrity_level()::Bool
        is_high_integrity = false

        h_token = Ref{HANDLE}()
        if OpenProcessToken(GetCurrentProcess(), TOKEN_QUERY | TOKEN_QUERY_SOURCE, h_token) != 0
            try
                # Maximum possible size of SID_AND_ATTRIBUTES is maximum size of a SID + size of attributes DWORD.
                mandatory_label_buffer = zeros(BYTE, SECURITY_MAX_SID_SIZE + sizeof(DWORD))
                buffer_size = Ref{DWORD}()
                if GetTokenInformation(h_token[], TokenIntegrityLevel, mandatory_label_buffer, length(mandatory_label_buffer), buffer_size) != 0
                    mandatory_label = unsafe_load(Ptr{TOKEN_MANDATORY_LABEL}(pointer(mandatory_label_buffer)))
                    sub_auth_count = unsafe_load(GetSidSubAuthorityCount(mandatory_label.Label.Sid))
                    integrity_level = unsafe_load(GetSidSubAuthority(mandatory_label.Label.Sid, sub_auth_count - 1))

                    return integrity_level > SECURITY_MANDATORY_MEDIUM_RID
                end
            finally
                CloseHandle(h_token[])
            end
        end

        return is_high_integrity
    end
end

# lazy initialization
const initialized = Ref{Bool}(false)
@noinline function initialize()
    initialized[] = true

    @static if Sys.iswindows()
        if is_high_integrity_level()
            @warn """Running at high integrity level, preventing OpenCL.jl from loading drivers from JLLs.

                     Only system drivers will be available. To enable JLL drivers, do not run Julia as an administrator."""
        end
    end

    ocd_filenames = join(OpenCL_jll.drivers, ':')
    if haskey(ENV, "OCL_ICD_FILENAMES")
        ocd_filenames *= ":" * ENV["OCL_ICD_FILENAMES"]
    end

    withenv("OCL_ICD_FILENAMES"=>ocd_filenames) do
        num_platforms = Ref{Cuint}()
        @ccall libopencl.clGetPlatformIDs(
            0::cl_uint, C_NULL::Ptr{cl_platform_id},
            num_platforms::Ptr{cl_uint})::cl_int

        if num_platforms[] == 0 && isempty(OpenCL_jll.drivers)
            @error """No OpenCL drivers available, either system-wide or provided by a JLL.

                      Please install a system-wide OpenCL driver, or load one together with OpenCL.jl,
                      e.g., by doing `using OpenCL, pocl_jll`."""
        end
    end
end

function __init__()
    if !OpenCL_jll.is_available()
        @error "OpenCL_jll is not available for your platform, OpenCL.jl. will not work."
    end
end

# Matrix Multiplication Driver
#
# This is a driver program to test various ways of computing
# the product:
#                 C = A * B
#
# A and B are constant matrices, square and the order is
# set as a constant, ORDER (see definitions.py). This is so
# we can make a quick test of the multiplication result.
#
# History:   C++ version written by Tim Mattson, August 2010
#            Modified by Simon McIntosh-Smith, September 2011
#            Modified by Tom Deakin and Simon McIntosh-Smith, October 2012
#            Ported to Python by Tom Deakin, July 2013
#            Ported to Julia by Jake Bolewski, Nov 2013

using OpenCL

# get the directory of this file
# (used for test runner)
src_dir = dirname(Base.source_path())

#### Definitions ###

# Order of the square matrices A, B and C
ORDER = 512

# A elements are constant and equal to AVAL
AVAL = 3.0

# B elements are constant and equal to BVAL
BVAL = 5.0

# tolerance used in floating point comparisons
TOL = 0.001

# Max dim for NDRange
DIM = 2

# number of times to do each multiplication
COUNT = 1

# Helper functions
include("helper.jl")

# A[N,P], B[P M], C[N,M]
Ndim = ORDER
Pdim = ORDER
Mdim = ORDER

# Number of elements in the matrix
sizeA = Ndim * Pdim
sizeB = Pdim * Mdim
sizeC = Ndim * Mdim

# Number of elements in the matrix
h_A = fill(Float32(AVAL), sizeA)
h_B = fill(Float32(BVAL), sizeB)
h_C = Vector{Float32}(undef, sizeC)

# %20 improvment using @inbounds
function seq_mat_mul_sdot(Mdim::Int, Ndim::Int, Pdim::Int,
                          A::Array{T}, B::Array{T}, C::Array{T}) where T
    for i in 1:Ndim
        for j in 1:Mdim
            tmp = zero(Float32)
            for k in 1:Pdim
                @inbounds tmp += A[(i-1)*Ndim+k] * B[(k-1)*Pdim+j]
            end
            @inbounds C[(i-1)*Ndim+j] = tmp
        end
    end
end

@info("=== Julia, matix mult (dot prod), order $ORDER ===")

# force compilation
seq_mat_mul_sdot(Mdim, Ndim, Pdim, h_A, h_B, h_C)

for i in 1:COUNT
    fill!(h_C, 0.0)
    t1 = time()
    seq_mat_mul_sdot(Mdim, Ndim, Pdim, h_A, h_B, h_C)
    t2 = time()
    results(Mdim, Ndim, Pdim, h_C, t2 - t1)
end

# create OpenCL array
d_a = CLArray(h_A)
d_b = CLArray(h_B)
d_c = CLArray{Float32}(undef, length(h_C))

#--------------------------------------------------------------------------------
# OpenCL matrix multiplication ... Naive
#--------------------------------------------------------------------------------

kernel_source = read(joinpath(src_dir, "C_elem.cl"), String)
prg  = cl.Program(source=kernel_source) |> cl.build!
mmul = cl.Kernel(prg, "mmul")

@info("=== OpenCL, matrix mult, C(i, j) per work item, order $Ndim ====")

for i in 1:COUNT
    fill!(h_C, 0.0)
    cl.queue!(:profile) do
        evt = clcall(mmul, Tuple{Int32, Int32, Int32, CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}},
                     Mdim, Ndim, Pdim, d_a, d_b, d_c; global_size=(Ndim, Mdim))
        wait(evt)

        # profiling events are measured in ns
        run_time = evt.profile_duration / 1e9
        cl.copy!(h_C, d_c)
        results(Mdim, Ndim, Pdim, h_C, run_time)
    end
end

#--------------------------------------------------------------------------------
# OpenCL matrix multiplication ... C row per work item
#--------------------------------------------------------------------------------

kernel_source = read(joinpath(src_dir, "C_row.cl"), String)
prg  = cl.Program(source=kernel_source) |> cl.build!
mmul = cl.Kernel(prg, "mmul")

@info("=== OpenCL, matrix mult, C row per work item, order $Ndim ====")

for i in 1:COUNT
    fill!(h_C, 0.0)
    global_size = (Ndim,)
    local_size = (div(ORDER, 16),)

    cl.queue!(:profile) do
        evt = clcall(mmul, Tuple{Int32, Int32, Int32, CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}},
                     Mdim, Ndim, Pdim, d_a, d_b, d_c; global_size, local_size)
        wait(evt)

        # profiling events are measured in ns
        run_time = evt.profile_duration / 1e9
        cl.copy!(h_C, d_c)
        results(Mdim, Ndim, Pdim, h_C, run_time)
    end
end

#--------------------------------------------------------------------------------
# OpenCL matrix multiplication ... C row per work item, A row in private memory
#--------------------------------------------------------------------------------
kernel_source = read(joinpath(src_dir, "C_row_priv.cl"), String)
prg  = cl.Program(source=kernel_source) |> cl.build!
mmul = cl.Kernel(prg, "mmul")
wk_size = cl.device().max_work_group_size
if Ndim * (ORDER ÷ 16) >= wk_size
    @warn("Specified work_size $(Ndim * (ORDER ÷ 16)) is bigger than $wk_size")
else

@info("=== OpenCL, matrix mult, C row, A row in priv mem, order $Ndim ====")

for i in 1:COUNT
    fill!(h_C, 0.0)

    cl.queue!(:profile) do
        evt = clcall(mmul, Tuple{Int32, Int32, Int32, CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}},
                     Mdim, Ndim, Pdim, d_a, d_b, d_c; global_size=Ndim, local_size=ORDER)
        wait(evt)

        # profiling events are measured in ns
        run_time = evt.profile_duration / 1e9
        cl.copy!(h_C, d_c)
        results(Mdim, Ndim, Pdim, h_C, run_time)
    end
end
end

export sub_group_shuffle, sub_group_shuffle_xor

const gentypes = [Int8, UInt8, Int16, UInt16, Int32, UInt32, Int64, UInt64, Float16, Float32, Float64]

for gentype in gentypes
    @eval begin
        @device_function sub_group_shuffle(x::$gentype, i::Integer) =
            @builtin_ccall("__spirv_GroupNonUniformShuffle", $gentype,
                           (UInt32, $gentype, UInt32),
                           UInt32(Scope.Subgroup), x, UInt32(i - 1))
        @device_function sub_group_shuffle_xor(x::$gentype, mask::Integer) =
            @builtin_ccall("__spirv_GroupNonUniformShuffleXor", $gentype,
                           (UInt32, $gentype, UInt32),
                           UInt32(Scope.Subgroup), x, UInt32(mask))
    end
end

struct SharedVirtualMemory <: AbstractPointerMemory
    ptr::CLPtr{Cvoid}
    bytesize::Int
    context::Context
end

SharedVirtualMemory() = SharedVirtualMemory(CL_NULL, 0, context())

function svm_alloc(bytesize::Integer;
        alignment::Integer = 0, access::Symbol = :rw, fine_grained = false
    )

    flags = if access == :rw
        CL_MEM_READ_WRITE
    elseif access == :r
        CL_MEM_READ_ONLY
    elseif access == :w
        CL_MEM_WRITE_ONLY
    else
        throw(ArgumentError("Invalid access type"))
    end

    if fine_grained
        flags |= CL_MEM_SVM_FINE_GRAIN_BUFFER
    end

    ptr = clSVMAlloc(context(), flags, bytesize, alignment)
    @assert ptr != C_NULL

    # JuliaGPU/OpenCL.jl#252: uninitialized SVM memory doesn't work on Intel
    if platform().name == "Intel(R) OpenCL Graphics"
        enqueue_svm_fill(ptr, UInt8(0), bytesize)
    end

    return SharedVirtualMemory(ptr, bytesize, context())
end

svm_free(mem::SharedVirtualMemory) = clSVMFree(context(mem), mem)

Base.pointer(mem::SharedVirtualMemory) = mem.ptr
Base.sizeof(mem::SharedVirtualMemory) = mem.bytesize
context(mem::SharedVirtualMemory) = mem.context

Base.show(io::IO, mem::SharedVirtualMemory) =
    @printf(io, "SharedVirtualMemory(%s at %p)", Base.format_bytes(sizeof(mem)), Int(pointer(mem)))

Base.convert(::Type{Ptr{T}}, mem::SharedVirtualMemory) where {T} =
    convert(Ptr{T}, reinterpret(Ptr{Cvoid}, pointer(mem)))

Base.convert(::Type{CLPtr{T}}, mem::SharedVirtualMemory) where {T} =
    reinterpret(CLPtr{T}, pointer(mem))


## memory operations

# these generally only make sense for coarse-grained SVM buffers;
# fine-grained buffers can just be used directly.

# copy from and to SVM buffers
function enqueue_svm_copy(
        dst::Union{Ptr, CLPtr}, src::Union{Ptr, CLPtr}, nbytes::Integer; queue::CmdQueue = queue(), blocking::Bool = false,
        wait_for::Vector{Event} = Event[]
    )
    n_evts = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    return GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueSVMMemcpy(queue, blocking, dst, src, nbytes, n_evts, evt_ids, ret_evt)
        @return_event ret_evt[]
    end
end

# map an SVM buffer into the host address space, returning an event
function enqueue_svm_map(
        ptr::Union{Ptr, CLPtr}, nbytes::Integer, flags = :rw; queue::CmdQueue = queue(), blocking::Bool = false,
        wait_for::Vector{Event} = Event[]
    )
    flags = if flags == :rw
        CL_MAP_READ | CL_MAP_WRITE
    elseif flags == :r
        CL_MAP_READ
    elseif flags == :w
        CL_MAP_WRITE
    else
        throw(ArgumentError("enqueue_unmap can have flags of :r, :w, or :rw, got :$flags"))
    end
    n_evts = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueSVMMap(
            queue, blocking, flags, ptr, nbytes,
            n_evts, evt_ids, ret_evt
        )

        return Event(ret_evt[])
    end
end

# unmap a buffer, returning an event
function enqueue_svm_unmap(ptr::Union{Ptr, CLPtr}; queue::CmdQueue = queue(), wait_for::Vector{Event} = Event[])
    n_evts = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueSVMUnmap(queue, ptr, n_evts, evt_ids, ret_evt)
        return Event(ret_evt[])
    end
end

# fill a buffer with a pattern, returning an event
function enqueue_svm_fill(ptr::Union{Ptr, CLPtr}, pattern::T, N::Integer;
                          wait_for::Vector{Event}=Event[]) where {T}
    nbytes = N * sizeof(T)
    pattern_size = sizeof(T)
    n_evts  = length(wait_for)
    evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve wait_for begin
        ret_evt = Ref{cl_event}()
        clEnqueueSVMMemFill(queue(), ptr, Ref(pattern),
                            pattern_size, nbytes,
                            n_evts, evt_ids, ret_evt)
        @return_event ret_evt[]
    end
end

using Random

gpuarrays_rng() = GPUArrays.default_rng(CLArray)

# GPUArrays in-place
Random.rand!(A::WrappedCLArray) = Random.rand!(gpuarrays_rng(), A)
Random.randn!(A::WrappedCLArray) = Random.randn!(gpuarrays_rng(), A)

# GPUArrays out-of-place
rand(T::Type, dims::Dims) = Random.rand!(CLArray{T}(undef, dims...))
randn(T::Type, dims::Dims; kwargs...) = Random.randn!(CLArray{T}(undef, dims...); kwargs...)

# support all dimension specifications
rand(T::Type, dim1::Integer, dims::Integer...) = Random.rand!(CLArray{T}(undef, dim1, dims...))
randn(T::Type, dim1::Integer, dims::Integer...; kwargs...) = Random.randn!(CLArray{T}(undef, dim1, dims...); kwargs...)

# untyped out-of-place
rand(dim1::Integer, dims::Integer...) = Random.rand!(CLArray{Float32}(undef, dim1, dims...))
randn(dim1::Integer, dims::Integer...; kwargs...) = Random.randn!(CLArray{Float32}(undef, dim1, dims...); kwargs...)

# seeding
seed!(seed = Base.rand(UInt64)) = Random.seed!(gpuarrays_rng(), seed)

macro print_and_throw(args...)
    quote
        @println "ERROR: " $(args...) "."
        throw(nothing)
    end
end

# math.jl
@device_override @noinline Base.Math.throw_complex_domainerror(f::Symbol, x) =
    @print_and_throw "This operation requires a complex input to return a complex result"
@device_override @noinline Base.Math.throw_exp_domainerror(x) =
    @print_and_throw "Exponentiation yielding a complex result requires a complex argument"

# intfuncs.jl
@device_override @noinline Base.throw_domerr_powbysq(::Any, p) =
    @print_and_throw "Cannot raise an integer to a negative power"
@device_override @noinline Base.throw_domerr_powbysq(::Integer, p) =
    @print_and_throw "Cannot raise an integer to a negative power"
@device_override @noinline Base.throw_domerr_powbysq(::AbstractMatrix, p) =
    @print_and_throw "Cannot raise an integer to a negative power"

# checked.jl
@device_override @noinline Base.Checked.throw_overflowerr_binaryop(op, x, y) =
    @print_and_throw "Binary operation overflowed"
@device_override @noinline Base.Checked.throw_overflowerr_negation(op, x, y) =
    @print_and_throw "Negation overflowed"

# boot.jl
@device_override @noinline Core.throw_inexacterror(f::Symbol, ::Type{T}, val) where {T} =
    @print_and_throw "Inexact conversion"

# abstractarray.jl
@device_override @noinline Base.throw_boundserror(A, I) =
    @print_and_throw "Out-of-bounds array access"

# trig.jl
@device_override @noinline Base.Math.sincos_domain_error(x) =
    @print_and_throw "sincos(x) is only defined for finite x."

# diagonal.jl
# XXX: remove when we have malloc
import LinearAlgebra
@device_override function Base.setindex!(D::LinearAlgebra.Diagonal, v, i::Int, j::Int)
    @boundscheck checkbounds(D, i, j)
    if i == j
        @inbounds D.diag[i] = v
    elseif !iszero(v)
        @print_and_throw "cannot set off-diagonal entry to a nonzero value"
    end
    return v
end

# number.jl
# XXX: remove when we have malloc
@device_override @inline function Base.getindex(x::Number, I::Integer...)
    @boundscheck all(isone, I) ||
        @print_and_throw "Out-of-bounds access of scalar value"
    x
end

# From Metal.jl to avoid widemul and Int128
@static if VERSION >= v"1.12.0-DEV.1736" # Partially reverts JuliaLang/julia PR #56750
    BitInteger64 = Union{Int64, UInt64}
    @device_override function Base.checkbounds(::Type{Bool}, v::StepRange{<:BitInteger64, <:BitInteger64}, i::BitInteger64)
        @inline
        return checkindex(Bool, eachindex(IndexLinear(), v), i)
    end
end

# reset the runtime cache from global scope, so that any change triggers recompilation
GPUCompiler.reset_runtime()

signal_exception() = return

malloc(sz) = C_NULL

report_oom(sz) = return

report_exception(ex) = return

report_exception_name(ex) = return

report_exception_frame(idx, func, file, line) = return

## kernel state

struct KernelState
    random_seed::UInt32
end

@inline @generated kernel_state() = GPUCompiler.kernel_state_value(KernelState)

## intrinsics for adding and accessing additional kernel arguments

# The amount of local shared memory we need for storing RNG state is determined
# dynamically at kernel launch time, so needs to be passed as additional arguments
# to the kernel.
# We define intrinsics that get transformed into additional kernel arguments which
# then get propagated across function calls to the caller.

function additional_arg_intr(mod::LLVM.Module, T_state, name)
    state_intr = if haskey(functions(mod), "julia.opencl.$name")
        functions(mod)["julia.opencl.$name"]
    else
        LLVM.Function(mod, "julia.opencl.$name", LLVM.FunctionType(T_state))
    end
    push!(function_attributes(state_intr), EnumAttribute("readnone", 0))

    return state_intr
end

# run-time equivalent
function additional_arg_value(state, name)
    @dispose ctx=Context() begin
        T_state = convert(LLVMType, state)

        # create function
        llvm_f, _ = create_function(T_state)
        mod = LLVM.parent(llvm_f)

        # get intrinsic
        state_intr = additional_arg_intr(mod, T_state, name)
        state_intr_ft = function_type(state_intr)

        # generate IR
        @dispose builder=IRBuilder() begin
            entry = BasicBlock(llvm_f, "entry")
            position!(builder, entry)

            val = call!(builder, state_intr_ft, state_intr, Value[], name)

            ret!(builder, val)
        end

        call_function(llvm_f, state)
    end
end

for name in [:random_keys, :random_counters]
    @eval @inline @generated $name() =
        additional_arg_value(LLVMPtr{UInt32, AS.Workgroup}, $(String(name)))
end

# OpenCL.Program

using Printf

mutable struct Program <: CLObject
    const id::cl_program

    function Program(program_id::cl_program; retain::Bool=false)
        p = new(program_id)
        retain && clRetainProgram(p)
        finalizer(clReleaseProgram, p)
        return p
    end
end

Base.show(io::IO, p::Program) = begin
    ptr_val = convert(UInt, pointer(p))
    ptr_address = "0x$(string(ptr_val, base = 16, pad = Sys.WORD_SIZE>>2))"
    print(io, "OpenCL.Program(@$ptr_address)")
end

Base.unsafe_convert(::Type{cl_program}, p::Program) = p.id

function Program(; source=nothing, binaries=nothing, il=nothing)
    if count(!isnothing, (source, binaries, il)) != 1
        throw(ArgumentError("Program must be source, binary, or intermediate language"))
    end
    if source !== nothing
        byte_source = [String(source)]
        err_code = Ref{Cint}()
        program_id = clCreateProgramWithSource(context(), 1, byte_source, C_NULL, err_code)
        if err_code[] != CL_SUCCESS
            throw(CLError(err_code[]))
        end

    elseif il !== nothing
        err_code = Ref{Cint}()
        program_id = clCreateProgramWithIL(context(), il, length(il), err_code)
        if err_code[] != CL_SUCCESS
            throw(CLError(err_code[]))
        end

    elseif binaries !== nothing
        ndevices = length(binaries)
        device_ids = Vector{cl_device_id}(undef, ndevices)
        bin_lengths = Vector{Csize_t}(undef, ndevices)
        binary_status = Vector{Cint}(undef, ndevices)
        binary_ptrs= Vector{Ptr{UInt8}}(undef, ndevices)
        try
            for (i, (dev, bin)) in enumerate(binaries)
                device_ids[i] = dev.id
                bin_lengths[i] = length(bin)
                binary_ptrs[i] = Base.unsafe_convert(Ptr{UInt8}, pointer(bin))
            end
            err_code = Ref{Cint}()
            program_id = clCreateProgramWithBinary(context(), ndevices, device_ids, bin_lengths,
                                                   binary_ptrs, binary_status, err_code)
            if err_code[] != CL_SUCCESS
                throw(CLError(err_code[]))
            end
            for status in binary_status
                if status != CL_SUCCESS
                    throw(CLError(status))
                end
            end
        catch err
            throw(err)
        end
    end
    Program(program_id)
end

#TODO: build callback...
function build!(p::Program; options="")
    opts = String(options)
    ndevices = 0
    device_ids = C_NULL
    try
        clBuildProgram(p, cl_uint(ndevices), device_ids, opts, C_NULL, C_NULL)
    catch err
        isa(err, CLError) || throw(err)

        for (dev, status) in p.build_status
            if status == CL_BUILD_ERROR
                io = IOBuffer()
                println(io, "Failed to compile program")
                if p.source !== nothing
                    println(io)
                    println(io, "Source code:")
                    for (i,line) in enumerate(split(p.source, "\n"))
                        println(io, @sprintf("%s%-2d: %s", " ", i, line))
                    end
                end
                println(io)
                println(io, "Build log:")
                println(io, strip(p.build_log[dev]))
                error(String(take!(io)))
            end
        end
    end
    return p
end

function Base.getproperty(p::Program, s::Symbol)
    if s == :reference_count
        count = Ref{Cuint}()
        clGetProgramInfo(p, CL_PROGRAM_REFERENCE_COUNT, sizeof(Cuint), count, C_NULL)
        return Int(count[])
    elseif s == :num_devices
        count = Ref{Cuint}()
        clGetProgramInfo(p, CL_PROGRAM_NUM_DEVICES, sizeof(Cuint), count, C_NULL)
        return Int(count[])
    elseif s == :devices
        device_ids = Vector{cl_device_id}(undef, p.num_devices)
        clGetProgramInfo(p, CL_PROGRAM_DEVICES, sizeof(device_ids), device_ids, C_NULL)
        return [Device(id) for id in device_ids]
    elseif s == :source
        src_len = Ref{Csize_t}()
        clGetProgramInfo(p, CL_PROGRAM_SOURCE, 0, C_NULL, src_len)
        src_len[] <= 1 && return nothing
        src = Vector{Cchar}(undef, src_len[])
        clGetProgramInfo(p, CL_PROGRAM_SOURCE, src_len[], src, C_NULL)
        return GC.@preserve src unsafe_string(pointer(src))
    elseif s == :binary_sizes
        sizes = Vector{Csize_t}(undef, p.num_devices)
        clGetProgramInfo(p, CL_PROGRAM_BINARY_SIZES, sizeof(sizes), sizes, C_NULL)
        return sizes
    elseif s == :binaries
        sizes = p.binary_sizes

        bins = Vector{Ptr{UInt8}}(undef, length(sizes))
        # keep a reference to the underlying binary arrays
        # as storing the pointer to the array hides the additional
        # reference from julia's garbage collector
        bin_arrays = Any[]
        for (i, s) in enumerate(sizes)
            if s > 0
                bin = Vector{UInt8}(undef, s)
                bins[i] = pointer(bin)
                push!(bin_arrays, bin)
            else
                bins[i] = Base.unsafe_convert(Ptr{UInt8}, C_NULL)
            end
        end
        clGetProgramInfo(p, CL_PROGRAM_BINARIES, sizeof(bins), bins, C_NULL)

        binary_dict = Dict{Device, Array{UInt8}}()
        bidx = 1
        for (i, d) in enumerate(p.devices)
            if sizes[i] > 0
                binary_dict[d] = bin_arrays[bidx]
                bidx += 1
            end
        end
        return binary_dict
    elseif s == :context
        ctx = Ref{cl_context}()
        clGetProgramInfo(p, CL_PROGRAM_CONTEXT, sizeof(cl_context), ctx, C_NULL)
        return Context(ctx[], retain=true)
    elseif s == :build_status
        status_dict = Dict{Device, cl_build_status}()
        for device in p.devices
            status = Ref{cl_build_status}()
            clGetProgramBuildInfo(p, device, CL_PROGRAM_BUILD_STATUS, sizeof(cl_build_status), status, C_NULL)
            status_dict[device] = status[]
        end
        return status_dict
    elseif s == :build_log
        log_dict = Dict{Device, String}()
        for device in p.devices
            size = Ref{Csize_t}()
            clGetProgramBuildInfo(p, device, CL_PROGRAM_BUILD_LOG, 0, C_NULL, size)
            log = Vector{Cchar}(undef, size[])
            clGetProgramBuildInfo(p, device, CL_PROGRAM_BUILD_LOG, size[], log, C_NULL)
            log_dict[device] = GC.@preserve log unsafe_string(pointer(log))
        end
        return log_dict
    else
        return getfield(p, s)
    end
end

#OpenCL 1.2
#TODO: create_program_with_built_in_kernels(ctx, devices, kernel_names)
#TODO: link_program(ctx, programs; options=[], devices=None)
#TODO: unload_platform_compiler(platform)

const known_intrinsics = String["printf"]

# SPIR-V wrapper and OpenCL.std functions need Itanium C++ ABI names. We
# implement a very limited subset here, just enough to support these builtins.
#
# This macro also keeps track of called builtins, generating `ccall("extern...", llvmcall)`
# expressions for them (so that we can exclude them during IR verification).
macro builtin_ccall(name, ret, argtypes, args...)
    @assert Meta.isexpr(argtypes, :tuple)
    argtypes = argtypes.args

    function mangle(T::Type)
        if T == Int32
            "i"
        elseif T == UInt32
            "j"
        elseif T == Int64
            "l"
        elseif T == UInt64
            "m"
        elseif T == Int16
            "s"
        elseif T == UInt16
            "t"
        elseif T == Int8
            "c"
        elseif T == UInt8
            "h"
        elseif T == Float16
            "Dh"
        elseif T == Float32
            "f"
        elseif T == Float64
            "d"
        elseif T <: LLVMPtr
            elt, as = T.parameters
            (as == AS.Private ? "P" : "PU3AS$as") * "V" * mangle(elt)
        else
            error("Unknown type $T")
        end
    end
    mangle(::Type{NTuple{N, VecElement{T}}}) where {N, T} = "Dv$(N)_" * mangle(T)

    # C++-style mangling; very limited to just support these intrinsics
    # TODO: generalize for use with other intrinsics? do we need to mangle those?
    mangled = "_Z$(length(name))$name"
    for t in argtypes
        # with `@eval @builtin_ccall`, we get actual types in the ast, otherwise symbols
        t = (isa(t, Symbol) || isa(t, Expr)) ? __module__.eval(t) : t
        mangled *= mangle(t)
    end

    push!(__module__.known_intrinsics, mangled)
    esc(quote
        @typed_ccall($mangled, llvmcall, $ret, ($(argtypes...),), $(args...))
    end)
end


## device overrides

# local method table for device functions
Base.Experimental.@MethodTable(method_table)

macro device_override(ex)
    # `method_table` is not interpolated so that the local backend method_table is used
    esc(quote
        Base.Experimental.@overlay(method_table, $ex)
    end)
end

macro device_function(ex)
    ex = macroexpand(__module__, ex)
    def = ExprTools.splitdef(ex)

    # generate a function that errors
    def[:body] = quote
        error("This function is not intended for use on the CPU")
    end

    esc(quote
        $(ExprTools.combinedef(def))
        @device_override $ex
    end)
end

if contains(cl.platform().vendor, "Intel") || contains(cl.platform().vendor, "pocl") || contains(cl.platform().name, "rusticl")
    # unsupported by POCL
    # hangs on Intel
    @warn "Skipping event tests on $(cl.platform().name)"
else

@testset "status" begin
    evt = cl.UserEvent()
    evt.status
    @test evt.status == :submitted
    cl.complete(evt)
    @test evt.status == :complete
    finalize(evt)
end

@testset "wait" begin
    # create user event
    usr_evt = cl.UserEvent()
    cl.enqueue_wait_for_events(usr_evt)

    # create marker event
    mkr_evt = cl.enqueue_marker()

    @test usr_evt.status == :submitted
    @test mkr_evt.status in (:queued, :submitted)

    cl.complete(usr_evt)
    @test usr_evt.status == :complete

    wait(mkr_evt)
    @test mkr_evt.status == :complete

    @test cl.cl_event_status(:running) == cl.CL_RUNNING
    @test cl.cl_event_status(:submitted) == cl.CL_SUBMITTED
    @test cl.cl_event_status(:queued) == cl.CL_QUEUED
    @test cl.cl_event_status(:complete) == cl.CL_COMPLETE
end

@testset "callback" begin
    global callback_called = Ref(false)

    function test_callback(evt, status)
        callback_called[] = true
    end

    usr_evt = cl.UserEvent()

    cl.enqueue_wait_for_events(usr_evt)

    mkr_evt = cl.enqueue_marker()
    cl.add_callback(mkr_evt, test_callback)

    @test usr_evt.status == :submitted
    @test mkr_evt.status in (:queued, :submitted)
    @test !callback_called[]

    cl.complete(usr_evt)
    @test usr_evt.status == :complete

    wait(mkr_evt)

    # Give callback some time to finish
    yield()
    sleep(0.5)

    @test mkr_evt.status == :complete
    @test callback_called[]
end

end

@testset "Type" begin
    for (t, k) in zip((cl.CL_DEVICE_TYPE_GPU, cl.CL_DEVICE_TYPE_CPU,
                       cl.CL_DEVICE_TYPE_ACCELERATOR, cl.CL_DEVICE_TYPE_ALL),
                      (:gpu, :cpu, :accelerator, :all))

        #for (dk, dt) in zip(cl.devices(cl.platform(), k), cl.devices(cl.platform(), t))
        #    @fact dk == dt --> true
        #end
        #devices = cl.devices(cl.platform(), k)
        #for device in devices
        #    @fact device.device_type == t --> true
        #end
    end
end

@testset "Equality" begin
    devices = cl.devices(cl.platform())

    if length(devices) > 1
        d1 = devices[1]
        for d2 in devices[2:end]
           @test pointer(d2) != pointer(d1)
           @test hash(d2) != hash(d1)
           @test isequal(d2, d1) == false
       end
   end
end

@testset "Info" begin
    device_info_keys = Symbol[
            :driver_version,
            :version,
            :extensions,
            :platform,
            :name,
            :device_type,
            :has_image_support,
            :vendor_id,
            :max_compute_units,
            :max_work_item_size,
            :max_clock_frequency,
            :address_bits,
            :max_read_image_args,
            :max_write_image_args,
            :global_mem_size,
            :max_mem_alloc_size,
            :max_const_buffer_size,
            :local_mem_size,
            :has_local_mem,
            :host_unified_memory,
            :available,
            :compiler_available,
            :max_work_group_size,
            :max_parameter_size,
            :profiling_timer_resolution,
            :max_image2d_shape,
            :max_image3d_shape,
        ]
    @test isa(cl.platform(), cl.Platform)
    if isdefined(Core, :FieldError) # VERSION > v"1.12.0-"
        @test_throws FieldError cl.platform().zjdlkf
    else
        @test_throws ErrorException cl.platform().zjdlkf
    end

    device = cl.device()
    @test isa(device, cl.Device)
    if isdefined(Core, :FieldError) # VERSION > v"1.12.0-"
        @test_throws FieldError device.zjdlkf
    else
        @test_throws ErrorException device.zjdlkf
    end
    for k in device_info_keys
        v = getproperty(device, k)
        if k == :extensions
            @test isa(v, Array)
            if length(v) > 0
                @test isa(v, Array{String, 1})
            end
        elseif k == :platform
            @test v == cl.platform()
        elseif k == :max_work_item_sizes
            @test length(v) == 3
        elseif k == :max_image2d_shape
            @test length(v) == 2
        elseif k == :max_image3d_shape
            @test length(v) == 3
        end
    end

    @test cl.queue_properties(cl.device()).profiling isa Bool
    @test cl.queue_properties(cl.device()).out_of_order_exec isa Bool

    @test cl.exec_capabilities(cl.device()).native_kernel isa Bool

    @test cl.svm_capabilities(cl.device()).fine_grain_buffer isa Bool
end

using SPIRV_LLVM_Translator_jll
using IOCapture

@testset "@opencl" begin

dummy() = nothing

@test_throws UndefVarError @opencl undefined()
@test_throws MethodError @opencl dummy(1)


@testset "launch configuration" begin
    @opencl dummy()

    global_size = 1
    @opencl global_size dummy()
    @opencl global_size=1 dummy()
    @opencl global_size=(1,1) dummy()
    @opencl global_size=(1,1,1) dummy()

    local_size = 1
    @opencl global_size local_size dummy()
    @opencl global_size=1 local_size=1 dummy()
    @opencl global_size=(1,1) local_size=(1,1) dummy()
    @opencl global_size=(1,1,1) local_size=(1,1,1) dummy()

    @test_throws ArgumentError @opencl global_size=(1,) local_size=(1,1) dummy()
    @test_throws InexactError @opencl global_size=(-2) dummy()
    @test_throws InexactError @opencl local_size=(-2) dummy()
end

@testset "launch=false" begin
    # XXX: how are svm_pointers handled here?
    k = @opencl launch=false dummy()
    k()
    k(; global_size=1)
end

@testset "inference" begin
    foo() = @opencl dummy()
    @inferred foo()

    # with arguments, we call OpenCL.kernel_convert
    kernel(a) = return
    bar(a) = @opencl kernel(a)
    @inferred bar(CLArray([1]))
end


@testset "reflection" begin
    OpenCL.code_lowered(dummy, Tuple{})
    OpenCL.code_typed(dummy, Tuple{})
    OpenCL.code_warntype(devnull, dummy, Tuple{})
    OpenCL.code_llvm(devnull, dummy, Tuple{})
    OpenCL.code_native(devnull, dummy, Tuple{})

    @device_code_lowered @opencl dummy()
    @device_code_typed @opencl dummy()
    @device_code_warntype io=devnull @opencl dummy()
    @device_code_llvm io=devnull @opencl dummy()
    @device_code_native io=devnull @opencl dummy()

    mktempdir() do dir
        @device_code dir=dir @opencl dummy()
    end

    @test_throws ErrorException @device_code_lowered nothing

    # make sure kernel name aliases are preserved in the generated code
    @test occursin("dummy", sprint(io->(@device_code_llvm io=io optimize=false @opencl dummy())))
    @test occursin("dummy", sprint(io->(@device_code_llvm io=io @opencl dummy())))
    @test occursin("dummy", sprint(io->(@device_code_native io=io @opencl dummy())))

    # make sure invalid kernels can be partially reflected upon
    let
        invalid_kernel() = throw()
        @test_throws OpenCL.InvalidIRError @opencl invalid_kernel()
        @test_throws OpenCL.InvalidIRError IOCapture.capture() do
            @device_code_warntype @opencl invalid_kernel()
        end
        c = IOCapture.capture() do
            try
                @device_code_warntype @opencl invalid_kernel()
            catch
            end
        end
        @test occursin("Body::Union{}", c.output)
    end

    # set name of kernel
    @test occursin("mykernel", sprint(io->(@device_code_llvm io=io begin
        @opencl name="mykernel" dummy()
    end)))

    @test OpenCL.return_type(identity, Tuple{Int}) === Int
    @test OpenCL.return_type(sin, Tuple{Float32}) === Float32
    @test OpenCL.return_type(getindex, Tuple{CLDeviceArray{Float32,1,AS.CrossWorkgroup},Int32}) === Float32
    @test OpenCL.return_type(getindex, Tuple{Base.RefValue{Integer}}) === Integer
end

end

###############################################################################

@testset "argument passing" begin

function memset(a, val)
    gid = get_global_id(1)
    @inbounds a[gid] = val
    return
end

a = CLArray{Int}(undef, 10)
@opencl global_size=length(a) memset(a, 42)
@test all(Array(a) .== 42)

end

@testset "broadcasting" begin
    a = rand(Float32, 2, 3)
    b = rand(Float32, 2)

    c = a .+ b
    a_cl, b_cl = CLArray(a), CLArray(b)
    c_cl = a_cl .+ b_cl
    @test Array(c_cl) == c
    @test c_cl isa CLArray{Float32, 2, OpenCL.memory_type()}

    if cl.usm_supported(cl.device())
        a_cl, b_cl = CLMatrix{Float32, cl.UnifiedSharedMemory}(a), CLVector{Float32, OpenCL.memory_type()}(b)
        c_cl = a_cl .+ b_cl
        @test Array(c_cl) == c
        @test c_cl isa CLArray{Float32, 2, cl.UnifiedSharedMemory}
    end
end

@testset "backends" begin
    llvm_backend_llvm = sprint() do io
        OpenCL.code_llvm(io, () -> nothing, (); dump_module = true, backend = :llvm)
    end
    if Int === Int64
        @test occursin("target triple = \"spirv64v1.4-unknown-unknown-unknown\"", llvm_backend_llvm)
    end

    llvm_backend_khronos = sprint() do io
        OpenCL.code_llvm(io, () -> nothing, (); dump_module = true, backend = :khronos)
    end
    if Int === Int64
        @test occursin("target triple = \"spir64-unknown-unknown\"", llvm_backend_khronos)
    end
end

@testset "has_feature folding" begin
    # has_feature must fold at compile time: the feature-bitset global gets baked in and DCE'd,
    # leaving only the branch matching the device.
    function feature_select(a)
        @inbounds a[] = has_feature(:subgroups) ? Int32(12345) : Int32(54321)
        return
    end
    ir = sprint(io -> OpenCL.code_llvm(io, feature_select,
                                       Tuple{CLDeviceArray{Int32, 0, AS.CrossWorkgroup}};
                                       kernel = true))
    @test !occursin("__opencl_feature_bitset", ir)
    if OpenCL.feature_supported(cl.device(), :subgroups)
        @test occursin("12345", ir) && !occursin("54321", ir)
    else
        @test occursin("54321", ir) && !occursin("12345", ir)
    end
end

#
# Vadd
#
# Element wise addition of three vectors at a time (R=A+B+C)
# Asks the user to select a device at runtime
#
# History: Initial version based on vadd.c, written by Tim Mattson, June 2011
#          Ported to C++ Wrapper API by Benedict Gaster, September 2011
#          Updated to C++ Wrapper API v1.2 by Tom Deakin and Simon McIntosh-Smith, October 2012
#          Ported to Python by Tom Deakin, July 2013
#          Ported to Julia by Jake Bolewski, Nov 2013

using OpenCL

# tolerance used in floating point comparisons
TOL = 1e-3

# length of vectors a, b, c
LENGTH = 1024

# Kernel: vadd
#
# To compute the elementwise sum r = a + b + c
#
# Input: a, b and c float vectors of length count
# Output r float vector of length count holding the sum a + b + cs

kernelsource = "
__kernel void vadd(
    __global float* a,
    __global float* b,
    __global float* c,
    __global float* r,
    const unsigned int count)
{
    unsigned int i = get_global_id(0);
    if (i < count)
        r[i] = a[i] + b[i] + c[i];
}"

# create the compute program and build it
program = cl.Program(source=kernelsource) |> cl.build!

# create a, b and c vectors and fill with random float values
# (the result array will be created when reading back from the device)
h_a = rand(Float32, LENGTH)
h_b = rand(Float32, LENGTH)
h_c = rand(Float32, LENGTH)

d_a = CLArray(h_a)
d_b = CLArray(h_b)
d_c = CLArray(h_c)

# create the output (r) buffer in device memory
d_r = CLArray{Float32}(undef, LENGTH)

# create the kernel
vadd = cl.Kernel(program, "vadd")

# execute the kernel over the entire range of the input
clcall(vadd, Tuple{CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}, Cuint},
       d_a, d_b, d_c, d_r, UInt32(LENGTH); global_size=size(h_a))

# read the results back from the compute device
h_r = Array(d_r)

# test the results
correct = 0
for i in 1:LENGTH
    tmp = h_a[i] + h_b[i] + h_c[i]
    # compute the deviation of expected and output result
    tmp -= h_r[i]
    if tmp^2 < TOL^2
        global correct += 1
    else
        println("tmp $tmp h_a $(h_a[i]) h_b $(h_b[i]) h_c $(h_c[i]) h_r $(h_r[i])")
    end
end

# summarize results
println("3 vector adds to find F=A+B+C: $correct out of $LENGTH results were correct")

#
# Pi reduction
#
# Numeric integration to estimate pi
# Asks the user to select a device at runtime
#
# History: C version written by Tim Mattson, May 2010
#          Ported to the C++ Wrapper API by Benedict R. Gaster, September 2011
#          C++ version Updated by Tom Deakin and Simon McIntosh-Smith, October 2012
#          Ported to Python by Tom Deakin, July 2013
#          Ported to Julia by Jake Bolewski, Nov 2013

using OpenCL

# get the directory of this file
# (used for test runner)
src_dir = dirname(Base.source_path())

#
# Some constant values
const INSTEPS = 512*512*512
const ITERS = 262144

# Set some default values:
# Default number of steps (updated later to device prefereable)
const in_nsteps = INSTEPS

# Default number of iterations
const niters = ITERS

kernelsource = read(joinpath(src_dir, "pi_ocl.cl"), String)
program = cl.Program(source=kernelsource) |> cl.build!

# pi is a julia keyword
pi_kernel = cl.Kernel(program, "pi")

# get the max work group size for the kernel pi on the device
work_group_size = cl.device().max_work_group_size

# now that we know the size of the work_groups, we can set the number
# of work groups, the actual number of steps, and the step size
nwork_groups = in_nsteps ÷ (work_group_size * niters)

if nwork_groups < 1
    # you can get opencl object info through the getproperty syntax
    nwork_groups = cl.device().max_compute_units
    work_group_size = in_nsteps ÷ (nwork_groups * niters)
end

nsteps = work_group_size * niters * nwork_groups
step_size = 1.0 / nsteps

# vector to hold partial sum
h_psum = Vector{Float32}(undef, nwork_groups)

println("$nwork_groups work groups of size $work_group_size.")
println("$nsteps integration steps")

d_partial_sums = CLArray{Float32}(undef, length(h_psum))

# start timer
rtime = time()

# Execute the kernel over the entire range of our 1d input data et
# using the maximum number of work group items for this device
# Set the global and local size as tuples
global_size = (nwork_groups * work_group_size,)
local_size  = (work_group_size,)
localmem    = cl.LocalMem(Float32, work_group_size)

clcall(pi_kernel, Tuple{Int32, Float32, CLPtr{Float32}, CLPtr{Float32}},
       niters, step_size, localmem, d_partial_sums; global_size, local_size)

cl.copy!(h_psum, d_partial_sums)

# complete the sum and compute final integral value
pi_res = sum(h_psum) * step_size

# stop the timer
rtime = time() - rtime

println("The calculation ran in $rtime secs")
println("pi=$pi_res for $nsteps steps")

# script to parse OpenCL headers and generate Julia wrappers


#
# Parsing
#

using Clang
using Clang.Generators

using JuliaFormatter

function wrap(name, headers...; defines=[], include_dirs=[], dependents=true)
    @info "Wrapping $name"

    args = get_default_args()
    for define in defines
        if isa(define, Pair)
            append!(args, ["-D", "$(first(define))=$(last(define))"])
        else
            append!(args, ["-D", "$define"])
        end
    end
    for include_dir in include_dirs
        push!(args, "-isystem$include_dir")
    end

    options = load_options(joinpath(@__DIR__, "$(name).toml"))

    # create context
    ctx = create_context([headers...], args, options)

    # run generator
    build!(ctx, BUILDSTAGE_NO_PRINTING)

    # if requested, only wrap stuff from the list of headers
    # (i.e., not from included ones)
    if !dependents
        function rewrite!(dag::ExprDAG)
            replace!(get_nodes(dag)) do node
                path = normpath(Clang.get_filename(node.cursor))
                if !in(path, headers)
                    return ExprNode(node.id, Generators.Skip(), node.cursor, Expr[], node.adj)
                end
                return node
            end
        end
        rewrite!(ctx.dag)
    end

    rewriter!(ctx, options)

    build!(ctx, BUILDSTAGE_PRINTING_ONLY)

    output_file = options["general"]["output_file_path"]

    # prepend "autogenerated, do not edit!" comment
    output_data = read(output_file, String)
    open(output_file, "w") do io
        println(io, """# This file is automatically generated. Do not edit!
                       # To re-generate, execute res/wrap/wrap.jl""")
        println(io)
        print(io, output_data)
    end

    format_file(output_file, YASStyle())

    return
end

function rewriter!(ctx, options)
    for node in get_nodes(ctx.dag)
        if Generators.is_function(node) && !Generators.is_variadic_function(node)
            expr = node.exprs[1]
            call_expr = expr.args[2].args[1].args[3]    # assumes `@ccall`

            target_expr = call_expr.args[1].args[1]
            fn = String(target_expr.args[2].value)

            # replace `@ccall` with `@ext_ccall` when dealing with an extension function
            if basename(get_filename(node.cursor)) == "cl_ext.h"
                expr.args[2].args[1].args[1] = Symbol("@ext_ccall")
            end

            # rewrite pointer return types
            if haskey(options, "api") && haskey(options["api"], fn)
                rettype = get(options["api"][fn], "rettype", nothing)
                if rettype !== nothing
                    call_expr.args[2] = Meta.parse(rettype)
                end
            end

            # rewrite pointer argument types
            arg_exprs = call_expr.args[1].args[2:end]
            if haskey(options, "api") && haskey(options["api"], fn)
                argtypes = get(options["api"][fn], "argtypes", Dict())
                for (arg, typ) in argtypes
                    i = parse(Int, arg)
                    arg_exprs[i].args[2] = Meta.parse(typ)
                end
            end

            # insert `@checked` before each function with a `ccall` returning a checked type`
            rettyp = call_expr.args[2]
            checked_types = if haskey(options, "api")
                get(options["api"], "checked_rettypes", String[])
            else
                String[]
            end
            if rettyp isa Symbol && String(rettyp) in checked_types
                node.exprs[1] = Expr(:macrocall, Symbol("@checked"), nothing, expr)
            end
        end

        if node isa ExprNode{<:AbstractMacroNodeType}
            isempty(node.exprs) && continue
            expr = node.exprs[1]
            if Meta.isexpr(expr, :const)
                expr = expr.args[1]
            end
            if Meta.isexpr(expr, :(=))
                lhs, rhs = expr.args
                if rhs isa Expr && rhs.head == :call
                    name = string(rhs.args[1])
                    if name == "CL_MAKE_VERSION"
                        rhs.head = :macrocall
                        rhs.args[1] = Symbol("@", name)
                        insert!(rhs.args, 2, nothing)
                    end
                end
            end
        end
    end
end


#
# Main application
#

using OpenCL_Headers_jll

function main()
    headers = ["cl.h", "cl_gl.h", "cl_ext.h"]
    include_dir = joinpath(OpenCL_Headers_jll.artifact_dir, "include")
    paths = map(headers) do header
        joinpath(include_dir, "CL", header)
    end
    cd(@__DIR__) do
        wrap("opencl", paths...; include_dirs=[include_dir],
             defines=["CL_TARGET_OPENCL_VERSION" => "300"],)
    end
end

isinteractive() || main()

"""
Format string using dict-like variables, replacing all accurancies of
`%(key)` with `value`.

Example:
    s = "Hello, %(name)"
    format(s, name="Tom")  ==> "Hello, Tom"
"""
function format(s::String; vars...)
    for (k, v) in vars
        s = replace(s, "%($k)" => v)
    end
    s
end

function build_kernel(program::String, kernel_name::String; vars...)
    src = format(program; vars...)
    p = cl.Program(source=src)
    cl.build!(p)
    return cl.Kernel(p, kernel_name)
end

const CACHED_KERNELS = Dict{Any, cl.Kernel}()
function get_kernel(program_file::String, kernel_name::String; vars...)
    key = (cl.context(), program_file, kernel_name, Dict(vars))
    if in(key, keys(CACHED_KERNELS))
        return CACHED_KERNELS[key]
    else
        kernel = build_kernel(read(program_file, String), kernel_name; vars...)
        CACHED_KERNELS[key] = kernel
        return kernel
    end
end

function versioninfo(io::IO=stdout)
    println(io, "OpenCL.jl version $(pkgversion(@__MODULE__))")
    println(io)

    println(io, "Toolchain:")
    println(io, " - Julia v$(VERSION)")
    for jll in [cl.OpenCL_jll, SPIRV_LLVM_Backend_jll]
        name = string(jll)
        println(io, " - $(name[1:end-4]): $(pkgversion(jll))")
    end
    println(io)

    println(io, "Julia packages:")
    for name in [:GPUArrays, :GPUCompiler, :KernelAbstractions, :LLVM, :SPIRVIntrinsics]
        mod = getfield(OpenCL, name)
        println(io, "- $(name): $(pkgversion(mod))")
    end
    # Display pocl_jll / pocl_next_jll if present
    for (uuid, name) in [("627d6b7a-bbe6-5189-83e7-98cc0a5aeadd", "pocl_jll"),
                         ("59abdad9-3cfc-5436-8271-411e8cad6b82", "pocl_next_jll")]
        pocl_id = Base.PkgId(Base.UUID(uuid), name)
        pocl_mod = get(Base.loaded_modules, pocl_id, nothing)
        isnothing(pocl_mod) || println(io, "- $name: $(pkgversion(pocl_mod))")
    end
    println(io)

    env = filter(var->startswith(var, "JULIA_OPENCL"), keys(ENV))
    if !isempty(env)
        println(io, "Environment:")
        for var in env
            println(io, "- $var: $(ENV[var])")
        end
        println(io)
    end

    prefs = [
        "default_memory_backend" => load_preference(OpenCL, "default_memory_backend"),
    ]
    if any(x->!isnothing(x[2]), prefs)
        println(io, "Preferences:")
        for (key, val) in prefs
            if !isnothing(val)
                println(io, "- $key: $val")
            end
        end
        println(io)
    end

    println(io, "Available platforms: ", length(cl.platforms()))
    for platform in cl.platforms()
        println(io, " - $(platform.name)")
        print(io, "   OpenCL $(platform.opencl_version.major).$(platform.opencl_version.minor)")
        if !isempty(platform.version)
            print(io, ", $(platform.version)")
        end
        println(io)

        for device in cl.devices(platform)
            print(io, "   · $(device.name)")

            # show a list of tags
            tags = []
            ## memory back-ends
            let
                svm_tags = []
                svm_caps = cl.svm_capabilities(device)
                if svm_caps.coarse_grain_buffer
                    push!(svm_tags, "c")
                end
                if svm_caps.fine_grain_buffer
                    push!(svm_tags, "f")
                end
                push!(tags, "svm:"*join(svm_tags, "+"))
            end
            if cl.usm_supported(device)
                usm_tags = []
                usm_caps = cl.usm_capabilities(device)
                if usm_caps.host.access
                    push!(usm_tags, "h")
                end
                if usm_caps.device.access
                    push!(usm_tags, "d")
                end
                if usm_caps.shared.access
                    push!(usm_tags, "s")
                end
                push!(tags, "usm:"*join(usm_tags, "+"))
            end
            if cl.bda_supported(device)
                push!(tags, "bda")
            end
            ## relevant extensions
            if in("cl_khr_fp16", device.extensions)
                push!(tags, "fp16")
            end
            if in("cl_khr_fp64", device.extensions)
                push!(tags, "fp64")
            end
            if in("cl_khr_il_program", device.extensions)
                push!(tags, "il")
            end
            ## render
            if !isempty(tags)
                print(io, " (", join(tags, ", "), ")")
            end
            println(io)
        end
    end
end

# KernelAbstractions has a testsuite that isn't part of the main package.
# Include it directly.

const KATestSuite = let
    mod = @eval module $(gensym())
        using ..Test
        import KernelAbstractions
        kernelabstractions = pathof(KernelAbstractions)
        kernelabstractions_root = dirname(dirname(kernelabstractions))
        include(joinpath(kernelabstractions_root, "test", "testsuite.jl"))
    end
    mod.Testsuite
end

skip_tests=Set([
    "sparse",
    "Convert", # Need to opt out of i128
])
KATestSuite.testsuite(OpenCLBackend, "OpenCL", OpenCL, CLArray, CLDeviceArray; skip_tests)

using SPIRVIntrinsics: @builtin_ccall, @typed_ccall, LLVMPtr, known_intrinsics

# Define the types to test
integer_types = [Int32, UInt32, Int64, UInt64]
float_types = [Float32, Float64]
all_types = vcat(integer_types, float_types)

dev = OpenCL.cl.device()

# Arithmetic operations
function test_atomic_add(counter::AbstractArray{T}) where T
    OpenCL.@atomic counter[] += one(T)
    return
end
function test_atomic_sub(counter::AbstractArray{T}) where T
    OpenCL.@atomic counter[] -= one(T)
    return
end
# Bitwise operations
function test_atomic_and(counter::AbstractArray{T}) where T
    OpenCL.@atomic counter[] &= ~(one(T) << (get_global_id() - 1))
    return
end
function test_atomic_or(counter::AbstractArray{T}) where T
    OpenCL.@atomic counter[] |= one(T) << (get_global_id() - 1)
    return
end
function test_atomic_xor(counter::AbstractArray{T}) where T
    OpenCL.@atomic counter[] ⊻= one(T) << ((get_global_id() - 1) % 32)
    return
end
# Min/max operations - use low-level API directly
function test_atomic_max(counter::AbstractArray{T}) where T
    OpenCL.atomic_max!(pointer(counter), T(get_global_id()))
    return
end
function test_atomic_min(counter::AbstractArray{T}) where T
    OpenCL.atomic_min!(pointer(counter), T(get_global_id()))
    return
end
# Exchange operation - use low-level API directly
function test_atomic_xchg(counter::AbstractArray{T}) where T
    OpenCL.atomic_xchg!(pointer(counter), one(T))
    return
end
# Compare-and-swap operation - use low-level API directly
function test_atomic_cas(counter::AbstractArray{T}) where T
    OpenCL.atomic_cmpxchg!(pointer(counter), zero(T), one(T))
    return
end

# Define atomic operations to test
atomic_operations = [
    # op, init_val, expected_val
    (test_atomic_add, 0, 1000),
    (test_atomic_sub, 1000, 0),
    (test_atomic_and, typemax(UInt64), 0),
    (test_atomic_or, 0, typemax(UInt64)),
    (test_atomic_xor, 0, typemax(UInt32) << 8),
    (test_atomic_max, 0, 1000),
    (test_atomic_min, 1000, 1),
    (test_atomic_xchg, 0, 1),
    (test_atomic_cas, 0, 1),
]
@testset "atomics" begin
@testset "$kernel_func - $T" for (kernel_func, init_val, expected_val) in atomic_operations, T in all_types
    # Skip Int64/UInt64 if not supported
    if sizeof(T) == 8 && T <: Integer && !("cl_khr_int64_extended_atomics" in dev.extensions)
        continue
    end

    # Skip Float64 if not supported
    if T == Float64 && !("cl_khr_fp64" in dev.extensions)
        continue
    end

    # Bitwise operations (only valid for integers)
    if kernel_func in [test_atomic_and, test_atomic_or, test_atomic_xor] && T <: AbstractFloat
        continue
    end

    # Min/max operations (only supported for 32-bit integers in OpenCL)
    if kernel_func in [test_atomic_min, test_atomic_max] && !(T in [Int32, UInt32])
        continue
    end

    if T <: Integer
        init_val %= T
        expected_val %= T
    end

    a = OpenCL.fill(T(init_val))
    @opencl global_size=1000 kernel_func(a)
    result_val = OpenCL.@allowscalar a[]
    @test result_val === T(expected_val)
end


@testset "atomic_add! ($T)" for T in [Float32, Float64]
    # Float64 requires cl_khr_fp64 extension
    if T == Float64 && !("cl_khr_fp64" in cl.device().extensions)
        continue
    end
if "cl_ext_float_atomics" in cl.device().extensions
    @eval function atomic_float_add(counter, val::$T)
        @builtin_ccall(
            "atomic_add", $T,
            (LLVMPtr{$T, AS.CrossWorkgroup}, $T),
            pointer(counter), val,
        )
        return
    end

    @testset "SPV_EXT_shader_atomic_float_add extension" begin
        a = OpenCL.zeros(T)
        @opencl global_size = 1000 extensions = ["SPV_EXT_shader_atomic_float_add"] atomic_float_add(a, one(T))
        @test OpenCL.@allowscalar a[] == T(1000.0)

        spv = sprint() do io
            OpenCL.code_native(io, atomic_float_add, Tuple{CLDeviceArray{T, 0, 1}, T}; extensions = ["SPV_EXT_shader_atomic_float_add"])
        end
        @test occursin("OpExtension \"SPV_EXT_shader_atomic_float_add\"", spv)
        @test occursin("OpAtomicFAddEXT", spv)
    end
end

end
end

# OpenCL.Context

mutable struct Context <: CLObject
    const id::cl_context

    # If created from ctx_id already, we need to increase the reference count
    # because then we give out multiple context references with multiple finalizers to the world
    # TODO should we make it in a way, that you can't overwrite it?
    function Context(ctx_id::cl_context; retain::Bool=false)
        ctx = new(ctx_id)
        retain && clRetainContext(ctx)
        finalizer(clReleaseContext, ctx)
        return ctx
    end
end

Base.unsafe_convert(::Type{cl_context}, ctx::Context) = ctx.id

function Base.show(io::IO, ctx::Context)
    dev_strs = [replace(d.name, r"\s+" => " ") for d in ctx.devices]
    devs_str = join(dev_strs, ",")
    ptr_val = convert(UInt, pointer(ctx))
    ptr_address = "0x$(string(ptr_val, base = 16, pad = Sys.WORD_SIZE>>2))"
    print(io, "OpenCL.Context(@$ptr_address on $devs_str)")
end

struct _CtxErr
    handle::Ptr{Nothing}
    err_info::Ptr{Cchar}
    priv_info::Ptr{Nothing}
    cb::Csize_t
end

const io_lock = ReentrantLock()
function log_error(message...)
    @async begin
        lock(stderr)
        lock(io_lock)
        print(stderr, string(message..., "\n"))
        unlock(io_lock)
        unlock(stderr)
    end
end

function ctx_notify_err(
        err_info::Ptr{Cchar}, priv_info::Ptr{Nothing},
        cb::Csize_t, func::Ptr{Nothing}
    )
    ccall(func, Nothing, (Ptr{Cchar}, Ptr{Nothing}, Csize_t), err_info, priv_info, cb)
    return
end


ctx_callback_ptr() = @cfunction(ctx_notify_err, Nothing,
                                (Ptr{Cchar}, Ptr{Nothing}, Csize_t, Ptr{Nothing}))

function raise_context_error(err_info, private_info, cb)
    log_error("OpenCL Error: | ", unsafe_string(err_info), " |")
    return
end

function Context(devs::Vector{Device};
                 properties=nothing,
                 callback::Union{Function, Nothing} = nothing)
    if isempty(devs)
        ArgumentError("No devices specified for context")
    end
    if properties !== nothing
        ctx_properties = encode_properties(properties)
    else
        ctx_properties = C_NULL
    end

    n_devices = length(devs)
    device_ids = Vector{cl_device_id}(undef, n_devices)
    for (i, d) in enumerate(devs)
        device_ids[i] = d.id
    end

    err_code = Ref{Cint}()
    payload = callback === nothing ? raise_context_error : callback
    f_ptr = @cfunction($payload, Nothing, (Ptr{Cchar}, Ptr{Nothing}, Csize_t))
    ctx_id = clCreateContext(
        ctx_properties, n_devices, device_ids,
        ctx_callback_ptr(), f_ptr, err_code)
    if err_code[] != CL_SUCCESS
        throw(CLError(err_code[]))
    end
    return Context(ctx_id)
end


Context(d::Device; properties=nothing, callback=nothing) =
    Context([d], properties=properties, callback=callback)

function Context(dev_type; properties = nothing, callback = nothing)
    if properties !== nothing
        ctx_properties = encode_properties(properties)
    else
        ctx_properties = C_NULL
    end
    if callback !== nothing
        ctx_user_data_cb = callback
    else
        ctx_user_data_cb = raise_context_error
    end
    err_code = Ref{Cint}()
    ctx_user_data = @cfunction($ctx_user_data_cb, Nothing, (Ptr{Cchar}, Ptr{Nothing}, Csize_t))
    ctx_id = clCreateContextFromType(ctx_properties, dev_type,
                                         ctx_callback_ptr(), ctx_user_data, err_code)
    if err_code[] != CL_SUCCESS
        throw(CLError(err_code[]))
    end
    return Context(ctx_id)
end

function Context(dev_type::Symbol;
                 properties=nothing, callback=nothing)
    Context(cl_device_type(dev_type),
            properties=properties, callback=callback)
end

function Base.getproperty(ctx::Context, s::Symbol)
    if s == :num_devices
        ndevices = Ref{Cuint}()
        clGetContextInfo(ctx, CL_CONTEXT_NUM_DEVICES, sizeof(Cuint), ndevices, C_NULL)
        return Int(ndevices[])
    elseif s == :devices
        n = ctx.num_devices
        if n == 0
            return Device[]
        end
        dev_ids = Vector{cl_device_id}(undef, n)
        clGetContextInfo(ctx, CL_CONTEXT_DEVICES, sizeof(dev_ids), dev_ids, C_NULL)
        return [Device(id) for id in dev_ids]
    elseif s == :properties
        nbytes = Ref{Csize_t}(0)
        clGetContextInfo(ctx, CL_CONTEXT_PROPERTIES, 0, C_NULL, nbytes)

        # Calculate length of storage array
        # At nbytes[] the size of the properties array in bytes is stored
        # The length of the property array is then nbytes[] / sizeof(cl_context_properties)
        # Note: nprops should be odd since it requires a C_NULL terminated array
        nprops = div(nbytes[], sizeof(cl_context_properties))

        props = Vector{cl_context_properties}(undef, nprops)
        clGetContextInfo(ctx, CL_CONTEXT_PROPERTIES, nbytes[], props, C_NULL)
        #properties array of [key,value..., C_NULL]
        result = Any[]
        for i in 1:2:nprops
            key = props[i]
            value = i < nprops ? props[i+1] : nothing

            if key == CL_CONTEXT_PLATFORM
                push!(result, (key, Platform(cl_platform_id(value))))
            elseif key == CL_GL_CONTEXT_KHR ||
               key == CL_EGL_DISPLAY_KHR ||
               key == CL_GLX_DISPLAY_KHR ||
               key == CL_WGL_HDC_KHR ||
               key == CL_CGL_SHAREGROUP_KHR
                push!(result, (key, value))
            elseif key == 0
                if i != nprops
                    @warn("Encountered OpenCL.Context property key == 0 at position $i")
                end
                break
            else
                @warn("Unknown OpenCL.Context property key encountered $key")
            end
        end
        return result
    elseif s == :reference_count
        refcount = Ref{Cuint}()
        clGetContextInfo(ctx, CL_CONTEXT_REFERENCE_COUNT, sizeof(Cuint), refcount, C_NULL)
        return Int(refcount[])
    else
        return getfield(ctx, s)
    end
end

function encode_properties(props)
    isempty(props) && return C_NULL

    cl_props = cl_context_properties[]
    for prop_tuple in props
        if length(prop_tuple) != 2
            throw(ArgumentError("Context property tuples must be of type (key, value)"))
        end
        prop, val = prop_tuple
        push!(cl_props, cl_context_properties(prop))
        if prop == CL_CONTEXT_PLATFORM
            isa(val, Platform) && (val = val.id)
            push!(cl_props, cl_context_properties(val))
        elseif prop == CL_WGL_HDC_KHR
            push!(cl_props, cl_context_properties(val))
        elseif Sys.isapple() && prop == CL_CONTEXT_PROPERTY_USE_CGL_SHAREGROUP_APPLE
            push!(cl_props, cl_context_properties(val))
        elseif prop == CL_GL_CONTEXT_KHR ||
            prop == CL_EGL_DISPLAY_KHR ||
            prop == CL_GLX_DISPLAY_KHR ||
            prop == CL_CGL_SHAREGROUP_KHR
            push!(cl_props, cl_context_properties(val))
        else
            throw(OpenCLException("Invalid OpenCL context property '$prop'"))
        end
    end

    # terminate with NULL
    push!(cl_props, cl_context_properties(C_NULL))

    return cl_props
end

test_source = "
__kernel void sum(__global const float *a,
                  __global const float *b,
                  __global float *c,
                  const unsigned int count)
{
  unsigned int gid = get_global_id(0);
  if (gid < count) {
      c[gid] = a[gid] + b[gid];
  }
}
"

#TODO: tests for invalid kernel build error && logs...

@testset "constructor" begin
    prg = cl.Program(source=test_source)
    @test_throws ArgumentError cl.Kernel(prg, "sum")
    cl.build!(prg)
    @test cl.Kernel(prg, "sum") != nothing
end

@testset "info" begin
    prg = cl.Program(source=test_source)
    cl.build!(prg)
    k = cl.Kernel(prg, "sum")
    @test k.function_name == "sum"
    @test k.num_args == 4
    @test k.reference_count > 0
    @test k.program == prg
    @test typeof(k.attributes) == String
end

@testset "mem/workgroup size" begin
    prg = cl.Program(source=test_source)
    cl.build!(prg)
    k = cl.Kernel(prg, "sum")
    wginfo = cl.work_group_info(k, cl.device())
    for sf in [:size, :compile_size, :local_mem_size, :private_mem_size, :prefered_size_multiple]
        @test getproperty(wginfo, sf) != nothing
    end
end

@testset "set_arg!/set_args!" begin
    prg = cl.Program(source=test_source) |> cl.build!
    k = cl.Kernel(prg, "sum")

    count  = 1024
    nbytes = count * sizeof(Float32)

    h_ones = ones(Float32, count)

    A = CLArray(h_ones)
    B = CLArray(h_ones)
    C = CLArray{Float32}(undef, count)

    # we use julia's index by one convention
    cl.set_arg!(k, 1, A.data[].mem)
    cl.set_arg!(k, 2, B.data[].mem)
    cl.set_arg!(k, 3, C.data[].mem)
    cl.set_arg!(k, 4, UInt32(count))

    cl.enqueue_kernel(k, count) |> wait
    r = Array(C)

    @test all(x -> x == 2.0, r)
    cl.flush(cl.queue())

    # test set_args with new kernel
    k2 = cl.Kernel(prg, "sum")
    cl.set_args!(k2, A.data[].mem, B.data[].mem, C.data[].mem, UInt32(count))

    h_twos = fill(2f0, count)
    copyto!(A, h_twos)
    copyto!(B, h_twos)

    #TODO: check for ocl version, fill is opencl v1.2
    #cl.enqueue_fill(A, 2f0)
    #cl.enqueue_fill(B, 2f0)

    cl.enqueue_kernel(k, count)

    @test all(x -> x == 4.0, Array(C))
end

@testset "clcall" begin
    simple_kernel = "
        __kernel void test(__global float *i) {
            *i += 1;
        };"

    h_buff = Float32[1,]
    d_arr = CLArray(h_buff)

    p = cl.Program(source=simple_kernel) |> cl.build!
    k = cl.Kernel(p, "test")

    # dimensions must be the same size
    @test_throws ArgumentError clcall(k, Tuple{CLPtr{Float32}}, d_arr;
                                      global_size=(1,), local_size=(1,1))
    @test_throws ArgumentError clcall(k, Tuple{CLPtr{Float32}}, d_arr;
                                      global_size=(1,1), local_size=(1,))

    # dimensions are bounded
    max_work_dim = cl.device().max_work_item_dims
    bad = tuple([1 for _ in 1:(max_work_dim + 1)])

    # calls are asynchronous, but cl.read blocks
    clcall(k, Tuple{CLPtr{Float32}}, d_arr)
    @test Array(d_arr) == [2f0]

    # enqueue task is an alias for calling
    # a kernel with a global/local size of 1
    evt = cl.enqueue_task(k)
    @test Array(d_arr) == [3f0]
end

@testset "packed structures" begin
    test_source = "
    struct __attribute__((packed)) Test2{
        long f1;
        int __attribute__((aligned (8))) f2;
    };
    __kernel void structest(__global float *out, struct Test2 b){
        out[0] = b.f1;
        out[1] = b.f2;
    }
    "
    prg = cl.Program(source = test_source)
    cl.build!(prg)
    structkernel = cl.Kernel(prg, "structest")
    out = CLArray{Float32}(undef, 2)
    bstruct = (1, Int32(4))
    clcall(structkernel, Tuple{CLPtr{Float32}, Tuple{Int64, Cint}}, out, bstruct)
    @test Array(out) == [1f0, 4f0]
end

@testset "vector arguments" begin
    test_source = "
    __kernel void vec3_unpack(__global float *out, float3 a, float3 b) {
        out[0] = a.x;
        out[1] = a.y;
        out[2] = a.z;
        out[3] = b.x;
        out[4] = b.y;
        out[5] = b.z;
    }
    "
    prg = cl.Program(source = test_source)
    cl.build!(prg)
    vec3kernel = cl.Kernel(prg, "vec3_unpack")
    out = CLArray{Float32}(undef, 6)
    # NOTE: the user is responsible for padding the vector to 4 elements
    #       (only on some platforms)
    vec3_a = (1f0, 2f0, 3f0, 0f0)
    vec3_b = (4f0, 5f0, 6f0, 0f0)
    clcall(
        vec3kernel, Tuple{CLPtr{Float32}, NTuple{4, Float32}, NTuple{4, Float32}},
                       out, vec3_a, vec3_b)
    @test Array(out) == [1f0, 2f0, 3f0, 4f0, 5f0, 6f0]
end

## gpucompiler interface

Base.@kwdef struct OpenCLCompilerParams <: AbstractCompilerParams
    # request a fixed sub-group width via `intel_reqd_sub_group_size`
    sub_group_size::Union{Nothing,Int} = nothing
    # optional features the target device supports, exposed to kernels via `has_feature`
    features::FeatureSet = zero(FeatureSet)
    # requested backend policy; kept here so the cache keys on it (the backends share a context)
    program_backend::Symbol = :auto
end

const OpenCLCompilerConfig = CompilerConfig{SPIRVCompilerTarget, OpenCLCompilerParams}
const OpenCLCompilerJob = CompilerJob{SPIRVCompilerTarget,OpenCLCompilerParams}

GPUCompiler.runtime_module(::CompilerJob{<:Any,OpenCLCompilerParams}) = OpenCL

GPUCompiler.method_table_view(job::OpenCLCompilerJob) =
    GPUCompiler.StackedMethodTable(job.world, method_table, SPIRVIntrinsics.method_table)

# filter out OpenCL built-ins
# TODO: eagerly lower these using the translator API
GPUCompiler.isintrinsic(job::OpenCLCompilerJob, fn::String) =
    invoke(GPUCompiler.isintrinsic,
           Tuple{CompilerJob{SPIRVCompilerTarget}, typeof(fn)},
           job, fn) ||
    in(fn, known_intrinsics) ||
    let SPIRVIntrinsicsSIMDExt = Base.get_extension(SPIRVIntrinsics, :SPIRVIntrinsicsSIMDExt)
        SPIRVIntrinsicsSIMDExt !== nothing && in(fn, SPIRVIntrinsicsSIMDExt.known_intrinsics)
    end ||
    contains(fn, "__spirv_")

GPUCompiler.kernel_state_type(::OpenCLCompilerJob) = KernelState

function GPUCompiler.finish_module!(@nospecialize(job::OpenCLCompilerJob),
                                    mod::LLVM.Module, entry::LLVM.Function)
    entry = invoke(GPUCompiler.finish_module!,
                   Tuple{CompilerJob{SPIRVCompilerTarget}, LLVM.Module, LLVM.Function},
                   job, mod, entry)

    sg_size = job.config.params.sub_group_size
    if sg_size !== nothing
        metadata(entry)["intel_reqd_sub_group_size"] = MDNode([ConstantInt(Int32(sg_size))])
    end

    # materialize the feature bitset for `has_feature`, if the kernel referenced it. A constant
    # initializer plus private linkage lets the optimizer fold the loads and drop the global, so it
    # never reaches SPIR-V.
    if haskey(globals(mod), "__opencl_feature_bitset")
        gv = globals(mod)["__opencl_feature_bitset"]
        initializer!(gv, ConstantInt(LLVM.Int64Type(), job.config.params.features))
        linkage!(gv, LLVM.API.LLVMPrivateLinkage)
        constant!(gv, true)
    end

    # if this kernel uses our RNG, we should prime the shared state.
    # XXX: these transformations should really happen at the Julia IR level...
    if haskey(functions(mod), "julia.opencl.random_keys") && job.config.kernel
        # insert call to `initialize_rng_state`
        f = initialize_rng_state
        ft = typeof(f)
        tt = Tuple{}

        # create a deferred compilation job for `initialize_rng_state`
        src = methodinstance(ft, tt, GPUCompiler.tls_world_age())
        cfg = CompilerConfig(job.config; kernel=false, name=nothing)
        job = CompilerJob(src, cfg, job.world)
        id = length(GPUCompiler.deferred_codegen_jobs) + 1
        GPUCompiler.deferred_codegen_jobs[id] = job

        # generate IR for calls to `deferred_codegen` and the resulting function pointer
        top_bb = first(blocks(entry))
        bb = BasicBlock(top_bb, "initialize_rng")
        @dispose builder=IRBuilder() begin
            position!(builder, bb)
            subprogram = LLVM.subprogram(entry)
            if subprogram !== nothing
                loc = DILocation(0, 0, subprogram)
                debuglocation!(builder, loc)
            end
            debuglocation!(builder, first(instructions(top_bb)))

            # call the `deferred_codegen` marker function
            T_ptr = if LLVM.version() >= v"17"
                LLVM.PointerType()
            elseif VERSION >= v"1.12.0-DEV.225"
                LLVM.PointerType(LLVM.Int8Type())
            else
                LLVM.Int64Type()
            end
            T_id = convert(LLVMType, Int)
            deferred_codegen_ft = LLVM.FunctionType(T_ptr, [T_id])
            deferred_codegen = if haskey(functions(mod), "deferred_codegen")
                functions(mod)["deferred_codegen"]
            else
                LLVM.Function(mod, "deferred_codegen", deferred_codegen_ft)
            end
            fptr = call!(builder, deferred_codegen_ft, deferred_codegen, [ConstantInt(id)])

            # call the `initialize_rng_state` function
            rt = Core.Compiler.return_type(f, tt)
            llvm_rt = convert(LLVMType, rt)
            llvm_ft = LLVM.FunctionType(llvm_rt)
            fptr = inttoptr!(builder, fptr, LLVM.PointerType(llvm_ft))
            call!(builder, llvm_ft, fptr)
            br!(builder, top_bb)

            # note the use of the device-side RNG in this kernel
            push!(function_attributes(entry), StringAttribute("julia.opencl.rng", ""))
        end

        # XXX: put some of the above behind GPUCompiler abstractions
        #      (e.g., a compile-time version of `deferred_codegen`)
    end
    return entry
end

function GPUCompiler.finish_linked_module!(@nospecialize(job::OpenCLCompilerJob), mod::LLVM.Module)
    for f in GPUCompiler.kernels(mod)
        kernel_intrinsics = Dict(
            "julia.opencl.random_keys" => (; name = "random_keys", typ = LLVMPtr{UInt32, AS.Workgroup}),
            "julia.opencl.random_counters" => (; name = "random_counters", typ = LLVMPtr{UInt32, AS.Workgroup}),
        )
        GPUCompiler.add_input_arguments!(job, mod, f, kernel_intrinsics)
    end
    return
end

## compiler implementation (cache, configure, compile, and link)

# cache of compilation caches, per context
const _compiler_caches = Dict{cl.Context, Dict{Any, Any}}()
function compiler_cache(ctx::cl.Context)
    cache = get(_compiler_caches, ctx, nothing)
    if cache === nothing
        cache = Dict{Any, Any}()
        _compiler_caches[ctx] = cache
    end
    return cache
end

# cache of compiler configurations, per device (but additionally configurable via kwargs)
const _toolchain = Ref{Any}()
const _compiler_configs = Dict{UInt, OpenCLCompilerConfig}()
function compiler_config(dev::cl.Device; kwargs...)
    # key on the policy, not the resolved backend: resolving queries the device, so defer it to link
    backend = program_backend()
    h = hash(dev, hash(backend, hash(kwargs)))
    config = get(_compiler_configs, h, nothing)
    if config === nothing
        config = _compiler_config(dev, backend; kwargs...)
        _compiler_configs[h] = config
    end
    return config
end
@inline _sub_group_size(dev) = "cl_intel_required_subgroup_size" in dev.extensions ? cl.sub_group_size(dev) : nothing

const SPIRV_VERSION = v"1.4"

@noinline function _compiler_config(dev, backend; kernel=true, name=nothing, always_inline=false,
                                     sub_group_size::Union{Nothing,Int}=_sub_group_size(dev), kwargs...)
    supports_fp16 = "cl_khr_fp16" in dev.extensions
    supports_fp64 = "cl_khr_fp64" in dev.extensions

    if sub_group_size !== nothing && !("cl_intel_required_subgroup_size" in dev.extensions)
        error("Device does not support cl_intel_required_subgroup_size")
    end

    # create GPUCompiler objects
    target = SPIRVCompilerTarget(; version=SPIRV_VERSION, supports_fp16, supports_fp64,
                                   validate=true, kwargs...)
    params = OpenCLCompilerParams(; sub_group_size, features=device_features(dev),
                                    program_backend=backend)
    CompilerConfig(target, params; kernel, name, always_inline)
end

# compile to executable machine code
const compilations = Threads.Atomic{Int}(0)
function compile(@nospecialize(job::CompilerJob))
    compilations[] += 1

    # TODO: this creates a context; cache those.
    obj, meta = JuliaContext() do ctx
        obj, meta = GPUCompiler.compile(:obj, job)

        entry = LLVM.name(meta.entry)
        device_rng = StringAttribute("julia.opencl.rng", "") in collect(function_attributes(meta.entry))

        (; obj, entry, device_rng)
    end
end

function run_and_collect(cmd)
    stdout = Pipe()
    proc = run(pipeline(ignorestatus(cmd); stdout, stderr=stdout), wait=false)
    close(stdout.in)

    reader = Threads.@spawn String(read(stdout))
    Base.wait(proc)
    log = strip(fetch(reader))

    return proc, log
end

# How kernels are fed to the driver:
# - `:auto`   — SPIR-V (clCreateProgramWithIL) when the device supports IL programs, otherwise
#               OpenCL C source translated from the SPIR-V via spirv2clc.
# - `:spirv`  — always SPIR-V IL; error if the device doesn't support it.
# - `:opencl` — always OpenCL C source. Useful to exercise pocl's source path on a device that
#               also supports IL.
# Task-local, like `cl.device`/`cl.queue`; `resolve_program_backend` maps it to a concrete backend.

"""
    program_backend() -> Symbol

The requested program backend for the current task (`:auto`, `:spirv`, or `:opencl`).
"""
program_backend() = get(task_local_storage(), :CLProgramBackend, :auto)::Symbol

"""
    program_backend!(mode::Symbol)
    program_backend!(f::Function, mode::Symbol)

Select how kernels are fed to the driver for the current task: `:auto` (default), `:spirv` (SPIR-V
IL), or `:opencl` (OpenCL C source). The second form applies `mode` only for the duration of `f`.
"""
function program_backend!(mode::Symbol)
    mode in (:auto, :spirv, :opencl) ||
        throw(ArgumentError("invalid program backend $mode (expected :auto, :spirv or :opencl)"))
    task_local_storage(:CLProgramBackend, mode)
    return mode
end

function program_backend!(f::Base.Callable, mode::Symbol)
    old = program_backend()
    program_backend!(mode)
    try
        f()
    finally
        program_backend!(old)
    end
end

# Map the policy to a concrete backend for `dev`. Done in `link`, off the per-launch path.
function resolve_program_backend(dev::cl.Device, mode::Symbol = program_backend())
    mode === :opencl && return :opencl
    mode in (:auto, :spirv) ||
        throw(ArgumentError("invalid program backend $mode (expected :auto, :spirv or :opencl)"))
    if "cl_khr_il_program" in dev.extensions
        return :spirv
    elseif mode === :spirv
        error("Device '$(dev.name)' does not support SPIR-V IL programs")
    else  # :auto
        @warn "Device '$(dev.name)' lacks IL support; using OpenCL C translation." maxlog=1 _id=Symbol(dev.name)
        return :opencl
    end
end

# Dump compilation artifacts (`extension => data` pairs sharing one random base name, e.g.
# `dump_artifacts(".spv" => spv, ".cl" => src)`) to a directory for later inspection. The
# directory is `JULIA_OPENCL_DUMP_DIR` if set, else `$RUNNER_TEMP/opencl-compilation-dumps` on
# GitHub Actions, else `tempdir()`. On CI the files are surfaced as downloadable artifacts
# (`buildkite-agent artifact upload`, or a GitHub Actions `::notice`). Returns the written paths.
function dump_artifacts(artifacts::Pair{String}...)
    on_github = get(ENV, "GITHUB_ACTIONS", "false") == "true"
    dir = if haskey(ENV, "JULIA_OPENCL_DUMP_DIR")
        mkpath(ENV["JULIA_OPENCL_DUMP_DIR"])
    elseif on_github
        mkpath(joinpath(get(ENV, "RUNNER_TEMP", tempdir()), "opencl-compilation-dumps"))
    else
        tempdir()
    end
    stem = tempname(dir; cleanup=false)

    paths = String[]
    for (ext, data) in artifacts
        path = stem * ext
        write(path, data)
        push!(paths, path)
    end

    if parse(Bool, get(ENV, "BUILDKITE", "false"))
        for path in paths
            run(`buildkite-agent artifact upload $path`)
        end
    elseif on_github
        println("::notice title=OpenCL compilation dump::wrote $(join(basename.(paths), ", ")) to $dir")
    end

    return paths
end

# link into an executable kernel
function link(@nospecialize(job::CompilerJob), compiled)
    spirv_bitcode = compiled.obj
    clc_source = nothing
    build_options = ""

    dev = cl.device()
    backend = resolve_program_backend(dev, job.config.params.program_backend)

    prog = if backend === :spirv
        cl.Program(; il=spirv_bitcode)
    else
        # Target the device's highest OpenCL C version
        clc_version = max_opencl_c_version(dev)
        cl_std = "CL$(clc_version.major).$(clc_version.minor)"

        # Be consistent with the SPIR-V version we generated code for
        spv = job.config.target.version
        spirv_version = "$(spv.major).$(spv.minor)"

        spirv_path = tempname(cleanup=false) * ".spv"
        write(spirv_path, spirv_bitcode)
        proc, log = run_and_collect(`$(spirv2clc_jll.spirv2clc()) --spirv-version=$spirv_version --cl-std=$cl_std $spirv_path`)
        rm(spirv_path)
        if !success(proc)
            spv_file, = dump_artifacts(".spv" => spirv_bitcode)
            error("Failed to translate SPIR-V to OpenCL C source code:\n$(log)\n" *
                  "If you think this is a bug, please file an issue and attach $spv_file")
        end

        clc_source = strip(log)
        build_options = "-cl-std=$cl_std"
        cl.Program(; source=clc_source)
    end

    # optionally dump the artifacts of every kernel (e.g. to debug a runtime miscompile)
    if haskey(ENV, "JULIA_OPENCL_DUMP_DIR")
        clc_source === nothing ? dump_artifacts(".spv" => spirv_bitcode) :
                                 dump_artifacts(".spv" => spirv_bitcode, ".cl" => clc_source)
    end

    try
        cl.build!(prog; options=build_options)
    catch e
        files = clc_source === nothing ?
            dump_artifacts(".spv" => spirv_bitcode) :
            dump_artifacts(".spv" => spirv_bitcode, ".cl" => clc_source)

        # `build!` already renders the source and build log; keep that and point at the artifacts
        msg = sprint(showerror, e)
        msg *= "\nIf you think this is a bug, please file an issue and attach $(join(files, " and "))"
        error(msg)
    end
    (; kernel=cl.Kernel(prog, compiled.entry), compiled.device_rng)
end

using ParallelTestRunner
using Preferences
import OpenCL
import Test

## custom arguments
args = parse_args(ARGS; custom=["platform"])

# `--platform` selects which OpenCL platform to run on, substring-matched against the
# platform name/vendor (e.g. `pocl`, `cuda`, `intel`). The special value `pocl_next`
# loads `pocl_next_jll` — a build of the upcoming PoCL release — instead of the released
# `pocl_jll`, then filters identically to `--platform=pocl` (both register a platform
# with the same name/vendor, differing only in version). We import exactly one PoCL JLL,
# so only a single PoCL platform shows up.
const platform_request = args.custom["platform"] === nothing ? nothing :
                         args.custom["platform"].value
const pocl_pkg = platform_request == "pocl_next" ? :pocl_next_jll : :pocl_jll
const platform_arg = platform_request == "pocl_next" ? Some("pocl") :
                     args.custom["platform"]
@eval import $pocl_pkg

@info "System information:\n" * sprint(io->OpenCL.versioninfo(io))

platform_filter = platform_arg
platform_selected(p) = platform_filter === nothing ||
    any(contains(platform_filter.value), lowercase.([p.name, p.vendor]))

ispocl(p) = occursin("portable", lowercase(p.name))

# short, stable label for a platform, used to prefix its tests
function target_label(p)
    str = lowercase(p.name * " " * p.vendor)
    ispocl(p)                ? "pocl"    :
    occursin("nvidia", str)  ? "nvidia"  :
    occursin("intel", str)   ? "intel"   :
    occursin("rusticl", str) ? "rusticl" :
    occursin("amd", str)     ? "amd"     :
    lowercase(first(split(p.vendor)))
end

# per-device label suffix, only when a platform exposes more than one device: "/gpu", "/cpu", plus
# an index when several share a type ("/gpu1", "/gpu2").
function device_suffixes(devices)
    length(devices) <= 1 && return fill("", length(devices))
    types = [string(d.device_type) for d in devices]
    map(enumerate(types)) do (i, t)
        same = findall(==(t), types)
        length(same) > 1 ? "/$t$(findfirst(==(i), same))" : "/$t"
    end
end

# Test targets: each selected device, run through its preferred backend (`:auto`). pocl devices also
# get a `…c` target forcing the OpenCL C source path, where `:auto` would pick SPIR-V IL.
const targets = let ts = []
    for p in OpenCL.cl.platforms()
        platform_selected(p) || continue
        base = target_label(p)
        for (i, suffix) in enumerate(device_suffixes(OpenCL.cl.devices(p)))
            push!(ts, (; label = base * suffix, platform = p.name, index = i, backend = :auto))
            ispocl(p) && push!(ts, (; label = base * "c" * suffix, platform = p.name, index = i, backend = :opencl))
        end
    end
    isempty(ts) && error("No OpenCL platforms found" *
                         (platform_filter === nothing ? "" : " matching '$(platform_filter.value)'"))
    ts
end

# determine tests to run
const testsuite = find_tests(@__DIR__)
## GPUArrays test suite: not part of the main package
const GPUArraysTestSuite = let
    mod = @eval module $(gensym())
        using ..Test
        import GPUArrays
        gpuarrays = pathof(GPUArrays)
        gpuarrays_root = dirname(dirname(gpuarrays))
        include(joinpath(gpuarrays_root, "test", "testsuite.jl"))
    end
    mod.TestSuite
end
for name in keys(GPUArraysTestSuite.tests)
    test = "gpuarrays/$name"
    testsuite[test] = :(GPUArraysTestSuite.tests[$name](CLArray))
end
# wrap a test body on a specific device of the named platform, with a fixed backend
function generate_test(expr, platform_name, device_index, backend)
    return quote
        platform = first(p for p in cl.platforms() if p.name == $platform_name)
        device = cl.devices(platform)[$device_index]
        @testset "$(device.name)" begin
            cl.platform!(platform)
            cl.device!(device)
            OpenCL.program_backend!($(QuoteNode(backend)))
            $(expr)
        end
    end
end

# Duplicate every test per target, prefixing the name so failures and `--` filters name the GPU
# backend (e.g. `pocl/`, `poclc/`, `nvidia/`, or `nvidia/gpu1/` when a platform has several devices).
for name in collect(keys(testsuite))
    body = testsuite[name]
    delete!(testsuite, name)
    for t in targets
        testsuite["$(t.label)/$name"] = generate_test(body, t.platform, t.index, t.backend)
    end
end

## filter
filter_tests!(testsuite, args)

# "indexing scalar" asserts scalar indexing throws when disallowed, which only
# holds for device-only memory; host-accessible memory (SVM, host/shared USM)
# serves it directly. Drop it for targets whose device uses such memory.
if args.list === nothing
    host_accessible = (OpenCL.cl.UnifiedHostMemory, OpenCL.cl.UnifiedSharedMemory,
                       OpenCL.cl.SharedVirtualMemory)
    for t in targets
        plat = first(p for p in OpenCL.cl.platforms() if p.name == t.platform)
        dev = OpenCL.cl.devices(plat)[t.index]
        OpenCL.cl.platform!(plat)
        OpenCL.cl.device!(dev)
        if OpenCL.memory_type() in host_accessible
            delete!(testsuite, "$(t.label)/gpuarrays/indexing scalar")
        end
    end
end

const init_worker_code = quote
    using OpenCL, $pocl_pkg

    OpenCL.allowscalar(false)

    # GPUArrays has a testsuite that isn't part of the main package.
    # Include it directly.
    const GPUArraysTestSuite = let
        mod = @eval module $(gensym())
            using Test
            import GPUArrays
            gpuarrays = pathof(GPUArrays)
            gpuarrays_root = dirname(dirname(gpuarrays))
            include(joinpath(gpuarrays_root, "test", "testsuite.jl"))
        end
        mod.TestSuite
    end

    const device_eltypes = Dict()
    function GPUArraysTestSuite.supported_eltypes(::Type{<:CLArray})
        get!(device_eltypes, cl.device()) do
            types = [Int16, Int32, Int64,
                    Complex{Int16}, Complex{Int32}, Complex{Int64},
                    Float32, ComplexF32]
            if "cl_khr_fp64" in cl.device().extensions
                push!(types, Float64)
                push!(types, ComplexF64)
            end
            if "cl_khr_fp16" in cl.device().extensions
                push!(types, Float16)
                push!(types, ComplexF16)
            end
            return types
        end
    end

    testf(f, xs...; kwargs...) = GPUArraysTestSuite.compare(f, CLArray, xs...; kwargs...)

    ## auxiliary stuff

    # Run some code on-device
    macro on_device(ex...)
        code = ex[end]
        kwargs = ex[1:end-1]

        @gensym kernel
        esc(quote
            let
                function $kernel()
                    $code
                    return
                end

                @opencl $(kwargs...) $kernel()
                cl.finish(cl.queue())
            end
        end)
    end
end

const init_code = quote
    using OpenCL, $pocl_pkg

    # bring used symbols into the temporary module
    import ..GPUArraysTestSuite, ..testf
    import ..@on_device
end

# avoid handle exhaustion on Windows by running each test in a separate process (pocl/pocl#1941)
function test_worker(_, init_worker_code)
    if Sys.iswindows()
        addworker(; init_worker_code)
    else
        nothing
    end
end

runtests(OpenCL, args; testsuite, init_code, init_worker_code, test_worker)

## Optional device features ("aspects")
#
# A flat set of optional capabilities, like SYCL 2020 aspects. A single OpenCL C version number
# isn't enough: NVIDIA and pocl both report OpenCL C 1.2 but differ on subgroups. Each `FEATURES`
# entry is a `name` and a host-side `detect` query; a device profile is a `FeatureSet` bitset
# indexed by position, so adding a feature just claims the next bit (no GPUCompiler release needed).
#
# We don't validate a kernel's feature use against the device; the driver rejects incompatible
# SPIR-V/OpenCL C itself. Kernels select features at compile time with `has_feature` and supply
# their own fallback (see the device RNG).

struct Feature
    name::Symbol
    detect::Function
end

# OpenCL 3.0: array of cl_name_version {cl_version (4 bytes); char name[64]}. Returns [] on
# devices that don't support the query (e.g. OpenCL 1.2).
function opencl_c_features(dev::cl.Device)::Vector{String}
    CL_DEVICE_OPENCL_C_FEATURES = 0x106f
    try
        sz = Ref{Csize_t}(0)
        cl.clGetDeviceInfo(dev, CL_DEVICE_OPENCL_C_FEATURES, 0, C_NULL, sz)
        sz[] == 0 && return String[]
        buf = Vector{UInt8}(undef, sz[])
        cl.clGetDeviceInfo(dev, CL_DEVICE_OPENCL_C_FEATURES, sz[], buf, C_NULL)
        entry = 68  # sizeof(cl_name_version)
        feats = String[]
        for off in 0:entry:(length(buf) - entry)
            namebytes = @view buf[(off + 5):(off + entry)]   # skip the 4-byte version
            nul = findfirst(==(0x00), namebytes)
            name = String(namebytes[1:(nul === nothing ? length(namebytes) : nul - 1)])
            isempty(name) || push!(feats, name)
        end
        return feats
    catch
        return String[]
    end
end

has_opencl_c_feature(dev, feat) = feat in opencl_c_features(dev)

# OpenCL 3.0: CL_DEVICE_OPENCL_C_ALL_VERSIONS lists every OpenCL C version the device accepts as
# an array of cl_name_version {cl_version (4 bytes); char name[64]}. This is the query to trust:
# the legacy CL_DEVICE_OPENCL_C_VERSION string reports "1.2" on both NVIDIA and pocl even though
# pocl accepts up to 3.0. Returns the highest version, falling back to the legacy string (or 1.2)
# on devices that don't support the 3.0 query.
function max_opencl_c_version(dev::cl.Device)::VersionNumber
    CL_DEVICE_OPENCL_C_ALL_VERSIONS = 0x1066
    try
        sz = Ref{Csize_t}(0)
        cl.clGetDeviceInfo(dev, CL_DEVICE_OPENCL_C_ALL_VERSIONS, 0, C_NULL, sz)
        if sz[] != 0
            buf = Vector{UInt8}(undef, sz[])
            cl.clGetDeviceInfo(dev, CL_DEVICE_OPENCL_C_ALL_VERSIONS, sz[], buf, C_NULL)
            entry = 68  # sizeof(cl_name_version)
            best = v"0"
            for off in 0:entry:(length(buf) - entry)
                ver = reinterpret(UInt32, buf[(off + 1):(off + 4)])[1]  # cl_version bitfield
                vn = VersionNumber(ver >> 22, (ver >> 12) & 0x3ff)      # major[31:22], minor[21:12]
                vn > best && (best = vn)
            end
            best > v"0" && return best
        end
    catch
    end
    return legacy_opencl_c_version(dev)
end

# Pre-3.0 fallback: parse the "OpenCL C <major>.<minor> <vendor>" string.
function legacy_opencl_c_version(dev::cl.Device)::VersionNumber
    CL_DEVICE_OPENCL_C_VERSION = 0x103d
    try
        sz = Ref{Csize_t}(0)
        cl.clGetDeviceInfo(dev, CL_DEVICE_OPENCL_C_VERSION, 0, C_NULL, sz)
        buf = Vector{UInt8}(undef, sz[])
        cl.clGetDeviceInfo(dev, CL_DEVICE_OPENCL_C_VERSION, sz[], buf, C_NULL)
        str = String(buf[1:(end - 1)])  # drop the trailing NUL
        m = match(r"OpenCL C (\d+)\.(\d+)", str)
        m !== nothing && return VersionNumber(parse(Int, m[1]), parse(Int, m[2]))
    catch
    end
    return v"1.2"  # conservative default
end

const FEATURES = Feature[
    Feature(:fp16, dev -> "cl_khr_fp16" in dev.extensions),
    Feature(:fp64, dev -> "cl_khr_fp64" in dev.extensions),
    Feature(:int64_atomics, dev -> "cl_khr_int64_base_atomics" in dev.extensions),
    Feature(:subgroups, cl.sub_groups_supported),
    Feature(:generic_address_space,
            dev -> has_opencl_c_feature(dev, "__opencl_c_generic_address_space")),
]

const FeatureSet = UInt64
@assert length(FEATURES) <= 64

function feature_index(name::Symbol)
    for (i, f) in enumerate(FEATURES)
        f.name === name && return i
    end
    throw(ArgumentError("unknown OpenCL feature $name"))
end

feature_bit(name::Symbol) = one(FeatureSet) << (feature_index(name) - 1)
feature_supported(fs::FeatureSet, name::Symbol) = (fs & feature_bit(name)) != 0

"""
    device_features(dev::cl.Device) -> FeatureSet

The set of optional features the device supports.
"""
function device_features(dev::cl.Device)::FeatureSet
    fs = zero(FeatureSet)
    for (i, f) in enumerate(FEATURES)
        f.detect(dev) && (fs |= one(FeatureSet) << (i - 1))
    end
    return fs
end

feature_supported(dev::cl.Device, name::Symbol) = feature_supported(device_features(dev), name)


## compile-time feature queries (device side, folded to a constant by the optimizer)

# Load the feature bitset that `finish_module!` materializes as a module-scope constant. Once the
# constant is in place the load folds away, so `has_feature` branches resolve at compile time. The
# global uses the UniformConstant (2) storage class to stay valid SPIR-V if it ever survives.
@device_function @inline function feature_bitset()
    Base.llvmcall(
        ("""@__opencl_feature_bitset = external addrspace(2) global i64
            define i64 @entry() #0 {
                %v = load i64, i64 addrspace(2)* @__opencl_feature_bitset
                ret i64 %v
            }
            attributes #0 = { alwaysinline }
        """, "entry"), UInt64, Tuple{})
end

export has_feature

"""
    has_feature(name::Symbol) -> Bool

Compile-time query (device side): does the kernel's target device support optional feature `name`
(see `FEATURES`)? Folds to a constant, so `if has_feature(:subgroups) … else … end` keeps only the
live branch. Host-side, use `feature_supported(dev, name)`.
"""
@inline has_feature(name::Symbol) = has_feature(Val(name))
@generated function has_feature(::Val{name}) where {name}
    bit = feature_bit(name)   # resolved at compile time from the registry
    return :((feature_bitset() & $bit) != zero(FeatureSet))
end

module cl

import ..OpenCL
using Printf
using Preferences

include("pointer.jl")
include("api.jl")

# OpenCL wrapper objects are expected to have an `id` field containing a handle pointer
abstract type CLObject end
Base.pointer(x::CLObject) = x.id
Base.:(==)(a::CLObject, b::CLObject) = pointer(a) == pointer(b)
Base.hash(obj::CLObject, h::UInt) = hash(pointer(obj), h)

# API wrappers
include("error.jl")
include("platform.jl")
include("device.jl")
include("context.jl")
include("cmdqueue.jl")
include("event.jl")
include("memory.jl")
include("program.jl")
include("kernel.jl")

include("state.jl")

end

#
# Vadd
#
# Element wise addition of two vectors at a time in a chain (C=A+B; D=C+E; F=D+G)
# Asks the user to select a device at runtime
#
# History: Initial version based on vadd.c, written by Tim Mattson, June 2011
# Ported to C++ Wrapper API by Benedict Gaster, September 2011
# Updated to C++ Wrapper API v1.2 by Tom Deakin and Simon McIntosh-Smith, October 2012
# Ported to Python by Tom Deakin, July 2013
# Ported to Julia  by Jake Bolewski, Nov 2013

using OpenCL

# tolerance used in floating point comparisons
TOL = 1e-3

# length of vectors a, b, c
LENGTH = 1024

# Kernel: vadd
#
# To compute the elementwise sum c = a + b
#
# Input: a and b float vectors of length count
# Output c float vector of length count holding the sum a + b

kernelsource = "
__kernel void vadd(
    __global float* a,
    __global float* b,
    __global float* c,
    const unsigned int count)
{
    unsigned int i = get_global_id(0);
    if (i < count)
        c[i] = a[i] + b[i];
}
"

# create a compute context

# create the compute program and build it
program = cl.Program(source=kernelsource) |> cl.build!

#create a, b, e, and g vectors and fill with random float values
#create empty vectors for c, d, and f
h_a = rand(Float32, LENGTH)
h_b = rand(Float32, LENGTH)
h_c = Vector{Float32}(undef, LENGTH)
h_d = Vector{Float32}(undef, LENGTH)
h_e = rand(Float32, LENGTH)
h_f = Vector{Float32}(undef, LENGTH)
h_g = rand(Float32, LENGTH)

# create the input (a,b,e,g) arrays in device memory and copy data from the host

# buffers can be passed memory flags:
# {:r = readonly, :w = writeonly, :rw = read_write (default)}

# buffers can also be passed flags for allocation:
# {:use (use host buffer), :alloc (alloc pinned memory), :copy (default)}

# Create the input (a, b, e, g) arrays in device memory and copy data from host
d_a = CLArray(h_a)
d_b = CLArray(h_b)
d_e = CLArray(h_e)
d_g = CLArray(h_g)
# Create the output (c, d, f) array in device memory
d_c = CLArray{Float32}(undef, LENGTH)
d_d = CLArray{Float32}(undef, LENGTH)
d_f = CLArray{Float32}(undef, LENGTH)

# create the kernel
vadd = cl.Kernel(program, "vadd")

# execute the kernel over the entire range of 1d input
# calling `queue` is asynchronous, it accepts the kernel, global / local work sizes,
# the the kernel's arguments.

# here we call the kernel with work size set to the number of elements and no local
# work size. This enables the opencl runtime to optimize the local size for simple
# kernels
clcall(vadd, Tuple{CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}, Cuint},
       d_a, d_b, d_c, LENGTH; global_size=size(h_a))
clcall(vadd, Tuple{CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}, Cuint},
       d_e, d_c, d_d, LENGTH; global_size=size(h_e))
clcall(vadd, Tuple{CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}, Cuint},
       d_g, d_d, d_f, LENGTH; global_size=size(h_g))

# copy back the results from the compute device
# copy!(queue, dst, src) follows same interface as julia's built in copy!
copy!(h_f, d_f)

# test the results
correct = 0
for i in 1:LENGTH
    tmp = h_a[i] + h_b[i] + h_e[i] + h_g[i]
    tmp -= h_f[i]
    if tmp^2 < TOL^2
        global correct += 1
    else
        println("tmp $tmp h_a $(h_a[i]) h_b $(h_b[i]) ",
                "h_e $(h_e[i]) h_g $(h_g[i]) h_f $(h_f[i])")
    end
end

# summarize results
println("3 vector adds to find F=A+B+E+G: $correct out of $LENGTH results were correct")

# Pi reduction - vectorized
#
# Numeric integration to estimate pi
# Asks the user to select a device at runtime
# Vector size must be present as a CLI argument
#
# History: C version written by Tim Mattson, May 2010
#          Ported to the C++ Wrapper API by Benedict R. Gaster, September 2011
#          C++ version Updated by Tom Deakin and Simon McIntosh-Smith, October 2012
#          Ported to Python by Tom Deakin, July 2013
#          Ported to Julia by Jake Bolewski, Nov 2013

using OpenCL

# get the directory of this file
# (used for test runner)
src_dir = dirname(Base.source_path())

# Some constant values
INSTEPS = 512 * 512 * 512
ITERS = -1
WGS = -1
NAME = ""

if length(ARGS) < 1
    @info("Usage: julia pi_vocl.jl [num] (where num = 1, 4, or 8)")
    exit(1)
end
vector_size = parse(Int, ARGS[1])

if vector_size == 1
        ITERS = 262144
        WGS = 8
elseif vector_size == 4
        ITERS = 65536 # (262144/4)
        WGS = 32
elseif vector_size == 8
        ITERS = 32768 # (262144/8)
        WGS = 64
else
    @warn("Invalid vector size")
    exit(1)
end

# Set some default values:
# Default number of steps (updated later to device prefereable)
in_nsteps = INSTEPS

# Default number of iterations
niters = ITERS
work_group_size = WGS

# Build program

kernelsource = read(joinpath(src_dir, "pi_vocl.cl"), String)
program = cl.Program(source=kernelsource) |> cl.build!

if vector_size == 1
    pi_kernel = cl.Kernel(program, "pi")
elseif vector_size == 4
    pi_kernel = cl.Kernel(program, "pi_vec4")
elseif vector_size == 8
    pi_kernel = cl.Kernel(program, "pi_vec8")
end

# Now that we know the size of the work_groups, we can set the number of work
# groups, the actual number of steps, and the step size
nwork_groups = in_nsteps ÷ (work_group_size * niters)

# get the max work group size for the kernel on our device
if vector_size == 1
    max_size = cl.work_group_info(pi_kernel, cl.device()).size
elseif vector_size == 4
    max_size = cl.work_group_info(pi_kernel, cl.device()).size
elseif vector_size == 8
    max_size = cl.work_group_info(pi_kernel, cl.device()).size
end

if max_size > work_group_size
    work_group_size = max_size
    nwork_groups = in_nsteps ÷ (work_group_size * niters)
end

if nwork_groups < 1
    nwork_groups = cl.device().max_compute_units
    work_group_size = in_nsteps ÷ (nwork_groups * niters)
end

nsteps = work_group_size * niters * nwork_groups
step_size = 1.0 / nsteps

# vector to hold partial sum
h_psum = Vector{Float32}(undef, nwork_groups)

println("$nwork_groups work groups of size $work_group_size.")
println("$nsteps integration steps")

d_partial_sums = CLArray{Float32}(undef, length(h_psum))

# start timer
rtime = time()

# Execute the kernel over the entire range of our 1d input data et
# using the maximum number of work group items for this device
# Set the global and local size as tuples
global_size = (nwork_groups * work_group_size,)
local_size  = (work_group_size,)
localmem    = cl.LocalMem(Float32, work_group_size)

clcall(pi_kernel, Tuple{Int32, Float32, CLPtr{Float32}, CLPtr{Float32}},
       niters, step_size, localmem, d_partial_sums; global_size, local_size)

cl.copy!(h_psum, d_partial_sums)

# complete the sum and compute final integral value
pi_res = sum(h_psum) * step_size

# stop the timer
rtime = time() - rtime

println("The calculation ran in $rtime secs")
println("pi=$pi_res for $nsteps steps")

# broadcasting

import Base.Broadcast: BroadcastStyle, Broadcasted

struct CLArrayStyle{N, B} <: AbstractGPUArrayStyle{N} end
CLArrayStyle{M, B}(::Val{N}) where {N, M, B} = CLArrayStyle{N, B}()

# identify the broadcast style of a (wrapped) CLArray
BroadcastStyle(::Type{<:CLArray{T, N, B}}) where {T, N, B} = CLArrayStyle{N, B}()
BroadcastStyle(W::Type{<:WrappedCLArray{T, N}}) where {T, N} =
    CLArrayStyle{N, memtype(Adapt.unwrap_type(W))}()

# when we are dealing with different buffer styles, we cannot know
# which one is better, so use shared memory
BroadcastStyle(
    ::CLArrayStyle{M, B1},
    ::CLArrayStyle{N, B2}
) where {M, N, B1, B2} =
    CLArrayStyle{max(M, N), B1 == B2 ? B1 : cl.UnifiedSharedMemory}()

# allocation of output arrays
Base.similar(bc::Broadcasted{CLArrayStyle{N, B}}, ::Type{T}, dims) where {T, N, B} =
    similar(CLArray{T, length(dims), B}, dims)

# Synchronization Functions

## SPIR-V wrappers

module Scope
    const CrossDevice  = 0
    const Device       = 1
    const Workgroup    = 2
    const Subgroup     = 3
    const Invocation   = 4
    const QueueFamily  = 5
    const ShaderCall   = 6
end

module MemorySemantics
    const None = const Relaxed      = 0x0000
    const Acquire                   = 0x0002
    const Release                   = 0x0004
    const AcquireRelease            = 0x0008
    const SequentiallyConsistent    = 0x0010
    const UniformMemory             = 0x0040
    const SubgroupMemory            = 0x0080
    const WorkgroupMemory           = 0x0100
    const CrossWorkgroupMemory      = 0x0200
    const AtomicCounterMemory       = 0x0400
    const ImageMemory               = 0x0800
    const OutputMemory              = 0x1000
    const MakeAvailable             = 0x2000
    const MakeVisible               = 0x4000
    const Signal                    = 0x8000
end

# `@builtin_ccall` does not support additional attributes like `convergent`
# XXX: is this even needed? Doesn't LLVM reconstruct these?
#      using the `@builtin_ccall` version causes validation issues.

#@device_function @inline memory_barrier(scope, semantics) =
#    @builtin_ccall("__spirv_MemoryBarrier", Cvoid, (UInt32, UInt32), scope, semantics)
@device_function memory_barrier(scope, semantics) =
    Base.llvmcall(("""
        declare void @_Z21__spirv_MemoryBarrierjj(i32, i32) #0
        define void @entry(i32 %scope, i32 %semantics) #1 {
            call void @_Z21__spirv_MemoryBarrierjj(i32 %scope, i32 %semantics)
            ret void
        }
        attributes #0 = { convergent }
        attributes #1 = { alwaysinline }
        """, "entry"),
    Cvoid, Tuple{UInt32, UInt32}, convert(UInt32, scope), convert(UInt32, semantics))

#@device_function @inline control_barrier(execution_scope, memory_scope, memory_semantics) =
#    @builtin_ccall("__spirv_ControlBarrier", Cvoid, (UInt32, UInt32, UInt32),
#                   execution_scope, memory_scope, memory_semantics)
@device_function @inline control_barrier(execution_scope, memory_scope, memory_semantics) =
    Base.llvmcall(("""
        declare void @_Z22__spirv_ControlBarrierjjj(i32, i32, i32) #0
        define void @entry(i32 %execution, i32 %memory, i32 %semantics) #1 {
            call void @_Z22__spirv_ControlBarrierjjj(i32 %execution, i32 %memory, i32 %semantics)
            ret void
        }
        attributes #0 = { convergent }
        attributes #1 = { alwaysinline }
        """, "entry"),
    Cvoid,
    Tuple{UInt32, UInt32, UInt32},
    convert(UInt32, execution_scope),
    convert(UInt32, memory_scope),
    convert(UInt32, memory_semantics))

## OpenCL-compatible fence API

const cl_mem_fence_flags = UInt32
const LOCAL_MEM_FENCE = cl_mem_fence_flags(1)
const GLOBAL_MEM_FENCE = cl_mem_fence_flags(2)
const IMAGE_MEM_FENCE = cl_mem_fence_flags(4)

@inline function mem_fence_flags_to_semantics(flags)
    semantics = MemorySemantics.None
    if (flags & LOCAL_MEM_FENCE) == LOCAL_MEM_FENCE
        semantics |= MemorySemantics.WorkgroupMemory
    end
    if (flags & GLOBAL_MEM_FENCE) == GLOBAL_MEM_FENCE
        semantics |= MemorySemantics.CrossWorkgroupMemory
    end
    return semantics
end

@enum memory_scope begin
    memory_scope_work_item
    memory_scope_sub_group
    memory_scope_work_group
    memory_scope_device
    memory_scope_all_svm_devices
    memory_scope_all_devices
end

@inline function memory_scope_to_spirv(scope)
    if scope == memory_scope_work_item
        Scope.Invocation
    elseif scope == memory_scope_sub_group
        Scope.Subgroup
    elseif scope == memory_scope_work_group
        Scope.Workgroup
    elseif scope == memory_scope_device
        Scope.Device
    elseif scope == memory_scope_all_svm_devices || scope == memory_scope_all_devices
        Scope.CrossDevice
    else
        error("Invalid memory scope: $scope")
    end
end

@enum memory_order begin
    memory_order_relaxed
    memory_order_acquire
    memory_order_release
    memory_order_acq_rel
    memory_order_seq_cst
end


## Memory barriers

export atomic_work_item_fence, mem_fence, read_mem_fence, write_mem_fence

@inline function atomic_work_item_fence(flags, order, scope)
    semantics = mem_fence_flags_to_semantics(flags)
    if order == memory_order_relaxed
        semantics |= MemorySemantics.Relaxed
    elseif order == memory_order_acquire
        semantics |= MemorySemantics.Acquire
    elseif order == memory_order_release
        semantics |= MemorySemantics.Release
    elseif order == memory_order_acq_rel
        semantics |= MemorySemantics.AcquireRelease
    elseif order == memory_order_seq_cst
        semantics |= MemorySemantics.SequentiallyConsistent
    else
        error("Invalid memory order: $order")
    end
    memory_barrier(memory_scope_to_spirv(scope), semantics)
end

# legacy fence functions
mem_fence(flags) = atomic_work_item_fence(flags, memory_order_acq_rel, memory_scope_work_group)
read_mem_fence(flags) = atomic_work_item_fence(flags, memory_order_acquire, memory_scope_work_group)
write_mem_fence(flags) = atomic_work_item_fence(flags, memory_order_release, memory_scope_work_group)


## Execution barriers

export barrier, work_group_barrier, sub_group_barrier

@inline work_group_barrier(flags, scope = memory_scope_work_group) =
    control_barrier(Scope.Workgroup, memory_scope_to_spirv(scope),
                    MemorySemantics.SequentiallyConsistent | mem_fence_flags_to_semantics(flags))

@inline sub_group_barrier(flags, scope = memory_scope_sub_group) =
    control_barrier(Scope.Subgroup, memory_scope_to_spirv(scope),
                    MemorySemantics.SequentiallyConsistent | mem_fence_flags_to_semantics(flags))

barrier(flags) = work_group_barrier(flags)

# OpenCL.Kernel

export clcall


## kernel object

mutable struct Kernel <: CLObject
    const id::cl_kernel

    function Kernel(k::cl_kernel, retain::Bool=false)
        kernel = new(k)
        retain && clRetainKernel(kernel)
        finalizer(clReleaseKernel, kernel)
        return kernel
    end
end

Base.unsafe_convert(::Type{cl_kernel}, k::Kernel) = k.id

Base.show(io::IO, k::Kernel) = begin
    print(io, "OpenCL.Kernel(\"$(k.function_name)\" nargs=$(k.num_args))")
end

function Kernel(p::Program, kernel_name::String)
    for (dev, status) in p.build_status
        if status != CL_BUILD_SUCCESS
            msg = "OpenCL.Program has to be built before Kernel constructor invoked"
            throw(ArgumentError(msg))
        end
    end
    err_code = Ref{Cint}()
    kernel_id = clCreateKernel(p, kernel_name, err_code)
    if err_code[] != CL_SUCCESS
        throw(CLError(err_code[]))
    end
    return Kernel(kernel_id)
end

function Base.getproperty(k::Kernel, s::Symbol)
    if s == :function_name
        size = Ref{Csize_t}()
        clGetKernelInfo(k, CL_KERNEL_FUNCTION_NAME, 0, C_NULL, size)
        result = Vector{Cchar}(undef, size[])
        clGetKernelInfo(k, CL_KERNEL_FUNCTION_NAME, size[], result, C_NULL)
        return GC.@preserve result unsafe_string(pointer(result))
    elseif s == :num_args
        result = Ref{Cuint}()
        clGetKernelInfo(k, CL_KERNEL_NUM_ARGS, sizeof(Cuint), result, C_NULL)
        return Int(result[])
    elseif s == :reference_count
        result = Ref{Cuint}()
        clGetKernelInfo(k, CL_KERNEL_REFERENCE_COUNT, sizeof(Cuint), result, C_NULL)
        return Int(result[])
    elseif s == :context
        result = Ref{cl_context}()
        clGetKernelInfo(k, CL_KERNEL_CONTEXT, sizeof(cl_context), result, C_NULL)
        return Context(result[], retain=true)
    elseif s == :program
        result = Ref{cl_program}()
        clGetKernelInfo(k, CL_KERNEL_PROGRAM, sizeof(cl_program), result, C_NULL)
        return Program(result[], retain=true)
    elseif s == :attributes
        size = Ref{Csize_t}()
        err = unchecked_clGetKernelInfo(k, CL_KERNEL_ATTRIBUTES, 0, C_NULL, size)
        if err == CL_SUCCESS && size[] > 1
            result = Vector{Cchar}(undef, size[])
            clGetKernelInfo(k, CL_KERNEL_ATTRIBUTES, size[], result, C_NULL)
            return GC.@preserve result unsafe_string(pointer(result))
        else
            return ""
        end
    else
        return getfield(k, s)
    end
end

struct KernelWorkGroupInfo
    kernel::Kernel
    device::Device
end
work_group_info(k::Kernel, d::Device) = KernelWorkGroupInfo(k, d)

function Base.getproperty(ki::KernelWorkGroupInfo, s::Symbol)
    k = getfield(ki, :kernel)
    d = getfield(ki, :device)

    function get(val, typ)
        result = Ref{typ}()
        clGetKernelWorkGroupInfo(k, d, val, sizeof(typ), result, C_NULL)
        return result[]
    end

    if s == :size
        Int(get(CL_KERNEL_WORK_GROUP_SIZE, Csize_t))
    elseif s == :compile_size
        Int.(get(CL_KERNEL_COMPILE_WORK_GROUP_SIZE, NTuple{3, Csize_t}))
    elseif s == :local_mem_size
        Int(get(CL_KERNEL_LOCAL_MEM_SIZE, cl_ulong))
    elseif s == :private_mem_size
        Int(get(CL_KERNEL_PRIVATE_MEM_SIZE, cl_ulong))
    elseif s == :prefered_size_multiple
        Int(get(CL_KERNEL_PREFERRED_WORK_GROUP_SIZE_MULTIPLE, Csize_t))
    else
        getfield(ki, s)
    end
end

struct KernelSubGroupInfo
    kernel::Kernel
    device::Device
    local_work_size::Vector{Csize_t}
end
sub_group_info(k::Kernel, d::Device, l) = KernelSubGroupInfo(k, d, Vector{Csize_t}(l))

# Helper function for getting local size for a specific sub-group count
function local_size_for_sub_group_count(ki::KernelSubGroupInfo, sub_group_count::Integer)
    k = getfield(ki, :kernel)
    d = getfield(ki, :device)
    input_value = Ref{Csize_t}(sub_group_count)
    result = Ref{NTuple{3, Csize_t}}()
    clGetKernelSubGroupInfo(k, d, CL_KERNEL_LOCAL_SIZE_FOR_SUB_GROUP_COUNT,
                           sizeof(Csize_t), input_value, sizeof(NTuple{3, Csize_t}), result, C_NULL)
    return Int.(result[])
end

function Base.getproperty(ki::KernelSubGroupInfo, s::Symbol)
    k = getfield(ki, :kernel)
    d = getfield(ki, :device)
    lws = getfield(ki, :local_work_size)

    function get(val, typ)
        result = Ref{typ}()
        clGetKernelSubGroupInfo(k, d, val, sizeof(lws), lws, sizeof(typ), result, C_NULL)
        return result[]
    end

    if s == :max_sub_group_size
        Int(get(CL_KERNEL_MAX_SUB_GROUP_SIZE_FOR_NDRANGE, Csize_t))
    elseif s == :sub_group_count
        Int(get(CL_KERNEL_SUB_GROUP_COUNT_FOR_NDRANGE, Csize_t))
    elseif s == :local_size_for_sub_group_count
        # This requires input_value to be the desired sub-group count
        error("local_size_for_sub_group_count requires specifying desired sub-group count")
    elseif s == :max_num_sub_groups
        Int(get(CL_KERNEL_MAX_NUM_SUB_GROUPS, Csize_t))
    elseif s == :compile_num_sub_groups
        Int(get(CL_KERNEL_COMPILE_NUM_SUB_GROUPS, Csize_t))
    elseif s == :compile_sub_group_size
        Int(get(CL_KERNEL_COMPILE_SUB_GROUP_SIZE_INTEL, Csize_t))
    else
        getfield(ki, s)
    end
end


## kernel calling

function enqueue_kernel(k::Kernel, global_work_size, local_work_size=nothing;
                        global_work_offset=nothing, wait_on::Vector{Event}=Event[],
                        rng_state=false, nargs=nothing)
    max_work_dim = device().max_work_item_dims
    work_dim     = length(global_work_size)
    if work_dim > max_work_dim
        throw(ArgumentError("global_work_size has max dim of $max_work_dim"))
    end
    gsize = Vector{Csize_t}(undef, work_dim)
    for (i, s) in enumerate(global_work_size)
        gsize[i] = s
    end

    goffset = C_NULL
    if global_work_offset !== nothing
        if length(global_work_offset) > max_work_dim
            throw(ArgumentError("global_work_offset has max dim of $max_work_dim"))
        end
        if length(global_work_offset) != work_dim
            throw(ArgumentError("global_work_size and global_work_offset have differing dims"))
        end
        goffset = Vector{Csize_t}(undef, work_dim)
        for (i, o) in enumerate(global_work_offset)
            goffset[i] = o
        end
    else
        # null global offset means (0, 0, 0)
    end

    lsize = C_NULL
    if local_work_size !== nothing
        if length(local_work_size) > max_work_dim
            throw(ArgumentError("local_work_offset has max dim of $max_work_dim"))
        end
        if length(local_work_size) != work_dim
            throw(ArgumentError("global_work_size and local_work_size have differing dims"))
        end
        lsize = Vector{Csize_t}(undef, work_dim)
        for (i, s) in enumerate(local_work_size)
            lsize[i] = s
        end
    else
        # null local size means OpenCL decides
    end

    if rng_state
        # match the device-side RNG layout (src/device/random.jl): one slot per subgroup when the
        # device supports subgroups, else one slot per work-item.
        use_subgroups = sub_groups_supported(device())
        num_slots = if use_subgroups
            if local_work_size !== nothing
                KernelSubGroupInfo(k, device(), lsize).sub_group_count
            else
                KernelSubGroupInfo(k, device(), Csize_t[]).max_num_sub_groups
            end
        else
            local_work_size !== nothing ? prod(lsize) : device().max_work_group_size
        end
        if nargs === nothing
            nargs = k.num_args - 2
        end
        rng_state_size = sizeof(UInt32) * num_slots
        set_arg!(k, nargs + 1, LocalMem(UInt32, rng_state_size))
        set_arg!(k, nargs + 2, LocalMem(UInt32, rng_state_size))
    end

    if !isempty(wait_on)
        n_events = length(wait_on)
        wait_event_ids = [evt.id for evt in wait_on]
    else
        n_events = 0
        wait_event_ids = C_NULL
    end

    ret_event = Ref{cl_event}()
    clEnqueueNDRangeKernel(queue(), k, work_dim, goffset, gsize, lsize,
                           n_events, wait_event_ids, ret_event)
    return Event(ret_event[], retain=false)
end

function enqueue_task(k::Kernel; wait_for=nothing)
    n_evts  = 0
    evt_ids = C_NULL
    #TODO: this should be split out into its own function
    if wait_for !== nothing
        if isa(wait_for, Event)
            n_evts = 1
            evt_ids = [wait_for.id]
        else
            @assert all([isa(evt, Event) for evt in wait_for])
            n_evts = length(wait_for)
            evt_ids = [evt.id for evt in wait_for]
        end
    end
    ret_event = Ref{cl_event}()
    clEnqueueTask(queue(), k, n_evts, evt_ids, ret_event)
    return ret_event[]
end

function call(
        k::Kernel, args...; global_size = (1,), local_size = nothing,
        global_work_offset = nothing, wait_on::Vector{Event} = Event[],
        indirect_memory::Vector{AbstractMemory} = AbstractMemory[],
        rng_state=false,
    )
    set_args!(k, args...)
    if !isempty(indirect_memory)
        svm_pointers = CLPtr{Cvoid}[]
        usm_pointers = CLPtr{Cvoid}[]
        bda_pointers = CLPtr{Cvoid}[]
        device_access = host_access = shared_access = false
        for memory in indirect_memory
            ptr = pointer(memory)
            if ptr == C_NULL || ptr == CL_NULL
                continue
            end

            if memory isa SharedVirtualMemory
                push!(svm_pointers, ptr)
            elseif memory isa Buffer
                push!(bda_pointers, ptr)
            elseif memory isa UnifiedDeviceMemory
                device_access = true
                push!(usm_pointers, ptr)
            elseif memory isa UnifiedHostMemory
                host_access = true
                push!(usm_pointers, reinterpret(CLPtr{Cvoid}, ptr))
            elseif memory isa UnifiedSharedMemory
                shared_access = true
                push!(usm_pointers, ptr)
            else
                throw(ArgumentError("Unknown memory type"))
            end
        end

        # configure USM access
        if device_access
            clSetKernelExecInfo(k, CL_KERNEL_EXEC_INFO_INDIRECT_DEVICE_ACCESS_INTEL, sizeof(cl_bool), Ref{cl_bool}(true))
        end
        if host_access
            clSetKernelExecInfo(k, CL_KERNEL_EXEC_INFO_INDIRECT_HOST_ACCESS_INTEL, sizeof(cl_bool), Ref{cl_bool}(true))
        end
        if shared_access
            clSetKernelExecInfo(k, CL_KERNEL_EXEC_INFO_INDIRECT_SHARED_ACCESS_INTEL, sizeof(cl_bool), Ref{cl_bool}(true))
        end

        # set the pointers
        if !isempty(svm_pointers)
            clSetKernelExecInfo(k, CL_KERNEL_EXEC_INFO_SVM_PTRS, sizeof(svm_pointers), svm_pointers)
        end
        if !isempty(bda_pointers)
            clSetKernelExecInfo(k, CL_KERNEL_EXEC_INFO_DEVICE_PTRS_EXT, sizeof(bda_pointers), bda_pointers)
        end
        if !isempty(usm_pointers)
            clSetKernelExecInfo(k, CL_KERNEL_EXEC_INFO_USM_PTRS_INTEL, sizeof(usm_pointers), usm_pointers)
        end
    end
    enqueue_kernel(k, global_size, local_size; global_work_offset, wait_on, rng_state, nargs=length(args))
end

# From `julia/base/reflection.jl`, adjusted to add specialization on `t`.
function _to_tuple_type(t)
    if isa(t, Tuple) || isa(t, AbstractArray) || isa(t, Core.SimpleVector)
        t = Tuple{t...}
    end
    if isa(t, Type) && t <: Tuple
        for p in (Base.unwrap_unionall(t)::DataType).parameters
            if isa(p, Core.TypeofVararg)
                p = Base.unwrapva(p)
            end
            if !(isa(p, Type) || isa(p, TypeVar))
                error("argument tuple type must contain only types")
            end
        end
    else
        error("expected tuple type")
    end
    t
end

clcall(f::F, types::Tuple, args::Vararg{Any,N}; kwargs...) where {N,F} =
    clcall(f, _to_tuple_type(types), args...; kwargs...)

function clcall(k::Kernel, types::Type{T}, args::Vararg{Any,N}; kwargs...) where {T,N}
    call_closure = function (converted_args::Vararg{Any,N})
        call(k, converted_args...; kwargs...)
    end
    convert_arguments(call_closure, types, args...)
end


## generic argument conversion

# convert the argument values to match the kernel's signature (specified by the user)
# (this mimics `lower-ccall` in julia-syntax.scm)
clconvert(typ, arg) = Base.cconvert(typ, arg)
unsafe_clconvert(typ, arg) = Base.unsafe_convert(typ, arg)
@inline @generated function convert_arguments(f::Function, ::Type{tt}, args...) where {tt}
    types = tt.parameters

    ex = quote end

    converted_args = Vector{Symbol}(undef, length(args))
    arg_ptrs = Vector{Symbol}(undef, length(args))
    for i in 1:length(args)
        converted_args[i] = gensym()
        arg_ptrs[i] = gensym()
        push!(ex.args, :($(converted_args[i]) = clconvert($(types[i]), args[$i])))
        push!(ex.args, :($(arg_ptrs[i]) = unsafe_clconvert($(types[i]), $(converted_args[i]))))
    end

    append!(ex.args, (quote
        GC.@preserve $(converted_args...) begin
            f($(arg_ptrs...))
        end
    end).args)

    return ex
end

function set_args!(k::Kernel, args...)
    for (i, a) in enumerate(args)
        set_arg!(k, i, a)
    end
end

function set_arg!(k::Kernel, idx::Integer, arg::T) where {T}
    ref = Ref(arg)
    tsize = sizeof(ref)
    err = unchecked_clSetKernelArg(k, idx - 1, tsize, ref)
    if err == CL_INVALID_ARG_SIZE
        error("""Mismatch between Julia and OpenCL type for kernel argument $idx.

                 Possible reasons:
                 - OpenCL does not support empty types.
                 - Vectors of length 3 (e.g., `float3`) are packed as 4-element vectors;
                   consider padding your tuples.
                 - The alignment of fields in your struct may not match the OpenCL layout.
                   Make sure your Julia definition matches the OpenCL layout, e.g., by
                   using `__attribute__((packed))` in your OpenCL struct definition.""")
    elseif err != CL_SUCCESS
        throw(CLError(err))
    end
    return k
end

function set_arg!(k::Kernel, idx::Integer, arg::Nothing)
    @assert idx > 0
    clSetKernelArg(k, idx - 1, sizeof(cl_mem), C_NULL)
end


## memory arguments

# passing pointers directly requires the memory type to be specified
set_arg!(k::Kernel, idx::Integer, arg::Union{Ptr, CLPtr}) =
    error("""Cannot pass a pointer to a kernel without specifying the origin memory type.
             Pass a memory object instead, or use the 4-arg version of `set_arg!` to indicate the memory type.""")
function set_arg!(k::Kernel, idx::Integer, ptr::Union{Ptr, CLPtr}, typ::Type)
    # XXX: this assumes that the receiving argument is pointer-typed, which is not the case
    #      with Julia's `Ptr` ABI. Instead, one should reinterpret the pointer as a
    #      `Core.LLVMPtr`, which _is_ pointer-valued. We retain this handling for `Ptr` for
    #      users passing pointers to OpenCL C, and because `Ptr` is pointer-valued starting
    #      with Julia 1.12.
    if typ == SharedVirtualMemory
        clSetKernelArgSVMPointer(k, idx - 1, ptr)
    elseif typ <: UnifiedMemory
        clSetKernelArgMemPointerINTEL(k, idx - 1, ptr)
    elseif typ == Buffer
        # XXX: this branch is never taken, as we currently still use plain `clSetKernelArg`,
        #      which is only possible because our pointer always comes from a `Buffer`.
        clSetKernelArgDevicePointerEXT(k, idx - 1, ptr)
    else
        error("Unknown memory type")
    end
end

# memory objects: pass the memory object itself
unsafe_clconvert(typ::Type{<:Union{Ptr, CLPtr}}, mem::AbstractMemoryObject) = mem
function set_arg!(k::Kernel, idx::Integer, arg::AbstractMemoryObject)
    arg_boxed = Ref(arg.id)
    clSetKernelArg(k, idx - 1, sizeof(cl_mem), arg_boxed)
end

# raw memory: pass as a pointer, keeping track of the memory type
struct TrackedPtr{T,M}
    ptr::Union{Ptr{T}, CLPtr{T}}
end
unsafe_clconvert(typ::Type{<:Union{Ptr{T}, CLPtr{T}}}, mem::AbstractPointerMemory) where {T} =
    TrackedPtr{T,typeof(mem)}(Base.unsafe_convert(typ, mem))
set_arg!(k::Kernel, idx::Integer, arg::TrackedPtr{<:Any,M}) where {M} =
    set_arg!(k, idx, arg.ptr, M)
set_arg!(k::Kernel, idx::Integer, arg::AbstractPointerMemory) =
    set_arg!(k, idx, pointer(arg), typeof(arg))


## local memory arguments

struct LocalMem{T}
    nbytes::Csize_t
end

function LocalMem(::Type{T}, len::Integer) where T
    @assert len > 0
    nbytes = sizeof(T) * len
    return LocalMem{T}(convert(Csize_t, nbytes))
end

Base.ndims(l::LocalMem) = 1
Base.eltype(l::LocalMem{T}) where {T} = T
Base.sizeof(l::LocalMem{T}) where {T} = Int(l.nbytes)
Base.length(l::LocalMem{T}) where {T} = Int(l.nbytes ÷ sizeof(T))

# XXX: can we avoid the `set_arg!` special case and `clconvert` to `CU_NULL`?
#      the problem is the size being passed to `clSetKernelArg`
unsafe_clconvert(::Type{CLPtr{T}}, l::LocalMem{T}) where {T} = l
function set_arg!(k::Kernel, idx::Integer, arg::LocalMem)
    clSetKernelArg(k, idx - 1, arg.nbytes, C_NULL)
end

@testset "Info" begin
    @test length(cl.platforms()) == cl.num_platforms()

    @test cl.platform() != nothing
    @test pointer(cl.platform()) != C_NULL
    @test cl.platform().opencl_version isa VersionNumber
end

@testset "Equality" begin
    platform       = cl.platforms()[1]
    platform_copy  = cl.platforms()[1]

    @test pointer(platform) == pointer(platform_copy)
    @test hash(platform) == hash(platform_copy)
    @test isequal(platform, platform)

    if length(cl.platforms()) > 1
        p1 = cl.platforms()[1]
        for p2 in cl.platforms()[2:end]
            @test pointer(p2) != pointer(p1)
            @test hash(p2) != hash(p1)
            @test !isequal(p2, p1)
        end
    end
end

# Integer Functions

# TODO: vector types
const generic_integer_types = [Int8, UInt8, Int16, UInt16, Int32, UInt32, Int64, UInt64]


# generically typed

for gentype in generic_integer_types
@eval begin

@device_override Base.abs(x::$gentype) = @builtin_ccall("abs", $gentype, ($gentype,), x)
@device_function abs_diff(x::$gentype, y::$gentype) = @builtin_ccall("abs_diff", $gentype, ($gentype, $gentype), x, y)

@device_function add_sat(x::$gentype, y::$gentype) = @builtin_ccall("add_sat", $gentype, ($gentype, $gentype), x, y)
@device_function hadd(x::$gentype, y::$gentype) = @builtin_ccall("hadd", $gentype, ($gentype, $gentype), x, y)
@device_function rhadd(x::$gentype, y::$gentype) = @builtin_ccall("rhadd", $gentype, ($gentype, $gentype), x, y)

@device_override Base.clamp(x::$gentype, minval::$gentype, maxval::$gentype) = @builtin_ccall("clamp", $gentype, ($gentype, $gentype, $gentype), x, minval, maxval)

@device_function clz(x::$gentype) = @builtin_ccall("clz", $gentype, ($gentype,), x)
@device_function ctz(x::$gentype) = @builtin_ccall("ctz", $gentype, ($gentype,), x)

@device_function mad_hi(a::$gentype, b::$gentype, c::$gentype) = @builtin_ccall("mad_hi", $gentype, ($gentype, $gentype, $gentype), a, b, c)
@device_function mad_sat(a::$gentype, b::$gentype, c::$gentype) = @builtin_ccall("mad_sat", $gentype, ($gentype, $gentype, $gentype), a, b, c)

# XXX: these definitions introduce ambiguities
#@device_override Base.max(x::$gentype, y::$gentype) = @builtin_ccall("max", $gentype, ($gentype, $gentype), x, y)
#@device_override Base.min(x::$gentype, y::$gentype) = @builtin_ccall("min", $gentype, ($gentype, $gentype), x, y)

@device_function mul_hi(x::$gentype, y::$gentype) = @builtin_ccall("mul_hi", $gentype, ($gentype, $gentype), x, y)

@device_function rotate(v::$gentype, i::$gentype) = @builtin_ccall("rotate", $gentype, ($gentype, $gentype), v, i)

@device_function sub_sat(x::$gentype, y::$gentype) = @builtin_ccall("sub_sat", $gentype, ($gentype, $gentype), x, y)

@device_function popcount(x::$gentype) = @builtin_ccall("popcount", $gentype, ($gentype,), x)

@device_function mad24(x::$gentype, y::$gentype, z::$gentype) = @builtin_ccall("mad24", $gentype, ($gentype, $gentype, $gentype), x, y, z)
@device_function mul24(x::$gentype, y::$gentype) = @builtin_ccall("mul24", $gentype, ($gentype, $gentype), x, y)

end
end


# specifically typed

@device_function upsample(hi::Int8, lo::UInt8) = @builtin_ccall("upsample", Int16, (Int8, UInt8), hi, lo)
@device_function upsample(hi::UInt8, lo::UInt8) = @builtin_ccall("upsample", UInt16, (UInt8, UInt8), hi, lo)
@device_function upsample(hi::Int16, lo::UInt16) = @builtin_ccall("upsample", Int32, (Int16, UInt16), hi, lo)
@device_function upsample(hi::UInt16, lo::UInt16) = @builtin_ccall("upsample", UInt32, (UInt16, UInt16), hi, lo)
@device_function upsample(hi::Int32, lo::UInt32) = @builtin_ccall("upsample", Int64, (Int32, UInt32), hi, lo)
@device_function upsample(hi::UInt32, lo::UInt32) = @builtin_ccall("upsample", UInt64, (UInt32, UInt32), hi, lo)

module OpenCL

using GPUCompiler
using LLVM, LLVM.Interop
using SPIRV_LLVM_Backend_jll, SPIRV_Tools_jll, spirv2clc_jll
using Adapt
using Reexport
using GPUArrays
using Random
using Preferences

import KernelAbstractions: KernelAbstractions

using Core: LLVMPtr

# library wrappers
include("../lib/cl/CL.jl")
@reexport using .cl
export cl

# device functionality
import SPIRVIntrinsics
SPIRVIntrinsics.@import_all
SPIRVIntrinsics.@reexport_public
Base.Experimental.@MethodTable(method_table)
include("device/runtime.jl")
include("device/array.jl")
include("device/quirks.jl")
include("device/random.jl")

# high level implementation
include("memory.jl")
include("array.jl")

# compiler implementation
include("compiler/capabilities.jl")
include("compiler/compilation.jl")
include("compiler/execution.jl")
include("compiler/reflection.jl")

# integrations and specialized functionality
include("util.jl")
include("broadcast.jl")
include("mapreduce.jl")
include("gpuarrays.jl")
include("random.jl")

include("OpenCLKernels.jl")
import .OpenCLKernels: OpenCLBackend
export OpenCLBackend
end

# Contiguous on-device arrays

export CLDeviceArray, CLDeviceVector, CLDeviceMatrix, CLLocalArray


## construction

# NOTE: we can't support the typical `tuple or series of integer` style construction,
#       because we're currently requiring a trailing pointer argument.

struct CLDeviceArray{T,N,A} <: DenseArray{T,N}
    ptr::LLVMPtr{T,A}
    maxsize::Int

    dims::Dims{N}
    len::Int

    # inner constructors, fully parameterized, exact types (ie. Int not <:Integer)
    # TODO: deprecate; put `ptr` first like oneArray
    CLDeviceArray{T,N,A}(dims::Dims{N}, ptr::LLVMPtr{T,A},
                          maxsize::Int=prod(dims)*sizeof(T)) where {T,A,N} =
        new(ptr, maxsize, dims, prod(dims))
end

const CLDeviceVector = CLDeviceArray{T,1,A} where {T,A}
const CLDeviceMatrix = CLDeviceArray{T,2,A} where {T,A}

# outer constructors, non-parameterized
CLDeviceArray(dims::NTuple{N,<:Integer}, p::LLVMPtr{T,A})                where {T,A,N} = CLDeviceArray{T,N,A}(dims, p)
CLDeviceArray(len::Integer,              p::LLVMPtr{T,A})                where {T,A}   = CLDeviceVector{T,A}((len,), p)

# outer constructors, partially parameterized
CLDeviceArray{T}(dims::NTuple{N,<:Integer},   p::LLVMPtr{T,A}) where {T,A,N} = CLDeviceArray{T,N,A}(dims, p)
CLDeviceArray{T}(len::Integer,                p::LLVMPtr{T,A}) where {T,A}   = CLDeviceVector{T,A}((len,), p)
CLDeviceArray{T,N}(dims::NTuple{N,<:Integer}, p::LLVMPtr{T,A}) where {T,A,N} = CLDeviceArray{T,N,A}(dims, p)
CLDeviceVector{T}(len::Integer,               p::LLVMPtr{T,A}) where {T,A}   = CLDeviceVector{T,A}((len,), p)

# outer constructors, fully parameterized
CLDeviceArray{T,N,A}(dims::NTuple{N,<:Integer}, p::LLVMPtr{T,A}) where {T,A,N} = CLDeviceArray{T,N,A}(Int.(dims), p)
CLDeviceVector{T,A}(len::Integer,               p::LLVMPtr{T,A}) where {T,A}   = CLDeviceVector{T,A}((Int(len),), p)


## array interface

Base.elsize(::Type{<:CLDeviceArray{T}}) where {T} = sizeof(T)

Base.size(g::CLDeviceArray) = g.dims
Base.sizeof(x::CLDeviceArray) = Base.elsize(x) * length(x)

# we store the array length too; computing prod(size) is expensive
Base.size(g::CLDeviceArray{<:Any, 1}) = (g.len,)
Base.length(g::CLDeviceArray) = g.len

Base.pointer(x::CLDeviceArray{T,<:Any,A}) where {T,A} = Base.unsafe_convert(LLVMPtr{T,A}, x)
@inline function Base.pointer(x::CLDeviceArray{T,<:Any,A}, i::Integer) where {T,A}
    Base.unsafe_convert(LLVMPtr{T,A}, x) + Base._memory_offset(x, i)
end

typetagdata(a::CLDeviceArray{<:Any,<:Any,A}, i=1) where {A} =
  reinterpret(LLVMPtr{UInt8,A}, a.ptr + a.maxsize) + i - one(i)


## conversions

Base.unsafe_convert(::Type{LLVMPtr{T,A}}, x::CLDeviceArray{T,<:Any,A}) where {T,A} =
  x.ptr


## indexing intrinsics

# TODO: how are allocations aligned by the level zero API? keep track of this
#       because it enables optimizations like Load Store Vectorization
#       (cfr. shared memory and its wider-than-datatype alignment)

@generated function alignment(::CLDeviceArray{T}) where {T}
    if Base.isbitsunion(T)
        _, sz, al = Base.uniontype_layout(T)
        al
    else
        Base.datatype_alignment(T)
    end
end

@device_function @inline function arrayref(A::CLDeviceArray{T}, index::Integer) where {T}
    # simplified bounds check to avoid the OneTo construction, which calls `max`
    # and breaks elimination of redundant bounds checks in the generated code.
    #@boundscheck checkbounds(A, index)
    @boundscheck index <= length(A) || Base.throw_boundserror(A, index)

    if isbitstype(T)
        arrayref_bits(A, index)
    else #if isbitsunion(T)
        arrayref_union(A, index)
    end
end

@inline function arrayref_bits(A::CLDeviceArray{T}, index::Integer) where {T}
    align = alignment(A)
    unsafe_load(pointer(A), index, Val(align))
end

@inline @generated function arrayref_union(A::CLDeviceArray{T,<:Any,AS}, index::Integer) where {T,AS}
    typs = Base.uniontypes(T)

    # generate code that conditionally loads a value based on the selector value.
    # lacking noreturn, we return T to avoid inference thinking this can return Nothing.
    ex = :(Base.llvmcall("unreachable", $T, Tuple{}))
    for (sel, typ) in Iterators.reverse(enumerate(typs))
        ex = quote
            if selector == $(sel-1)
                ptr = reinterpret(LLVMPtr{$typ,AS}, data_ptr)
                unsafe_load(ptr, 1, Val(align))
            else
                $ex
            end
        end
    end

    quote
        selector_ptr = typetagdata(A, index)
        selector = unsafe_load(selector_ptr)

        align = alignment(A)
        data_ptr = pointer(A, index)

        return $ex
    end
end

@device_function @inline function arrayset(A::CLDeviceArray{T}, x::T, index::Integer) where {T}
    # simplified bounds check (see `arrayref`)
    #@boundscheck checkbounds(A, index)
    @boundscheck index <= length(A) || Base.throw_boundserror(A, index)

    if isbitstype(T)
        arrayset_bits(A, x, index)
    else #if isbitsunion(T)
        arrayset_union(A, x, index)
    end
    return A
end

@inline function arrayset_bits(A::CLDeviceArray{T}, x::T, index::Integer) where {T}
    align = alignment(A)
    unsafe_store!(pointer(A), x, index, Val(align))
end

@inline @generated function arrayset_union(A::CLDeviceArray{T,<:Any,AS}, x::T, index::Integer) where {T,AS}
    typs = Base.uniontypes(T)
    sel = findfirst(isequal(x), typs)

    quote
        selector_ptr = typetagdata(A, index)
        unsafe_store!(selector_ptr, $(UInt8(sel-1)))

        align = alignment(A)
        data_ptr = pointer(A, index)

        unsafe_store!(reinterpret(LLVMPtr{$x,AS}, data_ptr), x, 1, Val(align))
        return
    end
end

@device_function @inline function const_arrayref(A::CLDeviceArray{T}, index::Integer) where {T}
    # simplified bounds check (see `arrayset`)
    #@boundscheck checkbounds(A, index)
    @boundscheck index <= length(A) || Base.throw_boundserror(A, index)

    align = alignment(A)
    unsafe_cached_load(pointer(A), index, Val(align))
end


## indexing

Base.IndexStyle(::Type{<:CLDeviceArray}) = Base.IndexLinear()

Base.@propagate_inbounds Base.getindex(A::CLDeviceArray{T}, i1::Integer) where {T} =
    arrayref(A, i1)
Base.@propagate_inbounds Base.setindex!(A::CLDeviceArray{T}, x, i1::Integer) where {T} =
    arrayset(A, convert(T,x)::T, i1)

# preserve the specific integer type when indexing device arrays,
# to avoid extending 32-bit hardware indices to 64-bit.
Base.to_index(::CLDeviceArray, i::Integer) = i

# Base doesn't like Integer indices, so we need our own ND get and setindex! routines.
# See also: https://github.com/JuliaLang/julia/pull/42289
Base.@propagate_inbounds Base.getindex(A::CLDeviceArray,
                                       I::Union{Integer, CartesianIndex}...) =
    A[Base._to_linear_index(A, to_indices(A, I)...)]
Base.@propagate_inbounds Base.setindex!(A::CLDeviceArray, x,
                                        I::Union{Integer, CartesianIndex}...) =
    A[Base._to_linear_index(A, to_indices(A, I)...)] = x


## const indexing

"""
    Const(A::CLDeviceArray)

Mark a CLDeviceArray as constant/read-only. The invariant guaranteed is that you will not
modify an CLDeviceArray for the duration of the current kernel.

This API can only be used on devices with compute capability 3.5 or higher.

!!! warning
    Experimental API. Subject to change without deprecation.
"""
struct Const{T,N,AS} <: DenseArray{T,N}
    a::CLDeviceArray{T,N,AS}
end
Base.Experimental.Const(A::CLDeviceArray) = Const(A)

Base.IndexStyle(::Type{<:Const}) = IndexLinear()
Base.size(C::Const) = size(C.a)
Base.axes(C::Const) = axes(C.a)
Base.@propagate_inbounds Base.getindex(A::Const, i1::Integer) = const_arrayref(A.a, i1)


## other

Base.show(io::IO, a::CLDeviceVector) =
    print(io, "$(length(a))-element device array at $(pointer(a))")
Base.show(io::IO, a::CLDeviceArray) =
    print(io, "$(join(size(a), '×')) device array at $(pointer(a))")

Base.show(io::IO, mime::MIME"text/plain", a::CLDeviceArray) = show(io, a)

@inline function Base.iterate(A::CLDeviceArray, i=1)
    if (i % UInt) - 1 < length(A)
        (@inbounds A[i], i + 1)
    else
        nothing
    end
end

function Base.reinterpret(::Type{T}, a::CLDeviceArray{S,N,A}) where {T,S,N,A}
    err = GPUArrays._reinterpret_exception(T, a)
    err === nothing || throw(err)

    if sizeof(T) == sizeof(S) # fast case
        return CLDeviceArray{T,N,A}(size(a), reinterpret(LLVMPtr{T,A}, a.ptr), a.maxsize)
    end

    isize = size(a)
    size1 = div(isize[1]*sizeof(S), sizeof(T))
    osize = tuple(size1, Base.tail(isize)...)
    return CLDeviceArray{T,N,A}(osize, reinterpret(LLVMPtr{T,A}, a.ptr), a.maxsize)
end


## local memory

# XXX: use OpenCL-style local memory arguments instead?

@inline function CLLocalArray(::Type{T}, dims) where {T}
    len = prod(dims)
    # NOTE: this relies on const-prop to forward the literal length to the generator.
    #       maybe we should include the size in the type, like StaticArrays does?
    ptr = emit_localmemory(T, Val(len))
    CLDeviceArray(dims, ptr)
end

function create_test_buffer()
    testarray = zeros(Float32, 1000)
    cl.Buffer(testarray)
end

@testset "context" begin
    buf = create_test_buffer()

    ctx = cl.context(buf)

    @test ctx != nothing
    @test isequal(ctx, cl.context()) != nothing
end

@testset "properties" begin
    buf = create_test_buffer()

    expectations = [
        (:type, cl.CL_MEM_OBJECT_BUFFER),
        (:flags, (:rw, :copy)),
        (:size, sizeof(buf)),
        (:reference_count, 1),
        (:map_count, 0)
    ]

    for expectation in expectations
        prop, value = expectation
        @test getproperty(buf, prop) == value
    end
end

using OpenCL, pocl_jll, Test

function vadd(a, b, c)
    i = get_global_id()
    @inbounds c[i] = a[i] + b[i]
    return
end

dims = (2,)
a = round.(rand(Float32, dims) * 100)
b = round.(rand(Float32, dims) * 100)
c = similar(a)

d_a = CLArray(a)
d_b = CLArray(b)
d_c = CLArray(c)

len = prod(dims)
@opencl global_size=len vadd(d_a, d_b, d_c)
c = Array(d_c)
@test a+b ≈ c

## COV_EXCL_START

# TODO
# - serial version for lower latency
# - group-stride loop to delay need for second kernel launch
# - let the driver choose the local size

# Reduce a value across a group, using local memory for communication
@inline function reduce_group(op, val::T, neutral, ::Val{maxitems}) where {T, maxitems}
    items = get_local_size()
    item = get_local_id()

    # local mem for a complete reduction
    shared = CLLocalArray(T, (maxitems,))
    @inbounds shared[item] = val

    # perform a reduction
    d = 1
    while d < items
        work_group_barrier(LOCAL_MEM_FENCE)
        index = 2 * d * (item-1) + 1
        @inbounds if index <= items
            other_val = if index + d <= items
                shared[index+d]
            else
                neutral
            end
            shared[index] = op(shared[index], other_val)
        end
        d *= 2
    end

    # load the final value on the first item
    if item == 1
        val = @inbounds shared[item]
    end

    return val
end

Base.@propagate_inbounds _map_getindex(args::Tuple, I) = ((args[1][I]), _map_getindex(Base.tail(args), I)...)
Base.@propagate_inbounds _map_getindex(args::Tuple{Any}, I) = ((args[1][I]),)
Base.@propagate_inbounds _map_getindex(args::Tuple{}, I) = ()

# Reduce an array across the grid. All elements to be processed can be addressed by the
# product of the two iterators `Rreduce` and `Rother`, where the latter iterator will have
# singleton entries for the dimensions that should be reduced (and vice versa).
function partial_mapreduce_device(f, op, neutral, maxitems, Rreduce, Rother, R, As...)
    # decompose the 1D hardware indices into separate ones for reduction (across items
    # and possibly groups if it doesn't fit) and other elements (remaining groups)
    localIdx_reduce = get_local_id()
    localDim_reduce = get_local_size()
    groupIdx_reduce, groupIdx_other = fldmod1(get_group_id(), length(Rother))
    groupDim_reduce = get_num_groups() ÷ length(Rother)

    # group-based indexing into the values outside of the reduction dimension
    # (that means we can safely synchronize items within this group)
    iother = groupIdx_other
    @inbounds if iother <= length(Rother)
        Iother = Rother[iother]

        # load the neutral value
        Iout = CartesianIndex(Tuple(Iother)..., groupIdx_reduce)
        neutral = if neutral === nothing
            R[Iout]
        else
            neutral
        end

        val = op(neutral, neutral)

        # reduce serially across chunks of input vector that don't fit in a group
        ireduce = localIdx_reduce + (groupIdx_reduce - 1) * localDim_reduce
        while ireduce <= length(Rreduce)
            Ireduce = Rreduce[ireduce]
            J = max(Iother, Ireduce)
            val = op(val, f(_map_getindex(As, J)...))
            ireduce += localDim_reduce * groupDim_reduce
        end

        val = reduce_group(op, val, neutral, maxitems)

        # write back to memory
        if localIdx_reduce == 1
            R[Iout] = val
        end
    end

    return
end

## COV_EXCL_STOP

function GPUArrays.mapreducedim!(
        f::F, op::OP, R::WrappedCLArray{T},
                                 A::Union{AbstractArray,Broadcast.Broadcasted};
                                 init=nothing) where {F, OP, T}
    Base.check_reducedims(R, A)
    length(A) == 0 && return R # isempty(::Broadcasted) iterates

    # add singleton dimensions to the output container, if needed
    if ndims(R) < ndims(A)
        dims = Base.fill_to_length(size(R), 1, Val(ndims(A)))
        R = reshape(R, dims)
    end

    # iteration domain, split in two: one part covers the dimensions that should
    # be reduced, and the other covers the rest. combining both covers all values.
    Rall = CartesianIndices(axes(A))
    Rother = CartesianIndices(axes(R))
    Rreduce = CartesianIndices(ifelse.(axes(A) .== axes(R), Ref(Base.OneTo(1)), axes(A)))
    # NOTE: we hard-code `OneTo` (`first.(axes(A))` would work too) or we get a
    #       CartesianIndices object with UnitRanges that behave badly on the GPU.
    @assert length(Rall) == length(Rother) * length(Rreduce)

    # allocate an additional, empty dimension to write the reduced value to.
    # this does not affect the actual location in memory of the final values,
    # but allows us to write a generalized kernel supporting partial reductions.
    R′ = reshape(R, (size(R)..., 1))

    # how many items do we want?
    #
    # items in a group work together to reduce values across the reduction dimensions;
    # we want as many as possible to improve algorithm efficiency and execution occupancy.
    wanted_items = length(Rreduce)
    function compute_items(max_items)
        if wanted_items > max_items
            max_items
        else
            wanted_items
        end
    end

    # how many items can we launch?
    #
    # we might not be able to launch all those items to reduce each slice in one go.
    # that's why each items also loops across their inputs, processing multiple values
    # so that we can span the entire reduction dimension using a single item group.

    # group size is restricted by local memory
    max_lmem_elements = cl.device().local_mem_size ÷ sizeof(T)
    max_items = min(cl.device().max_work_group_size,
                    compute_items(max_lmem_elements ÷ 2))
    # TODO: dynamic local memory to avoid two compilations

    # let the driver suggest a group size
    args = (f, op, init, Val(max_items), Rreduce, Rother, R′, A)
    kernel_args = kernel_convert.(args)
    kernel_tt = Tuple{Core.Typeof.(kernel_args)...}
    kernel = clfunction(partial_mapreduce_device, kernel_tt)
    wg_info = cl.work_group_info(kernel.fun, cl.device())
    reduce_items = compute_items(wg_info.size)

    # how many groups should we launch?
    #
    # even though we can always reduce each slice in a single item group, that may not be
    # optimal as it might not saturate the GPU. we already launch some groups to process
    # independent dimensions in parallel; pad that number to ensure full occupancy.
    other_groups = length(Rother)
    reduce_groups = cld(length(Rreduce), reduce_items)

    # determine the launch configuration
    local_size = reduce_items
    global_size = reduce_items*reduce_groups*other_groups

    # perform the actual reduction
    if reduce_groups == 1
        # we can cover the dimensions to reduce using a single group
        @opencl local_size global_size partial_mapreduce_device(
            f, op, init, Val(local_size), Rreduce, Rother, R′, A)
    else
        # we need multiple steps to cover all values to reduce
        partial = similar(R, (size(R)..., reduce_groups))
        if init === nothing
            # without an explicit initializer we need to copy from the output container
            partial .= R
        end
        @opencl local_size global_size partial_mapreduce_device(
            f, op, init, Val(local_size), Rreduce, Rother, partial, A)

        GPUArrays.mapreducedim!(identity, op, R′, partial; init=init)
    end

    return R
end

using OpenCL
using Documenter

DocMeta.setdocmeta!(OpenCL, :DocTestSetup, :(using OpenCL, pocl_jll); recursive = true)

const page_rename = Dict("developer.md" => "Developer docs") # Without the numbers
const numbered_pages = [
    file for file in readdir(joinpath(@__DIR__, "src")) if
    file != "index.md" && splitext(file)[2] == ".md"
]

makedocs(;
    modules = [OpenCL],
    authors = "Jake Bolewski, JuliaHub and other contributors",
    repo = "https://github.com/JuliaGPU/OpenCL.jl/blob/{commit}{path}#{line}",
    sitename = "OpenCL.jl",
    format = Documenter.HTML(; canonical = "https://JuliaGPU.github.io/OpenCL.jl"),
    pages = ["index.md"; numbered_pages],
)

deploydocs(; repo = "github.com/JuliaGPU/OpenCL.jl")

# pointer types

export CLPtr, CL_NULL, PtrOrCLPtr, CLRef, RefOrCLRef


#
# Device pointer
#

"""
    CLPtr{T}

A memory address that refers to data of type `T` that is accessible from q device. A `CLPtr`
is ABI compatible with regular `Ptr` objects, e.g. it can be used to `ccall` a function that
expects a `Ptr` to device memory, but it prevents erroneous conversions between the two.
"""
CLPtr

if sizeof(Ptr{Cvoid}) == 8
    primitive type CLPtr{T} 64 end
else
    primitive type CLPtr{T} 32 end
end

# constructor
CLPtr{T}(x::Union{Int, UInt, CLPtr}) where {T} = Base.bitcast(CLPtr{T}, x)

const CL_NULL = CLPtr{Cvoid}(0)


## getters

Base.eltype(::Type{<:CLPtr{T}}) where {T} = T


## conversions

# to and from integers
## pointer to integer
Base.convert(::Type{T}, x::CLPtr) where {T <: Integer} = T(UInt(x))
## integer to pointer
Base.convert(::Type{CLPtr{T}}, x::Union{Int, UInt}) where {T} = CLPtr{T}(x)
Base.Int(x::CLPtr) = Base.bitcast(Int, x)
Base.UInt(x::CLPtr) = Base.bitcast(UInt, x)

# between regular and OpenCL pointers
Base.convert(::Type{<:Ptr}, p::CLPtr) =
    throw(ArgumentError("cannot convert a device pointer to a host pointer"))

# between OpenCL pointers
Base.convert(::Type{CLPtr{T}}, p::CLPtr) where {T} = Base.bitcast(CLPtr{T}, p)

# defer conversions to unsafe_convert
Base.cconvert(::Type{<:CLPtr}, x) = x

# fallback for unsafe_convert
Base.unsafe_convert(::Type{P}, x::CLPtr) where {P <: CLPtr} = convert(P, x)

# from arrays
Base.unsafe_convert(::Type{CLPtr{S}}, a::AbstractArray{T}) where {S, T} =
    convert(CLPtr{S}, Base.unsafe_convert(CLPtr{T}, a))
Base.unsafe_convert(::Type{CLPtr{T}}, a::AbstractArray{T}) where {T} =
    error("conversion to pointer not defined for $(typeof(a))")

## limited pointer arithmetic & comparison

Base.isequal(x::CLPtr, y::CLPtr) = (x === y)
Base.isless(x::CLPtr{T}, y::CLPtr{T}) where {T} = x < y

Base.:(==)(x::CLPtr, y::CLPtr) = UInt(x) == UInt(y)
Base.:(<)(x::CLPtr, y::CLPtr) = UInt(x) < UInt(y)
Base.:(-)(x::CLPtr, y::CLPtr) = UInt(x) - UInt(y)

if VERSION >= v"1.12.0-DEV.225"
Base.:(+)(x::CLPtr{T}, y::Integer) where T =
    reinterpret(CLPtr{T}, Base.add_ptr(reinterpret(Ptr{T}, x), (y % UInt) % UInt))
Base.:(-)(x::CLPtr{T}, y::Integer) where T =
    reinterpret(CLPtr{T}, Base.sub_ptr(reinterpret(Ptr{T}, x), (y % UInt) % UInt))
else
Base.:(+)(x::CLPtr, y::Integer) = oftype(x, Base.add_ptr(UInt(x), (y % UInt) % UInt))
Base.:(-)(x::CLPtr, y::Integer) = oftype(x, Base.sub_ptr(UInt(x), (y % UInt) % UInt))
end
Base.:(+)(x::Integer, y::CLPtr) = y + x


#
# Host or device pointer
#

"""
    PtrOrCLPtr{T}

A special pointer type, ABI-compatible with both `Ptr` and `CLPtr`, for use in `ccall`
expressions to convert values to either a device or a host type (in that order). This is
required for APIs which accept pointers that either point to host or device memory.
"""
PtrOrCLPtr


if sizeof(Ptr{Cvoid}) == 8
    primitive type PtrOrCLPtr{T} 64 end
else
    primitive type PtrOrCLPtr{T} 32 end
end

function Base.cconvert(::Type{PtrOrCLPtr{T}}, val) where {T}
    # `cconvert` is always implemented for both `Ptr` and `CLPtr`, so pick the first result
    # that has done an actual conversion

    dev_val = Base.cconvert(CLPtr{T}, val)
    if dev_val !== val
        return dev_val
    end

    host_val = Base.cconvert(Ptr{T}, val)
    if host_val !== val
        return host_val
    end

    return val
end

function Base.unsafe_convert(::Type{PtrOrCLPtr{T}}, val) where {T}
    ptr = if Core.Compiler.return_type(
            Base.unsafe_convert,
            Tuple{Type{Ptr{T}}, typeof(val)}
        ) !== Union{}
        Base.unsafe_convert(Ptr{T}, val)
    elseif Core.Compiler.return_type(
            Base.unsafe_convert,
            Tuple{Type{CLPtr{T}}, typeof(val)}
        ) !== Union{}
        Base.unsafe_convert(CLPtr{T}, val)
    else
        throw(ArgumentError("cannot convert to either a host or device pointer"))
    end

    return Base.bitcast(PtrOrCLPtr{T}, ptr)
end


#
# Device reference objects
#

if sizeof(Ptr{Cvoid}) == 8
    primitive type CLRef{T} 64 end
else
    primitive type CLRef{T} 32 end
end

# general methods for CLRef{T} type
Base.eltype(x::Type{<:CLRef{T}}) where {T} = @isdefined(T) ? T : Any

Base.convert(::Type{CLRef{T}}, x::CLRef{T}) where {T} = x

# conversion or the actual ccall
Base.unsafe_convert(::Type{CLRef{T}}, x::CLRef{T}) where {T} = Base.bitcast(CLRef{T}, Base.unsafe_convert(CLPtr{T}, x))
Base.unsafe_convert(::Type{CLRef{T}}, x) where {T} = Base.bitcast(CLRef{T}, Base.unsafe_convert(CLPtr{T}, x))

# CLRef from literal pointer
Base.convert(::Type{CLRef{T}}, x::CLPtr{T}) where {T} = x

# indirect constructors using CLRef
Base.convert(::Type{CLRef{T}}, x) where {T} = CLRef{T}(x)


## CLRef object backed by an array at index i

struct CLRefArray{T, A <: AbstractArray{T}} <: Ref{T}
    x::A
    i::Int
    CLRefArray{T, A}(x, i) where {T, A <: AbstractArray{T}} = new(x, i)
end
CLRefArray{T}(x::AbstractArray{T}, i::Int = 1) where {T} = CLRefArray{T, typeof(x)}(x, i)
CLRefArray(x::AbstractArray{T}, i::Int = 1) where {T} = CLRefArray{T}(x, i)
Base.convert(::Type{CLRef{T}}, x::AbstractArray{T}) where {T} = CLRefArray(x, 1)

function Base.unsafe_convert(P::Type{CLPtr{T}}, b::CLRefArray{T}) where {T}
    return pointer(b.x, b.i)
end
function Base.unsafe_convert(P::Type{CLPtr{Any}}, b::CLRefArray{Any})
    return convert(P, pointer(b.x, b.i))
end
Base.unsafe_convert(::Type{CLPtr{Cvoid}}, b::CLRefArray{T}) where {T} =
    convert(CLPtr{Cvoid}, Base.unsafe_convert(CLPtr{T}, b))


## Union with all CLRef 'subtypes'

const CLRefs{T} = Union{CLPtr{T}, CLRefArray{T}}


## RefOrCLRef

if sizeof(Ptr{Cvoid}) == 8
    primitive type RefOrCLRef{T} 64 end
else
    primitive type RefOrCLRef{T} 32 end
end

Base.convert(::Type{RefOrCLRef{T}}, x::Union{RefOrCLRef{T}, Ref{T}, CLRef{T}, CLRefs{T}}) where {T} = x

# prefer conversion to CPU ref: this is generally cheaper
Base.convert(::Type{RefOrCLRef{T}}, x) where {T} = Ref{T}(x)
Base.unsafe_convert(::Type{RefOrCLRef{T}}, x::Ref{T}) where {T} =
    Base.bitcast(RefOrCLRef{T}, Base.unsafe_convert(Ptr{T}, x))
Base.unsafe_convert(::Type{RefOrCLRef{T}}, x) where {T} =
    Base.bitcast(RefOrCLRef{T}, Base.unsafe_convert(Ptr{T}, x))

# support conversion from GPU ref
Base.unsafe_convert(::Type{RefOrCLRef{T}}, x::CLRefs{T}) where {T} =
    Base.bitcast(RefOrCLRef{T}, Base.unsafe_convert(CLPtr{T}, x))

# support conversion from arrays
Base.convert(::Type{RefOrCLRef{T}}, x::Array{T}) where {T} = convert(Ref{T}, x)
Base.convert(::Type{RefOrCLRef{T}}, x::AbstractArray{T}) where {T} = convert(CLRef{T}, x)
Base.unsafe_convert(P::Type{RefOrCLRef{T}}, b::CLRefArray{T}) where {T} =
    Base.bitcast(RefOrCLRef{T}, Base.unsafe_convert(CLRef{T}, b))

using OpenCL, pocl_jll, Test

const source = """
   __kernel void vadd(__global const float *a,
                      __global const float *b,
                      __global float *c) {
      int i = get_global_id(0);
      c[i] = a[i] + b[i];
    }"""

dims = (2,)
a = round.(rand(Float32, dims) * 100)
b = round.(rand(Float32, dims) * 100)
c = similar(a)

d_a = CLArray(a)
d_b = CLArray(b)
d_c = CLArray(c)

prog = cl.Program(; source) |> cl.build!
kern = cl.Kernel(prog, "vadd")

len = prod(dims)
clcall(kern, Tuple{CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}},
       d_a, d_b, d_c; global_size=(len,))
c = Array(d_c)
@test a+b ≈ c

# OpenCL.CmdQueue

mutable struct CmdQueue <: CLObject
    const id::cl_command_queue
    Base.@atomic valid::Bool

    function CmdQueue(q_id::cl_command_queue; retain::Bool=false)
        q = new(q_id, true)
        retain && clRetainCommandQueue(q)
        finalizer(q) do _
            Base.@atomic q.valid = false
            clReleaseCommandQueue(q)
        end
        return q
    end
end

Base.unsafe_convert(::Type{cl_command_queue}, q::CmdQueue) = q.id

function Base.show(io::IO, q::CmdQueue)
    ptr_val = convert(UInt, pointer(q))
    ptr_address = "0x$(string(ptr_val, base = 16, pad = Sys.WORD_SIZE>>2))"
    print(io, "OpenCL.CmdQueue(@$ptr_address)")
end

function CmdQueue(prop::Symbol)
    flags = cl_command_queue_properties(0)
    if prop == :out_of_order
        flags |= CL_QUEUE_OUT_OF_ORDER_EXEC_MODE_ENABLE
    elseif prop == :profile
        flags |= CL_QUEUE_PROFILING_ENABLE
    else
        throw(ArgumentError("Only :out_of_order and :profile flags are valid, recognized flag $prop"))
    end
    return CmdQueue(flags)
end

function CmdQueue(props::NTuple{2,Symbol})
    if !(:out_of_order in props && :profile in props)
        throw(ArgumentError("Only :out_of_order and :profile flags are vaid, unrecognized flags $props"))
    end
    flags = CL_QUEUE_PROFILING_ENABLE | CL_QUEUE_OUT_OF_ORDER_EXEC_MODE_ENABLE
    return CmdQueue(flags)
end

function CmdQueue(flags=cl_command_queue_properties(0))
    err_code = Ref{Cint}()
    queue_id = clCreateCommandQueue(context(), device(), flags, err_code)
    if err_code[] != CL_SUCCESS
        if queue_id != C_NULL
            clReleaseCommandQueue(queue_id)
        end
        throw(CLError(err_code[]))
    end
    return CmdQueue(queue_id)
end

function flush(q::CmdQueue)
    clFlush(q)
    return q
end

function finish(q::CmdQueue)
    clFinish(q)
    return q
end

function Base.getproperty(q::CmdQueue, s::Symbol)
    if s == :context
        ctx_id = Ref{cl_context}()
        clGetCommandQueueInfo(q, CL_QUEUE_CONTEXT, sizeof(cl_context), ctx_id, C_NULL)
        return Context(ctx_id[], retain=true)
    elseif s == :device
        dev_id = Ref{cl_device_id}()
        clGetCommandQueueInfo(q, CL_QUEUE_DEVICE, sizeof(cl_device_id), dev_id, C_NULL)
        return Device(dev_id[])
    elseif s == :reference_count
        ref_count = Ref{Cuint}()
        clGetCommandQueueInfo(q, CL_QUEUE_REFERENCE_COUNT, sizeof(Cuint), ref_count, C_NULL)
        return Int(ref_count[])
    elseif s == :properties
        props = Ref{cl_command_queue_properties}()
        clGetCommandQueueInfo(q, CL_QUEUE_PROPERTIES, sizeof(cl_command_queue_properties),
                              props, C_NULL)
        return props[]
    else
        return getfield(q, s)
    end
end

context(queue::CmdQueue) = queue.context

@testset "constructor" begin
    @test cl.CmdQueue() != nothing
    @test cl.CmdQueue(:profile) != nothing
    try
        cl.CmdQueue(:out_of_order)
        cl.CmdQueue((:profile, :out_of_order))
    catch err
        @warn("Platform $(cl.device().platform.name) does not seem to " *
              "suport out of order queues: \n$err",maxlog=1,
              exception=(err, catch_backtrace()))
    end
    @test_throws ArgumentError cl.CmdQueue(:unrecognized_flag)
    for flag in [:profile, :out_of_order]
        @test_throws ArgumentError cl.CmdQueue((flag, :unrecognized_flag))
        @test_throws ArgumentError cl.CmdQueue((flag, flag))
    end
end

@testset "info" begin
    q = cl.CmdQueue()
    @test q.context == cl.context()
    @test q.device == cl.device()
    @test q.reference_count > 0
    @test typeof(q.properties) == cl.cl_command_queue_properties
end

module OpenCLKernels

using ..OpenCL
using ..OpenCL: @device_override, method_table

import KernelAbstractions as KA

import StaticArrays

import Adapt


## Back-end Definition

export OpenCLBackend

struct OpenCLBackend <: KA.GPU
end

function KA.allocate(::OpenCLBackend, ::Type{T}, dims::Tuple; unified::Bool = false) where T
    if unified
        memory_backend = cl.unified_memory_backend()
        if memory_backend === cl.USMBackend()
            return CLArray{T, length(dims), cl.UnifiedSharedMemory}(undef, dims)
        elseif memory_backend === cl.SVMBackend()
            return CLArray{T, length(dims), cl.SharedVirtualMemory}(undef, dims)
        else
            throw(ArgumentError("Unified memory not supported"))
        end
    else
        return CLArray{T}(undef, dims)
    end
end

KA.supports_unified(::OpenCLBackend) = cl.default_memory_backend(cl.device(); unified=true) !== nothing

KA.get_backend(::CLArray) = OpenCLBackend()
# TODO should be non-blocking
KA.synchronize(::OpenCLBackend) = cl.finish(cl.queue())
KA.supports_float64(::OpenCLBackend) = false  # TODO: Check if this is device dependent

Adapt.adapt_storage(::OpenCLBackend, a::Array) = Adapt.adapt(CLArray, a)
Adapt.adapt_storage(::OpenCLBackend, a::CLArray) = a
Adapt.adapt_storage(::KA.CPU, a::CLArray) = convert(Array, a)


## Memory Operations

function KA.copyto!(::OpenCLBackend, A, B)
    copyto!(A, B)
    # TODO: Address device to host copies in jl being synchronizing
end


## Kernel Launch

function KA.mkcontext(kernel::KA.Kernel{OpenCLBackend}, _ndrange, iterspace)
    KA.CompilerMetadata{KA.ndrange(kernel), KA.DynamicCheck}(_ndrange, iterspace)
end
function KA.mkcontext(kernel::KA.Kernel{OpenCLBackend}, I, _ndrange, iterspace,
                      ::Dynamic) where Dynamic
    KA.CompilerMetadata{KA.ndrange(kernel), Dynamic}(I, _ndrange, iterspace)
end

function KA.launch_config(kernel::KA.Kernel{OpenCLBackend}, ndrange, workgroupsize)
    if ndrange isa Integer
        ndrange = (ndrange,)
    end
    if workgroupsize isa Integer
        workgroupsize = (workgroupsize, )
    end

    # partition checked that the ndrange's agreed
    if KA.ndrange(kernel) <: KA.StaticSize
        ndrange = nothing
    end

    iterspace, dynamic = if KA.workgroupsize(kernel) <: KA.DynamicSize &&
        workgroupsize === nothing
        # use ndrange as preliminary workgroupsize for autotuning
        KA.partition(kernel, ndrange, ndrange)
    else
        KA.partition(kernel, ndrange, workgroupsize)
    end

    return ndrange, workgroupsize, iterspace, dynamic
end

function threads_to_workgroupsize(threads, ndrange)
    total = 1
    return map(ndrange) do n
        x = min(div(threads, total), n)
        total *= x
        return x
    end
end

function (obj::KA.Kernel{OpenCLBackend})(args...; ndrange=nothing, workgroupsize=nothing)
    ndrange, workgroupsize, iterspace, dynamic =
        KA.launch_config(obj, ndrange, workgroupsize)

    # this might not be the final context, since we may tune the workgroupsize
    ctx = KA.mkcontext(obj, ndrange, iterspace)
    kernel = @opencl launch=false obj.f(ctx, args...)

    # figure out the optimal workgroupsize automatically
    if KA.workgroupsize(obj) <: KA.DynamicSize && workgroupsize === nothing
        wg_info = cl.work_group_info(kernel.fun, cl.device())
        wg_size_nd = threads_to_workgroupsize(wg_info.size, ndrange)
        iterspace, dynamic = KA.partition(obj, ndrange, wg_size_nd)
        ctx = KA.mkcontext(obj, ndrange, iterspace)
    end

    groups = length(KA.blocks(iterspace))
    items = length(KA.workitems(iterspace))

    if groups == 0
        return nothing
    end

    # Launch kernel
    global_size = groups * items
    local_size = items
    kernel(ctx, args...; global_size, local_size)

    return nothing
end


## Indexing Functions

@device_override @inline function KA.__index_Local_Linear(ctx)
    return get_local_id(1)
end

@device_override @inline function KA.__index_Group_Linear(ctx)
    return get_group_id(1)
end

@device_override @inline function KA.__index_Global_Linear(ctx)
    #return get_global_id(1)    # JuliaGPU/OpenCL.jl#346
    I = KA.__index_Global_Cartesian(ctx)
    @inbounds LinearIndices(KA.__ndrange(ctx))[I]
end

@device_override @inline function KA.__index_Local_Cartesian(ctx)
    @inbounds KA.workitems(KA.__iterspace(ctx))[get_local_id(1)]
end

@device_override @inline function KA.__index_Group_Cartesian(ctx)
    @inbounds KA.blocks(KA.__iterspace(ctx))[get_group_id(1)]
end

@device_override @inline function KA.__index_Global_Cartesian(ctx)
    return @inbounds KA.expand(KA.__iterspace(ctx), get_group_id(1), get_local_id(1))
end

@device_override @inline function KA.__validindex(ctx)
    if KA.__dynamic_checkbounds(ctx)
        I = KA.__index_Global_Cartesian(ctx)
        return I in KA.__ndrange(ctx)
    else
        return true
    end
end


## Shared and Scratch Memory

@device_override @inline function KA.SharedMemory(::Type{T}, ::Val{Dims}, ::Val{Id}) where {T, Dims, Id}
    ptr = OpenCL.emit_localmemory(T, Val(prod(Dims)))
    CLDeviceArray(Dims, ptr)
end

@device_override @inline function KA.Scratchpad(ctx, ::Type{T}, ::Val{Dims}) where {T, Dims}
    StaticArrays.MArray{KA.__size(Dims), T}(undef)
end


## Synchronization and Printing

@device_override @inline function KA.__synchronize()
    work_group_barrier(OpenCL.LOCAL_MEM_FENCE | OpenCL.GLOBAL_MEM_FENCE)
end

@device_override @inline function KA.__print(args...)
    OpenCL._print(args...)
end


## Other

KA.argconvert(::KA.Kernel{OpenCLBackend}, arg) = OpenCL.kernel_convert(arg)

end

# OpenCL.Event

abstract type AbstractEvent <: CLObject end

mutable struct Event <: AbstractEvent
    const id::cl_event

    function Event(evt_id; retain::Bool=false)
        evt = new(evt_id)
        retain && clRetainEvent(evt)
        finalizer(clReleaseEvent, evt)
        return evt
    end
end

# wait for completion before running finalizer
mutable struct NannyEvent <: AbstractEvent
    const id::cl_event
    const obj::Any

    function NannyEvent(evt_id, obj; retain::Bool=false)
        nanny_evt = new(evt_id, obj)
        retain && clRetainEvent(nanny_evt)
        finalizer(clReleaseEvent, nanny_evt)
        nanny_evt
    end
end

NannyEvent(evt::Event, obj; retain=false) = NannyEvent(evt.id, obj; retain)

macro return_event(evt)
    quote
        evt = $(esc(evt))
        try
            return Event(evt, retain=false)
        catch err
            clReleaseEvent(evt)
            throw(err)
        end
    end
end

macro return_nanny_event(evt, obj)
    quote
        evt = $(esc(evt))
        try
            return NannyEvent(evt, $(esc(obj)))
        catch err
            clReleaseEvent(evt)
            throw(err)
        end
    end
end

Base.unsafe_convert(::Type{cl_event}, evt::AbstractEvent) = evt.id

function Base.show(io::IO, evt::Event)
    ptr_val = convert(UInt, pointer(evt))
    ptr_address = "0x$(string(ptr_val, base = 16, pad = Sys.WORD_SIZE>>2))"
    print(io, "OpenCL.Event(@$ptr_address)")
end

mutable struct UserEvent <: AbstractEvent
    const id::cl_event

    function UserEvent(evt_id::cl_event, retain::Bool=false)
        evt = new(evt_id)
        retain && clRetainEvent(evt)
        finalizer(clReleaseEvent, evt)
        return evt
    end
end

function UserEvent(; retain=false)
    status = Ref{Cint}()
    evt_id = clCreateUserEvent(context(), status)
    if status[] != CL_SUCCESS
        throw(CLError(status[]))
    end
    try
        return UserEvent(evt_id, retain)
    catch err
        clReleaseEvent(evt_id)
        throw(err)
    end
end

function Base.show(io::IO, evt::UserEvent)
    ptr_val = convert(UInt, pointer(evt))
    ptr_address = "0x$(string(ptr_val, base = 16, pad = Sys.WORD_SIZE>>2))"
    print(io, "OpenCL.UserEvent(@$ptr_address)")
end

function complete(evt::UserEvent)
    clSetUserEventStatus(evt, CL_COMPLETE)
    return evt
end

struct _EventCB
    handle::Ptr{Nothing}
    evt_id::cl_event
    status::Cint
end

function event_notify(evt_id::cl_event, status::Cint, payload::Ptr{Nothing})
    ptr = convert(Ptr{_EventCB}, payload)
    handle = unsafe_load(ptr).handle

    val = _EventCB(handle, evt_id, status)
    unsafe_store!(ptr, val)

    # Use uv_async_send to notify the main thread
    ccall(:uv_async_send, Nothing, (Ptr{Nothing},), handle)
    nothing
end

function add_callback(evt::AbstractEvent, callback::Function)
    event_notify_ptr = @cfunction(event_notify, Nothing,
                                  (cl_event, Cint, Ptr{Cvoid}))

    # The uv_callback is going to notify a task that,
    # then executes the real callback.
    cb = Base.AsyncCondition()
    GC.@preserve cb begin

        # Storing the results of our c_callback needs to be
        # isbits && isimmutable
        r_ecb = Ref(_EventCB(Base.unsafe_convert(Ptr{Cvoid}, cb), 0, 0))

        clSetEventCallback(evt, CL_COMPLETE, event_notify_ptr, r_ecb)

        @async begin
           try
             Base.wait(cb)
             ecb = r_ecb[]
             callback(ecb.evt_id, ecb.status)
           catch
             rethrow()
           finally
             Base.close(cb)
           end
        end
    end
end

function Base.wait(evt::AbstractEvent)
    evt_id = [evt.id]
    clWaitForEvents(cl_uint(1), evt_id)
    return evt
end

function Base.wait(evts::Vector{AbstractEvent})
    isempty(evts) && return evts
    evt_ids = [pointer(evt) for evt in evts]
    GC.@preserve evts begin
        clWaitForEvents(length(evt_ids), evt_ids)
    end
    return evts
end

function enqueue_marker_with_wait_list(wait_for::Vector{AbstractEvent})
    n_wait_events = cl_uint(length(wait_for))
    wait_evt_ids = [evt.id for evt in wait_for]
    ret_evt = Ref{cl_event}()
    clEnqueueMarkerWithWaitList(queue(), n_wait_events,
                                isempty(wait_evt_ids) ? C_NULL : wait_evt_ids,
                                ret_evt)
    @return_event ret_evt[]
end

function enqueue_barrier_with_wait_list(wait_for::Vector{AbstractEvent})
    n_wait_events = cl_uint(length(wait_for))
    wait_evt_ids = [evt.id for evt in wait_for]
    ret_evt = Ref{cl_event}()
    clEnqueueBarrierWithWaitList(queue(), n_wait_events,
                                 isempty(wait_evt_ids) ? C_NULL : wait_evt_ids,
                                 ret_evt)
    @return_event ret_evt[]
end

function enqueue_marker()
    evt = Ref{cl_event}()
    clEnqueueMarker(queue(), evt)
    @return_event evt[]
end
@deprecate enqueue_marker enqueue_marker_with_wait_list

function enqueue_wait_for_events(wait_for::Vector{T}) where {T<:AbstractEvent}
    wait_evt_ids = isempty(wait_for) ? C_NULL : [pointer(evt) for evt in wait_for]
    GC.@preserve wait_for begin
        clEnqueueWaitForEvents(queue(), length(wait_for), wait_evt_ids)
   end
end

function enqueue_wait_for_events(wait_for::AbstractEvent)
    enqueue_wait_for_events([wait_for])
end

function enqueue_barrier()
    clEnqueueBarrier(queue())
    return
end
@deprecate enqueue_barrier enqueue_barrier_with_wait_list

cl_event_status(s::Symbol) = begin
    if s == :queued
        return CL_QUEUED
    elseif s == :submitted
        return CL_SUBMITTED
    elseif s == :running
        return CL_RUNNING
    elseif s == :complete
        return CL_COMPLETE
    else
        throw(ArgumentError("unrecognized status symbol :$s"))
    end
end

function Base.getproperty(evt::AbstractEvent, s::Symbol)
    function profiling_info(evt::AbstractEvent, profile_info)
        time = Ref{Clong}(0)
        try
            clGetEventProfilingInfo(evt, profile_info, sizeof(cl_ulong), time, C_NULL)
        catch err
            if isa(err, CLError) && err.code == CL_PROFILING_INFO_NOT_AVAILABLE
                if evt.status != :complete
                    throw(ArgumentError("Event is not complete; cannot access profiling info yet"))
                else
                    throw(ArgumentError("Command queue does not support profiling; consider running under `cl.queue!(:profiling)`"))
                end
            end
            rethrow()
        end
        return time[]
    end

    # regular properties
    if s == :context
        ctx = Ref{cl_context}()
        clGetEventInfo(evt, CL_EVENT_CONTEXT, sizeof(cl_context), ctx, C_NULL)
        return Context(ctx[])
    elseif s == :command_queue
        cmd_q = Ref{cl_command_queue}()
        clGetEventInfo(evt, CL_EVENT_COMMAND_QUEUE, sizeof(cl_command_queue), cmd_q, C_NULL)
        return CmdQueue(cmd_q[])
    elseif s == :command_type
        cmd_t = Ref{Cint}()
        clGetEventInfo(evt, CL_EVENT_COMMAND_TYPE, sizeof(Cint), cmd_t, C_NULL)
        return cmd_t[]
    elseif s == :reference_count
        cnt = Ref{Cuint}()
        clGetEventInfo(evt, CL_EVENT_REFERENCE_COUNT, sizeof(Cuint), cnt, C_NULL)
        return Int(cnt[])
    elseif s == :status
        st = Ref{Cint}()
        clGetEventInfo(evt, CL_EVENT_COMMAND_EXECUTION_STATUS, sizeof(Cint), st, C_NULL)
        status = st[]
        if status == CL_QUEUED
            return :queued
        elseif status == CL_SUBMITTED
            return :submitted
        elseif status == CL_RUNNING
            return :running
        elseif status == CL_COMPLETE
            return :complete
        else
            throw(ArgumentError("Unknown status value: $status"))
        end

    # profiling properties
    elseif s == :profile_start
        return profiling_info(evt, CL_PROFILING_COMMAND_START)
    elseif s == :profile_end
        return profiling_info(evt, CL_PROFILING_COMMAND_END)
    elseif s == :profile_queued
        return profiling_info(evt, CL_PROFILING_COMMAND_QUEUED)
    elseif s == :profile_submit
        return profiling_info(evt, CL_PROFILING_COMMAND_SUBMIT)
    elseif s == :profile_duration
        return evt.profile_end - evt.profile_start

    else
        return getfield(evt, s)
    end
end

using OpenCL, Printf, LinearAlgebra

const bench_kernel = "
__kernel void sum(__global const float *a,
                  __global const float *b,
                  __global float *c)
{
        int gid = get_global_id(0);
        float a_temp;
        float b_temp;
        float c_temp;

        a_temp = a[gid]; // my a element (by global ref)
        b_temp = b[gid]; // my b element (by global ref)

        c_temp = a_temp+b_temp; // sum of my elements
        c_temp = c_temp * c_temp; // product of sums
        c_temp = c_temp * (a_temp/2.0f); // times 1/2 my a

        c[gid] = c_temp; // store result in global memory
}"

function cl_performance(ndatapts::Integer, nworkers::Integer)

    @assert ndatapts > 0
    @assert nworkers > 0

    a = rand(Float32,  ndatapts)
    b = rand(Float32,  ndatapts)
    c = Vector{Float32}(undef, ndatapts)

    @printf("Size of test data: %i MB\n", sizeof(a) / 1024 / 1024)

    t1 = time()
    for i in 1:ndatapts
        c_temp = a[i] + b[i]
        c_temp = c_temp * c_temp
        c[i]   = c_temp * (a[i] / 2f0)
    end
    t2 = time()

    @printf("Julia Execution time: %.4f seconds\n", t2 - t1)

    for platform in cl.platforms()
        cl.platform!(platform)

        for device in cl.available_devices(platform)
            cl.device!(device)

            @printf("====================================================\n")
            @printf("Platform name:    %s\n",  platform.name)
            @printf("Platform profile: %s\n",  platform.profile)
            @printf("Platform vendor:  %s\n",  platform.vendor)
            @printf("Platform version: %s\n",  platform.version)
            @printf("----------------------------------------------------\n")
            @printf("Device name: %s\n", device.name)
            @printf("Device type: %s\n", device.device_type)
            @printf("Device mem: %i MB\n",           device.global_mem_size / 1024^2)
            @printf("Device max mem alloc: %i MB\n", device.max_mem_alloc_size / 1024^2)
            @printf("Device max clock freq: %i MHZ\n",  device.max_clock_frequency)
            @printf("Device max compute units: %i\n",   device.max_compute_units)
            @printf("Device max work group size: %i\n", device.max_work_group_size)
            @printf("Device max work item size: %s\n",  device.max_work_item_size)

            if device.max_mem_alloc_size < sizeof(Float32) * ndatapts
                @warn("Requested buffer size exceeds device max alloc size!")
                @warn("Skipping device $(device.name)...")
                continue
            end

            if device.max_work_group_size < nworkers
                @warn("Number of workers exceeds the device's max work group size!")
                @warn("Skipping device $(device.name)...")
                continue
            end

            da = CLArray(a)
            db = CLArray(b)
            dc = CLArray{Float32}(undef, length(a))

            prg  = cl.Program(source=bench_kernel) |> cl.build!
            kern = cl.Kernel(prg, "sum")

            # work_group_multiple = kern.prefered_work_group_size_multiple
            global_size = (ndatapts,)
            local_size  = (nworkers,)

            cl.queue!(:profile) do
                # call the kernel
                evt = clcall(kern, Tuple{CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}},
                             da, db, dc; global_size, local_size)
                wait(evt)

                # duration in ns
                t = evt.profile_duration * 1e-9
                @printf("Execution time of test: %.4f seconds\n", t)

                @info("Result norm: $(norm(c - Array(dc)))")
            end
        end
    end
end

# Play with these numbers to see performance differences
# N_DATAPTS has to be a multiple of the number of workers
# N_WORKERS has to be less than or equal to the device's max work group size
# ex. N_WORKERS = 1 is non parallel execution on the gpu

const N_DATA_PTS = Int(2^23) # ~8 million
const N_WORKERS  = Int(2^7)
cl_performance(N_DATA_PTS, N_WORKERS)

using LinearAlgebra
import Adapt

@testset "constructors" begin
    xs = CLArray{Int, 2, cl.Buffer}(undef, 2, 3)
    @test collect(CLArray([1 2; 3 4])) == [1 2; 3 4]
    @test testf(vec, rand(Float32, 5, 3))
    @test Base.elsize(xs) == sizeof(Int)
    @test CLArray{Int, 2}(xs) === xs

    @test device_accessible(xs)
    @test !host_accessible(xs)
    @test_throws ArgumentError Base.unsafe_convert(Ptr{Int}, xs)
    @test_throws ArgumentError Base.unsafe_convert(Ptr{Float32}, xs)

    @test collect(OpenCL.zeros(Float32, 2, 2)) == zeros(Float32, 2, 2)
    @test collect(OpenCL.ones(Float32, 2, 2)) == ones(Float32, 2, 2)

    @test collect(OpenCL.fill(0, 2, 2)) == zeros(Int, 2, 2)
    @test collect(OpenCL.fill(1, 2, 2)) == ones(Int, 2, 2)
end

@testset "adapt" begin
    A = rand(Float32, 3, 3)
    dA = CLArray(A)
    @test Adapt.adapt(Array, dA) == A
    @test Adapt.adapt(CLArray, A) isa CLArray
    @test Array(Adapt.adapt(CLArray, A)) == A
end

@testset "reshape" begin
    A = [
        1 2 3 4
        5 6 7 8
    ]
    gA = reshape(CLArray(A), 1, 8)
    _A = reshape(A, 1, 8)
    _gA = Array(gA)
    @test all(_A .== _gA)
    A = [1, 2, 3, 4]
    gA = reshape(CLArray(A), 4)
end

@testset "fill(::SubArray)" begin
    xs = OpenCL.zeros(Float32, 3)
    fill!(view(xs, 2:2), 1)
    @test Array(xs) == [0, 1, 0]
end

@testset "reinterpret of view with non-aligned offset" begin
    # reinterpreting a view to a larger element type where the byte offset
    # is not a multiple of the new element size
    a = CLArray(Int32[1,2,3,4,5,6,7,8,9])
    v = view(a, 2:7)  # offset of 1 Int32 = 4 bytes
    r = reinterpret(Int64, v)  # Int64 = 8 bytes; 4 is not a multiple of 8
    @test Array(r) == reinterpret(Int64, @view Array(a)[2:7])
end
# TODO: Look into how to port the @sync

if cl.USMBackend() in cl.supported_memory_backends(cl.device())
    @testset "shared buffers & unsafe_wrap" begin
        a = CLVector{Int, cl.UnifiedSharedMemory}(undef, 2)

        # check that basic operations work on arrays backed by shared memory
        fill!(a, 40)
        a .+= 2
        @test Array(a) == [42, 42]

        # derive an Array object and test that the memory keeps in sync
        b = unsafe_wrap(Array, a)
        b[1] = 100
        @test Array(a) == [100, 42]
        copyto!(a, 2, [200], 1, 1)
        cl.finish(cl.queue())
        @test b == [100, 200]
    end

    # https://github.com/JuliaGPU/CUDA.jl/issues/2191
    @testset "preserving memory types" begin
        a = CLVector{Int, cl.UnifiedSharedMemory}([1])
        @test OpenCL.memtype(a) == cl.UnifiedSharedMemory

        # unified-ness should be preserved
        b = a .+ 1
        @test OpenCL.memtype(b) == cl.UnifiedSharedMemory

        # when there's a conflict, we should defer to unified memory
        c = CLVector{Int, cl.UnifiedSharedMemory}([1])
        d = CLVector{Int, cl.UnifiedDeviceMemory}([1])
        e = c .+ d
        @test OpenCL.memtype(e) == cl.UnifiedSharedMemory
    end
end

@testset "resizing" begin
    a = CLArray([1, 2, 3])

    resize!(a, 3)
    @test length(a) == 3
    @test Array(a) == [1, 2, 3]

    resize!(a, 5)
    @test length(a) == 5
    @test Array(a)[1:3] == [1, 2, 3]

    resize!(a, 2)
    @test length(a) == 2
    @test Array(a)[1:2] == [1, 2]

    b = CLArray{Int}(undef, 0)
    @test length(b) == 0
    resize!(b, 1)
    @test length(b) == 1
end

# high-level memory management

## managed memory

# to safely use allocated memory across tasks and devices, we don't simply return raw
# memory objects, but wrap them in a manager that ensures synchronization and ownership.

# XXX: immutable with atomic refs?
mutable struct Managed{M}
    const mem::M

    # which stream is currently using the memory.
    queue::cl.CmdQueue

    # whether there are outstanding operations that haven't been synchronized
    dirty::Bool

    # who is currently using the memory
    user::Symbol

    function Managed(mem::cl.AbstractMemory; queue = cl.queue(), dirty = true, user = :device)
        # NOTE: memory starts as dirty, because stream-ordered allocations are only
        #       guaranteed to be physically allocated at a synchronization event.
        # NOTE: memory also starts as device-owned, because we need to map it as soon as
        #       the host accesses it.
        return new{typeof(mem)}(mem, queue, dirty, user)
    end
end

Base.sizeof(managed::Managed) = sizeof(managed.mem)

# wait for the current owner of memory to finish processing
function synchronize(managed::Managed)
    cl.finish(managed.queue)
    managed.dirty = false
    return
end

function maybe_synchronize(managed::Managed)
    if managed.dirty
        synchronize(managed)
    end
    return nothing
end

function Base.convert(typ::Union{Type{<:CLPtr}, Type{cl.Buffer}}, managed::Managed{M}) where {M}
    # let null pointers pass through as-is
    # XXX: does not work for buffers
    ptr = convert(typ, managed.mem)
    if ptr == cl.CL_NULL
        return ptr
    end

    # accessing memory on another queue: ensure the data is ready and take ownership
    if managed.queue != cl.queue()
        maybe_synchronize(managed)
        managed.queue = cl.queue()
    end

    # coarse-grained SVM needs to be unmapped when accessing it back from the device
    # TODO: support fine-grained SVM
    if M == cl.SharedVirtualMemory && managed.user == :host
        cl.enqueue_svm_unmap(pointer(managed.mem))
        managed.user = :device
    end

    managed.dirty = true
    return ptr
end

function Base.convert(typ::Type{<:Ptr}, managed::Managed{M}) where {M}
    # let null pointers pass through as-is
    ptr = convert(typ, managed.mem)
    if ptr == C_NULL
        return ptr
    end

    # accessing memory on the CPU: only allowed for host or unified allocations
    if M == cl.UnifiedDeviceMemory
        throw(
            ArgumentError(
                """cannot take the CPU address of GPU memory."""
            )
        )
    end

    # make sure any work on the memory has finished.
    maybe_synchronize(managed)

    # coarse-grained SVM needs to be mapped when initially accessing it from the host
    # TODO: support fine-grained SVM
    if M == cl.SharedVirtualMemory && managed.user != :host
        cl.enqueue_svm_map(pointer(managed.mem), sizeof(managed.mem), :rw; blocking = true)
        managed.user = :host
    end

    return ptr
end


## OOM handling

export OutOfGPUMemoryError

"""
    OutOfGPUMemoryError()

An operation allocated too much GPU memory.
"""
struct OutOfGPUMemoryError <: Exception
    sz::Int
    dev::cl.Device

    function OutOfGPUMemoryError(sz::Integer = 0, dev::cl.Device = cl.device())
        return new(sz, dev)
    end
end

function Base.showerror(io::IO, err::OutOfGPUMemoryError)
    print(io, "Out of GPU memory")
    if err.sz > 0
        print(io, " trying to allocate $(Base.format_bytes(err.sz))")
    end
    print(" on device $((err.dev).name)")
    #=
    if length(memory_properties(err.dev)) == 1
        # XXX: how to handle multiple memories?
        print(" with $(Base.format_bytes(only(memory_properties(err.dev)).totalSize))")
    end
    =#
    return io
end


## public interface
function managed_alloc(t::Type{T}, bytes::Int; kwargs...) where T
    if bytes == 0
        return Managed(T())
    else
        alloc(t, bytes; kwargs...)
    end
end

function alloc(::Type{cl.UnifiedDeviceMemory}, bytes::Int; alignment::Int = 0)
    mem = cl.device_alloc(bytes; alignment)
    return Managed(mem)
end

function alloc(::Type{cl.UnifiedSharedMemory}, bytes::Int; alignment::Int = 0)
    # TODO: support cross-device shared memory (by setting `dev=nothing`)
    mem = cl.shared_alloc(bytes; alignment)
    return Managed(mem)
end

function alloc(::Type{cl.UnifiedHostMemory}, bytes::Int; alignment::Int = 0)
    mem = cl.host_alloc(bytes; alignment)
    return Managed(mem)
end

function alloc(::Type{cl.SharedVirtualMemory}, bytes::Int; alignment::Int = 0)
    mem = cl.svm_alloc(bytes; alignment)
    return Managed(mem)
end

function alloc(::Type{cl.Buffer}, bytes::Int; alignment::Int = 0)
    # TODO: use alignment
    buf = cl.Buffer(bytes)
    return Managed(buf)
end

function free(managed::Managed)
    sizeof(managed) == 0 && return
    mem = managed.mem
    cl.context!(cl.context(mem)) do
        # "`clSVMFree` does not wait for previously enqueued commands that may be using
        # svm_pointer to finish before freeing svm_pointer. It is the responsibility of the
        # application to make sure that enqueued commands that use svm_pointer have finished
        # before freeing svm_pointer". USM has `clMemBlockingFreeINTEL`, but by doing the
        # synchronization ourselves we provide more opportunity for concurrent execution.
        if managed.queue.valid
            synchronize(managed)
        end

        if mem isa cl.SharedVirtualMemory
            if managed.user == :host
                # if the coarse-grained SVM buffer is mapped on the host, unmap it first.
                cl.enqueue_svm_unmap(pointer(mem))
            end
            cl.svm_free(mem)
        elseif mem isa cl.UnifiedMemory
            cl.usm_free(mem)
        else
            cl.release(mem)
        end
    end

    return
end

```@meta
CurrentModule = OpenCL
```

# OpenCL

*Julia interface for the OpenCL parallel computation API*

This package aims to be a complete solution for OpenCL programming in Julia, similar in
scope to [PyOpenCL] for Python. It provides a high level API for OpenCL to make programing
hardware accelerators, such as GPUs, FPGAs, and DSPs, as well as multicore CPUs much less
onerous.


!!! note "OpenCL.jl needs your help!"
    If you can help maintain this package, please reach out on the [JuliaLang Slack](https://julialang.org/slack/) #gpu channel.

!!! warning "OpenCL.jl is currently undergoing major changes."
    If you have old code developed for OpenCL.jl v0.9, please check [`NEWS.md`](https://github.com/JuliaGPU/OpenCL.jl/blob/main/NEWS.md) for an overview of the changes.


## Installation

1. Install an OpenCL driver. You can install one system-wide, i.e., using your package
   manager, or use `pocl_jll.jl` for a CPU back-end.
2. Add OpenCL to your Julia environment:

```julia
using Pkg
Pkg.add("OpenCL")
```

3. Test your installation:

```julia-repl
julia> OpenCL.versioninfo()
OpenCL.jl version 0.10.0

Toolchain:
 - Julia v1.10.5
 - OpenCL_jll v2024.5.8+1

Available platforms: 3
 - Portable Computing Language
   version: OpenCL 3.0 PoCL 6.0  Linux, Release, RELOC, SPIR-V, LLVM 15.0.7jl, SLEEF, DISTRO, POCL_DEBUG
   · cpu-haswell-AMD Ryzen 9 5950X 16-Core Processor (fp64, il)
 - NVIDIA CUDA
   version: OpenCL 3.0 CUDA 12.6.65
   · NVIDIA RTX 6000 Ada Generation (fp64)
 - Intel(R) OpenCL Graphics
   version: OpenCL 3.0
   · Intel(R) Arc(TM) A770 Graphics (fp16, il)
```

!!! warning "Platform list is only computed once"
    OpenCL is only computing the list of platforms [once](https://github.com/KhronosGroup/OpenCL-ICD-Loader/blob/d547426c32f9af274ec1369acd1adcfd8fe0ee40/loader/linux/icd_linux.c#L234-L238).
    Therefore if `using pocl_jll` is executed after `OpenCL.versioninfo()` or other calls to the OpenCL API then it won't affect the list of platforms available and you will need to restart the Julia session and run `using pocl_jll` before `OpenCL` is used.

## Basic example: vector add

The traditional way of using OpenCL is by writing kernel source code in OpenCL C. For
example, a simple vector addition:

```julia
using OpenCL, pocl_jll

const source = """
   __kernel void vadd(__global const float *a,
                      __global const float *b,
                      __global float *c) {
      int gid = get_global_id(0);
      c[gid] = a[gid] + b[gid];
    }"""

a = rand(Float32, 50_000)
b = rand(Float32, 50_000)

d_a = CLArray(a)
d_b = CLArray(b)
d_c = similar(d_a)

p = cl.Program(; source) |> cl.build!
k = cl.Kernel(p, "vadd")

clcall(k, Tuple{CLPtr{Float32}, CLPtr{Float32}, CLPtr{Float32}},
       d_a, d_b, d_c; global_size=size(a))

c = Array(d_c)

@assert a + b ≈ c
```


## Native example: vector add

If your platform supports SPIR-V, it's possible to use Julia functions as kernels:

```julia
using OpenCL, pocl_jll

function vadd(a, b, c)
    gid = get_global_id(1)
    @inbounds c[gid] = a[gid] + b[gid]
    return
end

a = rand(Float32, 50_000)
b = rand(Float32, 50_000)

d_a = CLArray(a)
d_b = CLArray(b)
d_c = similar(d_a)

@opencl global_size=size(a) vadd(d_a, d_b, d_c)

c = Array(d_c)

@assert a + b ≈ c
```


## More examples

You may want to check out the `examples` folder. Either `git clone` the repository to your
local machine or navigate to the OpenCL.jl install directory via:

```julia
using OpenCL
cd(joinpath(dirname(pathof(OpenCL)), ".."))
```

Otherwise, feel free to take a look at the Jupyter notebooks below:

  * [Julia set fractals](https://github.com/JuliaGPU/OpenCL.jl/blob/main/examples/notebooks/julia_set_fractal.ipynb)
  * [Mandlebrot fractal](https://github.com/JuliaGPU/OpenCL.jl/blob/main/examples/notebooks/mandelbrot_fractal.ipynb)
  * [Transpose bandwidth](https://github.com/JuliaGPU/OpenCL.jl/blob/main/examples/notebooks/Transpose.ipynb)


## Credit

This package is heavily influenced by the work of others:

  * [PyOpenCL](http://mathema.tician.de/software/pyopencl/) by Andreas Klockner
  * [oclpb](https://github.com/srossross/oclpb) by Sean Ross
  * [Boost.Compute](https://github.com/kylelutz/compute) by Kyle Lutz
  * [rust-opencl](https://github.com/luqmana/rust-opencl)

# Profiling

OpenCL.jl applications can be profiled using [opencl-kernel-profiler](https://github.com/rjodinchr/opencl-kernel-profiler), which is based on Perfetto.
The most convenient way to use it is through `opencl_kernel_profiler_jll` by setting the `OPENCL_LAYERS` environment variable before initializing OpenCL as follows:

```julia
using opencl_kernel_profiler_jll
ENV["OPENCL_LAYERS"] = opencl_kernel_profiler_jll.libopencl_kernel_profiler
```

By default, traces are limited to 1024 KB. To increase this limit, set `CLKP_TRACE_MAX_SIZE` to a larger value, e.g. `ENV["CLKP_TRACE_MAX_SIZE"] = "100 * 1024"` for 100 MB.

After the Julia session exits, traces will be written to `opencl-kernel-profiler.trace` in the current directory, which can be changed using the `CLKP_TRACE_DEST` environment variable. These traces can then be visualized by going to [https://ui.perfetto.dev/](https://ui.perfetto.dev/) and opening the trace file.

`opencl-kernel-profiler` works by intercepting calls to the OpenCL API and recording the execution time of kernels as well as events on the host side. It will also log the OpenCL/SPIR-V source code of the kernels alongside the traced calls to `clEnqueueNDRangekernel`, which can be useful for debugging.
